/* DUPLICATOR MYSQL SCRIPT CREATED ON : January 31, 2014, 8:39 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8_unicode_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_duplicator` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `token` varchar(25) COLLATE utf8_unicode_ci NOT NULL,
  `packname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `zipname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `zipsize` int(11) DEFAULT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8_unicode_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=619 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=524 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8_unicode_ci NOT NULL,
  `post_title` text COLLATE utf8_unicode_ci NOT NULL,
  `post_excerpt` text COLLATE utf8_unicode_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8_unicode_ci NOT NULL,
  `pinged` text COLLATE utf8_unicode_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8_unicode_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=93 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8_unicode_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=132 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=132 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_pass` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


/* INSERT TABLE DATA: wp_commentmeta */
INSERT INTO `wp_commentmeta` VALUES("1", "1", "_wp_trash_meta_status", "1");
INSERT INTO `wp_commentmeta` VALUES("2", "1", "_wp_trash_meta_time", "1391192293");

/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "Mr WordPress", "", "http://wordpress.org/", "", "2013-12-06 17:13:19", "2013-12-06 17:13:19", "Hi, this is a comment.\nTo delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.", "0", "trash", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator */
INSERT INTO `wp_duplicator` VALUES("6", "52ec0a13cd9f63966", "20140131_makingmoneywithebooks", "52ec0a13cd9f63966_20140131_makingmoneywithebooks_package.zip", "0", "2014-01-31 20:39:47", "admin", "a:4:{s:14:\"plugin_version\";s:5:\"0.4.6\";s:4:\"type\";s:6:\"Manual\";s:6:\"status\";s:5:\"Error\";s:5:\"notes\";s:0:\"\";}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://blogsforsales.com/ebooks", "yes");
INSERT INTO `wp_options` VALUES("2", "blogname", "Making Money With Ebooks", "yes");
INSERT INTO `wp_options` VALUES("3", "blogdescription", "", "yes");
INSERT INTO `wp_options` VALUES("4", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("5", "admin_email", "mail@yourmail.info", "yes");
INSERT INTO `wp_options` VALUES("6", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("7", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("8", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("9", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "comments_notify", "", "yes");
INSERT INTO `wp_options` VALUES("11", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("12", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("13", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("17", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("18", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("19", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_pingback_flag", "", "yes");
INSERT INTO `wp_options` VALUES("21", "posts_per_page", "3", "yes");
INSERT INTO `wp_options` VALUES("22", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("23", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("24", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_recently_updated_prepend", "<em>", "yes");
INSERT INTO `wp_options` VALUES("26", "links_recently_updated_append", "</em>", "yes");
INSERT INTO `wp_options` VALUES("27", "links_recently_updated_time", "120", "yes");
INSERT INTO `wp_options` VALUES("28", "comment_moderation", "", "yes");
INSERT INTO `wp_options` VALUES("29", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("30", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("31", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("32", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("33", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("34", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("35", "active_plugins", "a:10:{i:0;s:39:\"associate_goliath/associate_goliath.php\";i:1;s:27:\"att-youtube/att-youtube.php\";i:2;s:25:\"duplicator/duplicator.php\";i:3;s:47:\"google-sitemap-plugin/google-sitemap-plugin.php\";i:4;s:30:\"jetpack-sharing/sharedaddy.php\";i:5;s:20:\"lazy-seo/lazyseo.php\";i:6;s:23:\"ml-slider/ml-slider.php\";i:7;s:41:\"sliding-contact-form-by-formget/index.php\";i:8;s:25:\"ultimate-gallery/init.php\";i:9;s:31:\"youtube-embed/youtube-embed.php\";}", "yes");
INSERT INTO `wp_options` VALUES("36", "home", "http://blogsforsales.com/ebooks", "yes");
INSERT INTO `wp_options` VALUES("37", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("38", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("39", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("40", "comment_max_links", "1", "yes");
INSERT INTO `wp_options` VALUES("41", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("42", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("43", "recently_edited", "a:3:{i:0;s:94:\"/home1/anton241/public_html/blogsforsales.com/ebooks/wp-content/themes/flexibility3/footer.php\";i:2;s:93:\"/home1/anton241/public_html/blogsforsales.com/ebooks/wp-content/themes/flexibility3/style.css\";i:3;s:0:\"\";}", "no");
INSERT INTO `wp_options` VALUES("44", "template", "flexibility3", "yes");
INSERT INTO `wp_options` VALUES("45", "stylesheet", "flexibility3", "yes");
INSERT INTO `wp_options` VALUES("46", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("47", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("48", "comment_registration", "1", "yes");
INSERT INTO `wp_options` VALUES("49", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("50", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("51", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("52", "db_version", "25824", "yes");
INSERT INTO `wp_options` VALUES("53", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("54", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("55", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("57", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("58", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("59", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("60", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("61", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("62", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("63", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("64", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("65", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("66", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("67", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("68", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("69", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("70", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("71", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("72", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("73", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("74", "close_comments_days_old", "1", "yes");
INSERT INTO `wp_options` VALUES("75", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("76", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("77", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("78", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("79", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("80", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("81", "sticky_posts", "a:3:{i:0;i:32;i:1;i:22;i:2;i:41;}", "yes");
INSERT INTO `wp_options` VALUES("82", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("83", "widget_text", "a:3:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:142:\"<center><a href=http://anton343.forsurveys.hop.clickbank.net><img src=\"http://d2geju3h8qicv6.cloudfront.net/160x600_stat_1.gif\" border=0></a> \";s:6:\"filter\";b:0;}i:3;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:251:\"<center><iframe src=\"http://rcm-na.amazon-adsystem.com/e/cm?t=freetos-20&o=1&p=12&l=ur1&category=sss&banner=1H48C87B8J19CF6V8W82&f=ifr\" width=\"300\" height=\"250\" scrolling=\"no\" border=\"0\" marginwidth=\"0\" style=\"border:none;\" frameborder=\"0\"></iframe>\r\n\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("84", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("85", "uninstall_plugins", "a:2:{s:25:\"duplicator/duplicator.php\";s:20:\"duplicator_uninstall\";s:47:\"google-sitemap-plugin/google-sitemap-plugin.php\";s:23:\"delete_gglstmp_settings\";}", "no");
INSERT INTO `wp_options` VALUES("86", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("87", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("90", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "initial_db_version", "22441", "yes");
INSERT INTO `wp_options` VALUES("92", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("96", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("97", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("98", "sidebars_widgets", "a:7:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:4:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:12:\"categories-2\";i:3;s:6:\"text-3\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:2:{i:0;s:6:\"text-2\";i:1;s:11:\"tag_cloud-2\";}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("128", "cron", "a:54:{i:1391211220;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1391211263;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1391238000;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1391278764;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1391430996;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"9faa5555021560fb2a78d8c9f3513bc5\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:42;}}}}i:1391445318;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"90769b99ac5e069f750a77f27934e890\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:43;}}}}i:1391515263;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"982af21b0685091f8b52b16d5acc3594\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:44;}}}}i:1391532799;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"d39dce9160616ba443fad3c74949d55a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:45;}}}}i:1391618756;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"5bf59cf32cb0da883a8449b5b1a4d30a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:46;}}}}i:1391777310;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"9a7037354a2b7b98ba90551f53b6ca93\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:47;}}}}i:1391788728;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"cb4a22a63ce87fc7c4c6c7c532ee7f5f\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:48;}}}}i:1391943833;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"c7c97442c7bbde2137452591b932e68d\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:49;}}}}i:1391964721;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"68d22f41eb0a025961de0a8e20e64064\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:50;}}}}i:1392027526;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"d500441b538711fa00c3ef048e23faf3\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:51;}}}}i:1392206742;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"d38bf3ceef616da487e3a5a67efee824\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:52;}}}}i:1392311436;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"c824bc7a784ee3d8f78d22b52f53879b\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:53;}}}}i:1392381835;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"a05c27d65e3068dce804d1d1ad40def4\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:54;}}}}i:1392396481;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"67a23b5262f56e030eab46a20e266de7\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:55;}}}}i:1392469658;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"1a89a2a2129300c1da6763ba0380ed1f\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:56;}}}}i:1392550694;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"2937749bdb63b97e582698a4b62671c0\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:57;}}}}i:1392562822;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"86a7658f8bc100e4f407e1e6e1fed875\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:58;}}}}i:1392723243;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"1f51f40c41f65aeb5bee2fa8a12cae3d\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:59;}}}}i:1392807250;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"1f2017e1ed51c7e11ca55ed0583ac79c\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:60;}}}}i:1392897686;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"3e5b9d87ec9acb6b0f0f88eb6019ab77\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:61;}}}}i:1392909409;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"3cba02404b28511a5438290dad5d447d\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:62;}}}}i:1393249686;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"4ab831df806c80761e34224b2a1499cc\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:63;}}}}i:1393328464;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"bf705dbc9d7d62b7604c53475d0de333\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:64;}}}}i:1393426769;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"32b7e32f14df1bb8be86a2080c8859d5\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:65;}}}}i:1393502455;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"40abb52b93b056290603eb7686c4546c\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:66;}}}}i:1393514236;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"cfdc1bee7d6996ba5306dacc5c100f2b\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:67;}}}}i:1393589974;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"2b8c7f2cec272332aa887b58e7ba4bee\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:68;}}}}i:1393605141;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"40c342a72be7f7f46752927189654190\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:69;}}}}i:1393683076;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"f953bd603d96036fad62a863c8deaa45\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:70;}}}}i:1393756390;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"301c94fab7b88db0f25594661c40527b\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:71;}}}}i:1393850345;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"45e49ef56f67b92f57be159c17e31b38\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:72;}}}}i:1393865384;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"c185de4a9f4c74ab215031e581ca3dd7\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:73;}}}}i:1393938369;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"04ed68d3d0d813372e658b4099f4ac13\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:74;}}}}i:1394037469;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"d99e77e0d50c9c3dc0e0e534829dd859\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:75;}}}}i:1394103176;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"87201d3637e485f7d6563d69209cf3f4\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:76;}}}}i:1394369367;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"cc601540ab6e33158c282b016fa947c6\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:77;}}}}i:1394454998;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"a62f2e612393a7fc399274410b3ac2d6\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:78;}}}}i:1394464973;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"fb5725de096d164fcec0dfd4917400a2\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:79;}}}}i:1394541564;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"ccd098f471dbcc3c8fe84865f60d1bee\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:80;}}}}i:1394550114;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"0130b445f2a3da777482c02317e1901a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:81;}}}}i:1394728264;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"6392c3b0cd930fb020f301c8a7fc1e72\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:82;}}}}i:1394800871;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"8ca3609783b6a736f8791c701d7bdc6f\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:83;}}}}i:1394886484;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"0a95b0e69189f4c5eff461fe523d450b\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:84;}}}}i:1394896639;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"8d0b3ce3dc4b5b7343b250e206e5d2cd\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:85;}}}}i:1394973076;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"77bfea138af154ec45b266ee439b4c6c\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:86;}}}}i:1394983852;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"3e8d8c2966a4b2c8853c021c20c64617\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:87;}}}}i:1395142946;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"35b679ffd89bc82eb262979d35f94f91\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:88;}}}}i:1395240080;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"4b0e200fdff92ea83cc5cbd92b3d3543\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:89;}}}}i:1395314543;a:1:{s:19:\"publish_future_post\";a:1:{s:32:\"d6f7b985c4364f8847c90b2d464e2479\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:90;}}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("137", "dashboard_widget_options", "a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:31:\"http://blogsforsales.com/ebooks\";s:4:\"link\";s:107:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://blogsforsales.com/ebooks/\";s:3:\"url\";s:140:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://blogsforsales.com/ebooks/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}", "yes");
INSERT INTO `wp_options` VALUES("173", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("177", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("179", "theme_mods_twentytwelve", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1386372956;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("180", "current_theme", "Flexibility3", "yes");
INSERT INTO `wp_options` VALUES("181", "theme_mods_flexibility3", "a:2:{i:0;b:0;s:18:\"nav_menu_locations\";a:1:{s:12:\"primary-menu\";i:2;}}", "yes");
INSERT INTO `wp_options` VALUES("182", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("183", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("187", "asg_version", "04.02.01", "yes");
INSERT INTO `wp_options` VALUES("189", "external_updates-associate_goliath", "O:8:\"stdClass\":3:{s:9:\"lastCheck\";i:1391191840;s:14:\"checkedVersion\";s:5:\"4.2.1\";s:6:\"update\";O:8:\"stdClass\":6:{s:2:\"id\";i:0;s:4:\"slug\";s:17:\"associate_goliath\";s:7:\"version\";s:5:\"4.2.3\";s:8:\"homepage\";s:27:\"http://associategoliath.com\";s:12:\"download_url\";s:72:\"http://wppluginupdate.com/package-download.php?product=associate_goliath\";s:14:\"upgrade_notice\";s:37:\"Get latest bugfixes and improvements.\";}}", "yes");
INSERT INTO `wp_options` VALUES("195", "duplicator_pack_passcount", "2", "yes");
INSERT INTO `wp_options` VALUES("196", "duplicator_add1_passcount", "2", "yes");
INSERT INTO `wp_options` VALUES("197", "duplicator_add1_clicked", "0", "yes");
INSERT INTO `wp_options` VALUES("200", "lazy-keywords", "a:6:{i:0;s:4:\"key1\";i:1;s:4:\"key2\";i:2;s:4:\"key3\";i:3;s:4:\"key4\";i:4;s:4:\"key5\";i:5;s:4:\"key6\";}", "yes");
INSERT INTO `wp_options` VALUES("201", "lazy-geo", "a:1:{i:0;s:4:\"geo1\";}", "yes");
INSERT INTO `wp_options` VALUES("202", "lazy-number", "6", "yes");
INSERT INTO `wp_options` VALUES("203", "lazy-number-geo", "1", "yes");
INSERT INTO `wp_options` VALUES("204", "lazy-check", "0", "yes");
INSERT INTO `wp_options` VALUES("209", "duplicator_settings", "a:4:{s:7:\"version\";s:5:\"0.4.6\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("210", "duplicator_version_plugin", "0.4.6", "yes");
INSERT INTO `wp_options` VALUES("211", "duplicator_options", "s:217:\"a:9:{s:6:\"dbhost\";s:9:\"localhost\";s:6:\"dbname\";s:0:\"\";s:6:\"dbuser\";s:0:\"\";s:7:\"url_new\";s:0:\"\";s:8:\"email-me\";s:1:\"0\";s:12:\"email_others\";s:0:\"\";s:10:\"dir_bypass\";s:0:\"\";s:9:\"log_level\";s:1:\"0\";s:8:\"skip_ext\";s:0:\"\";}\";", "yes");
INSERT INTO `wp_options` VALUES("213", "sharing-options", "a:1:{s:6:\"global\";a:5:{s:12:\"button_style\";s:9:\"icon-text\";s:13:\"sharing_label\";b:0;s:10:\"open_links\";s:3:\"new\";s:4:\"show\";a:5:{i:0;s:5:\"index\";i:1;s:4:\"post\";i:2;s:4:\"page\";i:3;s:10:\"attachment\";i:4;s:9:\"ml-slider\";}s:6:\"custom\";a:0:{}}}", "yes");
INSERT INTO `wp_options` VALUES("214", "pagenavi_options", "a:12:{s:10:\"pages_text\";s:36:\"Page %CURRENT_PAGE% of %TOTAL_PAGES%\";s:12:\"current_text\";s:13:\"%PAGE_NUMBER%\";s:9:\"page_text\";s:13:\"%PAGE_NUMBER%\";s:10:\"first_text\";s:13:\"&laquo; First\";s:9:\"last_text\";s:12:\"Last &raquo;\";s:9:\"next_text\";s:7:\"&raquo;\";s:9:\"prev_text\";s:7:\"&laquo;\";s:13:\"dotright_text\";s:3:\"...\";s:12:\"dotleft_text\";s:3:\"...\";s:5:\"style\";i:1;s:9:\"num_pages\";i:5;s:11:\"always_show\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("221", "flex_blog_width", "960", "yes");
INSERT INTO `wp_options` VALUES("222", "flex_content_width", "600", "yes");
INSERT INTO `wp_options` VALUES("223", "flex_lsidebar_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("224", "flex_lsidebar_width", "335", "yes");
INSERT INTO `wp_options` VALUES("225", "flex_rsidebar_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("226", "flex_rsidebar_width", "335", "yes");
INSERT INTO `wp_options` VALUES("227", "flex_page_backgroundcolor", "222", "yes");
INSERT INTO `wp_options` VALUES("228", "flex_blog_bgimage", "faintdots.png", "yes");
INSERT INTO `wp_options` VALUES("229", "flex_blog_custombg", "none", "yes");
INSERT INTO `wp_options` VALUES("230", "flex_blog_bgrepeat", "repeat", "yes");
INSERT INTO `wp_options` VALUES("231", "flex_blog_bgfade", "yes", "yes");
INSERT INTO `wp_options` VALUES("232", "flex_blog_bordercolor", "000", "yes");
INSERT INTO `wp_options` VALUES("233", "flex_blog_borderwidth", "2", "yes");
INSERT INTO `wp_options` VALUES("234", "flex_blog_margin", "15", "yes");
INSERT INTO `wp_options` VALUES("235", "flex_blog_font", "Arial", "yes");
INSERT INTO `wp_options` VALUES("236", "flex_blog_size", "12", "yes");
INSERT INTO `wp_options` VALUES("237", "flex_blog_tc", "C8C8C8", "yes");
INSERT INTO `wp_options` VALUES("238", "flex_blog_tclink", "A10000", "yes");
INSERT INTO `wp_options` VALUES("239", "flex_content_color", "000", "yes");
INSERT INTO `wp_options` VALUES("240", "flex_header_trans", "no", "yes");
INSERT INTO `wp_options` VALUES("241", "flex_header_backgroundcolor", "F71505", "yes");
INSERT INTO `wp_options` VALUES("242", "flex_header_bg", "Money.png", "yes");
INSERT INTO `wp_options` VALUES("243", "flex_head_image", "", "yes");
INSERT INTO `wp_options` VALUES("244", "flex_head_height", "120", "yes");
INSERT INTO `wp_options` VALUES("245", "flex_head_toppad", "20", "yes");
INSERT INTO `wp_options` VALUES("246", "flex_blog_logo", "", "yes");
INSERT INTO `wp_options` VALUES("247", "flex_title_seo", "yes", "yes");
INSERT INTO `wp_options` VALUES("248", "flex_title_font", "Georgia", "yes");
INSERT INTO `wp_options` VALUES("249", "flex_title_size", "34", "yes");
INSERT INTO `wp_options` VALUES("250", "flex_title_clr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("251", "flex_title_hvr", "999999", "yes");
INSERT INTO `wp_options` VALUES("252", "flex_tagline_color", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("253", "flex_search_visibility", "no", "yes");
INSERT INTO `wp_options` VALUES("254", "flex_search_txt", "Search our site...", "yes");
INSERT INTO `wp_options` VALUES("255", "flex_search_img", "punch.png", "yes");
INSERT INTO `wp_options` VALUES("256", "flex_search_margin", "0", "yes");
INSERT INTO `wp_options` VALUES("257", "flex_subrss_visibility", "yes", "yes");
INSERT INTO `wp_options` VALUES("258", "flex_rss_icon", "rssnewspaper", "yes");
INSERT INTO `wp_options` VALUES("259", "flex_email_address", "", "yes");
INSERT INTO `wp_options` VALUES("260", "flex_rss_color", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("261", "flex_rss_hover", "999999", "yes");
INSERT INTO `wp_options` VALUES("262", "flex_nav_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("263", "flex_nav_position", "above", "yes");
INSERT INTO `wp_options` VALUES("264", "flex_nav_home", "yes", "yes");
INSERT INTO `wp_options` VALUES("265", "flex_nav_style", "tabs", "yes");
INSERT INTO `wp_options` VALUES("266", "flex_nav_color", "F71505", "yes");
INSERT INTO `wp_options` VALUES("267", "flex_nav_tabhvr", "F71505", "yes");
INSERT INTO `wp_options` VALUES("268", "flex_nav_tabact", "F71505", "yes");
INSERT INTO `wp_options` VALUES("269", "flex_nav_txtclr", "FFFBFB", "yes");
INSERT INTO `wp_options` VALUES("270", "flex_nav_hvrcolor", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("271", "flex_nav_font", "Arial", "yes");
INSERT INTO `wp_options` VALUES("272", "flex_nav_txtsize", "12", "yes");
INSERT INTO `wp_options` VALUES("273", "flex_nav_fontwt", "normal", "yes");
INSERT INTO `wp_options` VALUES("274", "flex_nav_border", "no", "yes");
INSERT INTO `wp_options` VALUES("275", "flex_nav_showarrow", "true", "yes");
INSERT INTO `wp_options` VALUES("276", "flex_nav_subwidth", "150", "yes");
INSERT INTO `wp_options` VALUES("277", "flex_nav_subheight", "30", "yes");
INSERT INTO `wp_options` VALUES("278", "flex_nav_subback", "1F242C", "yes");
INSERT INTO `wp_options` VALUES("279", "flex_nav_subhov", "3D4A57", "yes");
INSERT INTO `wp_options` VALUES("280", "flex_nav_subtext", "CCCCCC", "yes");
INSERT INTO `wp_options` VALUES("281", "flex_nav_subtexthov", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("282", "flex_nav_subborder", "1", "yes");
INSERT INTO `wp_options` VALUES("283", "flex_nav_subbrdrclr", "000000", "yes");
INSERT INTO `wp_options` VALUES("284", "flex_feat_display", "no", "yes");
INSERT INTO `wp_options` VALUES("285", "flex_feat_pages", "home only", "yes");
INSERT INTO `wp_options` VALUES("286", "flex_feat_widgets", "2", "yes");
INSERT INTO `wp_options` VALUES("287", "flex_feat_shadow", "yes", "yes");
INSERT INTO `wp_options` VALUES("288", "flex_feat_bgcolor", "333333", "yes");
INSERT INTO `wp_options` VALUES("289", "flex_feat_txtcolor", "999999", "yes");
INSERT INTO `wp_options` VALUES("290", "flex_feat_linkcolor", "CCCCCC", "yes");
INSERT INTO `wp_options` VALUES("291", "flex_feat_hovercolor", "FFF", "yes");
INSERT INTO `wp_options` VALUES("292", "flex_feat_fontsize", "18", "yes");
INSERT INTO `wp_options` VALUES("293", "flex_feat_titlecolor", "FFF", "yes");
INSERT INTO `wp_options` VALUES("294", "flex_feat_bullet", "light arrow", "yes");
INSERT INTO `wp_options` VALUES("295", "flex_post_clr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("296", "flex_post_brdr", "000", "yes");
INSERT INTO `wp_options` VALUES("297", "flex_post_font", "Georgia", "yes");
INSERT INTO `wp_options` VALUES("298", "flex_post_titalign", "left", "yes");
INSERT INTO `wp_options` VALUES("299", "flex_post_color", "FFF", "yes");
INSERT INTO `wp_options` VALUES("300", "flex_post_titlebg", "303030", "yes");
INSERT INTO `wp_options` VALUES("301", "flex_post_hover", "999999", "yes");
INSERT INTO `wp_options` VALUES("302", "flex_post_size", "22", "yes");
INSERT INTO `wp_options` VALUES("303", "flex_post_weight", "normal", "yes");
INSERT INTO `wp_options` VALUES("304", "flex_post_h1pad", "8", "yes");
INSERT INTO `wp_options` VALUES("305", "flex_ptitle_uline", "solid", "yes");
INSERT INTO `wp_options` VALUES("306", "flex_ptitle_ulines", "0", "yes");
INSERT INTO `wp_options` VALUES("307", "flex_ptitle_ulinec", "000", "yes");
INSERT INTO `wp_options` VALUES("308", "flex_metadata_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("309", "flex_metadata_color", "666", "yes");
INSERT INTO `wp_options` VALUES("310", "flex_metadata_bg", "yes", "yes");
INSERT INTO `wp_options` VALUES("311", "flex_metadata_link", "FFF", "yes");
INSERT INTO `wp_options` VALUES("312", "flex_posttext_color", "333333", "yes");
INSERT INTO `wp_options` VALUES("313", "flex_link_color", "F71505", "yes");
INSERT INTO `wp_options` VALUES("314", "flex_link_hover", "000000", "yes");
INSERT INTO `wp_options` VALUES("315", "flex_link_und", "no", "yes");
INSERT INTO `wp_options` VALUES("316", "flex_bquote_color", "CCCCCC", "yes");
INSERT INTO `wp_options` VALUES("317", "flex_bquote_border", "999999", "yes");
INSERT INTO `wp_options` VALUES("318", "flex_show_tags", "yes", "yes");
INSERT INTO `wp_options` VALUES("319", "flex_show_cats", "yes", "yes");
INSERT INTO `wp_options` VALUES("320", "flex_show_where", "just posts", "yes");
INSERT INTO `wp_options` VALUES("321", "flex_show_like", "yes", "yes");
INSERT INTO `wp_options` VALUES("322", "flex_pagenavi_bg", "666", "yes");
INSERT INTO `wp_options` VALUES("323", "flex_pagenavi_hover", "444", "yes");
INSERT INTO `wp_options` VALUES("324", "flex_pagenavi_active", "F71505", "yes");
INSERT INTO `wp_options` VALUES("325", "flex_pagenavi_text", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("326", "flex_comments_background", "333", "yes");
INSERT INTO `wp_options` VALUES("327", "flex_comments_border", "555", "yes");
INSERT INTO `wp_options` VALUES("328", "flex_admin_comments", "222", "yes");
INSERT INTO `wp_options` VALUES("329", "flex_comments_text", "333333", "yes");
INSERT INTO `wp_options` VALUES("330", "flex_comments_link", "F71505", "yes");
INSERT INTO `wp_options` VALUES("331", "flex_comments_linkund", "no", "yes");
INSERT INTO `wp_options` VALUES("332", "flex_comments_reply", "A10000", "yes");
INSERT INTO `wp_options` VALUES("333", "flex_comments_button", "F71505", "yes");
INSERT INTO `wp_options` VALUES("334", "flex_comments_buttext", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("335", "flex_sidebar_visibility", "yes", "yes");
INSERT INTO `wp_options` VALUES("336", "flex_sidebar_toptitle", "About my blog", "yes");
INSERT INTO `wp_options` VALUES("337", "flex_sidebar_boxtext", "You can easily change this information in the Flexibility Theme Options page.<br/><br/> Simply type what you want to say and it will be displayed here!", "yes");
INSERT INTO `wp_options` VALUES("338", "flex_sidebar_boxcolor", "282828", "yes");
INSERT INTO `wp_options` VALUES("339", "flex_sidebar_topfont", "Arial", "yes");
INSERT INTO `wp_options` VALUES("340", "flex_sidebar_tfontsize", "14", "yes");
INSERT INTO `wp_options` VALUES("341", "flex_sidebar_case", "none", "yes");
INSERT INTO `wp_options` VALUES("342", "flex_sidebar_tfontspace", "0", "yes");
INSERT INTO `wp_options` VALUES("343", "flex_sidebar_align", "left", "yes");
INSERT INTO `wp_options` VALUES("344", "flex_sidebar_title", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("345", "flex_sidebar_titlebackground", "F71505", "yes");
INSERT INTO `wp_options` VALUES("346", "flex_sidebar_arrow", "yes", "yes");
INSERT INTO `wp_options` VALUES("347", "flex_sidebar_boxborder", "000", "yes");
INSERT INTO `wp_options` VALUES("348", "flex_sidebar_textcolor", "999", "yes");
INSERT INTO `wp_options` VALUES("349", "flex_sidebar_textlink", "FFF", "yes");
INSERT INTO `wp_options` VALUES("350", "flex_sidebar_hovercolor", "F71505", "yes");
INSERT INTO `wp_options` VALUES("351", "flex_sidebar_list", "light arrow", "yes");
INSERT INTO `wp_options` VALUES("352", "flex_lsidebar_titlecolor", "F71505", "yes");
INSERT INTO `wp_options` VALUES("353", "flex_sidebar_ssfont", "Arial", "yes");
INSERT INTO `wp_options` VALUES("354", "flex_sidebar_ssfontsize", "15", "yes");
INSERT INTO `wp_options` VALUES("355", "flex_sidebar_scase", "uppercase", "yes");
INSERT INTO `wp_options` VALUES("356", "flex_sidebar_sfontspace", "0", "yes");
INSERT INTO `wp_options` VALUES("357", "flex_sidebar_salign", "left", "yes");
INSERT INTO `wp_options` VALUES("358", "flex_sidebar_uline", "solid", "yes");
INSERT INTO `wp_options` VALUES("359", "flex_sidebar_ulines", "1", "yes");
INSERT INTO `wp_options` VALUES("360", "flex_sidebar_ulinec", "333", "yes");
INSERT INTO `wp_options` VALUES("361", "flex_lsidebar_txtcolor", "666666", "yes");
INSERT INTO `wp_options` VALUES("362", "flex_lsidebar_linkcolor", "666666", "yes");
INSERT INTO `wp_options` VALUES("363", "flex_lsidebar_hovercolor", "F71505", "yes");
INSERT INTO `wp_options` VALUES("364", "flex_lsidebar_list", "light arrow", "yes");
INSERT INTO `wp_options` VALUES("365", "flex_footer_color", "333333", "yes");
INSERT INTO `wp_options` VALUES("366", "flex_footer_bgimg", "yes", "yes");
INSERT INTO `wp_options` VALUES("367", "flex_foot_feature", "no", "yes");
INSERT INTO `wp_options` VALUES("368", "flex_foot_widgets", "2", "yes");
INSERT INTO `wp_options` VALUES("369", "flex_footer_text", "FFF", "yes");
INSERT INTO `wp_options` VALUES("370", "flex_footer_link", "FFF", "yes");
INSERT INTO `wp_options` VALUES("371", "flex_footer_widtitle", "21", "yes");
INSERT INTO `wp_options` VALUES("372", "flex_foot_list", "dark arrow", "yes");
INSERT INTO `wp_options` VALUES("373", "flex_foot_links", "", "yes");
INSERT INTO `wp_options` VALUES("374", "flex_adsense_id", "", "yes");
INSERT INTO `wp_options` VALUES("375", "flex_adsense_loc1", "no", "yes");
INSERT INTO `wp_options` VALUES("376", "flex_adsense_loc1size", "728x90", "yes");
INSERT INTO `wp_options` VALUES("377", "flex_adsense_loc1type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("378", "flex_adsense_loc1channel", "", "yes");
INSERT INTO `wp_options` VALUES("379", "flex_adsense_loc2", "no", "yes");
INSERT INTO `wp_options` VALUES("380", "flex_adsense_loc2size", "234x60", "yes");
INSERT INTO `wp_options` VALUES("381", "flex_adsense_loc2type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("382", "flex_adsense_loc2channel", "", "yes");
INSERT INTO `wp_options` VALUES("383", "flex_adsense_loc3", "no", "yes");
INSERT INTO `wp_options` VALUES("384", "flex_adsense_loc3size", "234x60", "yes");
INSERT INTO `wp_options` VALUES("385", "flex_adsense_loc3type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("386", "flex_adsense_loc3channel", "", "yes");
INSERT INTO `wp_options` VALUES("387", "flex_adsense_loc4", "no", "yes");
INSERT INTO `wp_options` VALUES("388", "flex_adsense_loc4size", "468x60", "yes");
INSERT INTO `wp_options` VALUES("389", "flex_adsense_loc4type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("390", "flex_adsense_loc4channel", "", "yes");
INSERT INTO `wp_options` VALUES("391", "flex_adsense_loc5", "no", "yes");
INSERT INTO `wp_options` VALUES("392", "flex_adsense_loc5size", "468x60", "yes");
INSERT INTO `wp_options` VALUES("393", "flex_adsense_loc5type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("394", "flex_adsense_loc5channel", "", "yes");
INSERT INTO `wp_options` VALUES("395", "flex_adsense_brdr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("396", "flex_adsense_back", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("397", "flex_adsense_link", "0000CC", "yes");
INSERT INTO `wp_options` VALUES("398", "flex_adsense_text", "000000", "yes");
INSERT INTO `wp_options` VALUES("399", "flex_adsense_url", "666666", "yes");
INSERT INTO `wp_options` VALUES("400", "flex_analytics_id", "", "yes");
INSERT INTO `wp_options` VALUES("401", "flex_footer_script", "", "yes");
INSERT INTO `wp_options` VALUES("402", "flex_css_pack", "yes", "yes");
INSERT INTO `wp_options` VALUES("403", "flex_customcss", "", "yes");
INSERT INTO `wp_options` VALUES("454", "sharing-services", "a:2:{s:7:\"visible\";a:10:{i:0;s:8:\"linkedin\";i:1;s:11:\"stumbleupon\";i:2;s:4:\"digg\";i:3;s:6:\"pocket\";i:4;s:13:\"google-plus-1\";i:5;s:7:\"twitter\";i:6;s:8:\"facebook\";i:7;s:6:\"tumblr\";i:8;s:9:\"pinterest\";i:9;s:6:\"reddit\";}s:6:\"hidden\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("455", "sharedaddy_disable_resources", "0", "yes");
INSERT INTO `wp_options` VALUES("459", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("461", "asg_announcement_cache", "a:2:{s:4:\"data\";s:219:\"<span style=\"background-color: #FFFFcc;\"><a href=\"http://www.georgekatsoudas.com/?p=1927\" target=\"_blank\">Your own beauty store with Avon, L\'Oreal Paris, and Christian Dior in 10 minutes (Bonus for first 20).</a></span>\";s:9:\"timestamp\";i:1391195119;}", "yes");
INSERT INTO `wp_options` VALUES("462", "asg_viewonamazon_visible", "1", "yes");
INSERT INTO `wp_options` VALUES("463", "asg_button_text", "View on Amazon", "yes");
INSERT INTO `wp_options` VALUES("464", "asg_addtocart_visible", "1", "yes");
INSERT INTO `wp_options` VALUES("465", "asg_addtocart_text", "Add to cart", "yes");
INSERT INTO `wp_options` VALUES("466", "asg_eye_candy_align", "left", "yes");
INSERT INTO `wp_options` VALUES("467", "asg_show_button_index", "1", "yes");
INSERT INTO `wp_options` VALUES("468", "asg_show_button_bottom", "1", "yes");
INSERT INTO `wp_options` VALUES("469", "asg_show_reviews_rev2", "iframe", "yes");
INSERT INTO `wp_options` VALUES("470", "asg_min_review_rating", "4", "yes");
INSERT INTO `wp_options` VALUES("471", "asg_US_affiliate_id", "freetos-20", "yes");
INSERT INTO `wp_options` VALUES("472", "asg_CA_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("473", "asg_UK_affiliate_id", "brooks-21", "yes");
INSERT INTO `wp_options` VALUES("474", "asg_DE_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("475", "asg_ES_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("476", "asg_amazon_key", "AKIAJULJCU4YH7LDDYQA", "yes");
INSERT INTO `wp_options` VALUES("477", "asg_amazon_secret_key", "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", "yes");
INSERT INTO `wp_options` VALUES("478", "asg_tracking_id", "", "yes");
INSERT INTO `wp_options` VALUES("479", "asg_cloak_enabled", "1", "yes");
INSERT INTO `wp_options` VALUES("480", "asg_cloak_dir", "recommends", "yes");
INSERT INTO `wp_options` VALUES("496", "youtube_embed_general", "a:24:{s:15:\"current_version\";s:3:\"3.1\";s:13:\"editor_button\";i:1;s:9:\"admin_bar\";i:1;s:10:\"profile_no\";i:5;s:7:\"list_no\";i:5;s:10:\"info_cache\";i:1;s:11:\"embed_cache\";i:24;s:16:\"transcript_cache\";i:24;s:11:\"alt_profile\";i:0;s:12:\"alt_profile2\";i:0;s:7:\"bracket\";s:0:\"\";s:3:\"alt\";i:0;s:13:\"other_profile\";i:0;s:8:\"comments\";s:0:\"\";s:16:\"comments_profile\";i:0;s:8:\"metadata\";i:1;s:4:\"feed\";s:1:\"b\";s:3:\"api\";i:1;s:13:\"error_message\";s:71:\"<p>The video cannot be shown at the moment. Please try again later.</p>\";s:9:\"thumbnail\";i:2;s:7:\"privacy\";i:0;s:11:\"frameborder\";i:1;s:7:\"widgets\";i:0;s:11:\"menu_access\";s:10:\"list_users\";}", "yes");
INSERT INTO `wp_options` VALUES("497", "youtube_embed_editor_sc", "youtube", "yes");
INSERT INTO `wp_options` VALUES("501", "gglstmp_settings", "a:2:{i:0;s:4:\"page\";i:1;s:4:\"post\";}", "yes");
INSERT INTO `wp_options` VALUES("504", "youtube_embed_shortcode", "a:2:{i:1;s:13:\"youtube_video\";i:2;s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("505", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:3:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:7:\"upgrade\";s:8:\"download\";s:41:\"https://wordpress.org/wordpress-3.8.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:41:\"https://wordpress.org/wordpress-3.8.1.zip\";s:10:\"no_content\";s:52:\"https://wordpress.org/wordpress-3.8.1-no-content.zip\";s:11:\"new_bundled\";s:53:\"https://wordpress.org/wordpress-3.8.1-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"3.8.1\";s:7:\"version\";s:5:\"3.8.1\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}i:1;O:8:\"stdClass\":10:{s:8:\"response\";s:10:\"autoupdate\";s:8:\"download\";s:41:\"https://wordpress.org/wordpress-3.8.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:41:\"https://wordpress.org/wordpress-3.8.1.zip\";s:10:\"no_content\";s:52:\"https://wordpress.org/wordpress-3.8.1-no-content.zip\";s:11:\"new_bundled\";s:53:\"https://wordpress.org/wordpress-3.8.1-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"3.8.1\";s:7:\"version\";s:5:\"3.8.1\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}i:2;O:8:\"stdClass\":10:{s:8:\"response\";s:10:\"autoupdate\";s:8:\"download\";s:39:\"https://wordpress.org/wordpress-3.8.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:39:\"https://wordpress.org/wordpress-3.8.zip\";s:10:\"no_content\";s:50:\"https://wordpress.org/wordpress-3.8-no-content.zip\";s:11:\"new_bundled\";s:51:\"https://wordpress.org/wordpress-3.8-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"3.8\";s:7:\"version\";s:3:\"3.8\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1391194850;s:15:\"version_checked\";s:5:\"3.7.1\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("515", "rewrite_rules", "a:67:{s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)(/[0-9]+)?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("519", "_site_transient_timeout_browser_6d44eab61dcf5b1f0e6fa8f6595ee1bc", "1391796777", "yes");
INSERT INTO `wp_options` VALUES("520", "_site_transient_browser_6d44eab61dcf5b1f0e6fa8f6595ee1bc", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";N;s:7:\"version\";N;s:10:\"update_url\";s:0:\"\";s:7:\"img_src\";s:0:\"\";s:11:\"img_src_ssl\";s:0:\"\";s:15:\"current_version\";s:0:\"\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("521", "_transient_timeout_feed_0305cc7580a71a4bc6b8ac27ebdce98d", "1391235181", "no");
INSERT INTO `wp_options` VALUES("522", "_transient_feed_0305cc7580a71a4bc6b8ac27ebdce98d", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:4:\"\n  \n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:33:\"\n    \n    \n    \n    \n    \n    \n  \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:3:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"link:http://blogsforsales.com/ebooks/ - Google Blog Search\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"http://www.google.com/search?ie=utf-8&q=link:http://blogsforsales.com/ebooks/&tbm=blg&tbs=sbd:1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"Your search - <b>link:http://blogsforsales.com/ebooks/</b> - did not match any documents.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://a9.com/-/spec/opensearch/1.1/\";a:3:{s:12:\"totalResults\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:10:\"startIndex\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:12:\"itemsPerPage\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"10\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:12:\"content-type\";s:28:\"text/xml; charset=ISO-8859-1\";s:4:\"date\";s:29:\"Fri, 31 Jan 2014 18:13:01 GMT\";s:7:\"expires\";s:2:\"-1\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:10:\"set-cookie\";a:2:{i:0;s:143:\"PREF=ID=03b28d2ab26f5d5a:FF=0:TM=1391191981:LM=1391191981:S=jK-lnYmhtzAbq7kc; expires=Sun, 31-Jan-2016 18:13:01 GMT; path=/; domain=.google.com\";i:1;s:212:\"NID=67=qQm0DmTBl-qBNAqaaqV7lWL7NWbed4mRpb1kuUVNbhS5Kebj6FqOVBsmt8wgIrPnPSESqZ5VYjURg7VD1DeUulckC40KnxbiWlXHLLQiR7U9Vxnc6ds_VK6Ax-OFWPIa; expires=Sat, 02-Aug-2014 18:13:01 GMT; path=/; domain=.google.com; HttpOnly\";}s:3:\"p3p\";s:122:\"CP=\"This is not a P3P policy! See http://www.google.com/support/accounts/bin/answer.py?hl=en&answer=151657 for more info.\"\";s:6:\"server\";s:3:\"gws\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:18:\"alternate-protocol\";s:7:\"80:quic\";}s:5:\"build\";s:14:\"20140131180937\";}", "no");
INSERT INTO `wp_options` VALUES("523", "_transient_timeout_feed_mod_0305cc7580a71a4bc6b8ac27ebdce98d", "1391235181", "no");
INSERT INTO `wp_options` VALUES("524", "_transient_feed_mod_0305cc7580a71a4bc6b8ac27ebdce98d", "1391191981", "no");
INSERT INTO `wp_options` VALUES("525", "_transient_timeout_dash_20494a3d90a6669585674ed0eb8dcd8f", "1391235182", "no");
INSERT INTO `wp_options` VALUES("526", "_transient_dash_20494a3d90a6669585674ed0eb8dcd8f", "<p>This dashboard widget queries <a href=\"http://blogsearch.google.com/\">Google Blog Search</a> so that when another blog links to your site it will show up here. It has found no incoming links&hellip; yet. It&#8217;s okay &#8212; there is no rush.</p>\n", "no");
INSERT INTO `wp_options` VALUES("527", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1391235182", "no");
INSERT INTO `wp_options` VALUES("528", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:54:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/?v=3.9-alpha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:37:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3063\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:358:\"After six weeks and more than 9.3 million downloads of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3809:\"<p>After six weeks and more than <a href=\"http://wordpress.org/download/counter/\">9.3 million downloads</a> of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available.</p>\n<p>Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query was resolved. And if you&#8217;ve been frustrated by submit buttons that won&#8217;t do anything when you click on them (or thought you were going crazy, like some of us), we&#8217;ve found and fixed this &#8220;dead zone&#8221; on submit buttons.</p>\n<p>It also contains a fix for <strong>embedding tweets</strong> (by placing the URL to the tweet on its own line), which was broken due to a recent Twitter API change. (For more on Embeds, see <a href=\"http://codex.wordpress.org/Embeds\">the Codex</a>.)</p>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.8.1\">list of tickets</a> and <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=27018&amp;stop_rev=26862\">the changelog</a>. There&#8217;s also a <a href=\"http://make.wordpress.org/core/2014/01/22/wordpress-3-8-1-release-candidate/\">detailed summary</a> for developers on the development blog.</p>\n<p>If you are one of the millions already running WordPress 3.8, we will start rolling out automatic background updates for WordPress 3.8.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.8.1:</p>\n<p><a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"#\">José Pino</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p><em>WordPress three eight one<br />\nWe heard you didn&#8217;t like bugs<br />\nSo we took them out</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"WordPress 3.8 “Parker”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://wordpress.org/news/2013/12/parker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/12/parker/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 17:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2765\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:354:\"Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:18740:\"<p>Version 3.8 of WordPress, named “Parker” in honor of <a href=\"http://en.wikipedia.org/wiki/Charlie_Parker\">Charlie Parker</a>, bebop innovator, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet.</p>\n<div id=\"v-6wORgoGb-1\" class=\"video-player\"><embed id=\"v-6wORgoGb-1-video\" src=\"http://s0.videopress.com/player.swf?v=1.03&amp;guid=6wORgoGb&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<h2 class=\"aligncenter\">Introducing a modern new design</h2>\n<p><img class=\"wp-image-2951 aligncenter\" alt=\"overview\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/overview.jpg?resize=623%2C193\" data-recalc-dims=\"1\" /></p>\n<p>WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. Gone are overbearing gradients and dozens of shades of grey — bring on a bigger, bolder, more colorful design!</p>\n<p><img class=\"aligncenter  wp-image-2856\" style=\"margin-left: 0;margin-right: 0\" alt=\"about-modern-wordpress\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/design.png?resize=623%2C151\" data-recalc-dims=\"1\" /></p>\n<h3>Modern aesthetic</h3>\n<p>The new WordPress dashboard has a fresh, uncluttered design that embraces clarity and simplicity.</p>\n<h3>Clean typography</h3>\n<p>The Open Sans typeface provides simple, friendly text that is optimized for both desktop and mobile viewing. It’s even open source, just like WordPress.</p>\n<h3>Refined contrast</h3>\n<p>We think beautiful design should never sacrifice legibility. With superior contrast and large, comfortable type, the new design is easy to read and a pleasure to navigate.</p>\n<hr />\n<h2 class=\"aligncenter\">WordPress on every device</h2>\n<p><img class=\"alignright  wp-image-2984\" alt=\"responsive\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/responsive.jpg?resize=255%2C255\" data-recalc-dims=\"1\" />We all access the internet in different ways. Smartphone, tablet, notebook, desktop — no matter what you use, WordPress will adapt and you’ll feel right at home.</p>\n<h3>High definition at high speed</h3>\n<p>WordPress is sharper than ever with new vector-based icons that scale to your screen. By ditching pixels, pages load significantly faster, too.</p>\n<hr />\n<h2 class=\"aligncenter\">Admin color schemes to match your personality</h2>\n<p><img class=\"aligncenter  wp-image-2954\" alt=\"colors\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/colors.jpg?resize=623%2C339\" data-recalc-dims=\"1\" /></p>\n<p>WordPress just got a colorful new update. We’ve included eight new admin color schemes so you can pick the one that suits you best.</p>\n<p>Color schemes can be previewed and changed from your Profile page.</p>\n<hr />\n<h2 class=\"aligncenter\">Refined theme management</h2>\n<p><img class=\"alignright  wp-image-2967\" alt=\"themes\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/themes.jpg?resize=360%2C344\" data-recalc-dims=\"1\" />The new themes screen lets you survey your themes at a glance. Or want more information? Click to discover more. Then sit back and use your keyboard’s navigation arrows to flip through every theme you’ve got.</p>\n<h3>Smoother widget experience</h3>\n<p>Drag-drag-drag. Scroll-scroll-scroll. Widget management can be complicated. With the new design, we’ve worked to streamline the widgets screen.</p>\n<p>Have a large monitor? Multiple widget areas stack side-by-side to use the available space. Using a tablet? Just tap a widget to add it.</p>\n<hr />\n<h2 class=\"aligncenter\">Twenty Fourteen, a sleek new magazine theme</h2>\n<p><img class=\"aligncenter size-large wp-image-2789\" alt=\"The new Twenty Fourteen theme displayed on a laptop. tablet and phone\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/twentyfourteen.jpg?resize=692%2C275\" data-recalc-dims=\"1\" /></p>\n<h3>Turn your blog into a magazine</h3>\n<p>Create a beautiful magazine-style site with WordPress and Twenty Fourteen. Choose a grid or a slider to display featured content on your homepage. Customize your site with three widget areas or change your layout with two page templates.</p>\n<p>With a striking design that does not compromise our trademark simplicity, Twenty Fourteen is our most intrepid default theme yet.</p>\n<hr />\n<h2>Beginning of a new era</h2>\n<p>This release was led by Matt Mullenweg. This is our second release using the new plugin-first development process, with a much shorter timeframe than in the past. We think it’s been going great. You can check out the features currently in production on the <a title=\"Make WordPress Core\" href=\"http://make.wordpress.org/core/\" target=\"_blank\">make/core blog</a>.</p>\n<p>There are 188 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/admiralthrawn\">admiralthrawn</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aralbald\">Andrey Kabakchiev</a>, <a href=\"http://profiles.wordpress.org/apeatling\">Andy Peatling</a>, <a href=\"http://profiles.wordpress.org/ankitgadertcampcom\">Ankit Gade</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/fliespl\">Arkadiusz Rzadkowolski</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/binarymoon\">binarymoon</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/calin\">Calin Don</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/chrisbliss18\">Chris Jean</a>, <a href=\"http://profiles.wordpress.org/iblamefish\">Clinton Montague</a>, <a href=\"http://profiles.wordpress.org/cojennin\">cojennin</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/dbernar1\">Dan Bernardic</a>, <a href=\"http://profiles.wordpress.org/danieldudzic\">Daniel Dudzic</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/datafeedrcom\">datafeedr</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">Dave Martin</a>, <a href=\"http://profiles.wordpress.org/drw158\">Dave Whitley</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/dziudek\">dziudek</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gnarf37\">gnarf37</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/isaackeyet\">Isaac Keyet</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"http://profiles.wordpress.org/janhenckens\">janhenckens</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"http://profiles.wordpress.org/jeffr0\">Jeff Chandler</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jeherve\">Jeremy Herve</a>, <a href=\"http://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jhned\">jhned</a>, <a href=\"http://profiles.wordpress.org/jim912\">jim912</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/nukaga\">Junko Nukaga</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K. Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/codebykat\">Kat Hagan</a>, <a href=\"http://profiles.wordpress.org/littlethingsstudio\">Kate Whitley</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/koki4a\">Konstantin Dankov</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lite3\">lite3</a>, <a href=\"http://profiles.wordpress.org/lucp\">Luc Princen</a>, <a href=\"http://profiles.wordpress.org/latz\">Lutz Schroer</a>, <a href=\"http://profiles.wordpress.org/mako09\">Mako</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/megane9988\">megane9988</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/micahwave\">micahwave</a>, <a href=\"http://profiles.wordpress.org/cainm\">Michael Cain</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">Michael Erlewine</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/chellycat\">Michelle Langston</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mt8biz\">moto hachi</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/neil_pie\">Neil Pie</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/ninio\">ninio</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"http://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/senlin\">Piet</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/bamadesigner\">Rachel Carden</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/radices\">Radices</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/defries\">Remkus de Vries</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/wet\">Robert Wetzlmayr, PHP-Programmierer</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood</a>, <a href=\"http://profiles.wordpress.org/sanchothefat\">sanchothefat</a>, <a href=\"http://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"http://profiles.wordpress.org/scottbasgaard\">Scott Basgaard</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/designsimply\">Sheri Bigelow (designsimply)</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirbrillig\">sirbrillig</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/thomasguillot\">Thomas Guillot</a>, <a href=\"http://profiles.wordpress.org/tierra\">tierra</a>, <a href=\"http://profiles.wordpress.org/tillkruess\">Till Krüss</a>, <a href=\"http://profiles.wordpress.org/tlamedia\">TLA Media</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tommcfarlin\">tommcfarlin</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/trishasalas\">trishasalas</a>, <a href=\"http://profiles.wordpress.org/mbmufffin\">Tyler Smith</a>, <a href=\"http://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/l10n\">Vladimir</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yonasy\">yonasy</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, and <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>. Also thanks to <a href=\"http://benmorrison.org/\">Ben Morrison</a> and <a href=\"http://christineswebb.com/\">Christine Webb</a> for help with the video.</p>\n<p>Thanks for choosing WordPress. See you soon for version 3.9!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://wordpress.org/news/2013/12/parker/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"3.8 RC2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"http://wordpress.org/news/2013/12/3-8-rc2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/news/2013/12/3-8-rc2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 01:08:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2805\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:343:\"Release candidate 2 of WordPress 3.8 is now available for download. This is the last pre-release, and we expect it to be effectively identical to what&#8217;s officially released to the public on Thursday. This means if you are a plugin or theme developer, start your engines! (If they&#8217;re not going already.) Lots of admin code [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1180:\"<p>Release candidate 2 of WordPress 3.8 is <a href=\"http://wordpress.org/wordpress-3.8-RC2.zip\">now available for download</a>. This is the last pre-release, and we expect it to be effectively identical to what&#8217;s officially released to the public on Thursday.</p>\n<p>This means if you are a plugin or theme developer, start your engines! (If they&#8217;re not going already.) Lots of admin code has changed so it&#8217;s especially important to see if your plugin works well within the new admin design and layout, and update <a href=\"http://wordpress.org/plugins/about/readme.txt\">the &#8220;Tested up to:&#8221; part of your plugin readme.txt</a>.</p>\n<p>If there is something in your plugin that you&#8217;re unable to fix, or if you think you&#8217;ve found a bug, join us <a href=\"http://codex.wordpress.org/IRC\">in #wordpress-dev in IRC</a>, especially if you&#8217;re able to join during the dev chat on Wednesday, or post in the <a href=\"http://wordpress.org/support/forum/alphabeta\">alpha/beta forum</a>. The developers and designers who worked on this release are happy to help anyone update their code before the 3.8 release.</p>\n<p>Happy hacking, everybody!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/news/2013/12/3-8-rc2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 3.8 RC1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/12/3-8-almost/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/news/2013/12/3-8-almost/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Dec 2013 09:54:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2760\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:345:\"We&#8217;re entering the quiet but busy part of a release, whittling down issues to bring you all of the new features you&#8217;re excited about with the stability you expect from WordPress. There are just a few days from the &#8220;code freeze&#8221; for our 3.8 release, which includes a number of exciting enhancements, so the focus [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1873:\"<p>We&#8217;re entering the quiet but busy part of a release, whittling down issues to bring you all of the new features you&#8217;re excited about with the stability you expect from WordPress. There are just a few days from the &#8220;code freeze&#8221; for our 3.8 release, <a href=\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/\">which includes a number of exciting enhancements</a>, so the focus is on identifying any major issues and resolving them as soon as possible.</p>\n<p>If you&#8217;ve ever wondered about how to contribute to WordPress, here&#8217;s a time you can: download this release candidate and use it in as many ways as you can imagine. Try to break it, and if you do, let us know how you did it so we can make sure it never happens again. If you work for a web host, this is the release you should test as much as possible and start getting your automatic upgrade systems and 1-click installers ready.</p>\n<p><a href=\"http://wordpress.org/wordpress-3.8-RC1.zip\">Download WordPress 3.8 RC1</a> (zip) or use the <a href=\"http://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;).</p>\n<p>If you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.8\">everything we’ve fixed</a> so far.</p>\n<p><em>We&#8217;re so close to the</em><br />\n<em>finish line, jump in and help</em><br />\n<em>good karma is yours.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/12/3-8-almost/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.8 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 21 Nov 2013 05:21:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2754\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:307:\"The first beta of the 3.8 is now available, and the next dates to watch out for are code freeze on December 5th and a final release on December 12th. 3.8 brings together several of the features as plugins projects and while this isn&#8217;t our first rodeo, expect this to be more beta than usual. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2236:\"<p>The first beta of the 3.8 is now available, and the next dates to watch out for are code freeze on December 5th and a final release on December 12th.</p>\n<p>3.8 brings together <a href=\"http://make.wordpress.org/core/features-as-plugins/\">several of the features as plugins projects</a> and while this isn&#8217;t our first rodeo, expect this to be more beta than usual. The headline things to test out in this release are:</p>\n<ul>\n<li>The new admin design, especially the responsive aspect of it. Try it out on different devices and browsers, see how it goes, especially the more complex pages like widgets or seldom-looked-at-places like Press This. Color schemes, which you can change on your profile, have also been spruced up.</li>\n<li>The dashboard homepage has been refreshed, poke and prod it.</li>\n<li>Choosing themes under Appearance is completely different, try to break it however possible.</li>\n<li>There&#8217;s a new default theme, Twenty Fourteen.</li>\n<li>Over 250 issues closed already.</li>\n</ul>\n<p>Given how many things in the admin have changed it&#8217;s extra super duper important to test as many plugins and themes with admin pages against the new stuff. Also if you&#8217;re a developer consider how you can make your admin interface fit the MP6 aesthetic better.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.8\">everything we’ve fixed</a> so far.</p>\n<p><a href=\"http://wordpress.org/wordpress-3.8-beta-1.zip\">Download WordPress 3.8 Beta 1</a> (zip) or use the <a href=\"http://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;).</p>\n<p><em>Alphabet soup of</em><br />\n<em>Plugins as features galore</em><br />\n<em>The future is here</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.7.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/10/wordpress-3-7-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2013/10/wordpress-3-7-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 29 Oct 2013 21:04:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2745\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:371:\"WordPress 3.7.1 is now available! This maintenance release addresses 11 bugs in WordPress 3.7, including: Images with captions no longer appear broken in the visual editor. Allow some sites running on old or poorly configured servers to continue to check for updates from WordPress.org. Avoid fatal errors with certain plugins that were incorrectly calling some [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1594:\"<p>WordPress 3.7.1 is now available! This maintenance release addresses 11 bugs in WordPress 3.7, including:</p>\n<ul>\n<li>Images with captions no longer appear broken in the visual editor.</li>\n<li>Allow some sites running on old or poorly configured servers to continue to check for updates from WordPress.org.</li>\n<li>Avoid fatal errors with certain plugins that were incorrectly calling some WordPress functions too early.</li>\n<li>Fix hierarchical sorting in get_pages(), exclusions in wp_list_categories(), and in_category() when called with empty values.</li>\n<li>Fix a warning that may occur in certain setups while performing a search, and a few other notices.</li>\n</ul>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.7.1\">list of tickets</a> and <a href=\"http://core.trac.wordpress.org/log/branches/3.7?stop_rev=25914&amp;rev=25986\">the changelog</a>.</p>\n<p>If you are one of the <a href=\"http://wordpress.org/download/counter/\">nearly two million</a> already running WordPress 3.7, we will start rolling out the all-new <a href=\"http://wordpress.org/news/2013/10/basie/\">automatic background updates</a> for WordPress 3.7.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.7.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p><em>Just a few fixes<br />\nYour new update attitude:<br />\nZero clicks given</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/wordpress-3-7-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.7 “Basie”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2013/10/basie/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/10/basie/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 22:35:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2736\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones: Updates while you sleep: With WordPress 3.7, you don&#8217;t have to lift a finger to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:17229:\"<p>Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of <a href=\"http://en.wikipedia.org/wiki/Count_basie\">Count Basie</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones:</p>\n<ul>\n<li><strong>Updates while you sleep</strong>: With WordPress 3.7, you don&#8217;t have to lift a finger to apply maintenance and security updates. Most sites are now able to automatically apply these updates in the background. The update process also has been made even more reliable and secure, with dozens of new checks and safeguards.</li>\n<li><strong>Stronger password recommendations</strong>: Your password is your site&#8217;s first line of defense. It&#8217;s best to create passwords that are complex, long, and unique. To that end, our password meter has been updated in WordPress 3.7 to recognize common mistakes that can weaken your password: dates, names, keyboard patterns (123456789), and even pop culture references.</li>\n<li><strong>Better global support</strong>: Localized versions of WordPress will receive faster and more complete translations. WordPress 3.7 adds support for automatically installing the right language files and keeping them up to date, a boon for the many millions who use WordPress in a language other than English.</li>\n</ul>\n<p>For developers there are lots of options around how to control the new updates feature, including allowing it to handle major upgrades as well as minor ones, more sophisticated date query support, and multisite improvements. As always, if you&#8217;re hungry for more <a href=\"http://codex.wordpress.org/Version_3.7\">dive into the Codex</a> or browse the <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.7\">over 400 closed tickets on Trac</a>.</p>\n<h3>A New Wave</h3>\n<p>This release was led by Andrew Nacin, backed up by Dion Hulse and Jon Cave. This is our first release using the new plugin-first development process, with a much shorter timeframe than in the past. (3.6 was released in August.) The 3.8 release, due in December, will continue this plugin-led development cycle that gives much more autonomy to plugin leads and allows us to decouple feature development from a release. You can follow this grand experiment, and what we&#8217;re learning from it, <a href=\"http://make.wordpress.org/core/\">on the make/core blog</a>. There are 211 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/technosailor\">Aaron Brazell</a>, <a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/andg\">andg</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/andrewspittle\">Andrew Spittle</a>, <a href=\"http://profiles.wordpress.org/askapache\">askapache</a>, <a href=\"http://profiles.wordpress.org/atimmer\">atimmer</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/beaulebens\">Beau Lebens</a>, <a href=\"http://profiles.wordpress.org/benmoody\">ben.moody</a>, <a href=\"http://profiles.wordpress.org/bhengh\">Ben Miller</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bftrick\">BFTrick</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/bmb\">bmb</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brianhogg\">brianhogg</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/charlesclarkson\">CharlesClarkson</a>, <a href=\"http://profiles.wordpress.org/chipbennett\">Chip Bennett</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisrudzki\">Chris Rudzki</a>, <a href=\"http://profiles.wordpress.org/aeg0125\">coderaaron</a>, <a href=\"http://profiles.wordpress.org/coenjacobs\">Coen Jacobs</a>, <a href=\"http://profiles.wordpress.org/crrobi01\">Colin Robinson</a>, <a href=\"http://profiles.wordpress.org/andreasnrb\">cyonite</a>, <a href=\"http://profiles.wordpress.org/daankortenbach\">Daan Kortenbach</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/convissor\">Daniel Convissor</a>, <a href=\"http://profiles.wordpress.org/dartiss\">dartiss</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/csixty4\">Dave Ross</a>, <a href=\"http://profiles.wordpress.org/davidjlaietta\">David Laietta</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/dllh\">dllh</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dpash\">dpash</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/dzver\">dzver</a>, <a href=\"http://profiles.wordpress.org/cais\">Edward Caissie</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faishal\">faishal</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/foofy\">Foofy</a>, <a href=\"http://profiles.wordpress.org/fjarrett\">Frankie Jarrett</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/gayadesign\">Gaya Kessler</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gizburdt\">Gizburdt</a>, <a href=\"http://profiles.wordpress.org/goldenapples\">goldenapples</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">gradyetc</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/webord\">Gustavo Bordoni</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/creativeinfusion\">itinerant</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jakubtyrcha\">jakub.tyrcha</a>, <a href=\"http://profiles.wordpress.org/jamescollins\">James Collins</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"http://profiles.wordpress.org/johnnyb\">John Beales</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn (johnbillion)</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/jchristopher\">Jonathan Christopher</a>, <a href=\"http://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jonlynch\">Jon Lynch</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/josephscott\">Joseph Scott</a>, <a href=\"http://profiles.wordpress.org/betzster\">Josh Betz</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/ketwaroo\">Ketwaroo</a>, <a href=\"http://profiles.wordpress.org/kevinb\">kevinB</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/koopersmith\">koopersmith</a>, <a href=\"http://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis (leewillis77)</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/layotte\">Lew Ayotte</a>, <a href=\"http://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"http://profiles.wordpress.org/iworks\">Marcin Pietrzak</a>, <a href=\"http://profiles.wordpress.org/cimmo\">Marco Cimmino</a>, <a href=\"http://profiles.wordpress.org/marco_teethgrinder\">Marco Galasso</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/tw2113\">Michael Beckwith</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/usermrpapa\">Mr Papa</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/naomicbush\">Naomi</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/natejacobs\">NateJacobs</a>, <a href=\"http://profiles.wordpress.org/nathanrice\">nathanrice</a>, <a href=\"http://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nickmomrik\">Nick Momrik</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/noahsilverstein\">noahsilverstein</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nukaga\">nukaga</a>, <a href=\"http://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"http://profiles.wordpress.org/butuzov\">Oleg Butuzov</a>, <a href=\"http://profiles.wordpress.org/paolal\">Paolo Belcastro</a>, <a href=\"http://profiles.wordpress.org/xparham\">Parham</a>, <a href=\"http://profiles.wordpress.org/pbiron\">Paul Biron</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/peterjaap\">peterjaap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/plocha\">plocha</a>, <a href=\"http://profiles.wordpress.org/pollett\">Pollett</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"http://profiles.wordpress.org/rasheed\">Rasheed Bydousi</a>, <a href=\"http://profiles.wordpress.org/raybernard\">RayBernard</a>, <a href=\"http://profiles.wordpress.org/rboren\">rboren</a>, <a href=\"http://profiles.wordpress.org/greuben\">Reuben Gunday</a>, <a href=\"http://profiles.wordpress.org/rfair404\">rfair404</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/r3df\">Rick Radko</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/wpmuguru\">Ron Rennick</a>, <a href=\"http://profiles.wordpress.org/rpattillo\">rpattillo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/hotchkissconsulting\">Sam Hotchkiss</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/scottsweb\">scottsweb</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/scruffian\">scruffian</a>, <a href=\"http://profiles.wordpress.org/tenpura\">Seisuke Kuraishi (tenpura)</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sillybean\">Stephanie Leary</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar (@netweb)</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/strangerstudios\">strangerstudios</a>, <a href=\"http://profiles.wordpress.org/sweetie089\">sweetie089</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">swissspidy</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tivnet\">tivnet</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/toscho\">toscho</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/sorich87\">Ulrich Sossou</a>, <a href=\"http://profiles.wordpress.org/vericgar\">vericgar</a>, <a href=\"http://profiles.wordpress.org/vinod-dalvi\">Vinod Dalvi</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wikicms\">wikicms</a>, <a href=\"http://profiles.wordpress.org/willnorris\">Will Norris</a>, <a href=\"http://profiles.wordpress.org/wojtekszkutnik\">Wojtek Szkutnik</a>, <a href=\"http://profiles.wordpress.org/wycks\">wycks</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p>Enjoy what may be one of your last few manual updates. See you soon for version 3.8!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/10/basie/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.7 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 00:05:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2729\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:417:\"The second release candidate of WordPress 3.7 is now available for testing! Those of you already testing WordPress 3.7 will be updated automatically to RC2. (Nice.) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”) or download the release candidate here (zip). Please post to the Alpha/Beta [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1183:\"<p>The second release candidate of WordPress 3.7 is now available for testing!</p>\n<p>Those of you already testing WordPress 3.7 will be updated automatically to RC2. (<em>Nice.</em>) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”) or <a href=\"http://wordpress.org/wordpress-3.7-RC2.zip\">download the release candidate here</a> (zip). Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a> if you think you&#8217;ve found a bug, and if any known issues are raised, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>Developers, please test your plugins and themes against WordPress 3.7. If there is a compatibility issue, let us know as soon as possible so we can deal with it before the final release.</p>\n<p>For more on WordPress 3.7, check out the <a href=\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\">announcement post for Release Candidate 1</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Upcoming WordCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 19:25:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2723\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:368:\"WordCamps are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3584:\"<p><a href=\"http://central.wordcamp.org/\">WordCamps</a> are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s over. If there&#8217;s one near you, check it out! In addition to getting to know your local WordPress community, most WordCamps attract some traveling visitors a well, giving you the chance to meet contributors to the WordPress open source project and <a href=\"http://make.wordpress.org/\">get involved</a> yourself.</p>\n<p>Here are the WordCamps on the schedule for the rest of this year.</p>\n<p>October 25-27: <strong><a href=\"http://2013.boston.wordcamp.org/\">WordCamp Boston</a></strong>, Boston, MA, USA<br />\nOctober 25-26: <strong><a href=\"http://2013.malaga.wordcamp.org/\">WordCamp Malaga</a></strong>, Spain<br />\nOctober 26: <strong><a href=\"http://2013.nepal.wordcamp.org/\">WordCamp Nepal</a></strong>, Kathmandu, Nepal<br />\nOctober 26: <strong><a href=\"http://2013.sofia.wordcamp.org/\">WordCamp Sofia</a></strong>, Bulgaria<br />\nNovember 7: <strong><a href=\"http://2013.capetown.wordcamp.org/\">WordCamp Cape Town</a></strong>, South Africa<br />\nNovember 9: <strong><a href=\"http://2013.porto.wordcamp.org/\">WordCamp Porto</a></strong>, Portugal<br />\nNovember 9-10: <strong><a href=\"http://2013.kenya.wordcamp.org/\">WordCamp Kenya</a></strong>, Nairobi, Kenya<br />\nNovember 15: <strong><a href=\"http://2013.edmonton.wordcamp.org/\">WordCamp Edmonton</a></strong>, AB, Canada<br />\nNovember 16-17: <strong><a href=\"http://2013.orlando.wordcamp.org/\">WordCamp Orlando</a></strong>, FL, USA<br />\nNovember 16: <strong><a href=\"http://2013.denver.wordcamp.org/\">WordCamp Denver</a></strong>, CO, USA<br />\nNovember 23-24: <strong><a href=\"http://2013.london.wordcamp.org/\">WordCamp London</a></strong>, UK<br />\nNovember 23-24: <strong><a href=\"http://2013.raleigh.wordcamp.org/\">WordCamp Raleigh</a></strong>, NC, USA<br />\nNovember 23: <strong><a href=\"http://2013.saopaulo.wordcamp.org/\">WordCamp São Paulo</a></strong>, Brazil<br />\nDecember 14: <strong><a href=\"http://2013.vegas.wordcamp.org/\">WordCamp Las Vegas</a></strong>, NV, USA<br />\nDecember 14-15: <strong><a href=\"http://2013.sevilla.wordcamp.org/\">WordCamp Sevilla</a></strong>, Spain</p>\n<p>No WordCamps on this list in your area? Not to worry! There are thriving <a href=\"http://wordpress.meetup.com/\">WordPress meetups</a> all over the world where you can meet like-minded people, and we maintain a library of <a href=\"http://wordpress.tv/category/wordcamptv/\">WordCamp videos</a> at <a href=\"http://wordpress.tv/\">WordPress.tv</a>.</p>\n<h3>Get Involved</h3>\n<ul>\n<li>If you&#8217;re interested in organizing a WordCamp in your area, check out our <a href=\"http://plan.wordcamp.org/\">WordCamp planning</a> site.</li>\n<li>If you&#8217;re interested in <a href=\"http://make.wordpress.org/community/meetup-interest-form/\">starting a WordPress meetup</a> in your area, let us know and we can set up a group on meetup.com for you.</li>\n<li>And speaking of WordCamp videos, we&#8217;ve recently enabled volunteer-generated subtitles/closed captioning of the videos on WordPress.tv to make them more accessible. Interested in helping? Check out the <a href=\"http://wordpress.tv/using-amara-org-to-caption-or-subtitle-a-wordpress-tv-video/\">WordPress.tv subtitling instructions</a>.</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.7 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 19:52:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2718\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:331:\"The first release candidate for WordPress 3.7 is now available! In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 next week, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2274:\"<p>The first release candidate for WordPress 3.7 is now available!</p>\n<p>In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>WordPress 3.7 introduces <strong>automatic background updates</strong> for security and minor releases (like updating from 3.7 to 3.7.1). These are really easy to test  — RC 1 will update every 12 hours or so to the latest development version, and then email you the results. (You may get two emails: one for debugging, and one all users of 3.7 will receive.) If something went wrong, you can report it.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 3.7 RC1, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.7-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what&#8217;s new in WordPress 3.7, visit the awesome About screen in your dashboard (<strong><img alt=\"\" src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" data-recalc-dims=\"1\" /> → About</strong> in the toolbar). There, you can also see if your install is eligible for background updates. WordPress won’t automatically update, for example, if you’re using version control like Subversion or Git.</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 3.7, so that if there is a compatibility issue, we can figure it out before the final release. Make sure you post any issues to the support forums.</p>\n<p><em>WordPress three seven</em><br />\n<em>A self-updating engine</em><br />\n<em>Lies beneath the hood</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Jan 2014 18:13:02 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 23 Jan 2014 20:54:06 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20140131180937\";}", "no");
INSERT INTO `wp_options` VALUES("529", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1391235182", "no");
INSERT INTO `wp_options` VALUES("530", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1391191982", "no");
INSERT INTO `wp_options` VALUES("531", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1391235182", "no");
INSERT INTO `wp_options` VALUES("532", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2014/01/wordpress-3-8-1/\' title=\'After six weeks and more than 9.3 million downloads of WordPress 3.8, we’re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query […]\'>WordPress 3.8.1 Maintenance Release</a> <span class=\"rss-date\">January 23, 2014</span><div class=\'rssSummary\'>After six weeks and more than 9.3 million downloads of WordPress 3.8, we’re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query […]</div></li><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/12/parker/\' title=\'Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you’ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. […]\'>WordPress 3.8 “Parker”</a> <span class=\"rss-date\">December 12, 2013</span><div class=\'rssSummary\'>Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you’ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. […]</div></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("533", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1391235183", "no");
INSERT INTO `wp_options` VALUES("534", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: How To Create A Dropdown Menu Of WordPress Categories Without Using Code\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15932\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:208:\"http://wptavern.com/how-to-create-a-dropdown-menu-of-wordpress-categories-without-using-code?utm_source=rss&utm_medium=rss&utm_campaign=how-to-create-a-dropdown-menu-of-wordpress-categories-without-using-code\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3167:\"<p>A long standing pain point I&#8217;ve had with WordPress is the inability to use the menu administration area to easily add a dropdown list of categories to my theme&#8217;s main menu. While the menu system provides the means to add categories to a menu, it doesn&#8217;t contain a way to easily create a dropdown list of categories. Thankfully, there is an easy work around that accomplishes the goal without using code. Thanks to <a title=\"https://foxnet-themes.fi/\" href=\"https://foxnet-themes.fi/\">Sami Keijonen</a> who told me about this technique on the <a title=\"http://themehybrid.com\" href=\"http://themehybrid.com\">ThemeHybrid support forums</a>.</p>\n<p>Start by browsing to <strong>Appearance &#8211; Menus</strong>. Select the menu where you want the link to be displayed. Create a new <strong>Link menu item</strong> and use <strong>#</strong> as the URL with the link text of categories. Then click the <strong>Add to Menu button</strong>.</p>\n<div id=\"attachment_15934\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/DropDownCategoriesTutorial.jpg\" rel=\"prettyphoto[15932]\"><img class=\"size-medium wp-image-15934\" alt=\"Creating The Placeholder\" src=\"http://wptavern.com/wp-content/uploads/2014/01/DropDownCategoriesTutorial-262x300.jpg\" width=\"262\" height=\"300\" /></a><p class=\"wp-caption-text\">Creating The Placeholder</p></div>\n<p>Select which categories you want to be displayed within the dropdown list. After you add the categories to the menu, make sure to drag and drop them so that they are a child link underneath the parent menu of categories. Look at the following screenshot for reference.</p>\n<div id=\"attachment_15936\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/DropDownCategoriesTutorial2.jpg\" rel=\"prettyphoto[15932]\"><img class=\"size-full wp-image-15936\" alt=\"Arranging The Menu Items\" src=\"http://wptavern.com/wp-content/uploads/2014/01/DropDownCategoriesTutorial2.jpg\" width=\"454\" height=\"256\" /></a><p class=\"wp-caption-text\">Arranging The Menu Items</p></div>\n<p>After you&#8217;ve arranged the category links, save the menu. Visit your front page and hover over the categories link to make sure the dropdown list works correctly. The parent menu item of categories acts as a placeholder which is the ingenious part of the tutorial.</p>\n<div id=\"attachment_15937\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/DropDownCategoriesTutorial3.jpg\" rel=\"prettyphoto[15932]\"><img class=\"size-full wp-image-15937\" alt=\"Drop Down List Of Categories\" src=\"http://wptavern.com/wp-content/uploads/2014/01/DropDownCategoriesTutorial3.jpg\" width=\"403\" height=\"264\" /></a><p class=\"wp-caption-text\">Drop Down Menu In Use</p></div>\n<p>By using this technique, I can modify which categories and what order they are displayed using the WordPress menu manager. I don&#8217;t have to worry about it disappearing via plugins or by switching themes. Thanks again to the always helpful, friendly, <a title=\"http://themehybrid.com/support/\" href=\"http://themehybrid.com/support/\">ThemeHybrid support forums</a> for this tip.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jan 2014 17:58:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Shortcode Suggest Helps You Discover Shortcodes in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15868\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:184:\"http://wptavern.com/shortcode-suggest-helps-you-discover-shortcodes-in-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=shortcode-suggest-helps-you-discover-shortcodes-in-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2217:\"<p>If you&#8217;re like me, you can never remember the shortcodes you have active on your WordPress site. This inevitably leads you to stop what you&#8217;re doing and hunt down the documentation for the feature you&#8217;re attempting to use. This is especially true when it&#8217;s a shortcode that can be configured with multiple attributes.  </p>\n<p>What if there was a way to make shortcodes more discoverable in the post editor? That&#8217;s exactly what <a href=\"http://scott.ee/\" target=\"_blank\">Scott Evans</a> has attempted to do in his <a href=\"https://github.com/scottsweb/shortcode-suggest/\" target=\"_blank\">Shortcode Suggest</a> plugin. When activated, this plugin adds autosuggest for shortcodes as you type in the visual editor. It also includes a short description of the shortcodes it detects.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/shortcodes.png\" rel=\"prettyphoto[15868]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/shortcodes.png\" alt=\"shortcodes\" width=\"1459\" height=\"997\" class=\"aligncenter size-full wp-image-15871\" /></a></p>\n<p>As of right now, the plugin is a rough concept that Evans put on github in order to gauge interest and collect feedback. In the future, he plans to improve the design of the suggestions and only load the plugin on the required post types and admin screens. Shortcode Suggest only works on the visual editor but Evans is considering enabling it for the HTML editor, depending on feedback.</p>\n<p>If there was a more standard approach to including shortcode attributes within inline docs, Evans says the plugin would be even more useful. As it is, there may be some gaps where the information is incomplete.</p>\n<p>Shortcodes are popular because they provide an easy and approachable method for users to embed complex functionality within content. However, there&#8217;s no easy way to know what shortcodes are available to your installation. Shortcode Suggest provides a nice solution for this. Download it from <a href=\"https://github.com/scottsweb/shortcode-suggest/\" target=\"_blank\">github</a> and take it for a test drive. Is this a plugin that you&#8217;d like to see further developed? What would make it more useful?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jan 2014 06:52:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Major Update To WordPress For iOS Now Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15858\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"http://wptavern.com/major-update-to-wordpress-for-ios-now-available?utm_source=rss&utm_medium=rss&utm_campaign=major-update-to-wordpress-for-ios-now-available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3269:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2010/08/wordpressIOSlogo.png\" rel=\"prettyphoto[15858]\"><img src=\"http://wptavern.com/wp-content/uploads/2010/08/wordpressIOSlogo.png\" alt=\"WordPress for iOS Banner\" width=\"264\" height=\"37\" class=\"alignright size-full wp-image-4346\" /></a> WordPress for iOS 3.9 <a title=\"http://ios.wordpress.org/2014/01/30/wordpress-for-ios-3-9-released/\" href=\"http://ios.wordpress.org/2014/01/30/wordpress-for-ios-3-9-released/\">has been released</a> and it includes some major changes. The first thing you&#8217;ll notice is that the&nbsp; sidebar navigation has been removed. In its place is a tab bar-based layout. This has enabled many other visual changes throughout the app. Reader, comments, and notifications have been revamped. My favorite feature in this update is seamless inline commenting. This addition makes replying to comments feel like text messaging. Keep in mind that from version 3.9 onwards will require iOS7.</p>\n<h3>My Thoughts On 3.9</h3>\n<p>I&#8217;ve upgraded the app on my iPhone 5 and without the sidebar navigation, I feel lost. The first screen that loads is Reader. From here, I have no idea what to do or where to go to access my connected sites. This is a drastic interface change that should have had a tour attached to it. I&#8217;d like to see a welcome screen or helpers added to WordPress for iOS so the feeling people get when they upgrade is not confusion or frustration. After a few minutes of using the new interface, I was able to locate my connected sites. To find your connected sites select the <strong>Me button</strong> on the bottom of the app.</p>\n<div id=\"attachment_15862\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/WPEditoriOS7.png\" rel=\"prettyphoto[15858]\"><img class=\"size-large wp-image-15862\" alt=\"WordPress Post Editor In iOS7\" src=\"http://wptavern.com/wp-content/uploads/2014/01/WPEditoriOS7-281x500.png\" width=\"281\" height=\"500\" /></a><p class=\"wp-caption-text\">Simple Post Editor</p></div>\n<p>Once I was comfortable navigating, I was able to appreciate the speed and responsiveness of the app. Some of this is due to the hardware within the iPhone 5. Regardless, the app is fast! I appreciate how big the Gravatars are on the comments and notifications pages. Thanks to the extra height on the iPhone 5, writing a post is easier than it was on my iPhone 4. The post editor is amazingly simple. Post title at the top, content underneath with the keyboard at the bottom. This layout works great. I like how the meta data entries are on a separate screen which enables the post editor to remain simple.</p>\n<h3>Solid Update</h3>\n<p>Overall this is a solid update. Congrats to the team and thanks to all of the contributors that helped make WordPress for iOS 3.9 a reality. If you would like to get involved with WordPress for iOS development, drop them a line at&nbsp;<a href=\"http://make.wordpress.org/mobile\">make.wordpress.org/mobile</a>&nbsp;and grab a copy of the code at&nbsp;<a href=\"http://github.com/wordpress-mobile/WordPress-iOS\">github.com/wordpress-mobile/WordPress-iOS</a>. You can also provide feedback and follow progress via their Twitter account <a href=\"https://twitter.com/WordPressiOS\">@WordPressiOS</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jan 2014 00:06:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: Why Post By Email Is Still Available In WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15745\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:162:\"http://wptavern.com/why-post-by-email-is-still-available-in-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=why-post-by-email-is-still-available-in-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3355:\"<p>It&#8217;s that time of year again. The process of <a title=\"http://make.wordpress.org/core/2014/01/29/gsoc-2014\" href=\"http://make.wordpress.org/core/2014/01/29/gsoc-2014\">finding mentors, projects, and students</a> is underway for the 2014 edition of the <a title=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2014\" href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2014\">Google Summer of Code</a>. One of the successful projects from last years event is the <a title=\"http://wordpress.org/plugins/post-by-email/\" href=\"http://wordpress.org/plugins/post-by-email/\">Post by Email plugin</a> by Kat Hagan. The plugin was supposed to <a title=\"http://wptavern.com/wordpress-3-7-to-remove-post-by-email-feature-in-favor-of-official-plugin\" href=\"http://wptavern.com/wordpress-3-7-to-remove-post-by-email-feature-in-favor-of-official-plugin\">replace the feature</a> in WordPress 3.7.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/PostByEmailFeaturedImage.jpg\" rel=\"prettyphoto[15745]\"><img class=\"aligncenter size-large wp-image-15750\" alt=\"Post By Email\" src=\"http://wptavern.com/wp-content/uploads/2014/01/PostByEmailFeaturedImage-500x153.jpg\" width=\"500\" height=\"153\" /></a></p>\n<p>I reached out to WordPress core developer Andrew Nacin to find out if the feature will be removed from WordPress sometime soon and whether Kat&#8217;s plugin was a source of the delay. One thing is certain, the feature will be removed.</p>\n<blockquote><p>There were some nagging concerns that outright removing the feature from core could inconvenience users who still rely on it. That doesn&#8217;t detract from Kat&#8217;s work at all. Her plugin is fantastic and it&#8217;s definitely a huge improvement over what&#8217;s in core now. It was never designed to be pulled into core, but rather to provide us an opportunity to remove what&#8217;s in core now.</p></blockquote>\n<p>Removing post by email presents a number of challenges. This will be the first time a feature is removed from core and substituted by a plugin. The team is still working on a plan of action.</p>\n<blockquote><p>In order to make the transition graceful, should we, say, download, activate, and set up Kat&#8217;s plugin when updating to WordPress 3.9? Or we could remove it but if they had it configured, point them toward the plugin. Or, at the very least, we could keep it functional, hiding the UI for new and existing installs unless they already had it configured. So there&#8217;s a bit more UX decision-making that has to happen there, but it&#8217;s on the table.</p></blockquote>\n<p>While WordPress is accustomed to merging plugins into core, this is the opposite situation. If I don&#8217;t have the post by email functionality configured in WordPress, I hope that it&#8217;s detected and the code is removed without adding the plugin to my install. It&#8217;s easy enough to delete it but I&#8217;d rather not go through the process. It will be interesting to see how this is handled and if the results are satisfactory, it may pave the way for something similar to happen with the <a title=\"http://codex.wordpress.org/Links_Manager\" href=\"http://codex.wordpress.org/Links_Manager\">Link Manager</a> that was hidden from view in WordPress 3.5</p>\n<p>How do you propose this feature be removed with as little hassle to end users as possible?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 22:30:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WP iPhone: WordPress for iOS 3.9 Released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://ios.wordpress.org/?p=1528\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://ios.wordpress.org/2014/01/30/wordpress-for-ios-3-9-released/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2765:\"<p><img class=\"aligncenter size-full wp-image-1531\" alt=\"ios-39\" src=\"http://wpiphone.files.wordpress.com/2014/01/ios-39.jpg\" /></p>\n<p>WordPress for iOS 3.9 is out and now available to download from the App Store. This release is one of our largest app releases to date. This update is remarkable both for the significant changes we’ve introduced, and for the level of dedication it received from our hard-working team members.</p>\n<p>Version 3.9 includes a major visual redesign of the app. We decided to drop the sidebar navigation and embrace a tab bar-based layout. The app’s new design allowed us to add numerous visual improvements throughout, including revamped and enhanced Reader, Comments, and Notifications sections. We also created a seamless inline commenting experience to make it easier for you to engage with the content you love. Finally, we made visual improvements to the editing experience of posts and pages.</p>\n<p>Our team has embraced the latest and greatest technologies that Apple has provided us with iOS 7 to deliver you the best app possible. Version 3.9 and future updates will require iOS 7.</p>\n<p>The app also includes several other changes. On top of various bug fixes and performance improvements, it now supports deep-linking from Twitter, and features an improved login screen. Be sure to try it out.</p>\n<p>A huge thanks to the contributors who worked on this release: <a href=\"https://github.com/pivotal-rebecca\">@pivotal-rebecca</a>, <a href=\"https://github.com/mikejohnstn\">@mikejohnstn</a>, <a href=\"https://github.com/aerych\">@aerych</a>, <a href=\"https://github.com/h4xnoodle\">@h4xnoodle</a>, <a href=\"https://github.com/astralbodies\">@astralbodies</a>, <a href=\"https://github.com/tomwitkin\">@tomwitkin</a>, <a href=\"https://github.com/irbrad\">@irbrad</a>, <a href=\"https://github.com/beaucollins\">@beaucollins</a>,<a href=\"https://github.com/koke\">@koke</a>, <a href=\"https://github.com/intoxicated\">@intoxicated</a></p>\n<p>If you would like to get involved with WordPress for iOS development, drop us a line at <a href=\"http://make.wordpress.org/mobile\">make.wordpress.org/mobile</a> and grab a copy of the code at <a href=\"http://github.com/wordpress-mobile/WordPress-iOS\">github.com/wordpress-mobile/WordPress-iOS</a>.</p>\n<p>Have feedback? Leave a comment below or tweet us <a href=\"https://twitter.com/WordPressiOS\">@WordPressiOS</a></p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wpiphone.wordpress.com/1528/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wpiphone.wordpress.com/1528/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=ios.wordpress.org&blog=3882653&post=1528&subd=wpiphone&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 22:19:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Sendhil\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: Audio/Video 2.0 Project Aims to Improve WordPress Core Multimedia Support\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=14537\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:220:\"http://wptavern.com/new-disco-fries-project-aims-to-improve-wordpress-core-audio-and-video-support?utm_source=rss&utm_medium=rss&utm_campaign=new-disco-fries-project-aims-to-improve-wordpress-core-audio-and-video-support\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4046:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/wp-audio.jpg\" rel=\"prettyphoto[14537]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/wp-audio.jpg\" alt=\"wp-audio\" width=\"816\" height=\"377\" class=\"aligncenter size-full wp-image-15827\" /></a><br />\nWordPress 3.6 introduced <a href=\"http://make.wordpress.org/core/2013/04/08/audio-video-support-in-core/\" target=\"_blank\">native support for audio and video files</a> which meant that you no longer need to add a plugin in order to play multimedia files hosted in your media library. A new group, led by <a href=\"http://make.wordpress.org/core/author/wonderboymusic/\" target=\"_blank\">Scott Taylor</a> under the project code name &#8220;Disco Fries,&#8221; has set out to continue iterating on this feature. </p>\n<p>Taylor said the goal of project Disco Fries is &#8220;to continue to modernize Media and give our huge user base even more ways to display and manage their content.&#8221; The group is working on adding and improving support for MediaElement.js, Backbone, and Underscore to bring WordPress media into the future.  Here are a few of the highlights of what the team is currently working on:</p>\n<ul>\n<li>Replace media file type icons with Dashicons</li>\n<li><a href=\"https://core.trac.wordpress.org/ticket/26870\" target=\"_blank\">Documentation of media code</a> &#8211; Add (JSDoc)umentation to the Backbone-centric Media files</li>\n<li><a href=\"https://core.trac.wordpress.org/ticket/26825\" target=\"_blank\">Metadata Regeneration for audio/video</a> &#8211; ability to generate on-demand</li>\n<li>Add &#8220;Playlist&#8221; and &#8220;Video Playlist&#8221; <a href=\"https://core.trac.wordpress.org/ticket/26631\" target=\"_blank\">shortcodes</a></li>\n<li>Consolidate handling of object, audio and video tags in <a href=\"https://core.trac.wordpress.org/ticket/26864\" target=\"_blank\">wpautop()</a></li>\n<li>Placeholders (TinyMCE views) for Audio / Video shortcodes</li>\n<li>Support mediaelement.js YouTube sources in the video shortcode</li>\n</ul>\n<p>Many of these are are subtle or otherwise invisible changes to users in general, as in the case of documenting the Backbone files. The most visible changes are placeholders in the visual editor and the capability to add audio/video playlists via shortcode. </p>\n<div id=\"attachment_15846\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/placeholders.png\" rel=\"prettyphoto[14537]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/placeholders.png\" alt=\"Audio/Video placeholders in the visual editor\" width=\"567\" height=\"530\" class=\"size-full wp-image-15846\" /></a><p class=\"wp-caption-text\">Audio/Video placeholders in the visual editor</p></div>\n<p>Taylor shared some of the progress on the playlists in an <a href=\"http://make.wordpress.org/core/2014/01/29/audiovideo-2-0-update/\" target=\"_blank\">update</a> on make.wordpress.org/core. He created a basic UI for playlists with minimal HTML and CSS that should inherit the styles of the active theme. Here&#8217;s an example of how that looks with the Twenty Fourteen theme:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/twenty-fourteen-audio-playlist.png\" rel=\"prettyphoto[14537]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/twenty-fourteen-audio-playlist.png\" alt=\"twenty-fourteen-audio-playlist\" width=\"536\" height=\"392\" class=\"aligncenter size-full wp-image-15836\" /></a></p>\n<p>The prospect of soon having native audio and video playlists in the core is very exciting.  While oEmbed support for playing multimedia files is excellent, WordPress has been lagging behind in the ability to play files located in its own media library. With these new updates, WordPress users who frequently post media files will have the option to eliminate the plugins they previously depended on for playback. To check in on the progress of the Disco Fries project, check out the new core <a href=\"http://make.wordpress.org/core/components/media/\" target=\"_blank\">Media component</a> page for an overview.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 22:04:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WP Android: Now Available: New Reader, Easier Setup and Improved UI\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://android.wordpress.org/?p=965\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://android.wordpress.org/2014/01/30/2-6-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2849:\"<p><img src=\"http://wpandroid.files.wordpress.com/2014/01/android26.png?w=840&h=560\" alt=\"WordPress for Android 2.6\" width=\"840\" height=\"560\" class=\"alignnone size-full wp-image-966\" /></p>\n<p>The latest update to WordPress for Android includes a new reading and setup experience, as well as significant updates to the user interface. Here are some of the highlights of this release.</p>\n<h2>New Reader</h2>\n<p>The app Reader has been completely redesigned, and now provides a much-improved, native reading experience. You’ll definitely notice its speed — posts appear in a snap, and images fade in as they load. You can also view users that have commented or liked posts, as well as edit the list of tags that you follow. We’ve revamped the like, reblog, and comment interfaces to make it easier than ever to respond to posts that strike your fancy.</p>\n<h2>Redesigned Blog Setup</h2>\n<p>When signing in to the app or creating an account on WordPress.com, you’ll notice a brand new user interface that makes it super-simple to start blogging. If you keep multiple blogs on your account, they will all be automatically added for you. You can also hide whichever blogs you don’t wish to work on in the app.</p>\n<h2>UI Improvements</h2>\n<p>We’ve given the app a facelift, including a new color scheme, a refined navigation drawer layout, and sharp-looking lists in notifications, posts, pages and comments.</p>\n<p>You’ll also notice some changes to the post editor, with larger images and a new Post Settings area where you’ll manage post data such as status, post formats, and categories, among others. The post content area will now go full screen while you are editing, to give you maximum space to focus on your content. Give the app a try here:</p>\n<p>Download the update today from <a href=\"https://play.google.com/store/apps/details?id=org.wordpress.android\">Google Play</a>.</p>\n<h2>What’s next?</h2>\n<p>A big thanks to all of the contributors who worked so hard on this release: <a href=\"https://github.com/aerych\">aerych</a>, <a href=\"https://github.com/daniloercoli\">daniloercoli</a>, <a href=\"https://github.com/Jason-Chen\">Jason-Chen</a>, <a href=\"https://github.com/maxme\">maxme</a>, <a href=\"https://github.com/nbradbury\">nbradbury</a> and <a href=\"https://github.com/roundhill\">roundhill</a>!</p>\n<p>The mobile team isn’t stopping here! We have pretty big plans for the months to come and the rest of 2014. You can keep up with the development progress over at <a href=\"http://make.wordpress.org/mobile\" rel=\"nofollow\">http://make.wordpress.org/mobile</a>. You can also follow the app on twitter <a href=\"http://twitter.com/wpandroid\">@WPAndroid</a>.</p><img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=android.wordpress.org&blog=9426921&post=965&subd=wpandroid&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 19:02:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:3:\"Dan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Alex King: RAMP v 1.4.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=19358\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://alexking.org/blog/2014/01/30/ramp-v-1-4-4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1449:\"<p>We&#8217;ve pushed out a few new versions of RAMP recently, addressing:</p>\n<ul>\n<li><a href=\"http://crowdfavorite.com/blog/2014/01/ramp-v1-4-4/\">v1.4.4</a> More obvious error messages when media fails to transfer</li>\n<li><a href=\"http://crowdfavorite.com/blog/2014/01/ramp-v1-4-3/\">v1.4.3</a> and <a href=\"http://crowdfavorite.com/blog/2014/01/ramp-v1-4-2/\">v1.4.2</a> both address issues with backslashes being removed from content. I&#8217;ve written about <a href=\"http://alexking.org/blog/thread/wordpress-slashes\">this issue</a> ad nauseum, but RAMP was originally written before the issue was discovered. If my patches had gone through, RAMP would have been silently fixed. Instead, we needed to patch it to match the insane WordPress core behavior (adding slashes to things before saving them).</li>\n</ul>\n<p>Anyway &#8211; a few nice recent changes to make RAMP better! We&#8217;ve also added additional customer documentation around troubleshooting various issues, something we intend to continue to expand.</p>\n<p class=\"threads-post-notice\">This post is part of the thread: <a href=\"http://alexking.org/blog/thread/wordpress-slashes\">WordPress Slashes</a> &#8211; an ongoing story on this site. View the thread timeline for more context on this post.</p>\n<p class=\"threads-post-notice\">This post is part of the project: <a href=\"http://alexking.org/project/ramp\">RAMP</a>. View the project timeline for more context on this post.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 19:00:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: BuddyPress 2.0 To Add Profile Editing in the WordPress Admin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15511\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:184:\"http://wptavern.com/buddypress-2-0-to-add-profile-editing-in-the-wordpress-admin?utm_source=rss&utm_medium=rss&utm_campaign=buddypress-2-0-to-add-profile-editing-in-the-wordpress-admin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4270:\"<p>BuddyPress 2.0 is underway and an exciting new feature is in the works. This next release will <a href=\"https://buddypress.trac.wordpress.org/ticket/5197\" target=\"_blank\">add profile editing to the WordPress admin</a>. Navigating to the admin Users screen and clicking on &#8220;profile&#8221; will take you to a new &#8220;Community Profile&#8221; tab for backend profile management.</p>\n<div id=\"attachment_15795\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/community-profile.png\" rel=\"prettyphoto[15511]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/community-profile.png\" alt=\"New Community Profile Tab\" width=\"1257\" height=\"955\" class=\"size-full wp-image-15795\" /></a><p class=\"wp-caption-text\">New Community Profile Tab</p></div>\n<p>In addition to editing profile fields, this new screen allows administrators to quickly mark a user as &#8220;Active&#8221; or &#8220;Spammer,&#8221; delete the avatar and view member stats.</p>\n<p>The code for this feature has already <a href=\"https://buddypress.trac.wordpress.org/changeset/7764\" target=\"_blank\">landed</a> in the BuddyPress trunk and core developers plan to iterate on it throughout the 2.0 cycle. Profile editing adds the following to BuddyPress:</p>\n<ul>\n<li>New bp-members-admin.php and accompanying assets to handle the initial admin page creation (outside of XProfile).</li>\n<li>New stats template functions in Blogs, Friends, and Groups components, to provide additional meta data about a members community involvement.</li>\n<li>Modifies some existing XProfile admin/template/filters to make it more accommodating to querying for profile data outside of BuddyPress&#8217;s traditional displayed_user context.</li>\n</ul>\n<p>The new Community Profile tab should save administrators quite a bit of time when managing their communities, since they won&#8217;t have to switch to the front end to view profiles. Sometimes it isn&#8217;t clear if a user is a spammer and having a quick way to view profiles in the backend helps to clarify that, especially with the addition of community involvement stats for each member. This feature is enabled by default for administrators only. Further down the road, this setting may be something that can be <a href=\"https://buddypress.trac.wordpress.org/ticket/5197#comment:3\" target=\"_blank\">turned on for non-admins via a filter</a>, but that has not yet been implemented. </p>\n<h3>Roadmap For BuddyPress 2.0</h3>\n<p>The features that are currently under active development for the <a href=\"https://buddypress.trac.wordpress.org/milestone/2.0\" target=\"_blank\">BuddyPress 2.0 milestone</a> include:</p>\n<ul>\n<li>bp-forums <a href=\"https://buddypress.trac.wordpress.org/ticket/5351\" target=\"_blank\">retirement</a></li>\n<li>WordPress Rewrite Rules API <a href=\"https://buddypress.trac.wordpress.org/ticket/4954\" target=\"_blank\">integration</a></li>\n<li><a href=\"https://buddypress.trac.wordpress.org/ticket/5352\" target=\"_blank\">Move XProfile visibility</a> from each field into Settings</li>\n<li>last_activity usermeta <a href=\"https://buddypress.trac.wordpress.org/ticket/5128\" target=\"_blank\">improvements</a></li>\n<li>Activity comment sync for comments</li>\n<li>Ticket triage and general maintenance</li>\n<li>New <a href=\"https://buddypress.trac.wordpress.org/ticket/4952\" target=\"_blank\">template pack</a></li>\n</ul>\n<p>Additionally, Boone Gorges has been working on <a href=\"https://buddypress.trac.wordpress.org/ticket/5349\" target=\"_blank\">refactoring the Activity query</a> to improve BuddyPress performance. He hopes to implement persistent caching for individual activity items before BuddyPress 2.0 is released. &#8220;It&#8217;ll be a good test case for spreading some individual object caching throughout the rest of the components,&#8221; he said. This should help to provide a little boost for any BuddyPress sites that make use of object caching. </p>\n<p>Results of the most recent <a href=\"http://wptavern.com/help-shape-buddypress-development-in-2014\" target=\"_blank\">BuddyPress development survey</a> should be available early next week. An exact date has not yet been set for the 2.0 release but it should drop sometime in March. The dates will be finalized at the next development meeting.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 18:20:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WPTavern: How To Create A Platform Agnostic Favicon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15757\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:146:\"http://wptavern.com/how-to-create-a-platform-agnostic-favicon?utm_source=rss&utm_medium=rss&utm_campaign=how-to-create-a-platform-agnostic-favicon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5396:\"<p>Remember <a href=\"http://en.wikipedia.org/wiki/Favicon\" title=\"http://en.wikipedia.org/wiki/Favicon\">favicons</a>? Those cute 16&#215;16 pixel images that are used to quickly locate a site when multiple browser tabs are opened. According to Philippe Bernard, favicons are not mobile friendly nor do they look good on mobile platforms by default. That&#8217;s why he created <a href=\"http://realfavicongenerator.net/\" title=\"http://realfavicongenerator.net/\">RealFaviconGenerator.net</a>. The site generates favicons that look good in all major browsers and platforms. </p>\n<p>To get started, make sure you have a square image that is at least <strong>260&#215;260</strong> pixels in size for optimal results. In this tutorial, I&#8217;ll be using the WordPress Tavern beer mug. After you&#8217;ve uploaded your image, you&#8217;ll see a screen that gives you the ability to edit how the image will look on iOS and Android. Transparent icons don&#8217;t look very good on iOS devices so consider adding a background color. You can also configure the image to not touch the inside borders of the icon. </p>\n<div id=\"attachment_15760\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/FaviconForAppleAndroid.jpg\" rel=\"prettyphoto[15757]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/FaviconForAppleAndroid-500x184.jpg\" alt=\"Favicon For Apple And Android\" width=\"500\" height=\"184\" class=\"size-large wp-image-15760\" /></a><p class=\"wp-caption-text\">Customize How The Icon Will Look</p></div>\n<p>Since the beer mug is black, it didn&#8217;t look good against any of the Windows 8 tile colors. Thankfully, the generator provides an option to use a saturated version of the logo. This option changed the mug from black to white. The white beer mug is compatible with just about every tile color available. </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/FaviconWindowsTile.jpg\" rel=\"prettyphoto[15757]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/FaviconWindowsTile-500x148.jpg\" alt=\"Windows 8 Favicon Tile\" width=\"500\" height=\"148\" class=\"aligncenter size-large wp-image-15762\" /></a></p>\n<p>Once you&#8217;re satisfied with the images, tell the generator how you&#8217;ll apply them to your website. On the following page, you&#8217;ll be given a link to download a Favicon package. Within this package are your compressed and uncompressed images along with a browser config XML file that is used by Windows 8. You&#8217;ll need to upload the contents of the package to the websites root folder. Last but not least, copy the code provided to you and paste it within your sites <code>head</code> section. If you&#8217;re using a Stargazer child theme, you&#8217;ll find the <code>head</code> section within <strong>header.php</strong>. After you&#8217;ve uploaded all of the files and made the change to header.php, use their favicon checker provided by their site to see if everything checks out ok. </p>\n<h3>The Significance Of These Images</h3>\n<p>I was unaware of the fact that WPTavern doesn&#8217;t look nice when added as a bookmark to the home screen of iOS devices. The next two images show what it looked like before and after using the favicon generator. </p>\n<p><div id=\"attachment_15780\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/BeforeFaviconGenerator.jpg\" rel=\"prettyphoto[15757]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/BeforeFaviconGenerator.jpg\" alt=\"Before Favicon Generator\" width=\"274\" height=\"152\" class=\"size-full wp-image-15780\" /></a><p class=\"wp-caption-text\">Before</p></div> <div id=\"attachment_15779\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/AfterFaviconGenerator.jpg\" rel=\"prettyphoto[15757]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/AfterFaviconGenerator.jpg\" alt=\"After Favicon Generator\" width=\"184\" height=\"96\" class=\"size-full wp-image-15779\" /></a><p class=\"wp-caption-text\">After</p></div></p>\n<p>As you can see, by having an image specifically for iOS devices, WPTavern looks like a native app. It&#8217;s really just a bookmark. Since the site has a responsive design, it might as well be an app! We&#8217;ve already had compliments on the improvement. </p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p><a href=\"https://twitter.com/wptavern\">@wptavern</a> <a href=\"https://twitter.com/petyeah\">@petyeah</a> Looks much better as the fav icon that’s for sure. I agree the mug could be just a shade larger though!</p>\n<p>&mdash; Chris Black (@ThatChrisBlack) <a href=\"https://twitter.com/ThatChrisBlack/statuses/428685542574673920\">January 30, 2014</a></p></blockquote>\n<p></p>\n<p>As for the size of the mug, we&#8217;re working on it.</p>\n<h3>Little Work Equals Big Gains</h3>\n<p>I thought <a href=\"http://realfavicongenerator.net/\" title=\"http://realfavicongenerator.net/\">Realfavicongenerator</a> was just another typical generator looking for traffic but by going through this exercise, I was able to improve the way WPTavern looks across multiple platforms when users save the site to their home screen. The site is free and I encourage you to give it a try. I&#8217;d also like to hear from experienced theme designers to see what they think of the code generated by the site. Is there a way to achieve the same results with more efficient code? </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 14:00:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: WordPress Trac Gets New Core Components Overview Page for Filtering Tickets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15747\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:214:\"http://wptavern.com/wordpress-trac-gets-new-core-components-overview-page-for-filtering-tickets?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-trac-gets-new-core-components-overview-page-for-filtering-tickets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2113:\"<p>The exciting news today in WordPress core development is a shiny new <a href=\"http://make.wordpress.org/core/components/\" target=\"_blank\">core/components</a> page that presents an organized overview of open Trac tickets for each component. Nacin announced the new feature today during the #wordpress-dev IRC meeting, which delighted many core contributors in attendance. The page breaks down 34 top-level components with two dozen subcomponents.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/core-components.jpg\" rel=\"prettyphoto[15747]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/core-components.jpg\" alt=\"core-components\" width=\"666\" height=\"710\" class=\"aligncenter size-full wp-image-15761\" /></a></p>\n<p>When you further navigate to a component page, you&#8217;ll see any subcomponents linked at the top, along with a description, and any recent <a href=\"http://make.wordpress.org/\" target=\"_blank\">make.wordpress.org</a> blog posts. Below the open ticket summary is a list of tickets with no replies and tickets slated for the next major milestone. At the bottom you&#8217;ll find a list of the component&#8217;s maintainers.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/formatting-component.jpg\" rel=\"prettyphoto[15747]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/formatting-component.jpg\" alt=\"formatting-component\" width=\"730\" height=\"698\" class=\"aligncenter size-full wp-image-15766\" /></a></p>\n<p>Trac has been <a href=\"http://make.wordpress.org/core/2014/01/27/proposed-trac-component-reorganization/\" target=\"_blank\">completely reorganized</a> into a few dozen components. The purpose behind the reorganization and the <a href=\"http://make.wordpress.org/core/components/\" target=\"_blank\">overview page</a> is to help better classify tickets and streamline contributions. Contributors with a particular area of interest are able to instantly drill down to open tickets within that component. Nacin plans to add component-based notifications by the end of the week, so you can subscribe to any components where you have an interest. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Jan 2014 00:30:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: Create Stylish Surveys Easily With Typeform\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15695\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"http://wptavern.com/create-stylish-surveys-easily-with-typeform?utm_source=rss&utm_medium=rss&utm_campaign=create-stylish-surveys-easily-with-typeform\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3220:\"<p><a title=\"https://www.typeform.com/\" href=\"https://www.typeform.com/\">Typeform</a> is a brand new free service that makes it easy to create stylish forms. The interface reminds me of <a title=\"http://www.gravityforms.com/\" href=\"http://www.gravityforms.com/\">GravityForms</a>. Field types are located on the left part of the screen while the form structure is on the right. There are a myriad of field types ranging from dropdown boxes to multiple choice questions.</p>\n<p>One draw back I immediately discovered is that if you don&#8217;t drag and drop the fields into the form, they won&#8217;t be saved. This was frustrating because I initially just clicked on the fields, configured them, then clicked the save button only to discover they were not added to the form. Both methods should be available.</p>\n<div id=\"attachment_15697\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/TypeFormFieldsandLayout.jpg\" rel=\"prettyphoto[15695]\"><img class=\"size-large wp-image-15697\" alt=\"Typeform Fields And Layout\" src=\"http://wptavern.com/wp-content/uploads/2014/01/TypeFormFieldsandLayout-500x239.jpg\" width=\"500\" height=\"239\" /></a><p class=\"wp-caption-text\">Field Types On The Left, Layout On The Right</p></div>\n<p>Typeform supplies a variety of pre-made themes and color schemes to add visual style. Once the form is finished, there are a few different ways to distribute it.</p>\n<ul>\n<li>Direct link to Typeform</li>\n<li>Launch in a popup window</li>\n<li>Embed in a webpage</li>\n</ul>\n<p>If you opt to embed the form into a post, you&#8217;ll need to decide whether you want to embed as a widget or a full page. Typeforms are automatically responsive and can be used on touch devices. They also provide users a stats area to measure metrics so you can keep tabs on how well it&#8217;s performing.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/TypeFormMetrics.jpg\" rel=\"prettyphoto[15695]\"><img class=\"aligncenter size-large wp-image-15699\" alt=\"Typeform Metrics\" src=\"http://wptavern.com/wp-content/uploads/2014/01/TypeFormMetrics-500x262.jpg\" width=\"500\" height=\"262\" /></a></p>\n<p>The service is free to try while it&#8217;s in Beta. According to a <a title=\"http://hellotypeform.tumblr.com/post/68472467781/typeform-is-leaving-beta-soon-pricing-revealed#.UukzurRjbvk\" href=\"http://hellotypeform.tumblr.com/post/68472467781/typeform-is-leaving-beta-soon-pricing-revealed#.UukzurRjbvk\">recent blog post</a>, the beta period will be ending near <strong>February 12th</strong>. The post also explains that the service will remain free with unlimited data collection. The only time you&#8217;ll <a title=\"http://i.cubeupload.com/aiklCg.jpg\" href=\"http://i.cubeupload.com/aiklCg.jpg\" rel=\"prettyphoto[15695]\">have to pay</a> is when you need to use a <strong>Pro</strong> feature.</p>\n<p>Overall, creating and managing surveys through Typeform was an easy experience. I still think survey building is boring. Pretty images and improved workflow won&#8217;t change my mind. If you want to see an example form, look below and take the pop quiz. If you give Typeform a try, let me know in the comments what you think.</p>\n<div class=\"typeform-widget\"></div>\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 23:30:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Why Aren’t Post Formats In WordPress More Popular?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15726\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:160:\"http://wptavern.com/why-arent-post-formats-in-wordpress-more-popular?utm_source=rss&utm_medium=rss&utm_campaign=why-arent-post-formats-in-wordpress-more-popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5002:\"<p>No, Post Formats haven&#8217;t gone anywhere but theme support and their use appear to be waning. Joyce Grace over at ManageWP.com has <a title=\"https://managewp.com/wordpress-post-formats-blogging\" href=\"https://managewp.com/wordpress-post-formats-blogging\">published a great article</a> that explores some possibilities as to why the feature is not being used, why we might see the feature make a comeback, and the SEO issues surrounding them. Outside of&nbsp; <a title=\"http://wptavern.com/behind-the-scenes-of-the-collections-theme\" href=\"http://wptavern.com/behind-the-scenes-of-the-collections-theme\">Collections by The Theme Foundry</a> I&#8217;ve not seen many themes where Post Formats is a selling point.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2013/08/CollectionsTheme2.jpg\" rel=\"prettyphoto[15726]\"><img class=\"aligncenter size-large wp-image-8364\" alt=\"CollectionsTheme 2\" src=\"http://wptavern.com/wp-content/uploads/2013/08/CollectionsTheme2-500x264.jpg\" width=\"500\" height=\"264\" /></a></p>\n<p>It didn&#8217;t help that the UI components for Post Formats <a title=\"http://wptavern.com/mark-jaquith-on-wordpress-3-6-postmortem-and-post-formats-ui\" href=\"http://wptavern.com/mark-jaquith-on-wordpress-3-6-postmortem-and-post-formats-ui\">were delayed and then dropped</a> out of core during the development cycle of WordPress 3.6. The main purpose of Post Formats UI was to expose the feature to thousands of users who otherwise, may not have known about it. I like what Joyce said about their implementation:</p>\n<blockquote><p>Whether Post Formats stay part of core or part of a plugin doesn’t really matter. The content producers, their primary users, won’t notice a huge difference either way. The main objective should be that more people are aware of, and start using them. They will make blogging more effective, more fun, less strenuous and less intimidating.</p></blockquote>\n<h3>Post Formats Are Unpredictable</h3>\n<p>Instead of the typical blog post that contains a <em>title, category, tags,</em> and additional meta data, formatted posts can be styled to display only the content specific to its type. For example, a post that uses the <strong>Quote format</strong> can be styled to only show the quote with an attribution link.</p>\n<p>This is part of the reason why I&#8217;m not comfortable using them. There is no consistency between themes where I can predict what a post will look like when assigned a format. I either have to browse my archive that has a post with the format already applied or look at the theme demo page.</p>\n<p>One of my gripes is that you can&#8217;t preview a post with a format assigned to it because the post preview shows you the <a title=\"http://codex.wordpress.org/Theme_Development#Single_Post_.28single.php.29\" href=\"http://codex.wordpress.org/Theme_Development#Single_Post_.28single.php.29\">single post view</a>. This view is different from what visitors will see when browsing the front page. What usually ends up happening is I publish a post with a format assigned, load the front page and make any necessary edits. I like Post Formats but this unique problem is a huge turn off for me.</p>\n<div id=\"attachment_15741\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/TumblrPostFormats.jpg\" rel=\"prettyphoto[15726]\"><img class=\"size-large wp-image-15741\" alt=\"Tumblr Post Formats\" src=\"http://wptavern.com/wp-content/uploads/2014/01/TumblrPostFormats-500x98.jpg\" width=\"500\" height=\"98\" /></a><p class=\"wp-caption-text\">Post Formats On Tumblr</p></div>\n<p>When I used <a title=\"https://www.tumblr.com/\" href=\"https://www.tumblr.com/\">Tumblr</a> a few years ago, it was the easiest way to publish content I&#8217;ve ever encountered. It was a relief to not use tags, categories, or other forms of content organization. I would add a title, specify the type of post and hit publish. Most of my content was short with the occasional long form post. <strong>This is the hidden beauty of Post Formats</strong>. As Joyce rightfully points out, &#8220;<em>they make blogging more effective, more fun, less strenuous and less intimidating.</em>&#8221;</p>\n<h3>Do You Use Post Formats?</h3>\n<p>Once it&#8217;s discovered that not every post needs to be 1,000 words in length and that short pieces of content can look great, Post Formats become an addicting way to keep a blog alive. It was for me when I used them on the Tavern. It&#8217;s worth noting that instead of tweeting or publishing a video on Facebook, a Post Format supported theme on a WordPress powered site would make an excellent alternative for publishing short form content. Not only do you retain ownership of your content, you can fully customize how it looks.</p>\n<p>Do you use Post Formats on your site? Do you know of any other WordPress themes that are built around Post Formats? If so, share them in the comments. Last but not least, what will it take to get more people to use this unique feature of WordPress?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 22:32:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WPTavern: High Demand For WordPress Education Prompts Treehouse to Launch New Beginner’s Course\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15513\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:232:\"http://wptavern.com/high-demand-for-wordpress-education-prompts-treehouse-to-launch-new-beginners-course?utm_source=rss&utm_medium=rss&utm_campaign=high-demand-for-wordpress-education-prompts-treehouse-to-launch-new-beginners-course\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3668:\"<p><a href=\"http://teamtreehouse.com/\" target=\"_blank\">Treehouse</a> offers technology education courses in a virtual environment to help users pick up new skills. Membership to the site offers access to various tracks of study that include topics such as iOS and Android development, web design, PHP, Rails development and more.  Treehouse has been gradually adding to its collection of WordPress courses and this week the company announced a new beginner&#8217;s course in the WordPress track, titled <a href=\"http://teamtreehouse.com/library/how-to-make-a-website-with-wordpress\" target=\"_blank\">How to Make a Website with WordPress</a>. </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/treehousewp1.png\" rel=\"prettyphoto[15513]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/treehousewp1.png\" alt=\"treehousewp\" width=\"640\" height=\"441\" class=\"aligncenter size-full wp-image-15527\" /></a></p>\n<p>This course is taught by <a href=\"http://zacgordon.com/\" target=\"_blank\">Zac Gordon</a> and covers everything from getting up and running to customizing a WordPress site with themes and plugins:</p>\n<ul>\n<li>Installing WordPress</li>\n<li>Managing and Customizing Themes</li>\n<li>Using Custom Post Types</li>\n<li>Managing Widgets and Menus</li>\n<li>Tips for Using Plugins</li>\n</ul>\n<h3>Treehouse Plans to Prioritize WordPress Education</h3>\n<p>In February, Treehouse plans to add a new course on Local WordPress Development and is currently cranking out one or two WordPress courses a month. </p>\n<p>I spoke with Treehouse instructor Zac Gordon to gauge the level of demand for WordPress education. Surprisingly, he said the company is actually receiving more requests for instruction on using WordPress, as opposed to developing for the platform. <strong>&#8220;While our main goal is to get someone to the point where they are ready to work as a WordPress developer, a lot of folks are more interested in being WordPress power users than they are at being developers.&#8221;</strong></p>\n<p>Smaller agencies and companies often use Treehouse in order to offload WordPress support for clients who are still learning how to use it. Gordon says that those requests are what inspired their <a href=\"http://teamtreehouse.com/library/wordpress-for-website-owners\" target=\"_blank\">WordPress for Website Owners</a> course.</p>\n<p>&#8220;At this point we don&#8217;t see as much of a request for in-depth material as we do for requests on specific topics or plugins,&#8221; he said.  &#8220;For example, a lot of folks ask about working with child themes or custom post types so we cover that in a range of formats.  We also get requests for things like WooCommerce and BuddyPress.&#8221;</p>\n<p>Gordon is working on revamping Treehouse&#8217;s current <a href=\"http://teamtreehouse.com/library/how-to-build-a-wordpress-theme\" target=\"_blank\">theme</a> and <a href=\"http://teamtreehouse.com/library/how-to-build-a-wordpress-plugin\" target=\"_blank\">plugin</a> development courses in order to keep the content fresh. A new theme development course aimed at beginners, followed by a more advanced course, will replace the current ones in the near future. He also hopes to launch a new course later this year for using WordPress as an application framework.</p>\n<p>As the global usage of WordPress continues to climb past 20%, the reports from Treehouse confirm that the demand for WordPress education is at an all time high. High quality beginner&#8217;s courses are becoming just as important as advanced development tutorials. I expect this trend to continue as more people discover just how easy it is to manage their own websites with WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 20:51:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WPTavern: Widget Customizer Proposed For WordPress 3.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15658\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:152:\"http://wptavern.com/widget-customizer-proposed-for-wordpress-3-9?utm_source=rss&utm_medium=rss&utm_campaign=widget-customizer-proposed-for-wordpress-3-9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3474:\"<p>The <a href=\"http://wptavern.com/the-future-of-wordpress-widgets-a-better-ui-with-real-time-previews\" target=\"_blank\">Widget Customizer</a> plugin is currently being considered for inclusion in WordPress 3.9. Weston Ruter, the project&#8217;s lead developer, submitted a <a href=\"http://make.wordpress.org/core/2014/01/28/widget-customizer-feature-as-plugin-merge-proposal/\" target=\"_blank\">proposal</a> for its merge into core. He and a large team of contributors have been working ardently to bring this feature into WordPress so that users no longer have to edit widgets blind. With the <a href=\"http://wordpress.org/plugins/widget-customizer/\" target=\"_blank\">Widget Customizer</a> in place, you can see a live preview of your widget as you are editing it. </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/widget-editing.png\" rel=\"prettyphoto[15658]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/widget-editing.png\" alt=\"widget-editing\" width=\"962\" height=\"927\" class=\"aligncenter size-full wp-image-15711\" /></a></p>\n<p>The Widget Customizer actually goes far beyond simply editing widgets. Actions available in the live preview include: adding a new widget, editing existing widgets, reordering widgets, dragging widgets to other sidebars, or even removing widgets from the sidebars entirely. There&#8217;s no need to save and move to the frontend to preview any of these actions, since they can all make use of the customizer&#8217;s preview.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/widget-actions.png\" rel=\"prettyphoto[15658]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/widget-actions.png\" alt=\"widget-actions\" width=\"1190\" height=\"894\" class=\"aligncenter size-full wp-image-15709\" /></a></p>\n<p>As you can see in the screenshot above, the plugin includes a couple of other new additions. The team added a search bar for finding a specific widget and icons to help you quickly identify a widget. Support for widget visibility is also included with a semi-transparent indicator in the customizer for widgets that are not able to be rendered in the preview.</p>\n<h3>New Requirements for WordPress Themes</h3>\n<p>If the Widget Customizer is added to core, WordPress theme developers will need to indicate that their widget areas support live previews in the customizer. This is as simple as adding support to the parent or child theme&#8217;s <em>functions.php</em> file:</p>\n<p><strong>add_theme_support(&#8216;widget-customizer&#8217;)</strong> </p>\n<p>Additionally, themes will need to indicate a widget&#8217;s support for live previews by including <a href=\"https://gist.github.com/westonruter/7965203/c1f78af5882dfecca575d7c7da4f0837af8fa869#file-lightbox-widget-php-L22\" target=\"_blank\">&#8216;customizer_support&#8217; => true</a> in the array passed to WP_Widget::__construct(). If the Widget Customizer is merged, WordPress theme developers will need to get busy making these updates for 3.9 in order to ensure a smooth experience for widget previews. </p>\n<p>WordPress core developers will be studying the implementation of the Widget Customizer plugin today during the regularly scheduled development meeting. They will determine whether it is ready for core and provide feedback for improvement. </p>\n<p>Have you tried the <a href=\"http://wordpress.org/plugins/widget-customizer/\" target=\"_blank\">Widget Customizer</a> plugin? Would you like to see it added in the next major release? </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 18:55:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: Aesop WordPress Storytelling Plugin Is Now Fully Funded\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15661\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:174:\"http://wptavern.com/aesop-wordpress-storytelling-plugin-is-now-fully-funded?utm_source=rss&utm_medium=rss&utm_campaign=aesop-wordpress-storytelling-plugin-is-now-fully-funded\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2838:\"<p><a href=\"http://aesopstories.com/story-engine/\" target=\"_blank\">Aesop</a> plugin developer <a href=\"https://twitter.com/nphaskins\" target=\"_blank\">Nick Haskins</a> announced tonight that the project has now been <a href=\"http://aesopstories.com/updates/aesop-funded/\" target=\"_blank\">fully funded</a> through its <a href=\"https://aesop.crowdhoster.com/storytelling-engine\" target=\"_blank\">Crowdhoster campaign</a>. He&#8217;s raised $6,397 of $6,000, thanks to backing from many major WordPress companies and individuals who are hoping to make the Aesop storytelling engine a reality.</p>\n<p>Haskin&#8217;s <a href=\"http://wptavern.com/aesop-story-engine-an-open-source-wordpress-plugin-for-storytelling\" target=\"_blank\">open source storytelling plugin</a> allows publishers to create rich storytelling experiences with multimedia elements. </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/aesop1.png\" rel=\"prettyphoto[15661]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/aesop1.png\" alt=\"aesop\" width=\"640\" height=\"480\" class=\"aligncenter size-full wp-image-15676\" /></a></p>\n<p>The Aesop fundraising campaign ended on January 26th but was shy of its original $15,000 goal. The campaign was subsequently <a href=\"http://aesopstories.com/updates/campaign-update/\" target=\"_blank\">extended</a> with a vastly reduced goal of $6k and a new focus on polishing the story engine before moving on to the hosted version: </p>\n<blockquote><p>Because we did not raise the full amount, there’s a strong chance that the hosted version may not come to fruition. This wasn’t scheduled to happen until the Spring anyways, so there’s still a small chance it will pan out, however focus is being put on finishing the core story engine first.</p></blockquote>\n<p>Development on the project will now refocus to complete the story engine along with a couple of themes built specifically for Aesop. Haskins is getting the plugin ready for submission to the WordPress.org repository and is working towards building out the business and branding for the project. Those who have backed Aesop will receive access to the themes before they are released to the general public.</p>\n<h3>Storytelling is Not Dead</h3>\n<p>The successful funding of the Aesop project demonstrates how much potential this new tool has for revolutionizing storytelling on the web. Once the plugin is polished up, anyone will be able to easily create photo essays, novels, interviews and big visual posts with a user-friendly story editor and full design control. Publishers are looking for new ways to keep readers engaged, as the industry evolves to keep pace with the modern web. The Aesop storytelling engine makes it possible for WordPress, the world&#8217;s leading publishing platform, to keep the art of storytelling alive in the digital age.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 04:53:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Industry Night #6 – Talking Shop with John Overall\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15647\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"http://wptavern.com/industry-night-6-john-overall?utm_source=rss&utm_medium=rss&utm_campaign=industry-night-6-john-overall\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1722:\"<p><img class=\"alignleft size-medium wp-image-14203\" alt=\"IndustryNight_albumart_2d\" src=\"http://wptavern.com/wp-content/uploads/2014/01/IndustryNight_albumart_2d-300x300.jpg\" width=\"300\" height=\"300\" />For more than two years, I&#8217;ve been in a weekly routine of co-hosting the <a title=\"WordPress Plugins A-Z\" href=\"http://wppluginsatoz.com\">WordPress Plugins A-Z</a> podcast with John Overall. Every week we talk about the latest and greatest in plugins. Sorting out the junk from the gems. We&#8217;re like the Siskel &amp; Ebert of plugins, giving our opinions on the newest plugins being released in the repository.</p>\n<p>Once the show is over though, we generally just set the meeting time for the next episode and hang up. This time however, I decided to take a rare opportunity to extend my time with John for a little WordPress &#8220;<em>shop talk</em>&#8220;. Like me, John has done hundreds of development projects. He&#8217;s seen just about everything that can (<strong>and will</strong>) go wrong with WordPress. John has done so much in WordPress that a majority of his business is providing emergency support. While so many people focus on the building of sites, John has specialized in fixing things that break in WordPress. You can call him any time, day or night and he&#8217;s there to rescue your WordPress install with emergency level support.</p>\n<p>In this episode we talk about the ten plugins that John installs on <span>every client site</span> and why simplicity is often the most difficult concept for clients to grasp. So pull up a chair, grab a cold one and join me in my conversation with <a title=\"http://www.johnoverall.com/\" href=\"http://www.johnoverall.com/\">John Overall</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 02:17:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marcus Couch\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WPTavern: GovFresh WP: A Free WordPress Theme For Governments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15597\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"http://wptavern.com/govfresh-a-free-wordpress-theme-for-governments?utm_source=rss&utm_medium=rss&utm_campaign=govfresh-a-free-wordpress-theme-for-governments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3079:\"<p>This week <a href=\"http://govfresh.com/\" target=\"_blank\">GovFresh</a>, a government and technology blog, launched a new WordPress theme project to help promote the use of open source software among governments. </p>\n<p>If you&#8217;ve ever visited a local government website that looks like it hasn&#8217;t been updated since 1999, then you understand the problem that the folks at GovFresh are trying to tackle here. Many smaller cities do not have a technology budget to afford website consulting services and therefore get left behind. It&#8217;s mind boggling to see how widespread this problem is, given all the user-friendly open source technology available these days.</p>\n<p>The deplorable state of government websites inspired Luke Fretwell to develop <a href=\"http://wp.govfresh.com/\" target=\"_blank\">GovFresh WP</a>, a free WordPress theme for governments. </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/govfreshwp.png\" rel=\"prettyphoto[15597]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/govfreshwp.png\" alt=\"govfreshwp\" width=\"671\" height=\"374\" class=\"aligncenter size-full wp-image-15633\" /></a></p>\n<p>GovFresh WP is a starter theme based on Bootstrap and features all the basics for building a modern website:</p>\n<ul>\n<li>Mobile-friendly and adapts to all devices (PC, laptop, tablet, smartphone)</li>\n<li>Custom header and background images</li>\n<li>Homepage, sidebar, footer widgets</li>\n<li>Data portability &#8211; change the design and never lose your content</li>\n</ul>\n<p>It also comes with a <a href=\"http://wp.govfresh.com/plugins/\" target=\"_blank\">list of recommended plugins</a> to help those administering government websites to get started, including solutions for performance and caching, workflow, analytics, security, SEO and more.  </p>\n<h3>Calling on WordPress Developers to Help</h3>\n<p>Luke Fretwell is looking for help from the WordPress developer community and GovFresh WP is now available on <a href=\"https://github.com/govfresh/govfreshwp\" target=\"_blank\">github</a>. He wants to improve the theme and incorporate <a href=\"http://govfresh.uservoice.com/forums/238740-govfresh-wp\" target=\"_blank\">new ideas</a>, which will require some rebuilding of his code. </p>\n<p>The project currently has two pilot cities, <a href=\"http://cityofdeleon.org/\" target=\"_blank\">De Leon, TX</a> and <a href=\"http://cityofferndale.org/\" target=\"_blank\">Ferndale, WA</a>, running on the theme, and there are plans in the works to offer support for small city web operations. It would be exciting if the theme had some support for incorporating <a href=\"http://wptavern.com/data-gov-is-using-wordpress-and-all-the-code-is-open-source\" target=\"_blank\">open data features</a> into the website in the case of cities or agencies. If you can help to further develop GovFresh WP or have suggestions to improve it, get in touch with Luke Fretwell at <a href=\"http://govfresh.com/contact\" target=\"_blank\">GovFresh</a>. By contributing to this theme you will be helping smaller governments to more adequately serve their citizens.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 22:24:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: Sir Trevor WP: An Alternative Post Editor for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=14852\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:172:\"http://wptavern.com/sir-trevor-wp-an-alternative-post-editor-for-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=sir-trevor-wp-an-alternative-post-editor-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4711:\"<p>There&#8217;s nothing more fun than exploring different interface ideas for the WordPress publishing process. Over the past several months we&#8217;ve featured a number of plugins that are vying for the best way to edit content on the front end. <a href=\"http://wordpress.org/plugins/sir-trevor-wp/\" target=\"_blank\">Sir Trevor WP</a> is a new plugin that presents an alternative way to edit content within the admin.</p>\n<p>It&#8217;s based on <a href=\"http://madebymany.github.io/sir-trevor-js/\" target=\"_blank\">Sir Trevor JS</a>, a rich content editor that claims not to presuppose anything about how the content will be rendered. Sir Trevor content is made up of blocks that are easy to edit. It ships with a handful of default content blocks but is also extensible if you want to add your own:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/sirtrevorjs.jpg\" rel=\"prettyphoto[14852]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/sirtrevorjs.jpg\" alt=\"sirtrevorjs\" width=\"940\" height=\"182\" class=\"aligncenter size-full wp-image-15605\" /></a></p>\n<p>The Sir Trevor WP plugin brings these intuitive block types into the WordPress content editor, making it easy for anyone to understand how to add content. When you install the plugin, it is turned on by default for all new posts, but you will retain the option to use the normal editor at any time via a strategically placed button. Here&#8217;s what Sir Trevor WP looks like in the post editor:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/sir-trevor-wp1.jpg\" rel=\"prettyphoto[14852]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/sir-trevor-wp1.jpg\" alt=\"sir-trevor-wp\" width=\"739\" height=\"338\" class=\"aligncenter size-full wp-image-15610\" /></a></p>\n<p>Selecting the Text block gives you what you need to input text:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/text-block.jpg\" rel=\"prettyphoto[14852]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/text-block.jpg\" alt=\"text-block\" width=\"833\" height=\"438\" class=\"aligncenter size-full wp-image-15612\" /></a></p>\n<p>Selecting &#8220;Image&#8221; provides an upload interface that bypasses the normal WordPress media dialog.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/sir-trevor-media.jpg\" rel=\"prettyphoto[14852]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/sir-trevor-media.jpg\" alt=\"sir-trevor-media\" width=\"777\" height=\"496\" class=\"aligncenter size-full wp-image-15614\" /></a></p>\n<h3>Testing Sir Trevor WP</h3>\n<p>If you want to test out this plugin, the most important thing to remember is that you will need to start a new post in order to see it in action. If you go to edit your old posts, Sir Trevor will not be an option.</p>\n<p>No time to test on your own server? Check out an animated gif of the plugin in action.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/sirtrevor.gif\" rel=\"prettyphoto[14852]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/sirtrevor.gif\" alt=\"sirtrevor\" width=\"384\" height=\"280\" class=\"aligncenter size-full wp-image-15608\" /></a></p>\n<p>You can also try out the <a href=\"http://madebymany.github.io/sir-trevor-js/example.html\" target=\"_blank\">live interactive demo</a> of the editor on the Sir Trevor JS site.</p>\n<p>While testing the plugin, I found that it certainly could use a little polishing. Adding images is currently very slow and may not work at all. Also, you will not be able to edit previously created posts in the Sir Trevor editor. This may ultimately be an impossibility given how it stores content. Errors on content blocks could also be a little more explanatory. For example, a user might receive the following error &#8220;List block is invalid&#8221;, but there is no explanation to help the user find a way forward. Unless you&#8217;re willing to experiment quite a bit, it&#8217;s not as user-friendly as it seems from the outset.</p>\n<p>The <a href=\"http://wordpress.org/plugins/sir-trevor-wp/\" target=\"_blank\">Sir Trevor WP</a> plugin probably isn&#8217;t ready for a production environment at present, but I love the fact that its creator is exploring new ways to improve the WordPress publishing experience. It reminds me of all of the things that were appealing about the <a href=\"http://wptavern.com/mark-jaquith-on-wordpress-3-6-postmortem-and-post-formats-ui\" target=\"_blank\">Post Formats UI</a> feature the WordPress community explored in 3.6. The challenge of simplifying WordPress&#8217; powerful publishing capabilities still remains.  Sir Trevor WP tackles that with a new way of presenting the editor. Hopefully, the surrounding discussion can spark some new ideas for the future.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 19:53:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WPTavern: WordPress, Openness, and Communication\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15519\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"http://wptavern.com/wordpress-openness-and-communication?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-openness-and-communication\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7956:\"<p>One of the battles the WordPress.org project has faced since its inception is communication. Not just how much or how little but also the tools used to communicate. When I followed the development of WordPress with eagle eyes from <strong>2008-2011</strong>, I used all of the communication channels that were available. IRC, the WordPress development blog, the WordPress.org forum, mailing lists, blogs about WordPress, and wherever else discussion on the core of WordPress took place. </p>\n<p>There were times when WordPress appeared to be a completely transparent project. There were also instances when changes took place that were <a href=\"http://justintadlock.com/archives/2010/07/08/lowercase-p-dangit\" title=\"http://justintadlock.com/archives/2010/07/08/lowercase-p-dangit\">not communicated very well to the community</a> that caused more harm than good. </p>\n<div id=\"attachment_15569\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/CommunicationFeaturedImage.jpg\" rel=\"prettyphoto[15519]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/CommunicationFeaturedImage.jpg\" alt=\"Communication Featured Image\" width=\"637\" height=\"200\" class=\"size-full wp-image-15569\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/elycefeliz/3224486233/\">elycefeliz</a>  &#8211;  <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a></p></div>\n<h3>Four Examples Of Communication Within WordPress.org</h3>\n<p>Siobhan McKeown, author of the <a title=\"http://wordpress.org/about/history/\" href=\"http://wordpress.org/about/history/\">WordPress history book</a> has <a title=\"http://siobhanmckeown.com/degrees-of-openness-communication-in-the-wordpress-community/\" href=\"http://siobhanmckeown.com/degrees-of-openness-communication-in-the-wordpress-community/\">published a great post</a> that looks at the openness and types of communication used within the WordPress.org project. She specifically highlights four different projects within WordPress. They are as follows:</p>\n<ul>\n<li>Shuttle &#8211; Admin redesign project between WordPress 1.5 and 2.3</li>\n<li>Redesign of the backend using design agency Happy Cog</li>\n<li>Redesign of the backend immediately after 2.5 codenamed Crazyhorse</li>\n<li>Redesign of the backend codenamed MP6</li>\n</ul>\n<h3>WordPress 2.5 Morphs Into Crazyhorse</h3>\n<p>I was one of the first to publicly view <a title=\"http://wordpress.org/news/2008/03/wordpress-25-brecker/\" href=\"http://wordpress.org/news/2008/03/wordpress-25-brecker/\">WordPress 2.5</a> redesigned by Happy Cog. It was released at WordCamp Dallas 2008 to cheers. Within a month, those cheers turned into boos. To the surprise of many including myself, the <a title=\"http://wordpress.org/news/2008/10/usability-testing-report-25-and-crazyhorse/\" href=\"http://wordpress.org/news/2008/10/usability-testing-report-25-and-crazyhorse/\">Crazyhorse project was announced</a> soon after the release of 2.5.</p>\n<blockquote><p>Whereas the 2.5 redesign was done behind closed doors, a lot of work was done in the Crazyhorse to keep the community up to date. Significantly, a number of the key developers at that time feel that it was one of the project’s most exciting times, a point at which WordPress really grew up.</p></blockquote>\n<div id=\"attachment_15571\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/WordPress27CrazyHorse.png\" rel=\"prettyphoto[15519]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/WordPress27CrazyHorse.png\" alt=\"WordPress 2.7 Crazyhorse\" width=\"597\" height=\"402\" class=\"size-full wp-image-15571\" /></a><p class=\"wp-caption-text\">WordPress 2.7 Unfinished Post Writing Panel</p></div>\n<p>I agree that Crazyhorse was one of the most exciting times for the WordPress project. It&#8217;s one of the few times I remember witnessing a strong devotion to get the community involved in all aspects of the project with surveys and usability reports. Jen Mylo did an awesome job gathering community feedback every step of the way. The communication channel she administered between core developers and users is one of the biggest reasons I believe WordPress 2.7 was so successful. </p>\n<h3>MP6 Development Using a Skype Back Channel</h3>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2013/05/mp6logo.jpg\" rel=\"prettyphoto[15519]\"><img src=\"http://wptavern.com/wp-content/uploads/2013/05/mp6logo.jpg\" alt=\"mp6 plugin header logo\" width=\"206\" height=\"197\" class=\"alignright size-full wp-image-6888\" /></a>MP6 was an interesting project to follow. Most of the communication surrounding the development of MP6 took place on a private Skype channel. Anyone could access the channel if they asked for permission but those chat logs are not searchable. They are not easily obtainable by anyone and it left many people wondering whether this type of communication is beneficial to the development of WordPress. </p>\n<p>During <a href=\"http://youtu.be/al_Saklwq48?t=41m15s\" title=\"http://youtu.be/al_Saklwq48?t=41m15s\">Matt&#8217;s State of The Word presentation in 2013</a>, Matt wasn&#8217;t sure whether the private channel on Skype was a good or bad thing. At the very least, reports of all of the changes that went into MP6 during the week were published on the <a href=\"http://make.wordpress.org/core/tag/mp6/\" title=\"http://make.wordpress.org/core/tag/mp6/\">Make.core.WordPress blog</a>. The reports gave those that didn&#8217;t have access to the Skype channel the chance to provide feedback and be part of the development process. </p>\n<div id=\"attachment_15574\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/MP6Report.jpg\" rel=\"prettyphoto[15519]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/MP6Report-500x283.jpg\" alt=\"Standard Status Report Of MP6\" width=\"500\" height=\"283\" class=\"size-large wp-image-15574\" /></a><p class=\"wp-caption-text\">Standard Status Report Of MP6</p></div>\n<h3>Reports Are Boring But Are Publicly Available</h3>\n<p>There are those who believe that to be truly open source, everything concerning the project should be transparent. Others are ok with back channel conversations as long as the results of those conversations are published in a public location. Thanks to the success of the MP6 model, features as plugins first and other aspects of core development are being published as reports on the <a href=\"http://make.wordpress.org/core/\" title=\"http://make.wordpress.org/core/\">Make.Core.WordPress</a> site. Siobhan made an excellent point regarding all of these reports:</p>\n<blockquote><p>The downfall of all this reporting is that it changes the public tone of the project from a conversation between community members, to a list of reports. The updates blog is particularly report-heavy, though many of the other make blogs are becoming that way. Reports are boring to read. No one wants to read a hundred reports. People want to be part of the conversation. Commenting on a report of a conversation that has already taken place elsewhere doesn’t make you feel part of things.</p></blockquote>\n<h3>Complex Problem With No Easy Solution</h3>\n<p>I agree that reports are <strong>BORING</strong>. However, I&#8217;m thankful that the information in those reports is publicly available since I can not be part of the conversation. All it takes for me to keep up with a project is to keep tabs on those reports. The biggest take away from Siobhan&#8217;s post is that there is no tool or service that solves all of the communication issues within WordPress.org. It&#8217;s a problem that will continue show its ugly head. Thanks to Siobhan for putting the post together and showcasing just how delicate the balance is. </p>\n<p>If you were in a leadership role within the WordPress.org project, what ideas, tools, or suggestions would you put in place to make communication accessible and easier for all contributors? </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 17:12:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: Progeny MMXIV: A Free WordPress Audio Theme Based on Twenty Fourteen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15541\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:198:\"http://wptavern.com/progeny-mmxiv-a-free-wordpress-audio-theme-based-on-twenty-fourteen?utm_source=rss&utm_medium=rss&utm_campaign=progeny-mmxiv-a-free-wordpress-audio-theme-based-on-twenty-fourteen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2786:\"<p>Progeny MMXIV is a new free child theme for <a href=\"http://wordpress.org/themes/twentyfourteen\" target=\"_blank\">Twenty Fourteen</a>. It was created by the folks at <a href=\"http://audiotheme.com/\" target=\"_blank\">AudioTheme</a>, a commercial theme shop that focuses on themes for bands, musicians, and labels.</p>\n<p>Although most of the design strongly resembles its Twenty Fourteen parent theme, Progeny MMXIV is unique in that it offers integration with the AudioTheme Framework. This plugin adds gig management, discography, videos and other music industry-related features.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/progeny.png\" rel=\"prettyphoto[15541]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/progeny.png\" alt=\"progeny\" width=\"880\" height=\"660\" class=\"aligncenter size-full wp-image-15545\" /></a></p>\n<p>Progeny MMXIV enhances Twenty Fourteen&#8217;s default functionality to provide everything you need to launch a music website. The theme adds to and modifies Twenty Fourteen in the following ways:</p>\n<ul>\n<li>Customized page layouts for music, videos, and gigs</li>\n<li>Support for featured music or videos in the top content grid or slider</li>\n<li>Widgets for AudioTheme framework&#8217;s record, track, video, and upcoming gigs</li>\n<li><a href=\"http://demo.audiotheme.com/progeny-mmxiv/about/\" target=\"_blank\">Contributor page</a> template extended to allow for a list of user IDs to be specified to showcase band members along with social links for each</li>\n<li>Automatic detection for adding social icons, i.e. Twitter, Facebook, Pinterest, Google+, directly into menu navigation</li>\n</ul>\n<p>Check out the <a href=\"http://demo.audiotheme.com/progeny-mmxiv/\" target=\"_blank\">live demo</a> of Progeny MMXIV to see the theme in action. Make sure to view an <a href=\"http://demo.audiotheme.com/progeny-mmxiv/shows/telluride-bluegrass-festival/\" target=\"_blank\">example gig listing</a>, the <a href=\"http://demo.audiotheme.com/progeny-mmxiv/about/\" target=\"_blank\">band members page</a> and <a href=\"http://demo.audiotheme.com/progeny-mmxiv/music/atascosa-sand/\" target=\"_blank\">sample track listings</a> to see the special features applied.</p>\n<p>Music makers often have multimedia content spread across multiple sites that specialize in audio, video, blogging, scheduling, etc. <a href=\"http://wordpress.org/themes/progeny-mmxiv\" target=\"_blank\">Progeny MMXIV</a> gives you all the tools you need to unify your brand by managing your content, music, gigs, and videos all in one place. Download it for free from <a href=\"https://github.com/AudioTheme/progeny-mmxiv\" target=\"_blank\">gihub</a> or <a href=\"http://wordpress.org/themes/progeny-mmxiv\" target=\"_blank\">install it</a> directly from the WordPress Themes Directory.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 05:56:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: WordCamp Norway 2014: WordPress In a Winter Wonderland\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15459\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:170:\"http://wptavern.com/wordcamp-norway-2014-wordpress-in-a-winter-wonderland?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-norway-2014-wordpress-in-a-winter-wonderland\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6715:\"<div id=\"attachment_15497\" class=\"wp-caption alignleft\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/wcnorge.jpg\" rel=\"prettyphoto[15459]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/wcnorge.jpg\" alt=\"photo credit - @sonjanyc\" width=\"1022\" height=\"356\" class=\"size-full wp-image-15497\" /></a><p class=\"wp-caption-text\">photo credit &#8211; <a href=\"https://twitter.com/sonjanyc/status/427092946564173824\" target=\"_blank\">@sonjanyc</a></p></div>\n<p>The WordPress community in Norway is growing fast. Just three years ago, WordPress did not have much representation in the country at all. The success of the first Oslo WordPress meetup in May 6th, 2011, sparked more gatherings, including the first WordCamp Norway. There are now <a href=\"http://www.meetup.com/find/?keywords=wordpress+norway&radius=Infinity&userFreeform=Oslo%2C+Norway&sort=default\" target=\"_blank\">three official WordPress meetups</a> happening regularly in different parts of the country.</p>\n<p>This past weekend, Oslo hosted its <a href=\"http://2014.norway.wordcamp.org/\" target=\"_blank\">3rd WordCamp</a> at the Radisson Blu Hotel and 150 attendees were greeted with snow. Most of the activities at this particular event were centered around the hotel and the nearby Metronet offices where the contributor day was held.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/ag.png\" rel=\"prettyphoto[15459]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/ag.png\" alt=\"ag\" width=\"80\" height=\"80\" class=\"alignleft size-full wp-image-15484\" /></a>I had the chance to chat with <a href=\"http://aloisia.net/\" target=\"_blank\">Aloisia Gabat</a>, a WordPress developer and first time attendee who traveled from her home outside of Paris to join the event. Gabat attended <a href=\"http://wptavern.com/wordcamp-paris-2014-uniting-the-french-wordpress-community\" target=\"_blank\">WordCamp Paris</a> the previous weekend. &#8220;The two events were quite different,&#8221; she said, &#8220;But still represented all that I love about WordPress.&#8221;</p>\n<p>I asked her what she found to be unique in the Norwegian WordPress community. She found the diversity of people, countries, and disciplines to be remarkable:</p>\n<blockquote><p>But what strikes me is its openness, the diversity of disciplines, and how international it is. The part of the community I met comprises several nationalities, and attendees included designers, developers, business owners, bloggers, etc. Based on the attendance here, I would expect the larger Norwegian WordPress community to further reflect those characteristics.</p></blockquote>\n<p><div id=\"attachment_15470\" class=\"wp-caption alignright\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/wcnorway-tshirts1.jpg\" rel=\"prettyphoto[15459]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/wcnorway-tshirts1-300x300.jpg\" alt=\"photo credit - Noel Tock\" width=\"300\" height=\"300\" class=\"size-medium wp-image-15470\" /></a><p class=\"wp-caption-text\">photo credit &#8211; <a href=\"http://instagram.com/p/jlxaTWHCI0/\" target=\"_blank\">Noel Tock</a></p></div>\n<p>Almost 100% of the presentations were given in English, due to the international mix of attendees. Two tracks ran simultaneously and Gabat particularly enjoyed <a href=\"https://twitter.com/ryanhellyer\" target=\"_blank\">Ryan Hellyer</a>&#8216;s &#8220;My Experiences Learning WordPress Security&#8221; and <a href=\"https://twitter.com/cageNL\" target=\"_blank\">Barry Kooij</a>&#8216;s talk on <a href=\"http://www.slideshare.net/cageNL/plugin-development-wordcamp-norway-2014\" target=\"_blank\">Plugin Development</a>. &#8220;I can find most of the information presented scattered on the internet and offline in various forms,&#8221; she said, &#8220;But Barry covered the different aspects of developing a plugin, from tools to WordPress core functions and hooks to coding standards to security, in one succinct presentation.&#8221;</p>\n<h3>Winter Fun on Contributor Day</h3>\n<p><div id=\"attachment_15532\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/contributor-day.jpg\" rel=\"prettyphoto[15459]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/contributor-day.jpg\" alt=\"credit: @rarst\" width=\"800\" height=\"534\" class=\"size-full wp-image-15532\" /></a><p class=\"wp-caption-text\">credit: <a href=\"http://www.flickr.com/photos/rarst/12180847314/sizes/z/in/set-72157640234422803/\">@rarst</a></p></div>\n<p>During Contributor Day, participants engaged in a variety of tasks, including tickets, translations and BuddyPress support.</p>\n<p><a href=\"http://markoheijnen.com/\" target=\"_blank\">Marko Heijnen</a>, who has attended every WordCamp held in Norway, said that the community is always very welcoming to international attendees. &#8220;I guess they must be,&#8221; he said. &#8220;Since it’s always really cold in the winter.&#8221; WordCamp Norway offered many opportunities for sitting around the fire and getting to know new friends. Attendees remarked on how nicely the venue&#8217;s lobby lent itself to group discussions during the after party. </p>\n<div id=\"attachment_15529\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/fireplace.jpg\" rel=\"prettyphoto[15459]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/fireplace.jpg\" alt=\"credit: @rarst\" width=\"640\" height=\"342\" class=\"size-full wp-image-15529\" /></a><p class=\"wp-caption-text\">credit: <a href=\"http://www.flickr.com/photos/rarst/12180422405/in/set-72157640234422803\">@rarst</a></p></div>\n<p>After the contributor day a large group went to a restaurant on the Korketrekkeren hill. Since it was closed due to a private party, they decided on an impromptu sledding adventure down the hill instead of taking the metro. </p>\n<div id=\"attachment_15534\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/adventure.jpg\" rel=\"prettyphoto[15459]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/adventure.jpg\" alt=\"credit: @rarst\" width=\"800\" height=\"534\" class=\"size-full wp-image-15534\" /></a><p class=\"wp-caption-text\">credit: <a href=\"http://www.flickr.com/photos/rarst/12180432875/in/set-72157640234422803\" target=\"_blank\">@rarst</a></p></div>\n<p>Overall, the third annual WordCamp Norway seems to have been a smashing success. While this winter event tends to be quite cold, the community is warm and welcoming. If sledding and fireside chats sound like the perfect WordCamp experience for you, consider adding this one to your calendar next year. For more photos and tweets from the event, check out the  WordCamp Norway <a href=\"http://wcnorge.wparmchair.com/\" target=\"_blank\">WP Armchair website</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 20:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: WordPress Co-Founder Mike Little Gets His Own Wikipedia Page\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15457\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:184:\"http://wptavern.com/wordpress-co-founder-mike-little-gets-his-own-wikipedia-page?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-co-founder-mike-little-gets-his-own-wikipedia-page\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1547:\"<p>Thanks to the <a href=\"http://winningwp.com/mike-little-wikipedia/\" title=\"http://winningwp.com/mike-little-wikipedia/\">folks behind WinningWP.com</a>, WordPress co-founder Mike Little has his very <a href=\"https://en.wikipedia.org/wiki/Mike_Little\" title=\"https://en.wikipedia.org/wiki/Mike_Little\">own Wikipedia page</a>. While Matt Mullenweg has been the public figurehead of the WordPress project, little is known about Mike. Within the past two years however, we&#8217;ve begun to get a better understanding of who Mike is and what lead him to <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\" title=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">leave a comment</a> on Matt&#8217;s blog post that ending up being the birth place of WordPress. </p>\n<p>As it turns out, Mike&#8217;s had a passion for technology since he was a little kid. If you want to learn more about the other co-founder of WordPress, I encourage you to watch this interview between Simon Dickson and Mike Little that took place live on stage as everyone around the world celebrated WordPress&#8217; 10th birthday. </p>\n<p></p>\n<p>If you know anything about Mike Little, consider adding it to his Wikipedia page. If you&#8217;re not familiar with how Wikipedia works, <a href=\"https://en.wikipedia.org/wiki/Help:Editing\" title=\"https://en.wikipedia.org/wiki/Help:Editing\">this guide</a> will give you a head start. It&#8217;s important that the editing guidelines are followed or else the page could end up being removed. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 17:42:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: A Library of WP-CLI Commands for BuddyPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15437\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"http://wptavern.com/a-library-of-wp-cli-commands-for-buddypress?utm_source=rss&utm_medium=rss&utm_campaign=a-library-of-wp-cli-commands-for-buddypress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2000:\"<p><img src=\"http://wptavern.com/wp-content/uploads/2014/01/wp-cli-bp.jpg\" alt=\"wp-cli-bp\" width=\"800\" height=\"271\" class=\"aligncenter size-full wp-image-15446\" />BuddyPress developers, here&#8217;s something new for your toolbox. <a href=\"http://teleogistic.net/2014/01/wp-cli-tools-for-buddypress/\" target=\"_blank\">Boone Gorges</a> has created a <a href=\"https://github.com/wp-cli/wp-cli/wiki/Community-Packages\" target=\"_blank\">WP-CLI community package</a> of BuddyPress commands. This collection includes just a few commands that have helped him with BuddyPress development but he welcomes your pull requests.</p>\n<p>So far, the commands include:</p>\n<ul>\n<li><strong>bp activate</strong> &#8212; Activate a component.</li>\n<li><strong>bp activity_create</strong> &#8212; Create a single activity item.</li>\n<li><strong>bp activity_generate</strong> &#8212; Generate a large number of random activity items.</li>\n<li><strong>bp deactivate</strong> &#8212; Deactivate a component.</li>\n<li><strong>bp group_create</strong> &#8212; Create new BuddyPress groups.</li>\n<li><strong>bp group_add_member</strong> &#8212; Add a member to a BuddyPress group.</li>\n<li><strong>bp member_generate</strong> &#8212; Create lots of site members, with the proper BP metadata.</li>\n</ul>\n<p>Setting up a BuddyPress test site can be fairly time consuming, especially if you need enough demo data to properly test all of the components. The WP-CLI commands included here will get your site populated with plenty of random activity items, groups and site members, including the proper BP metadata, in a matter of seconds. This is a big time saver for testing BuddyPress core, themes and plugins.</p>\n<p>The BuddyPress community package can be found on <a href=\"https://github.com/boonebgorges/wp-cli-buddypress\" target=\"_blank\">Github</a> and is also listed on the WP-CLI <a href=\"http://wp-cli.org/package-index/\" target=\"_blank\">package index</a>, along with other community packages to improve your workflow.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 16:09:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"WordPress.tv: Ilona Filipi: 3.5 Years Of Running A WordPress Web Agency: Do’s, Don’ts and Lessons Learned\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30114\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://wordpress.tv/2014/01/26/3-5-years-of-running-a-wordpress-web-agency-dos-donts-and-lessons-learned/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:754:\"<div id=\"v-KA8Evmxe-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30114/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30114/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30114&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/26/3-5-years-of-running-a-wordpress-web-agency-dos-donts-and-lessons-learned/\"><img alt=\"Ilona Filipi: 3.5 Years Of Running A WordPress Web Agency: Do&#8217;s, Don&#8217;ts and Lessons Learned\" src=\"http://videos.videopress.com/KA8Evmxe/video-55a1472e32_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 03:16:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Austin Smith: Big Media Strategies For WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30093\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.tv/2014/01/26/austin-smith-big-media-strategies-for-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:673:\"<div id=\"v-MGFc7mdA-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30093/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30093/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30093&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/26/austin-smith-big-media-strategies-for-wordpress/\"><img alt=\"Austin Smith: Big Media Strategies For WordPress\" src=\"http://videos.videopress.com/MGFc7mdA/video-e113f9b8cd_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 00:13:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Matt: Marco on Long-Form\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43480\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://ma.tt/2014/01/marco-on-long-form/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"<p>Marco Arment on <a href=\"http://www.marco.org/2014/01/26/long-form\">Long-Form content</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 26 Jan 2014 21:57:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"WordPress.tv: David Lockie: 10 Ways That WordPressers Can Make The World A Better Place\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30102\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://wordpress.tv/2014/01/25/david-lockie-10-ways-that-wordpressers-can-make-the-world-a-better-place/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:723:\"<div id=\"v-eRcBXwZA-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30102/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30102/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30102&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/25/david-lockie-10-ways-that-wordpressers-can-make-the-world-a-better-place/\"><img alt=\"David Lockie: 10 Ways That WordPressers Can Make The World A Better Place\" src=\"http://videos.videopress.com/eRcBXwZA/video-370b734fce_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 26 Jan 2014 00:14:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WordPress.tv: Hristo Pandjarov: Need For Speed: Gear Up Your WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30087\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wordpress.tv/2014/01/25/hristo-pandjarov-need-for-speed-gear-up-your-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:688:\"<div id=\"v-1nPSHx0E-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30087/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30087/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30087&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/25/hristo-pandjarov-need-for-speed-gear-up-your-wordpress/\"><img alt=\"Hristo Pandjarov: Need For Speed: Gear Up Your WordPress\" src=\"http://videos.videopress.com/1nPSHx0E/video-99b7cff76f_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 26 Jan 2014 00:06:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: WPWeekly Episode 135 – Podcasting With WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=15427&preview_id=15427\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:156:\"http://wptavern.com/wpweekly-episode-135-podcasting-with-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=wpweekly-episode-135-podcasting-with-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3563:\"<p>In this episode of WordPress Weekly, I was joined by <a href=\"http://marcuscouch.com/\" title=\"http://marcuscouch.com/\">Marcus Couch</a> and Matt Medeiros of <a href=\"http://mattreport.com/\" title=\"http://mattreport.com/\">Mattreport.com</a> and founder of <a href=\"http://slocumstudio.com/\" title=\"http://slocumstudio.com/\">Slocumstudio.com</a>. I threw out the show notes for this episode and instead, tapped into the collective knowledge of my guests to discuss the world of podcasting with WordPress. The first part of the conversation covers equipment, audio quality, and audience while the second half focuses on WordPress. One thing immediately became clear. We&#8217;re all fans of the <a href=\"http://wordpress.org/plugins/powerpress/\" title=\"http://wordpress.org/plugins/powerpress/\">Blubrry Powerpress</a> plugin. If you&#8217;re thinking about starting a show and using WordPress to publish it, you&#8217;ll want to listen to this episode!</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/wordpress-developers-take-note-tinymce-4-0-merged-into-core\" title=\"http://wptavern.com/wordpress-developers-take-note-tinymce-4-0-merged-into-core\">WordPress Developers Take Note: TinyMCE 4.0 Merged Into Core</a><br />\n<a href=\"http://wptavern.com/interview-with-jason-schuller-founder-of-press75-com\" title=\"http://wptavern.com/interview-with-jason-schuller-founder-of-press75-com\">Interview With Jason Schuller Founder Of Press75.com</a><br />\n<a href=\"http://wptavern.com/tickets-on-sale-for-wordcamp-dayton-ohio\" title=\"http://wptavern.com/tickets-on-sale-for-wordcamp-dayton-ohio\">Tickets On Sale For WordCamp Dayton, Ohio</a><br />\n<a href=\"http://wptavern.com/wordpress-3-8-1-released-fixes-twitter-oembed-issues\" title=\"http://wptavern.com/wordpress-3-8-1-released-fixes-twitter-oembed-issues\">WordPress 3.8.1 Released: Fixes Twitter oEmbed Issues</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"http://wordpress.org/plugins/google-drive-wp-media/\" title=\"http://wordpress.org/plugins/google-drive-wp-media/\">Google Drive WP Media</a> allows direct access to your Google Drive, enabling you to manage your files remotely from your WordPress blog. Upload and share your files directly from your WordPress blog to Google Drive and back again.</p>\n<p><a href=\"http://wordpress.org/plugins/skype-mobile-switcher/\" title=\"http://wordpress.org/plugins/skype-mobile-switcher/\">Skype Mobile Switcher</a> uses a shortcode to switch between presenting a Skype call link and a phone number that can be clicked to call. </p>\n<p><a href=\"http://wordpress.org/plugins/dynamic-home-length/\" title=\"http://wordpress.org/plugins/dynamic-home-length/\">Dynamic Home Length</a> adjusts the number of posts per page of the front page based on the total amount of text in all recent posts so that its height will automatically be in proportional with the height of your widget column.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, January 31st 3 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #135:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 25 Jan 2014 03:17:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: Technique For Creating Portable Social Menus In WordPress Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15271\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:192:\"http://wptavern.com/technique-for-creating-portable-social-menus-in-wordpress-themes?utm_source=rss&utm_medium=rss&utm_campaign=technique-for-creating-portable-social-menus-in-wordpress-themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1903:\"<p>One of the features within the <a href=\"http://themehybrid.com/themes/stargazer\" title=\"http://themehybrid.com/themes/stargazer\">Stargazer</a> child theme we are using on WPTavern are the social icons located at the bottom of the site. The social icons are not images but rather, <a href=\"http://genericons.com/\" title=\"http://genericons.com/\">Genericons</a>. As explained by <a href=\"http://kovshenin.com/2014/social-menus-in-wordpress-themes/\" title=\"http://kovshenin.com/2014/social-menus-in-wordpress-themes/\">Konstantin Kovshenin</a>, Justin Tadlock used a method to add social network icons that are portable between themes. By using a few simple CSS selectors, the social links are able to be targeted by their <em>href</em> attribute.</p>\n<blockquote><p>No more plugin dependencies, no more long docs of CSS class names, no more arguing with the Theme Reviewers Theme on WordPress.org that social profile icons are part of the appearance of a theme and not “plugin territory” because users can lose their content upon theme switch.</p></blockquote>\n<p>Justin Tadlock published <a href=\"http://justintadlock.com/archives/2013/08/07/social-media-nav-menus\" title=\"http://justintadlock.com/archives/2013/08/07/social-media-nav-menus\">two</a> different <a href=\"http://justintadlock.com/archives/2013/08/14/social-nav-menus-part-2\" title=\"http://justintadlock.com/archives/2013/08/14/social-nav-menus-part-2\">posts</a> that explain the thought process behind the technique as well as the code needed to make it work. It&#8217;s being championed by the WordPress theme community to the point of it possibly being added to the <a href=\"https://make.wordpress.org/docs/theme-developer-handbook/releasing-your-theme/theme-review-guidelines/\" title=\"https://make.wordpress.org/docs/theme-developer-handbook/releasing-your-theme/theme-review-guidelines/\">WordPress Theme Review Guidelines</a>. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jan 2014 22:06:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: Status App: A WordPress-Powered Mobile Micro Messaging Service\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=14785\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:186:\"http://wptavern.com/status-app-a-wordpress-powered-mobile-micro-messaging-service?utm_source=rss&utm_medium=rss&utm_campaign=status-app-a-wordpress-powered-mobile-micro-messaging-service\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3595:\"<p>As Matt Mullenweg predicted in the State of the Word address in 2013, this new year brings with it a growing excitement around building applications based on WordPress. The launch of <a href=\"http://wptavern.com/apppresser-launches-first-mobile-app-development-framework-for-wordpress\" target=\"_blank\">AppPresser</a>, the first mobile application framework for WordPress, produced a healthy buzz around the idea and now the community is primed for more.</p>\n<p>Ryan Fugate, better known around the web as &#8220;<a href=\"https://twitter.com/modemlooper\" target=\"_blank\">@modemlooper</a>&#8220;, has created a WordPress-powered micro messaging app for mobile. <a href=\"http://taptappress.com/status-app/\" target=\"_blank\">Status App</a> is actually a WordPress plugin that creates a Twitter type micro blogging platform for mobile users at your chosen URL.</p>\n<p><img src=\"http://wptavern.com/wp-content/uploads/2014/01/status.png\" alt=\"status\" width=\"906\" height=\"454\" class=\"aligncenter size-full wp-image-15390\" /></p>\n<p>Want to try it? Visit this URL from a mobile browser: <a href=\"http://status.taptappress.com/status\" target=\"_blank\">http://status.taptappress.com/status</a></p>\n<p>The status updates are stored as a custom post type within WordPress and can be managed from the admin. Right now the app doesn&#8217;t include a settings panel. You simply activate the plugin and then visit your site on mobile. </p>\n<p><img src=\"http://wptavern.com/wp-content/uploads/2014/01/status-cpt.png\" alt=\"status-cpt\" width=\"985\" height=\"302\" class=\"aligncenter size-full wp-image-15403\" /></p>\n<p>Since Status App is technically a social app, why didn&#8217;t he build it with BuddyPress? Ryan explained his reasoning when he <a href=\"http://taptappress.com/status-app/\" target=\"_blank\">introduced</a> the app: </p>\n<blockquote><p>This could have been an app for BuddyPress but I am targeting a different group of users. BuddyPress is for front sided social networks with lots of features. Status App is for the content creators of a site. If you have ever used Yammer then you can understand the need for this type of functionality.</p></blockquote>\n<p>For now, @modemlooper is completing more user testing on multiple devices before the beta release of the plugin. More features are currently in the works, including @mentions, favoriting, profile editing, private messages. He plans to release Status App as a free plugin with a commercial version available to include more settings and add additional features. </p>\n<p>Check out @modemlooper&#8217;s <a href=\"http://taptappress.com/news/\" target=\"_blank\">TapTapPress blog</a> for more discussions on developing mobile apps for WordPress. If you&#8217;re testing the Status App and can help with reporting any issues, <a href=\"http://taptappress.com/contact/\" target=\"_blank\">get in touch with Ryan</a> and let him know the type of device you&#8217;re using.</p>\n<p>I tested Status App last night and found it to be ridiculously simple and enjoyable to use. Additionally, unlike using Twitter, you own your own data when you create your own messaging service. I believe it&#8217;s apps like these that will lead to the ultimate crumbling of the massive social data silos that feed you advertisements and blatantly disregard user privacy. Eventually, users are going to be fed up and will flock to simple private social networks like the kind you can create with Status App. We&#8217;ll be closely following the evolution of this app and will let you know when you can download the free plugin to create your own micro messaging service.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jan 2014 20:43:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: 30 Beautiful Brewery Websites Built With WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:164:\"http://wptavern.com/30-beautiful-brewery-websites-built-with-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=30-beautiful-brewery-websites-built-with-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8099:\"<p>While the WordPress community continues to grow and expand every day, so does the craft beer scene. So it only makes sense that a growing number of craft breweries are choosing to build their websites on WordPress. After all, WordPress and craft beer have a lot in common: enthusiasm, loyalty, broad appeal, no shortage of strong opinions and a community of contributors of every stripe. </p>\n<p>Craft brewers often share many of the same ideals found in open source culture, including  the cheerful sharing of knowledge, skills, recipes and the strong support of each other&#8217;s work. You might even say that craft brewing culture is the open source version of the beer industry. With that in mind, here are 30 beautiful brewery websites that have been built with WordPress. Pour your favorite local pint, sit back, and enjoy. Cheers!</p>\n<h3>Groundswell Brewing Company</h3>\n<p><a href=\"http://groundswellbrew.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/groundswell.png\" alt=\"groundswell\" width=\"1400\" height=\"791\" class=\"aligncenter size-full wp-image-15322\" /></a></p>\n<h3>The Post Brewing Co.</h3>\n<p><a href=\"http://www.postbrewing.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/thepost.png\" alt=\"thepost\" width=\"1280\" height=\"800\" class=\"aligncenter size-full wp-image-15327\" /></a></p>\n<h3>Canal Park Brewing Company</h3>\n<p><a href=\"http://canalparkbrewery.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/canalpark.png\" alt=\"canalpark\" width=\"1400\" height=\"884\" class=\"aligncenter size-full wp-image-15332\" /></a></p>\n<h3>Brewsters Brewing Company</h3>\n<p><a href=\"http://brewsters.ca/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/brewsters.png\" alt=\"brewsters\" width=\"1400\" height=\"836\" class=\"aligncenter size-full wp-image-15330\" /></a></p>\n<h3>Camden Town Brewery</h3>\n<p><a href=\"http://www.camdentownbrewery.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/camdentownbrewery.png\" alt=\"camdentownbrewery\" width=\"1400\" height=\"804\" class=\"aligncenter size-full wp-image-15333\" /></a></p>\n<h3>Cook Ale Works</h3>\n<p><a href=\"http://coopaleworks.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/coop.png\" alt=\"coop\" width=\"1400\" height=\"759\" class=\"aligncenter size-full wp-image-15335\" /></a></p>\n<h3>Rogness Brewing Company</h3>\n<p><a href=\"http://rognessbrewing.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/rogness.png\" alt=\"rogness\" width=\"1400\" height=\"703\" class=\"aligncenter size-full wp-image-15337\" /></a></p>\n<h3>Driftwood Brewery</h3>\n<p><a href=\"http://driftwoodbeer.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/driftwood.png\" alt=\"driftwood\" width=\"1227\" height=\"856\" class=\"aligncenter size-full wp-image-15338\" /></a></p>\n<h3>Brouwerij ‘t IJ</h3>\n<p><a href=\"http://www.brouwerijhetij.nl/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/Brouwerij-‘t-IJ.png\" alt=\"Brouwerij ‘t IJ\" width=\"1500\" height=\"740\" class=\"aligncenter size-full wp-image-15357\" /></a></p>\n<h3>Carolina Brewery</h3>\n<p><a href=\"http://carolinabrewery.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/carolinabrewery.png\" alt=\"carolinabrewery\" width=\"1400\" height=\"943\" class=\"aligncenter size-full wp-image-15341\" /></a></p>\n<h3>Matso&#8217;s Broome Brewery</h3>\n<p><a href=\"http://www.matsos.com.au/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/matsos.png\" alt=\"matsos\" width=\"1400\" height=\"915\" class=\"aligncenter size-full wp-image-15343\" /></a></p>\n<h3>Hargreaves Hill Brewing Company</h3>\n<p><a href=\"http://www.hargreaveshill.com.au/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/hargreaves.jpg\" alt=\"hargreaves\" width=\"1440\" height=\"822\" class=\"aligncenter size-full wp-image-15378\" /></a></p>\n<h3>Prairie Artisan Ales</h3>\n<p><a href=\"http://prairieales.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/prairie.png\" alt=\"prairie\" width=\"1500\" height=\"930\" class=\"aligncenter size-full wp-image-15345\" /></a></p>\n<h3>U Fleků</h3>\n<p><a href=\"http://ufleku.cz/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/UFleku.jpg\" alt=\"UFleku\" width=\"1312\" height=\"826\" class=\"aligncenter size-full wp-image-15372\" /></a></p>\n<h3>Widmer Brothers</h3>\n<p><a href=\"http://widmerbrothers.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/widmer.png\" alt=\"widmer\" width=\"1500\" height=\"820\" class=\"aligncenter size-full wp-image-15347\" /></a></p>\n<h3>Gigantic Brewing Company</h3>\n<p><a href=\"http://giganticbrewing.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/gigantic.png\" alt=\"gigantic\" width=\"1500\" height=\"817\" class=\"aligncenter size-full wp-image-15349\" /></a></p>\n<h3>Mikkeller</h3>\n<p><a href=\"http://mikkeller.dk/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/mikkeller.jpg\" alt=\"mikkeller\" width=\"1322\" height=\"830\" class=\"aligncenter size-full wp-image-15375\" /></a></p>\n<h3>Bonfire Brewing</h3>\n<p><a href=\"http://bonfirebrewing.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/bonfire-brewing.png\" alt=\"bonfire-brewing\" width=\"1500\" height=\"899\" class=\"aligncenter size-full wp-image-15351\" /></a></p>\n<h3>Monkey Paw Brewing</h3>\n<p><a href=\"http://monkeypawbrewing.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/monkeypaw.png\" alt=\"monkeypaw\" width=\"1060\" height=\"878\" class=\"aligncenter size-full wp-image-15353\" /></a></p>\n<h3>Yowie Beer</h3>\n<p><a href=\"http://yowiebeer.com.au/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/yowie.jpg\" alt=\"yowie\" width=\"1326\" height=\"918\" class=\"aligncenter size-full wp-image-15382\" /></a></p>\n<h3>Thorn St. Brewery</h3>\n<p><a href=\"http://thornstreetbrew.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/thornstbrewery.png\" alt=\"thornstbrewery\" width=\"1500\" height=\"983\" class=\"aligncenter size-full wp-image-15355\" /></a></p>\n<h3>Brouwerij De 7 Deugden</h3>\n<p><a href=\"http://www.de7deugden.nl/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/Brouwerij-De-7-Deugden.png\" alt=\"Brouwerij De 7 Deugden\" width=\"1500\" height=\"1036\" class=\"aligncenter size-full wp-image-15359\" /></a></p>\n<h3>Redemption Brewing Co.</h3>\n<p><a href=\"http://www.redemptionbrewing.co.uk/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/redemption.jpg\" alt=\"redemption\" width=\"1054\" height=\"896\" class=\"aligncenter size-full wp-image-15364\" /></a></p>\n<h3>Oskar Blue Brewery</h3>\n<p><a href=\"http://oskarblues.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/oskar-blues.jpg\" alt=\"oskar-blues\" width=\"1100\" height=\"880\" class=\"aligncenter size-full wp-image-15365\" /></a></p>\n<h3>Hops and Grains</h3>\n<p><a href=\"http://www.hopsandgrain.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/hopsandgrains.jpg\" alt=\"hopsandgrains\" width=\"1036\" height=\"798\" class=\"aligncenter size-full wp-image-15367\" /></a></p>\n<h3>Captain Lawrence Brewing Company</h3>\n<p><a href=\"http://www.captainlawrencebrewing.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/captainlawrence.jpg\" alt=\"captainlawrence\" width=\"1098\" height=\"830\" class=\"aligncenter size-full wp-image-15368\" /></a></p>\n<h3>Red Hook</h3>\n<p><a href=\"http://redhook.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/redhook.jpg\" alt=\"redhook\" width=\"1134\" height=\"824\" class=\"aligncenter size-full wp-image-15370\" /></a></p>\n<h3>Manchester Marble Beers</h3>\n<p><a href=\"http://www.marblebeers.com/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/marble.jpg\" alt=\"marble\" width=\"1026\" height=\"748\" class=\"aligncenter size-full wp-image-15384\" /></a></p>\n<h3>Dugges Ale &#038; Porterbryggeri</h3>\n<p><a href=\"http://dugges.se/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/dugges.jpg\" alt=\"dugges\" width=\"1098\" height=\"680\" class=\"aligncenter size-full wp-image-15376\" /></a></p>\n<h3>Hawthorne Brewing Co.</h3>\n<p><a href=\"http://hawthornbrewing.com.au/\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/hawthorne.jpg\" alt=\"hawthorne\" width=\"1080\" height=\"914\" class=\"aligncenter size-full wp-image-15380\" /></a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jan 2014 18:47:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WordPress.tv: Marko Heijnen: Building Plugins Like A Pro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30007\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.tv/2014/01/24/marko-heijnen-building-plugins-like-a-pro/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:661:\"<div id=\"v-GucbrQSP-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30007/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30007/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30007&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/24/marko-heijnen-building-plugins-like-a-pro/\"><img alt=\"Marko Heijnen: Building Plugins Like A Pro\" src=\"http://videos.videopress.com/GucbrQSP/video-abf855d2e0_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jan 2014 16:06:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WordPress.tv: Luke Oatham: GovIntranet WordPress Theme\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.tv/2014/01/24/luke-oatham-govintranet-wordpress-theme/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:657:\"<div id=\"v-UQ0KX6xM-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30013/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30013/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30013&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/24/luke-oatham-govintranet-wordpress-theme/\"><img alt=\"Luke Oatham: GovIntranet WordPress Theme\" src=\"http://videos.videopress.com/UQ0KX6xM/video-240a36afb3_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jan 2014 13:25:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: PressCastle Aims to Put Every WordPress Theme in One Place\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15264\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:180:\"http://wptavern.com/presscastle-aims-to-put-every-wordpress-theme-in-one-place?utm_source=rss&utm_medium=rss&utm_campaign=presscastle-aims-to-put-every-wordpress-theme-in-one-place\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3057:\"<p><a href=\"http://presscastle.com/\" target=\"_blank\">PressCastle</a> launched this month with an ambitious goal: to put every WordPress theme in one place. The site currently has more than 13,000 themes that are categorized and searchable. The themes were collected from more than 250 sites and represent 400+ theme authors.</p>\n<p>If you visit the <a href=\"http://presscastle.com/themes/\" target=\"_blank\">Themes section</a> of the site you can filter themes based on price, layout, framework and genre with subcategories for each. PressCastle is in the process of adding filters to the themes to specify compatibility with multisite, BuddyPress, bbPress, Jigoshop and other commonly used plugins.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/presscastle-themes.jpg\" rel=\"prettyphoto[15264]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/presscastle-themes.jpg\" alt=\"presscastle-themes\" width=\"946\" height=\"491\" class=\"aligncenter size-full wp-image-15298\" /></a></p>\n<p>The site is using affiliate links on the themes to help fund the efforts required for indexing this massive library. The launch post claims that they now have the largest and most up to date index of WordPress themes on the web. They plan to update it with new theme releases and remove discontinued items along the way.</p>\n<p>I entered a few common search terms related to WordPress themes and found that the search engine was quite accurate in returning relevant information. Although, from a consumer standpoint, I have a difficult time connecting with the whole medieval castle theme they&#8217;ve got running, I can see the utility in the indexing and searching capabilities PressCastle provides. But does it solve a real problem?</p>\n<h3>Are WordPress Theme Indexing Sites a Fad?</h3>\n<p>The fact that themes are scattered throughout hundreds of websites can make it difficult to locate one that you want to use. PressCastle is trying to provide a solution for this. <a href=\"http://wptavern.com/theme-friendly-helps-you-find-the-perfect-wordpress-theme\" target=\"_blank\">Theme Friendly</a> is another site that recently launched with a similar goal of helping users find the perfect WordPress theme. While Theme Friendly has a different angle in that it provides reviews on the quality of themes, the work is similarly powered by affiliate links. Only time will tell whether affiliate commissions will be adequate compensation for the amount of effort required to keep these indexes current.</p>\n<p>Theme indexing sites seem to be popping up quite frequently these days, all of them vying to capitalize on the high demand for WordPress themes and the difficulty users have when searching. The question remains &#8211; will any of these sites actually take off and gain a following? In many cases their efforts seem to be duplicating the results a user might find with a reasonably formed search engine query. So I put the question to you: <strong>Are you likely to visit a WordPress theme indexing site when shopping for your next theme?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jan 2014 00:09:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"Alex King: Owning Your Online Identity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=19292\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://crowdfavorite.com/blog/2014/01/own-your-online-identity/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1470:\"<div>\n	<img width=\"160\" height=\"120\" src=\"http://alexking.org/wp-content/uploads/2014/01/Screen-Shot-2014-01-23-at-2.39.30-PM-160x120.png\" class=\"attachment-thumb-img wp-post-image\" alt=\"Post at the Crowd Favorite blog\" /></div>\n<p>I&#8217;ve put up a post on the <a href=\"http://crowdfavorite.com/blog/\">Crowd Favorite blog</a> about how I use WordPress and the <a href=\"http://crowdfavorite.com/favepersonal/\">FavePersonal</a> theme (free!) to own my online identity, while still participating with my friends on Facebook and Twitter.</p>\n<p>I love how I have (on my own site) a history of the social reactions to <a href=\"http://alexking.org/blog/2013/04/24/capsule-the-developers-code-journal\">posts like this</a>. Here&#8217;s a <a href=\"http://alexking.org/blog/2014/01/09/ipad-use-and-productivity\">more casual example</a>; where the social reactions really add to the overall story.</p>\n<p>I think owning your online identity is hugely important &#8211; don&#8217;t outsource it to some 3rd-party service. But there&#8217;s no reason not to take advantage of the benefits of those services. I want to have my cake and eat it to &#8211; and I believe I&#8217;m doing just that.</p>\n<p class=\"threads-post-notice\">This post is part of the project: <a href=\"http://alexking.org/project/favepersonal\">FavePersonal</a>. View the project timeline for more context on this post.</p>\n<p><a href=\"http://alexking.org/blog/2014/01/23/owning-your-online-identity\">#</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 21:41:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: WordPress 3.8.1 Released: Fixes Twitter oEmbed Issues\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=13644\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:168:\"http://wptavern.com/wordpress-3-8-1-released-fixes-twitter-oembed-issues?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-8-1-released-fixes-twitter-oembed-issues\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2429:\"<p>WordPress 3.8.1 was <a href=\"http://wordpress.org/news/2014/01/wordpress-3-8-1/\" target=\"_blank\">released</a> today with more than 30 tickets resolved for this <a href=\"https://core.trac.wordpress.org/query?milestone=3.8.1\" target=\"_blank\">milestone</a>. Automatic background updates will be gradually rolled out over the next 24 hours.</p>\n<p>One of the most notable fixes was switching Twitter oEmbed to SSL. Twitter changed its API, which broke Twitter oEmbed links across all WordPress installations. If you&#8217;ve got a lot of content with embedded tweets, then upgrading to WordPress 3.8.1 should be a high priority for you. </p>\n<p>Additionally, WordPress 3.8.1 addresses some issues with taxonomy queries in WP_Query, general fixes for the newly designed admin areas and resolves a strange bug with &#8220;dead zones&#8221; on submit buttons.</p>\n<h3>An Impressive Success Rate For Automatic Updates</h3>\n<p>Skeptics of WordPress 3.7&#8242;s automatic updates feature may be interested in looking at the results so far. The success rate for automatic updates with WordPress 3.8 was astonishing, given that it was a major release, with many major changes. Andrew Nacin <a href=\"http://make.wordpress.org/core/2013/12/18/automatic-updates-for-3-8-started-to-flow-early/\" target=\"_blank\">cites</a> the stats for critical failures:</p>\n<blockquote><p>Success rate is around 99.78 percent of about 15,000 updates. That’s a bit lower than 3.7.1, which was 99.988 percent for about a million updates. This is to be expected; for example, far more files were changed.</p></blockquote>\n<p>When referring to critical failures, Nacin clarifies that these are not disaster scenarios, as the term might seem to indicate. &#8220;<strong>Remember that a critical failure (what these numbers are calculating) only means &#8216;we started to copy files and failed to verify we copied all of them&#8217;</strong>,&#8221; he clarified. &#8220;It doesn&#8217;t mean the site crashed and burned.&#8221; </p>\n<p>These stats are good news for any WordPress admin who has been hesitant to have automatic background updates turned on for minor releases. If you previously had background updates turned off, now might be a good time to consider <a href=\"http://wptavern.com/how-to-configure-automatic-core-updates-for-wordpress-3-7\" target=\"_blank\">re-configuring your settings</a> to include automatic core updates for minor releases. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 21:24:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"Dev Blog: WordPress 3.8.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3063\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3834:\"<p>After six weeks and more than <a href=\"http://wordpress.org/download/counter/\">9.3 million downloads</a> of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available.</p>\n<p>Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query was resolved. And if you&#8217;ve been frustrated by submit buttons that won&#8217;t do anything when you click on them (or thought you were going crazy, like some of us), we&#8217;ve found and fixed this &#8220;dead zone&#8221; on submit buttons.</p>\n<p>It also contains a fix for <strong>embedding tweets</strong> (by placing the URL to the tweet on its own line), which was broken due to a recent Twitter API change. (For more on Embeds, see <a href=\"http://codex.wordpress.org/Embeds\">the Codex</a>.)</p>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.8.1\">list of tickets</a> and <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=27018&stop_rev=26862\">the changelog</a>. There&#8217;s also a <a href=\"http://make.wordpress.org/core/2014/01/22/wordpress-3-8-1-release-candidate/\">detailed summary</a> for developers on the development blog.</p>\n<p>If you are one of the millions already running WordPress 3.8, we will start rolling out automatic background updates for WordPress 3.8.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.8.1:</p>\n<p><a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://wordpress.org/news/feed/\">José Pino</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p><em>WordPress three eight one<br />\nWe heard you didn&#8217;t like bugs<br />\nSo we took them out</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:37:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Behind The Scenes In The WordPress Plugin Directory With Mika Epstein\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15237\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:202:\"http://wptavern.com/behind-the-scenes-in-the-wordpress-plugin-directory-with-mika-epstein?utm_source=rss&utm_medium=rss&utm_campaign=behind-the-scenes-in-the-wordpress-plugin-directory-with-mika-epstein\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10264:\"<p>The <a href=\"http://wordpress.org/plugins/\" target=\"_blank\">WordPress Plugin Directory</a> currently lists more than 29,000 plugins. It&#8217;s the first stop for any WordPress user looking to extend the capabilities of the software. With over 585 million downloads and a massive worldwide user base, it takes a dedicated team to monitor the quality and security of so many extensions.</p>\n<p><div id=\"attachment_15252\" class=\"wp-caption alignright\"><a href=\"http://wptavern.com/wp-content/uploads/2014/01/ipstenu.jpg\" rel=\"prettyphoto[15237]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/ipstenu-332x500.jpg\" alt=\"Mika Epstein - photo credit: ma.tt \" width=\"332\" height=\"500\" class=\"size-large wp-image-15252\" /></a><p class=\"wp-caption-text\">Mika Epstein &#8211; photo credit: <a href=\"http://ma.tt/2012/08/wcsf-hack-day/mcm_3384-3/\" target=\"_blank\">ma.tt</a></p></div>\n<p>I had the opportunity to interview Mika Epstein, better known around the web as &#8220;<a href=\"https://twitter.com/ipstenu\" target=\"_blank\">Ipstenu</a>&#8220;, about her work behind the scenes with the plugin directory. Epstein is part of a team of folks, including Scott Reilly, Pippin Williamson, Otto, and a handful of others, who stand at the door of the repository and review incoming plugins to make sure they meet the <a href=\"http://wordpress.org/plugins/about/guidelines/\" target=\"_blank\">guidelines</a>.</p>\n<p>How does someone get involved with reviewing plugins for WordPress? For Mika it was in the vein with something she&#8217;d be doing already. She has a passion for helping plugins play nice with WordPress. </p>\n<blockquote><p>Otto reached out to me to join the plugin review team after I started, on my own, scanning the repo using <a href=\"https://github.com/markjaquith/WordPress-Plugin-Directory-Slurper\" target=\"_blank\">Mark Jaquith&#8217;s slurper</a> &#8211; for people who were doing some silly, but easy to mistake, things like jquery. This started after WP upgraded jquery and a lot of plugins and themes broke. I was so annoyed, I started trying to head them off at the pass.</p></blockquote>\n<h3>The Plugin Review Process</h3>\n<p>Once a plugin developer submits his work to the directory, he or she generally has to wait a little while for it to be approved. Epstein says that they try to get to everyone within seven days but that some weeks are better than others. &#8220;Small plugins are often approved right away, larger can take a while,&#8221; she said. &#8220;On our good days, we can same-day review everyone. How long each review takes is also subjective to the plugin size and complexity. <span class=\"pullquote alignleft\">Many times a delay pops up when we have to figure out what the code was supposed to do because of poor documentation.</span>&#8221;</p>\n<p>There&#8217;s a helpful gem in there for aspiring plugin developers submitting to WordPress.org: <strong>The better your documentation is, the faster your plugin is likely to move through the process.</strong></p>\n<p>You might be surprised to learn that the plugin review process is not terribly mysterious or complicated. It simply takes a little bit of time. Epstein outlines what&#8217;s involved:</p>\n<blockquote><p>We review plugin submissions, and that really means we download the zip, read the code, test it, and approve it or push back for various things. Every single line of code is looked at, and we generally look for things that are &#8216;wrong.&#8217; After a while, they start to jump out at you.</p></blockquote>\n<p>This translates into a daily routine for her. <strong>&#8220;I usually spend an hour or two a day just on plugins,&#8221;</strong> Epstein said. &#8220;Minimum&#8217;s an hour, which lets me run a decent triage on people with pending requests and some of the new ones.&#8221; Additionally, there are reports and weird issues that come in that she will funnel to the entire team.</p>\n<h4>The Most Common Issues With Plugins</h4>\n<p>Believe it or not, the most common reason for a plugin to get rejected is not ultimately due to brazen violations of the guidelines. Epstein says that many plugin authors simply do not reply to emails: &#8220;After 7 days, if the plugin code isn&#8217;t completed, the plugin&#8217;s rejected.&#8221; </p>\n<p>Bad plugin names are another reason that she says are grounds for rejection, as well as HTML in the title. &#8220;We auto-reject anyone with &#8216;wordpress&#8217; in the plugin slug (like you can no longer request &#8216;wordpress-fedex-shipping&#8217;) but manually we reject anything with encoded HTML characters in the title (like %d) or the term &#8216;plugin&#8217; (most of the time&#8230; if your plugin is &#8216;network plugin settings&#8217; that&#8217;s okay, but &#8216;rebooter-plugin&#8217; is not).&#8221;</p>\n<h3>Why Plugins Get Pulled From the Directory</h3>\n<p>You&#8217;ve probably seen it happen a time or two: A plugin is newly listed in the repository and then it suddenly vanishes a day or two later. I asked Mika why it is that a plugins make it through this review process but end up being pulled just a couple days later. She replied:</p>\n<blockquote><p>Ouch. So &#8230; we&#8217;re human, right? And SOME plugins are really simple and others are really complex. Just like the dev may miss a security hole in their plugin, we might too. While we do look at every line of code, the problem with this is the same as the problem with all security reviews and that is we look for wrong, and sometimes miss it in the cruft of right.</p></blockquote>\n<p>In addition, Epstein said that sometimes WP Tavern or another site will post about a new plugin and then a larger number of people will take a look at it, inspect the code, and uncover something that might have been missed. However, there are some plugin developers out there with bad motives, who knowingly violate the guidelines through what Epstein calls a <strong>&#8220;bait-and-switch&#8221;</strong>:</p>\n<blockquote><p>Someone submits plugin A, we approve it, but they upload plugin B to the repository. That&#8217;s something a lot of spammers like to do. Sometimes people upload the wrong version of the code by accident, other times they intentionally go back and add in code we told them to remove. We try to mitigate this by filtering emails (I actually get an email for every single plugin check in) and scan for known issues, but it&#8217;s never-ending. Right now there are 20 security reports to go through.</p></blockquote>\n<p>The review team is constantly improving its checks, which help them scan for the most basic and unintentional violations. Unfortuantely, there is no way to scan for bait-and-switch techniques, which require someone to go back and manually check for violations after the plugin is already sent to the repository.</p>\n<h3>Advice For Managing Orphaned Plugins</h3>\n<p>One of the problems plaguing the plugin directory is plugins that have been abandoned or are no longer maintained. Given Epstein&#8217;s close involvement with support, I asked her what the best course of action is for a plugin author who no longer wishes to update his/her plugin on WordPress.org. Would it be best to remove it? If he/she can&#8217;t find someone to adopt the plugin, is it better to leave the plugin there as a starting point for someone else or to remove it entirely to prevent frustrating users? Ultimately, the decision falls to the plugin author, but Epstein offered some practical tips:</p>\n<ul>\n<li>If a plugin author wants to no longer support or update a plugin, I suggest they make DARN SURE that&#8217;s documented in their readme!</li>\n<li>If they want to leave it open for someone else to adopt that&#8217;s great, just make sure to put up a way to be contacted.</li>\n<li>If they want to close it forever and ever, that&#8217;s okay too, just email plugins AT wordpress.org and link to the plugin.</li>\n</ul>\n<p>&#8220;Which is better? Depends on the plugin,&#8221; she said. &#8220;Like <a href=\"http://wordpress.org/plugins/twitter-blackbird-pie/\" target=\"_blank\">Blackbird Pie</a>, the plugin to embed Twitter, was something I would feel was essential not to close &#8230; until we added in Twitter oEmbeds. Now it&#8217;s not really as needed and may not even work. Would I extend that or close it? Hard to say, even if it was mine.&#8221;</p>\n<h3>The Readme.txt File is Key to Improving User Experience in the Plugin Directory</h3>\n<p>When searching the directory, it&#8217;s not uncommon to find plugins with what seems to be only a title. Many plugins are missing vital details (or any details), screenshots, FAQs and basic information about what the plugin does. I asked Epstein what can we do to encourage plugin authors to provide more information. She has a few solid tips:</p>\n<blockquote><p>I hate bad readmes with a passion. I try to push people to make better ones, pointing out that if the readme (which makes your wporg repository page) isn&#8217;t descriptive and helpful, no one will use your plugin and you&#8217;ll waste time answering easy questions. But we only force them to have a readme at submission if they&#8217;re a service (that is they&#8217;re calling other servers). Screenshots aren&#8217;t always needed, but a good and descriptive readme would save everyone a lot of pain. Short of letting me actually chase after people with a baseball bat, I don&#8217;t know if we&#8217;ll ever get to a place where everyone&#8217;s doing that.</p></blockquote>\n<p>Unfortunately, the plugin review team cannot require better readme.txt files, but her advice would be good to take to heart if you are a plugin developer reading this. Don&#8217;t leave people in the dark about what your plugin does if you want anyone to use it.</p>\n<p>Now that you know a little bit more about what the plugin review team has to contend with, aren&#8217;t you grateful for everything they do on WordPress.org? Many thanks to Mika Epstein and the rest of the team for their daily work on the <a href=\"http://wordpress.org/plugins/\" target=\"_blank\">WordPress Plugin Directory</a>. Without them, the directory would be a wasteland, overrun with spam and security threats. Because of their dedication, WordPress.org remains one of the safest places to look for extensions.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:31:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WPTavern: Tickets On Sale For WordCamp Dayton, Ohio\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15246\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"http://wptavern.com/tickets-on-sale-for-wordcamp-dayton-ohio?utm_source=rss&utm_medium=rss&utm_campaign=tickets-on-sale-for-wordcamp-dayton-ohio\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1975:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2013/12/WordCampDayton2014Logo.jpg\" rel=\"prettyphoto[15246]\"><img src=\"http://wptavern.com/wp-content/uploads/2013/12/WordCampDayton2014Logo.jpg\" alt=\"WordCamp Dayton 2014\" width=\"177\" height=\"226\" class=\"alignright size-full wp-image-12640\" /></a> Six weeks from now between March 7th and 8th, <a href=\"http://2014.dayton.wordcamp.org/\" title=\"http://2014.dayton.wordcamp.org/\">WordCamp Dayton, Ohio</a> will be underway. This is the first WordCamp to take place in the Dayton area and is <a href=\"http://central.wordcamp.org/schedule/\" title=\"http://central.wordcamp.org/schedule/\">one of three scheduled</a> in the state of Ohio. Sessions range from <a href=\"http://2014.dayton.wordcamp.org/session/podcasting-for-wordpress/\" title=\"http://2014.dayton.wordcamp.org/session/podcasting-for-wordpress/\">Podcasting for WordPress</a> to <a href=\"http://2014.dayton.wordcamp.org/session/wordpress-version-control/\" title=\"http://2014.dayton.wordcamp.org/session/wordpress-version-control/\">WordPress Version control</a>. There are three tracks of sessions available for the publisher, power user, and developer. To see a full list of speakers and their sessions, check out <a href=\"http://2014.dayton.wordcamp.org/schedule/\" title=\"http://2014.dayton.wordcamp.org/schedule/\">the event schedule</a>. </p>\n<p><a href=\"http://2014.dayton.wordcamp.org/tickets/\" title=\"http://2014.dayton.wordcamp.org/tickets/\">Tickets for the event</a> are on sale and cost <strong>$40.00</strong> for general admission. If you&#8217;re a freelance developer, there is a specific package just for you that will get your name, website, and Twitter handle published on the <a href=\"http://2014.dayton.wordcamp.org/call-for-sponsors/\" title=\"http://2014.dayton.wordcamp.org/call-for-sponsors/\">WordCamp Dayton sponsors page</a>. I&#8217;ll be in attendance at this years event. If you&#8217;re going, let me know in the comments so we can meetup.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 18:17:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: The Four Freedoms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43469\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://ma.tt/2014/01/four-freedoms/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12488:\"<p>Eleven months before the U.S. declared war on Japan, <a href=\"http://voicesofdemocracy.umd.edu/fdr-the-four-freedoms-speech-text/\">President Franklin D. Roosevelt said</a> &#8220;As men do not live by bread alone, they do not fight by armaments alone.&#8221; He articulated four fundamental freedoms that everyone in the world ought to enjoy:</p>\n<ol>\n<li>Freedom of speech.</li>\n<li>Freedom of worship.</li>\n<li>Freedom from want.</li>\n<li>Freedom from fear.</li>\n</ol>\n<p>Fast forward 72 years: technology has advanced at dizzying rates and permeated every aspect of our lives, from <a title=\"Too much technology.\" href=\"http://www.theatlantic.com/health/archive/2012/03/the-most-scientific-birth-is-often-the-least-technological-birth/254420/\">how we are born</a> to <a title=\"Still too much technology.\" href=\"http://www.newyorker.com/reporting/2007/04/30/070430fa_fact_gawande\">how we die</a> and everything in between. In this co-evolution of society and technology, what it means to be truly &#8220;free&#8221; is no longer about just the country we live in, or even its laws, but is shaped by the products we live <em>on</em>.</p>\n<p>As <a title=\"Don\'t you wish Marc blogged more?\" href=\"http://online.wsj.com/news/articles/SB10001424053111903480904576512250915629460\">Marc Andreessen says, software is eating the world</a>. It’s a creative gale of destruction that irreversibly changes every industry it touches, and if you don&#8217;t control the software, the software controls you. It mediates how and with whom you communicate, what news you see, and what other software you&#8217;re able to run. It <a title=\"Long, but good, read.\" href=\"http://edge.org/responses/how-is-the-internet-changing-the-way-you-think\">influences</a> the <a href=\"http://www.theatlantic.com/magazine/archive/2008/07/is-google-making-us-stupid/306868/\">very way your brain works</a>, as you process the creative gale of <em>distraction</em> that interrupts us all hundreds of times each day. With <a href=\"http://www.nirandfar.com/2012/10/escape.html\">every ping</a>, software burrows deeper into our lives.</p>\n<p>In the early nineties, a prescient hacker named <a title=\"Read about the parrots.\" href=\"http://stallman.org/\">Richard Stallman</a> — working at MIT, where today&#8217;s future had already happened — recognized this shift. He <a href=\"https://www.gnu.org/philosophy/free-sw.html\">proposed a set of four freedoms</a> that were fundamental for software in an enlightened, tech-dependent society.</p>\n<ol start=\"0\">\n<li>The freedom to run the program, for any purpose.</li>\n<li>The freedom to study how the program works, and change it so it does your computing as you wish.</li>\n<li>The freedom to redistribute copies so you can help your neighbor.</li>\n<li>The freedom to distribute copies of your modified versions, giving the community a chance to benefit from your changes.</li>\n</ol>\n<p>(Aside: I originally thought Stallman <a href=\"http://en.wikipedia.org/wiki/Zero-based_numbering\">started counting with zero instead of one</a> because he&#8217;s a geek. He is, but that wasn&#8217;t the reason. Freedoms one, two, and three came first, but later he wanted to add something to supercede all of them. So: freedom zero. The geekness is a happy accident.)</p>\n<p>This is our Bill of Rights. Stallman called it <a title=\"Don\'t call it open source.\" href=\"https://www.gnu.org/philosophy/free-sw.html\">Free Software</a>. The &#8220;free&#8221; doesn&#8217;t have to do with price, as you’re still free to charge for your software, but with freedom to create. Or as we geeks often say: not free as in beer, <a href=\"http://en.wikipedia.org/wiki/Freedom_of_speech_in_the_United_States\">free as in speech</a>.</p>\n<p>People are scared of free software, and I understand why. You&#8217;re taking the <a title=\"Industries with low IP protection are more creative and generate more sales.\" href=\"http://intenseminimalism.com/2010/creativity-in-a-copyright-less-world/\">most valuable thing</a> you have, <a title=\"Old-school theme.\" href=\"http://sob.apotheon.org/?p=1519\">your intellectual property</a>, and granting the freedom you enjoy as a creator to anyone who downloads your work. It&#8217;s terrifying, actually. It’s releasing your ideas, and letting anyone build on them — in a way that might be better than your own work. It’s releasing your traditional understanding of ownership, and your fear of being out-developed.</p>\n<p>The most experienced entrepreneurs can cling to the concept that your <a href=\"http://www.paulgraham.com/ideas.html\">idea is something precious that must be protected from the world</a>, and meted out in a controlled way. Lots of us hang on to the assumption that scarcity creates a proprietary advantage. It’s how many non-tech markets work.</p>\n<p>Open source abdicates your flexibility as a developer to better serve the people who actually use your products. You can see that as a constraint&#8230; or you can see it as a door to iteration, innovation, and constant progress.</p>\n<p>I&#8217;ve spent a third of my life building software based on Stallman’s four freedoms, and I&#8217;ve been astonished by the results. <a href=\"http://wordpress.org/\">WordPress</a> wouldn’t be here if it weren’t for those freedoms, and it couldn’t have evolved the way it has.</p>\n<p>WordPress was based on a program called <a title=\"The header is still classic.\" href=\"http://cafelog.com/\">B2/cafelog</a> that predated it by two years. I was using B2 because it had freedoms 0 and 1: I could use it for whatever I wanted, including my zero-budget personal blog, and the source code was open. It was elegant and easy to understand, and anyone could tweak it.</p>\n<p>B2 was ultimately <a title=\"This post is where WordPress started.\" href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">abandoned</a> by its creator. If I’d been using it under a proprietary license, that would have been the end — for me, and all its other users. But because we had freedoms 2 and 3, Mike Little and I were able to use the software as a foundation, giving us a two-year headstart over building something from scratch, and realize our own vision of what blogging could be.</p>\n<p>We were just consumers of the software, volunteers in the forums, and occasional contributors to the codebase, but because (of the GPL) we had the freedom to build on B2, we were able to continue development as if it had been our own creation.</p>\n<p>Ten years later, those freedoms are still embedded in every copy of WordPress downloaded, including the <a href=\"http://wordpress.org/download/counter/\">9.2 million downloaded</a> in the past month or so since our <a href=\"http://wordpress.org/news/2013/12/parker/\">3.8 release</a>.</p>\n<p>I believe that software, and in fact entire companies, should be run in a way that assumes that the sum of the talent of people outside your walls is greater than the sum of the few you have inside. None of us are as smart as all of us. Given the right environment — one that leverages the marginal cost of distributing software and ideas — independent actors can work toward something that benefits them, while also increasing the capability of the entire community.</p>\n<p>This is where open source gets really interesting: it&#8217;s not just about the <a href=\"http://www.gnu.org/licenses/license-list.html\">legal wonkery around software licensing</a>, but what effect open sourced software has on people using it. In the proprietary world, those people are typically called &#8220;users,&#8221; a strange term that connotes dependence and addiction. In the open source world, they’re more rightly called a community.</p>\n<p>The core features of WordPress aren’t <a href=\"http://www.amazon.com/Rocket-Surgery-Made-Easy-Do-It-Yourself/dp/0321657292\">rocket surgery</a>. A handful of smart people in a room for a year could create a reasonable approximation of the software, and undoubtably improve some things — I see other startups do this <a title=\"Someday they will build a museum to document your former competitors.\" href=\"http://www.crunchbase.com/tag/cms\">three or four times a year</a>.</p>\n<p>What they miss is that WordPress isn&#8217;t a checklist of features. It&#8217;s over <a title=\"I have about 20 of them.\" href=\"http://wordpress.org/plugins/\">29,000 plugins</a> created by the community, from the in-demand things like SEO to niche features like <a title=\"I can\'t make these things up.\" href=\"http://wordpress.org/plugins/hundstall-404/\">using your 404 page to help adopt homeless dogs in Sweden</a>. Every WordPress site looks different, because of the thousands of themes available. Instead of one event to outdo, there are more than <a title=\"Check one out if you haven\'t been yet, amazing groups of folks.\" href=\"http://central.wordcamp.org/\">70 volunteer-organized WordCamps on six continents</a> (and there’ll be more in 2014).</p>\n<p>WordPress marketing has nothing to do with its website or <a title=\"Fight the Fauxgo.\" href=\"http://wordpress.org/about/logos/\">logo</a>, it&#8217;s the <a href=\"http://wordpress.tv/2013/07/29/matt-mullenweg-state-of-the-word-2013/\">tens of thousands of people who make a living building WordPress sites</a> and receive so much value from it that they proselytize to anyone that will listen, spreading the flame one site at a time. It works — as of December 2013, 21% of websites are powered by WordPress. One-fifth of the web is built with a tool that anyone can use, change, or improve, whenever and however they want (even more when you count other open source projects, like Drupal).</p>\n<p>This approach to building isn&#8217;t an abdication of developers’ and designers’ responsibility to build beautiful, functional software. Design and forethought are <em>more important</em> than ever when every change sends millions of independent actors down a new path. Changes to WordPress have consequences today, tomorrow, five years, and ten years down the road, but the passion and talent of the community helps ensure that it always moves forward in a positive way.</p>\n<p>The four freedoms don’t limit us as creators — they open possibilities for us as creators <em>and</em> consumers. When you apply them to software, you get Linux, Webkit/Chrome, and WordPress. When you apply them to medicine, you get the <a href=\"http://www.opengenomicsengine.org/\">Open Genomics Engine</a>, which is accelerating cancer research and bringing us closer to personalized treatment. When you apply them to companies, you get radically geographically distributed, results-based organizations like <a href=\"http://automattic.com/\">Automattic</a>. When you apply them to events you get <a href=\"http://www.ted.com/tedx\">TEDx</a>, <a title=\"Which I accidentally ended up helping get started.\" href=\"http://en.wikipedia.org/wiki/BarCamp\">Barcamp</a>, and <a href=\"http://wordcamp.org/\">WordCamp</a>. When you apply them to knowledge, you get <a title=\"Where people argue you for deletion.\" href=\"http://wikipedia.org/\">Wikipedia</a>.</p>\n<p><a href=\"http://www.williamgibsonbooks.com/\">William Gibson</a> is attributed with saying &#8220;The future is already here — it&#8217;s just not very evenly distributed.&#8221; The world is changing faster than any one person or organization can keep up with it. Closed off, proprietary development creates closed off, proprietary products that won’t keep pace in the long run. Open source provides another path — one that’s open to everyone, and can take advantage of the skills and talents of anyone in the world to build software that helps everyone.</p>\n<p>As <a href=\"http://en.wikipedia.org/wiki/Joy\'s_Law_(management)\">Bill Joy said</a>, &#8220;No matter who you are, most of the smartest people work for someone else.&#8221; Good ideas aren’t the sole province of groups of people behind high walls, and software shouldn’t be either.</p>\n<p><em>This was adapted from a talk I gave at <a title=\"Was great fun, hope they do it again next year.\" href=\"http://www.lifeisbeautifulfestival.com/\">the Life is Beautiful festival</a> in <a title=\"One of the more interesting scenes around right now.\" href=\"http://downtownproject.com/\">Downtown Las Vegas</a>. Thanks to <a href=\"http://kingofstates.com/\">Michelle</a>, <a href=\"http://stratechery.com/\">Ben</a>, <a href=\"http://intenseminimalism.com/\">Davide</a>, and <a href=\"http://paulmaiorana.com/notes/\">Paul</a> for help with this.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 17:02:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WordPress.tv: Konstantin Kovshenin: Templating WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30011\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.tv/2014/01/23/konstantin-kovshenin-templating-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:661:\"<div id=\"v-JH7sJM4H-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30011/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30011/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30011&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/23/konstantin-kovshenin-templating-wordpress/\"><img alt=\"Konstantin Kovshenin: Templating WordPress\" src=\"http://videos.videopress.com/JH7sJM4H/video-6338ae249d_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 16:03:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WordPress.tv: Joe Hoyle: Setting Up Production Environments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=30003\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wordpress.tv/2014/01/23/joe-hoyle-setting-up-production-environments/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:667:\"<div id=\"v-c5z1cRXz-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30003/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30003/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30003&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/23/joe-hoyle-setting-up-production-environments/\"><img alt=\"Joe Hoyle: Setting Up Production Environments\" src=\"http://videos.videopress.com/c5z1cRXz/video-3b5a88069a_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 15:39:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Interview With Jason Schuller Founder Of Press75.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15204\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:168:\"http://wptavern.com/interview-with-jason-schuller-founder-of-press75-com?utm_source=rss&utm_medium=rss&utm_campaign=interview-with-jason-schuller-founder-of-press75-com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2067:\"<p>The last time I spoke with <a href=\"http://jason.sc/\" title=\"http://jason.sc/\">Jason Schuller</a>, it was 2008 at WordCamp Chicago. He had just launched his commercial theme company <a href=\"http://press75.com/\" title=\"http://press75.com/\">Press75</a>. Since 2008, he&#8217;s launched a number of projects such as ThemeGarden, the first ever WordPress theme marketplace that gave 100% of the sale back to the theme author. Lately, Jason has been experimenting with creating simple publishing systems like Dropplets and Leeflets that focus on streamlining the publishing process. Many of these projects have since shut down.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/ThemeGardenLogo.jpg\" rel=\"prettyphoto[15204]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/ThemeGardenLogo.jpg\" alt=\"ThemeGarden Logo\" width=\"458\" height=\"231\" class=\"aligncenter size-full wp-image-15222\" /></a></p>\n<p>I caught up with Jason Schuller one on one to find out what happened to all of the projects mentioned above, what he&#8217;s been up to the past 6 years and last but not least, find out what he&#8217;s working on in the immediate future. During the interview, we learn some valuable lessons from Jason such as when to ask others for help when a project gets too large for one person to handle. He tells us how he got involved with WordPress theme development and how WordPress became a pivotal moment in his life. </p>\n<p>One of the main reasons for conducting this interview is that based on everything I&#8217;ve read from <a href=\"https://twitter.com/jschuller\" title=\"https://twitter.com/jschuller\">his Twitter account</a>, it seemed like he was leaving the WordPress community to pursue other opportunities. Jason told me that although he won&#8217;t be concentrating his efforts on WordPress in the immediate future, he will still attend WordCamps and continue to interact with all of the friends he&#8217;s made throughout the community over the years. I wish Jason the best with his future endeavors and hope you enjoy the interview. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 02:05:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: WordPress.org vs. GitHub For Hosting WordPress Plugins and Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=13576\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:192:\"http://wptavern.com/wordpress-org-vs-github-for-hosting-wordpress-plugins-and-themes?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-org-vs-github-for-hosting-wordpress-plugins-and-themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8157:\"<p>There are many factors that come into play when deciding where to host your open source WordPress plugin or theme. Who is your target audience? How much support do you want to offer? Is the project open for collaboration? For many developers this choice often comes down to <a href=\"http://wordpress.org/\" target=\"_blank\">WordPress.org</a> vs. <a href=\"https://github.com/\" target=\"_blank\">GitHub</a>. </p>\n<p>In the past, hosting with WordPress.org was the only option that would allow developers to push out updates to their plugin or theme via the WordPress admin. The <a href=\"https://github.com/afragen/github-updater\" target=\"_blank\">GitHub Updater</a> plugin, created by Andy Fragen and added to GitHub in July of 2013, makes it possible to ship updates to Github-hosted plugins and themes. This makes it convenient for developers who prefer GitHub to stay within their preferred workflow while continuing to provide updates. Incidentally, this plugin is banned from the WordPress.org repository.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/updater.png\" rel=\"prettyphoto[13576]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/updater.png\" alt=\"updater\" width=\"640\" height=\"480\" class=\"aligncenter size-full wp-image-15182\" /></a></p>\n<p>Of course there are a number of other places that you can host your project, i.e. your own website or another code sharing site. We&#8217;re looking at GitHub vs. WordPress.org for the purposes of this comparison, since the two are among the most popular.</p>\n<h2>Advantages of Hosting Your Project on WordPress.org</h2>\n<p>By far, one of the best reasons to host a plugin or theme on WordPress.org is the increased exposure that it will offer for your work. Your extension is just a couple clicks away when a user performs a search within the WordPress admin, giving you an audience of millions of potential users. </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/wporg.jpg\" rel=\"prettyphoto[13576]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/wporg.jpg\" alt=\"wporg\" width=\"969\" height=\"399\" class=\"aligncenter size-full wp-image-15207\" /></a></p>\n<p>A summary of the advantages includes:</p>\n<ul>\n<li>Maximum exposure: Your extension can be searched for within the WP admin</li>\n<li>Built-in trac and support forums</li>\n<li>Easily push out updates to users</li>\n<li>Ratings, reviews and download stats</li>\n<li>Extensions are more trusted due to the WordPress.org review process and guidelines</li>\n</ul>\n<p>Of course, some of these same &#8220;advantages&#8221; could also be considered disadvantages. For example, if you&#8217;re not willing to offer free support, having your plugin or theme on WordPress.org with such a wide audience may send you a flood of support requests. If you don&#8217;t have the time to provide updates or support, the resulting star ratings and reviews may hurt your extension&#8217;s reputation.</p>\n<h4>Disadvantages:</h4>\n<p>One of the primary disadvantages of hosting a project on WordPress.org alone is that it can severely limit collaboration. Themes and plugins on WordPress.org are simply not geared for collaborative development. Most developers find it easier to collaborate via Git. Hosting on WordPress.org also requires a basic knowledge of SVN, which is not very popular these days. In summary, the disadvantages include:</p>\n<ul>\n<li>SVN</li>\n<li>Does not encourage collaboration</li>\n<li>Possible massive influx of support requests</li>\n</ul>\n<h2>Advantages of Hosting Your Project on GitHub</h2>\n<p>Where a lack of collaboration is probably the strongest disadvantage of hosting on WordPress.org, it&#8217;s also the biggest advantage to hosting your extension on GitHub. The barrier of entry for participation on GitHub is much higher, which significantly lessens the likelihood of you becoming inundated with support requests.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/github-social-coding.jpg\" rel=\"prettyphoto[13576]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/github-social-coding.jpg\" alt=\"github-social-coding\" width=\"580\" height=\"230\" class=\"aligncenter size-full wp-image-15213\" /></a></p>\n<p>Other advantages include:</p>\n<ul>\n<li>Easy for others to contribute to your project</li>\n<li>Built-in wiki and issues queue available</li>\n<li>Fewer support requests</li>\n<li>Can easily push out updates w/ use of GitHub Updater</li>\n<li>Fewer restrictions &#8211; No code review process or extra guidelines for compliance</li>\n<li>Traffic analytics &#8211; GitHub recently introduced <a href=\"https://github.com/blog/1672-introducing-github-traffic-analytics\" target=\"_blank\">analytics data</a> for repositories</li>\n</ul>\n<h4>Disadvantages:</h4>\n<ul>\n<li>Likely a smaller audience</li>\n<li>Will need to bundle the Git Updater with your extension or ask users to install it in order to ship updates</li>\n<li>Does not include the same level of user trust as projects hosed on WordPress.org</li>\n</ul>\n<p>If you don&#8217;t want to have to mess with SVN and don&#8217;t mind losing out on the audience you get hosting on WordPress.org, then hosting your project on GitHub might be a strong option for you. </p>\n<h2>The Best of Both Worlds</h2>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/wpvsgithub.jpg\" rel=\"prettyphoto[13576]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/wpvsgithub.jpg\" alt=\"wpvsgithub\" width=\"1600\" height=\"594\" class=\"aligncenter size-full wp-image-15216\" /></a><br />\nThere&#8217;s no clear winner in the comparison between hosting on WordPress.org vs. Github. It depends entirely on your workflow and your goals for the extension.  Of course, many projects do a mixture of both, either through maintaining git mirrors or synchronizing via a script. Since every GitHub repository is also a Subversion repository, you can use SVN tools to checkout, branch, and commit to GitHub repositories if you are so inclined.  </p>\n<p>Brent Shepherd has a <a href=\"https://github.com/thenbrent/multisite-user-management/blob/master/deploy.sh\" target=\"_blank\">script that will deploy a WordPress plugin from within Git</a> to WordPress.org&#8217;s SVN repository. &#8220;Since running the script for my plugins, I&#8217;ve not suffered the frustrations of minor errors – like having version numbers in the readme.txt &#038; plugin file differ,&#8221; Shepherd said. &#8220;I&#8217;ve lost less time deploying, so I&#8217;ve released more frequently, which means fewer bugs in the wild.&#8221;</p>\n<p>Here are some other resources you might want to check out for learning more about working between Git and SVN for WordPress extensions.</p>\n<ul>\n<li><a href=\"http://ben.lobaugh.net/blog/90633/creating-a-synchronized-github-fork-of-a-wordpress-org-subversion-plugin-repository\" target=\"_blank\">Creating a Synchronized Github Fork of a WordPress.org Subversion Plugin Repository</a> &#8211; Ben Lobaugh</li>\n<li><a href=\"http://teleogistic.net/2011/05/revisiting-git-github-and-the-wordpress-org-plugin-repository/\" target=\"_blank\">Revisiting Git, Github, and the WordPress.org Plugin Repository</a> &#8211; Boone Gorges</li>\n<li><a href=\"http://danielbachhuber.com/2012/09/30/git-in-my-subversion/\" target=\"_blank\">Git in my Subversion</a> &#8211; Daniel Bachhuber</li>\n<li><a href=\"https://github.com/growthdesigner/WordPress-3.8-Dashboard/issues/3\" target=\"_blank\">Syncing Git Repo with WordPress.org</a> &#8211; Daniel Bachhuber</li>\n<li><a href=\"http://thereforei.am/2011/04/21/git-to-svn-automated-wordpress-plugin-deployment/\" target=\"_blank\">Git to SVN: Automated WordPress Plugin Deployment</a> &#8211; Brent Shepherd</li>\n<li><a href=\"http://sudarmuthu.com/blog/developing-wordpress-plugins-in-github\" target=\"_blank\">Developing WordPress Plugins in Github</a> &#8211; Sudar Muthu</li>\n</ul>\n<p>Every developer has a different workflow, but there&#8217;s a good option for however you choose to develop and maintain your WordPress plugin or theme. After reviewing the advantages and disadvantages of each, which of these factors is the most important for you when making a decision about where to host an extension? </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jan 2014 23:43:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Matt: Abusing Copyright Laws\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43463\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://ma.tt/2014/01/abusing-copyright-laws/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:251:\"<p>Paul Sieminski, the general counsel at Automattic (Automattlock), writes for Wired on how <a href=\"http://www.wired.com/opinion/2014/01/internet-companies-care-fair-use/\">Corporations Abusing Copyright Laws Are Ruining the Web for Everyone</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jan 2014 19:21:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WPTavern: CodePen Releases Official WordPress Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15130\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"http://wptavern.com/codepen-releases-official-wordpress-plugin?utm_source=rss&utm_medium=rss&utm_campaign=codepen-releases-official-wordpress-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2629:\"<p><a href=\"http://codepen.io/\" target=\"_blank\">CodePen</a> has released an official plugin for embedding pens in WordPress. If you haven&#8217;t yet discovered CodePen, it&#8217;s basically a virtual playground for frontend developers and browsing the site  can be addictive. It&#8217;s a place where you can write HTML, CSS, and JavaScript code in your browser and then see an instant preview. Each collection of snippets you create is saved under your account as a &#8220;pen&#8221; with its live preview directly beneath it. </p>\n<p><a href=\"http://wordpress.org/plugins/codepen-embedded-pen-shortcode/\" target=\"_blank\">CodePen Embedded Pens Shortcode</a> is the new plugin that makes it easy to embed any pen on your self-hosted WordPress site. On the CodePen side of things, pens have now been updated to show a WordPress shortcode option when you click on Embed: </p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/embed-pen.jpg\" rel=\"prettyphoto[15130]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/embed-pen.jpg\" alt=\"embed-pen\" width=\"944\" height=\"470\" class=\"aligncenter size-full wp-image-15164\" /></a></p>\n<p>If you&#8217;ve found a pen that inspires you and want to share it on your site, it&#8217;s as easy as copying that shortcode and pasting it into either the visual or text editor in WordPress.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/visual-editor.jpg\" rel=\"prettyphoto[15130]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/visual-editor.jpg\" alt=\"visual-editor\" width=\"1138\" height=\"657\" class=\"aligncenter size-full wp-image-15170\" /></a></p>\n<p>The pen will then be embedded on your site with a tabbed interface for the code and the demo:</p>\n<p class=\"codepen\">See the Pen <a href=\"http://codepen.io/sang_nguyen/pen/pJxms\">pJxms</a> by Sang Nguyen (<a href=\"http://codepen.io/sang_nguyen\">@sang_nguyen</a>) on <a href=\"http://codepen.io\">CodePen</a>.</p>\n<p><br />\nThe plugin allows you to set a default theme for the pens. You can also override the default theme via the shortcode attribute. In the future, the CodePen team plans to add a fancy UI for picking pens to embed as well as more control over the HTML output.</p>\n<p>CodePen and WordPress working together can be a beautiful thing, especially if you often publish frontend development tutorials with HTML, CSS and/or Javascript. Check out the <a href=\"http://wordpress.org/plugins/codepen-embedded-pen-shortcode/\" target=\"_blank\">CodePen Embedded Pens Shortcode</a> plugin on WordPress.org if you&#8217;re active on CodePen and want to add interactive demos to your WordPress site.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jan 2014 18:11:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WordPress.tv: David Coveney: Can WordPress Save The Publishing Industry?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=29948\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://wordpress.tv/2014/01/22/david-coveney-can-wordpress-save-the-publishing-industry/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:692:\"<div id=\"v-bvUnu4KU-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/29948/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/29948/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=29948&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/01/22/david-coveney-can-wordpress-save-the-publishing-industry/\"><img alt=\"David Coveney: Can WordPress Save The Publishing Industry?\" src=\"http://videos.videopress.com/bvUnu4KU/video-dd5e5adfff_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jan 2014 13:46:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WPTavern: Quick Tip: WordPress Saves Your Widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=15146\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:140:\"http://wptavern.com/quick-tip-wordpress-saves-your-widgets?utm_source=rss&utm_medium=rss&utm_campaign=quick-tip-wordpress-saves-your-widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1582:\"<p>Have you ever thought about switching your WordPress theme but then hesitated, wondering what might happen to your widgets? Although it may not be obvious, the good news is that WordPress remembers where you previously had your widgets and saves the settings. If you decide to revert back to your previous theme, WordPress will put your widgets back where they were.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/01/save-widgets.png\" rel=\"prettyphoto[15146]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/01/save-widgets.png\" alt=\"save-widgets\" width=\"1200\" height=\"485\" class=\"aligncenter size-full wp-image-15148\" /></a></p>\n<p>As you can see in the screenshot, WordPress will even remind you of its widget saving capabilities when you switch to a new theme. </p>\n<p>Back in the old days, if you switched your theme and then reverted it, you&#8217;d have to set all your widgets again, one by one. This could be quite a time consuming process if you had several widgetized areas loaded up with multiple widgets. In some cases this discouraged site owners from experimenting with different themes. That&#8217;s why widget saving is one of my favorite features of WordPress. Every time I see this feature reminder, I get a small thrill and I know I can rest easy when changing my theme.</p>\n<p>WordPress has actually been saving your widgets since <a href=\"http://codex.wordpress.org/Version_3.3\" target=\"_blank\">version 3.3</a> was released in December of 2011. It was a small feature but it makes a big difference when you&#8217;re testing new themes.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jan 2014 03:21:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Jan 2014 18:13:02 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"206826\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 31 Jan 2014 18:00:18 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20140131180937\";}", "no");
INSERT INTO `wp_options` VALUES("535", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1391235183", "no");
INSERT INTO `wp_options` VALUES("536", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1391191983", "no");
INSERT INTO `wp_options` VALUES("537", "_transient_timeout_dash_aa95765b5cc111c56d5993d476b1c2f0", "1391235183", "no");
INSERT INTO `wp_options` VALUES("538", "_transient_dash_aa95765b5cc111c56d5993d476b1c2f0", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wptavern.com/how-to-create-a-dropdown-menu-of-wordpress-categories-without-using-code?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=how-to-create-a-dropdown-menu-of-wordpress-categories-without-using-code\' title=\'A long standing pain point I’ve had with WordPress is the inability to use the menu administration area to easily add a dropdown list of categories to my theme’s main menu. While the menu system provides the means to add categories to a menu, it doesn’t contain a way to easily create a dropdown list of categories. Thankfully, there is an easy work around that accomplishes the goal without using code. Thanks to Sami Keijonen who told me about this technique on the ThemeHybrid support forums. Start by browsing to Appearance – Menus. Select the menu where you want the link to be displayed. Create a new Link menu item and use # as the URL with the link text of categories. Then click the Add to Menu button. Creating The Placeholder Select which categories you want to be displayed within the dropdown list. After you add the categories to the menu, make sure to drag and drop them so that they are a child link underneath the parent menu of categories. Look at the following screenshot for reference. Arranging The Menu Items After you’ve arranged the category links, save the menu. Visit your front page and hover over the categories link to make sure the dropdown list works correctly. The parent menu item of categories acts as a placeholder which is the ingenious part of the tutorial. Drop Down Menu In Use By using this technique, I can modify which categories and what order they are displayed using the WordPress menu manager. I don’t have to worry about it disappearing via plugins or by switching themes. Thanks again to the always helpful, friendly, ThemeHybrid support forums for this tip.\'>WPTavern: How To Create A Dropdown Menu Of WordPress Categories Without Using Code</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/shortcode-suggest-helps-you-discover-shortcodes-in-wordpress?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=shortcode-suggest-helps-you-discover-shortcodes-in-wordpress\' title=\'If you’re like me, you can never remember the shortcodes you have active on your WordPress site. This inevitably leads you to stop what you’re doing and hunt down the documentation for the feature you’re attempting to use. This is especially true when it’s a shortcode that can be configured with multiple attributes.   What if there was a way to make shortcodes more discoverable in the post editor? That’s exactly what Scott Evans has attempted to do in his Shortcode Suggest plugin. When activated, this plugin adds autosuggest for shortcodes as you type in the visual editor. It also includes a short description of the shortcodes it detects.  As of right now, the plugin is a rough concept that Evans put on github in order to gauge interest and collect feedback. In the future, he plans to improve the design of the suggestions and only load the plugin on the required post types and admin screens. Shortcode Suggest only works on the visual editor but Evans is considering enabling it for the HTML editor, depending on feedback. If there was a more standard approach to including shortcode attributes within inline docs, Evans says the plugin would be even more useful. As it is, there may be some gaps where the information is incomplete. Shortcodes are popular because they provide an easy and approachable method for users to embed complex functionality within content. However, there’s no easy way to know what shortcodes are available to your installation. Shortcode Suggest provides a nice solution for this. Download it from github and take it for a test drive. Is this a plugin that you’d like to see further developed? What would make it more useful?\'>WPTavern: Shortcode Suggest Helps You Discover Shortcodes in WordPress</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/major-update-to-wordpress-for-ios-now-available?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=major-update-to-wordpress-for-ios-now-available\' title=\' WordPress for iOS 3.9 has been released and it includes some major changes. The first thing you’ll notice is that the  sidebar navigation has been removed. In its place is a tab bar-based layout. This has enabled many other visual changes throughout the app. Reader, comments, and notifications have been revamped. My favorite feature in this update is seamless inline commenting. This addition makes replying to comments feel like text messaging. Keep in mind that from version 3.9 onwards will require iOS7. My Thoughts On 3.9 I’ve upgraded the app on my iPhone 5 and without the sidebar navigation, I feel lost. The first screen that loads is Reader. From here, I have no idea what to do or where to go to access my connected sites. This is a drastic interface change that should have had a tour attached to it. I’d like to see a welcome screen or helpers added to WordPress for iOS so the feeling people get when they upgrade is not confusion or frustration. After a few minutes of using the new interface, I was able to locate my connected sites. To find your connected sites select the Me button on the bottom of the app. Simple Post Editor Once I was comfortable navigating, I was able to appreciate the speed and responsiveness of the app. Some of this is due to the hardware within the iPhone 5. Regardless, the app is fast! I appreciate how big the Gravatars are on the comments and notifications pages. Thanks to the extra height on the iPhone 5, writing a post is easier than it was on my iPhone 4. The post editor is amazingly simple. Post title at the top, content underneath with the keyboard at the bottom. This layout works great. I like how the meta data entries are on a separate screen which enables the post editor to remain simple. Solid Update Overall this is a solid update. Congrats to the team and thanks to all of the contributors that helped make WordPress for iOS 3.9 a reality. If you would like to get involved with WordPress for iOS development, drop them a line at make.wordpress.org/mobile and grab a copy of the code at github.com/wordpress-mobile/WordPress-iOS. You can also provide feedback and follow progress via their Twitter account @WordPressiOS.\'>WPTavern: Major Update To WordPress For iOS Now Available</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/why-post-by-email-is-still-available-in-wordpress?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=why-post-by-email-is-still-available-in-wordpress\' title=\'It’s that time of year again. The process of finding mentors, projects, and students is underway for the 2014 edition of the Google Summer of Code. One of the successful projects from last years event is the Post by Email plugin by Kat Hagan. The plugin was supposed to replace the feature in WordPress 3.7.  I reached out to WordPress core developer Andrew Nacin to find out if the feature will be removed from WordPress sometime soon and whether Kat’s plugin was a source of the delay. One thing is certain, the feature will be removed. There were some nagging concerns that outright removing the feature from core could inconvenience users who still rely on it. That doesn’t detract from Kat’s work at all. Her plugin is fantastic and it’s definitely a huge improvement over what’s in core now. It was never designed to be pulled into core, but rather to provide us an opportunity to remove what’s in core now. Removing post by email presents a number of challenges. This will be the first time a feature is removed from core and substituted by a plugin. The team is still working on a plan of action. In order to make the transition graceful, should we, say, download, activate, and set up Kat’s plugin when updating to WordPress 3.9? Or we could remove it but if they had it configured, point them toward the plugin. Or, at the very least, we could keep it functional, hiding the UI for new and existing installs unless they already had it configured. So there’s a bit more UX decision-making that has to happen there, but it’s on the table. While WordPress is accustomed to merging plugins into core, this is the opposite situation. If I don’t have the post by email functionality configured in WordPress, I hope that it’s detected and the code is removed without adding the plugin to my install. It’s easy enough to delete it but I’d rather not go through the process. It will be interesting to see how this is handled and if the results are satisfactory, it may pave the way for something similar to happen with the Link Manager that was hidden from view in WordPress 3.5 How do you propose this feature be removed with as little hassle to end users as possible?\'>WPTavern: Why Post By Email Is Still Available In WordPress</a></li><li><a class=\'rsswidget\' href=\'http://ios.wordpress.org/2014/01/30/wordpress-for-ios-3-9-released/\' title=\' WordPress for iOS 3.9 is out and now available to download from the App Store. This release is one of our largest app releases to date. This update is remarkable both for the significant changes we’ve introduced, and for the level of dedication it received from our hard-working team members. Version 3.9 includes a major visual redesign of the app. We decided to drop the sidebar navigation and embrace a tab bar-based layout. The app’s new design allowed us to add numerous visual improvements throughout, including revamped and enhanced Reader, Comments, and Notifications sections. We also created a seamless inline commenting experience to make it easier for you to engage with the content you love. Finally, we made visual improvements to the editing experience of posts and pages. Our team has embraced the latest and greatest technologies that Apple has provided us with iOS 7 to deliver you the best app possible. Version 3.9 and future updates will require iOS 7. The app also includes several other changes. On top of various bug fixes and performance improvements, it now supports deep-linking from Twitter, and features an improved login screen. Be sure to try it out. A huge thanks to the contributors who worked on this release: @pivotal-rebecca, @mikejohnstn, @aerych, @h4xnoodle, @astralbodies, @tomwitkin, @irbrad, @beaucollins,@koke, @intoxicated If you would like to get involved with WordPress for iOS development, drop us a line at make.wordpress.org/mobile and grab a copy of the code at github.com/wordpress-mobile/WordPress-iOS. Have feedback? Leave a comment below or tweet us @WordPressiOS   \'>WP iPhone: WordPress for iOS 3.9 Released</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("539", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1391235183", "no");
INSERT INTO `wp_options` VALUES("540", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jan 2014 18:02:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your Wordpress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"WP-PageNavi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wp-pagenavi/#post-363\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 23:17:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"363@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"Adds a more advanced paging navigation interface.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Lester Chan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Google Analytics for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2316@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"Track your WordPress site easily and with lots of metadata: views per author &#38; category, automatic tracking of outbound clicks and pageviews.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Wordfence Security is a free enterprise class security plugin that includes a firewall, virus scanning, real-time traffic with geolocation and more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 7.5 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Better WP Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"The easiest, most effective way to secure WordPress. Improve the security of any WordPress site in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2082@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/wp-super-cache/#post-2572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Nov 2007 11:40:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2572@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"A very fast caching engine for WordPress that produces static html files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Donncha O Caoimh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:7:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Jan 2014 18:13:03 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Thu, 01 Jan 2009 20:34:44 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20140131180937\";}", "no");
INSERT INTO `wp_options` VALUES("541", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1391235183", "no");
INSERT INTO `wp_options` VALUES("542", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1391191983", "no");
INSERT INTO `wp_options` VALUES("543", "_transient_timeout_feed_77fa140e07ce53fe8c87136636f83d72", "1391235183", "no");
INSERT INTO `wp_options` VALUES("544", "_transient_feed_77fa140e07ce53fe8c87136636f83d72", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/plugins/browse/new/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Jan 2014 17:59:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Skip Cart WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/skip-cart-woocommerce/#post-63405\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 19:41:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63405@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"Skip Cart for WooCommerce and go straight to checkout. Suitable for buying single product at ounce like a membership or single product web site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Jean-Philippe Sirois\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"DE Social Login\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/de-social-login/#post-63352\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 12:27:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63352@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:143:\"A Simple wordpress plugin which enable the user to login in wordress site with Google/Twitter/OpenId/LinkedIn/Facebook accounts with one click.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"sunildhanda\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"AdSense Revenue Share\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/adsense-revenue-share/#post-63123\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Jan 2014 14:10:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63123@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"AdSense Revenue Share plugin allows you to share AdSense revenue with authors.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"GarretUA\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"IndieWeb\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/plugins/indieweb/#post-63393\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 11:41:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63393@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"IndieWeb for WordPress!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"pfefferle\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"CP Related Posts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/cp-related-posts/#post-63411\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 21:34:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63411@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:146:\"CP Related Posts is a plugin that displays related articles on your website, manually, or by the terms in the content, title or abstract, and tags\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"codepeople\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"SX No author Pagination\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/plugins/sx-no-author-pagination/#post-63400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 16:58:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63400@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"SX No author Pagination removes properly any author pagination and redirects useless paginated content.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Daniel Roch\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Tumblr Crosspostr\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/tumblr-crosspostr/#post-26546\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 14 May 2011 07:33:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26546@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:141:\"Tumblr Crosspostr cross-posts your published WordPress entries to Tumblr. Changes to your WordPress posts are reflected in your Tumblr posts.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Meitar Moscovitz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"EDD CF7 Register Guest Customers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/plugins/edd-cf7-register-guest-customers/#post-63402\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 18:00:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63402@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"Register EDD guest customers with Contact Form 7 custom registration, disable registration for everyone else.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"isabel104\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"BuzzTarget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/plugins/buzztarget/#post-63387\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 03:53:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63387@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:133:\"Commercial Real Estate Listing integration with BuzzTarget.  Publish your BuzzTarget listings to your Private WordPress powered site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"buzztarget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Gator Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/gator-cache/#post-63172\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 15:56:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63172@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"An easy to manage page cache for Wordpress.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"GatorDog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"ActivityRez Wordpress Web Booker Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/activityrez-webbooker/#post-63341\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 05:37:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63341@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"ActivityRez Webbooker plugin for hosting your own booking engine.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"activityrez\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Cookie Law\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/cookie-eu/#post-62277\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Dec 2013 16:50:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"62277@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Adds a notification message to the top of your website stating that cookies are used, if they continue viewing the site then that counts as implied co\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Tomjoneswp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Switch JQ Version\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/switch-jq-version/#post-63398\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jan 2014 13:42:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63398@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"Let you switch your JQ version and the CDN of JQ of your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jason Ho\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"System Information\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/ad-system-information/#post-63351\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Jan 2014 11:50:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63351@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Displays useful system information for debugging purposes. It gathers information such as PHP settings, Browser used, installed plugin...\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Abid Omar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Zilla Portfolio\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/zillaportfolio/#post-62764\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 13 Jan 2014 22:33:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"62764@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"A complete portfolio plugin for creative folks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"marksouthard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:41:\"http://wordpress.org/plugins/rss/view/new\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Jan 2014 18:13:03 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Fri, 31 Jan 2014 18:34:16 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Fri, 31 Jan 2014 17:59:16 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20140131180937\";}", "no");
INSERT INTO `wp_options` VALUES("545", "_transient_timeout_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1391235183", "no");
INSERT INTO `wp_options` VALUES("546", "_transient_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1391191983", "no");
INSERT INTO `wp_options` VALUES("547", "_transient_timeout_plugin_slugs", "1391278383", "no");
INSERT INTO `wp_options` VALUES("548", "_transient_plugin_slugs", "a:12:{i:0;s:19:\"akismet/akismet.php\";i:1;s:39:\"associate_goliath/associate_goliath.php\";i:2;s:27:\"att-youtube/att-youtube.php\";i:3;s:25:\"duplicator/duplicator.php\";i:4;s:47:\"google-sitemap-plugin/google-sitemap-plugin.php\";i:5;s:9:\"hello.php\";i:6;s:30:\"jetpack-sharing/sharedaddy.php\";i:7;s:20:\"lazy-seo/lazyseo.php\";i:8;s:23:\"ml-slider/ml-slider.php\";i:9;s:41:\"sliding-contact-form-by-formget/index.php\";i:10;s:25:\"ultimate-gallery/init.php\";i:11;s:31:\"youtube-embed/youtube-embed.php\";}", "no");
INSERT INTO `wp_options` VALUES("549", "_transient_timeout_dash_de3249c4736ad3bd2cd29147c4a0d43e", "1391235183", "no");
INSERT INTO `wp_options` VALUES("550", "_transient_dash_de3249c4736ad3bd2cd29147c4a0d43e", "<h4>Most Popular</h4>\n<h5><a href=\'http://wordpress.org/plugins/wordpress-importer/\'>WordPress Importer</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=wordpress-importer&amp;_wpnonce=90ca89ae45&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'WordPress Importer\'>Install</a>)</span>\n<p>Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.</p>\n<h4>Newest Plugins</h4>\n<h5><a href=\'http://wordpress.org/plugins/sx-no-author-pagination/\'>SX No author Pagination</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=sx-no-author-pagination&amp;_wpnonce=183a47c6c0&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'SX No author Pagination\'>Install</a>)</span>\n<p>SX No author Pagination removes properly any author pagination and redirects useless paginated content.</p>\n", "no");
INSERT INTO `wp_options` VALUES("559", "_site_transient_timeout_wporg_theme_feature_list", "1391205706", "yes");
INSERT INTO `wp_options` VALUES("560", "_site_transient_wporg_theme_feature_list", "a:5:{s:6:\"Colors\";a:15:{i:0;s:5:\"black\";i:1;s:4:\"blue\";i:2;s:5:\"brown\";i:3;s:4:\"gray\";i:4;s:5:\"green\";i:5;s:6:\"orange\";i:6;s:4:\"pink\";i:7;s:6:\"purple\";i:8;s:3:\"red\";i:9;s:6:\"silver\";i:10;s:3:\"tan\";i:11;s:5:\"white\";i:12;s:6:\"yellow\";i:13;s:4:\"dark\";i:14;s:5:\"light\";}s:7:\"Columns\";a:6:{i:0;s:10:\"one-column\";i:1;s:11:\"two-columns\";i:2;s:13:\"three-columns\";i:3;s:12:\"four-columns\";i:4;s:12:\"left-sidebar\";i:5;s:13:\"right-sidebar\";}s:8:\"Features\";a:19:{i:1;s:8:\"blavatar\";i:2;s:10:\"buddypress\";i:3;s:17:\"custom-background\";i:4;s:13:\"custom-colors\";i:5;s:13:\"custom-header\";i:6;s:11:\"custom-menu\";i:7;s:12:\"editor-style\";i:8;s:21:\"featured-image-header\";i:9;s:15:\"featured-images\";i:10;s:15:\"flexible-header\";i:11;s:20:\"front-page-post-form\";i:12;s:19:\"full-width-template\";i:13;s:12:\"microformats\";i:14;s:12:\"post-formats\";i:15;s:20:\"rtl-language-support\";i:16;s:11:\"sticky-post\";i:17;s:13:\"theme-options\";i:18;s:17:\"threaded-comments\";i:19;s:17:\"translation-ready\";}s:7:\"Subject\";a:3:{i:0;s:7:\"holiday\";i:1;s:13:\"photoblogging\";i:2;s:8:\"seasonal\";}s:5:\"Width\";a:2:{i:0;s:11:\"fixed-width\";i:1;s:14:\"flexible-width\";}}", "yes");
INSERT INTO `wp_options` VALUES("573", "_site_transient_timeout_theme_roots", "1391196650", "yes");
INSERT INTO `wp_options` VALUES("574", "_site_transient_theme_roots", "a:4:{s:12:\"flexibility3\";s:7:\"/themes\";s:12:\"twentyeleven\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("575", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1391194850;s:7:\"checked\";a:4:{s:12:\"flexibility3\";s:3:\"1.0\";s:12:\"twentyeleven\";s:3:\"1.5\";s:14:\"twentythirteen\";s:3:\"1.1\";s:12:\"twentytwelve\";s:3:\"1.1\";}s:8:\"response\";a:2:{s:12:\"twentyeleven\";a:3:{s:11:\"new_version\";s:3:\"1.7\";s:3:\"url\";s:41:\"https://wordpress.org/themes/twentyeleven\";s:7:\"package\";s:58:\"https://wordpress.org/themes/download/twentyeleven.1.7.zip\";}s:12:\"twentytwelve\";a:3:{s:11:\"new_version\";s:3:\"1.3\";s:3:\"url\";s:41:\"https://wordpress.org/themes/twentytwelve\";s:7:\"package\";s:58:\"https://wordpress.org/themes/download/twentytwelve.1.3.zip\";}}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("576", "_site_transient_update_plugins", "O:8:\"stdClass\":3:{s:12:\"last_checked\";i:1391194850;s:8:\"response\";a:5:{s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":5:{s:2:\"id\";s:5:\"22600\";s:4:\"slug\";s:10:\"duplicator\";s:11:\"new_version\";s:5:\"0.5.1\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/duplicator.0.5.1.zip\";}s:47:\"google-sitemap-plugin/google-sitemap-plugin.php\";O:8:\"stdClass\":5:{s:2:\"id\";s:5:\"30201\";s:4:\"slug\";s:21:\"google-sitemap-plugin\";s:11:\"new_version\";s:5:\"2.8.7\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/google-sitemap-plugin/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/google-sitemap-plugin.2.8.7.zip\";}s:30:\"jetpack-sharing/sharedaddy.php\";O:8:\"stdClass\":5:{s:2:\"id\";s:5:\"45612\";s:4:\"slug\";s:15:\"jetpack-sharing\";s:11:\"new_version\";s:3:\"2.7\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/jetpack-sharing/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/jetpack-sharing.2.7.zip\";}s:23:\"ml-slider/ml-slider.php\";O:8:\"stdClass\":5:{s:2:\"id\";s:5:\"38583\";s:4:\"slug\";s:9:\"ml-slider\";s:11:\"new_version\";s:5:\"2.6.3\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/ml-slider/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/ml-slider.2.6.3.zip\";}s:41:\"sliding-contact-form-by-formget/index.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"45528\";s:4:\"slug\";s:31:\"sliding-contact-form-by-formget\";s:11:\"new_version\";s:3:\"1.5\";s:14:\"upgrade_notice\";s:68:\"There is a new version of Sliding Contact Form By FormGet available.\";s:3:\"url\";s:62:\"https://wordpress.org/plugins/sliding-contact-form-by-formget/\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/plugin/sliding-contact-form-by-formget.1.5.zip\";}}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("580", "asg_cache", "a:1:{s:26:\"amazon.categories.US._root\";a:2:{s:6:\"expire\";i:1391281561;s:5:\"value\";a:39:{i:2858778011;s:20:\"Amazon Instant Video\";i:2619525011;s:10:\"Appliances\";i:2350149011;s:16:\"Apps for Android\";i:2617941011;s:15:\"Arts and Crafts\";i:15690151;s:10:\"Automotive\";i:165796011;s:4:\"Baby\";i:11055981;s:6:\"Beauty\";i:1000;s:5:\"Books\";i:2335752011;s:25:\"Cell Phones & Accessories\";i:1036682;s:22:\"Clothing & Accessories\";i:541966;s:9:\"Computers\";i:130;s:3:\"DVD\";i:493964;s:11:\"Electronics\";i:2238192011;s:10:\"Gift Cards\";i:16310101;s:22:\"Grocery & Gourmet Food\";i:3760931;s:22:\"Health & Personal Care\";i:1063498;s:14:\"Home & Kitchen\";i:228239;s:10:\"Industrial\";i:16310091;s:23:\"Industrial & Scientific\";i:3880591;s:7:\"Jewelry\";i:133141011;s:12:\"Kindle Store\";i:599872;s:9:\"Magazines\";i:10304191;s:13:\"Miscellaneous\";i:2625373011;s:11:\"Movies & TV\";i:163856011;s:13:\"MP3 Downloads\";i:301668;s:5:\"Music\";i:11965861;s:19:\"Musical Instruments\";i:1084128;s:15:\"Office Products\";i:286168;s:20:\"Patio, Lawn & Garden\";i:2619533011;s:12:\"Pet Supplies\";i:672123011;s:5:\"Shoes\";i:409488;s:8:\"Software\";i:3375251;s:17:\"Sports & Outdoors\";i:468240;s:24:\"Tools & Home Improvement\";i:165793011;s:12:\"Toys & Games\";i:468642;s:11:\"Video Games\";i:377110011;s:7:\"Watches\";i:508494;s:8:\"Wireless\";i:13900851;s:20:\"Wireless Accessories\";}}}", "yes");
INSERT INTO `wp_options` VALUES("581", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("582", "asg_publish_type", "schedule", "yes");
INSERT INTO `wp_options` VALUES("583", "asg_posts_per_week", "7", "yes");
INSERT INTO `wp_options` VALUES("584", "asg_max_items", "100", "yes");
INSERT INTO `wp_options` VALUES("585", "asg_keywords_type", "keyword", "yes");
INSERT INTO `wp_options` VALUES("586", "asg_search_keywords", "ebook marketing", "yes");
INSERT INTO `wp_options` VALUES("587", "asg_amazon_market", "US", "yes");
INSERT INTO `wp_options` VALUES("588", "asg_search_category", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("589", "asg_price_min", "", "yes");
INSERT INTO `wp_options` VALUES("590", "asg_price_max", "", "yes");
INSERT INTO `wp_options` VALUES("591", "asg_post_category", "a:1:{i:0;s:1:\"5\";}", "yes");
INSERT INTO `wp_options` VALUES("616", "widget_tag_cloud", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:8:\"taxonomy\";s:8:\"post_tag\";}s:12:\"_multiwidget\";i:1;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "fullwidth-template.php");
INSERT INTO `wp_postmeta` VALUES("18", "1", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("19", "1", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("20", "12", "_wp_attached_file", "2013/12/str__0008_sky.png");
INSERT INTO `wp_postmeta` VALUES("21", "12", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1650;s:6:\"height\";i:614;s:4:\"file\";s:25:\"2013/12/str__0008_sky.png\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"str__0008_sky-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"str__0008_sky-300x111.png\";s:5:\"width\";i:300;s:6:\"height\";i:111;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"str__0008_sky-1024x381.png\";s:5:\"width\";i:1024;s:6:\"height\";i:381;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("22", "12", "_edit_lock", "1386507150:1");
INSERT INTO `wp_postmeta` VALUES("32", "14", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("33", "14", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("34", "14", "_menu_item_object_id", "2");
INSERT INTO `wp_postmeta` VALUES("35", "14", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("36", "14", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("37", "14", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("38", "14", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("39", "14", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("41", "2", "_edit_lock", "1386507327:1");
INSERT INTO `wp_postmeta` VALUES("42", "2", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("43", "2", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("44", "2", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("45", "1", "_edit_lock", "1391192274:1");
INSERT INTO `wp_postmeta` VALUES("46", "1", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("48", "19", "_wp_attached_file", "2013/12/jimmy-157594_150.png");
INSERT INTO `wp_postmeta` VALUES("49", "19", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:111;s:6:\"height\";i:150;s:4:\"file\";s:28:\"2013/12/jimmy-157594_150.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("53", "22", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("54", "22", "_edit_lock", "1391196604:1");
INSERT INTO `wp_postmeta` VALUES("55", "23", "_wp_attached_file", "2014/01/business-163461_640.jpg");
INSERT INTO `wp_postmeta` VALUES("56", "23", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:424;s:4:\"file\";s:31:\"2014/01/business-163461_640.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"business-163461_640-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"business-163461_640-300x198.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:198;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("58", "22", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("59", "22", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("60", "26", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("61", "26", "_edit_lock", "1391192920:1");
INSERT INTO `wp_postmeta` VALUES("62", "27", "_wp_attached_file", "2014/01/scribbling-152216_640.png");
INSERT INTO `wp_postmeta` VALUES("63", "27", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:368;s:4:\"file\";s:33:\"2014/01/scribbling-152216_640.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"scribbling-152216_640-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"scribbling-152216_640-300x172.png\";s:5:\"width\";i:300;s:6:\"height\";i:172;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("65", "26", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("66", "26", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("67", "29", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("68", "29", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("69", "29", "_menu_item_object_id", "1");
INSERT INTO `wp_postmeta` VALUES("70", "29", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("71", "29", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("72", "29", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("73", "29", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("74", "29", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("76", "30", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("77", "30", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("78", "30", "_menu_item_object_id", "3");
INSERT INTO `wp_postmeta` VALUES("79", "30", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("80", "30", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("81", "30", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("82", "30", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("83", "30", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("85", "32", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("86", "32", "_edit_lock", "1391197388:1");
INSERT INTO `wp_postmeta` VALUES("88", "32", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("89", "32", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("90", "34", "_wp_attached_file", "2014/01/e-book-158406_150.png");
INSERT INTO `wp_postmeta` VALUES("91", "34", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:150;s:6:\"height\";i:136;s:4:\"file\";s:29:\"2014/01/e-book-158406_150.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("93", "36", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("94", "36", "_edit_lock", "1391195080:1");
INSERT INTO `wp_postmeta` VALUES("95", "37", "_wp_attached_file", "2014/01/Ecover.jpg");
INSERT INTO `wp_postmeta` VALUES("96", "37", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:680;s:6:\"height\";i:459;s:4:\"file\";s:18:\"2014/01/Ecover.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"Ecover-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"Ecover-300x202.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:202;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("98", "36", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("99", "36", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("101", "40", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("102", "40", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("103", "40", "_menu_item_object_id", "4");
INSERT INTO `wp_postmeta` VALUES("104", "40", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("105", "40", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("106", "40", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("107", "40", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("108", "40", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("111", "41", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("112", "41", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("113", "41", "asg_item_id", "B00HEWI7AM");
INSERT INTO `wp_postmeta` VALUES("114", "41", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B00HEWI7AM\";s:13:\"DetailPageURL\";s:210:\"http://www.amazon.com/Ebook-Marketing-Convert-A-Book-ebook/dp/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HEWI7AM\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:220:\"http://www.amazon.com/Ebook-Marketing-Convert-A-Book-ebook/dp/tech-data/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00HEWI7AM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00HEWI7AM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00HEWI7AM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HEWI7AM\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"110\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"344\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"76\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"110\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"344\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:14:\"Convert A Book\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:14:\"Convert A Book\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:14:\"Convert A Book\";s:13:\"NumberOfPages\";s:1:\"3\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-17\";s:9:\"Publisher\";s:14:\"Convert A Book\";s:11:\"ReleaseDate\";s:10:\"2013-12-17\";s:6:\"Studio\";s:14:\"Convert A Book\";s:5:\"Title\";s:15:\"Ebook Marketing\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:200:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00HEWI7AM&atag=freetos-20&exp=2014-02-01T19%3A06%3A58Z&v=2&sig=rZocdu%2BX9SYjLKDmCMj%2BS6FeGuC2RWCEC%2BmSDK%2B3ygM%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:93:\"A few simple tricks to help you leap over the competition - Ebook publishing tips and tricks.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("115", "41", "asg_last_refresh_attempt", "1391195219");
INSERT INTO `wp_postmeta` VALUES("116", "41", "asg_update_timestamp", "1391195219");
INSERT INTO `wp_postmeta` VALUES("117", "42", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("118", "42", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("119", "42", "asg_item_id", "1493665189");
INSERT INTO `wp_postmeta` VALUES("120", "42", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1493665189\";s:13:\"DetailPageURL\";s:217:\"http://www.amazon.com/Whispers-Contagion-Espionage-Marketing-Bots/dp/1493665189%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1493665189\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:227:\"http://www.amazon.com/Whispers-Contagion-Espionage-Marketing-Bots/dp/tech-data/1493665189%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1493665189%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1493665189%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1493665189%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1493665189%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1493665189%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1493665189%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";}}}s:9:\"SalesRank\";s:7:\"1929421\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"104\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"324\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"71\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"104\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51ieaLaCUAL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"324\";}}}s:14:\"ItemAttributes\";a:19:{s:6:\"Author\";s:7:\"M. Eigh\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781493665181\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781493665181\";}s:4:\"ISBN\";s:10:\"1493665189\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"768\";s:6:\"Length\";s:2:\"20\";s:6:\"Weight\";s:2:\"20\";s:5:\"Width\";s:3:\"500\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:3:\"999\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$9.99\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:2:\"84\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"19\";s:6:\"Length\";s:3:\"781\";s:6:\"Weight\";s:2:\"32\";s:5:\"Width\";s:3:\"506\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-11-02\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:58:\"Whispers, Contagion and Espionage: Web Marketing with Bots\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"695\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.95\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:5:\"99911\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:7:\"$999.11\";}s:8:\"TotalNew\";s:2:\"10\";s:9:\"TotalUsed\";s:1:\"1\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1493665189%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1493665189\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:132:\"3V8zgCo0y0E8NLBxvIWZIaXtGCWWnohrAQtqlSXgft7okqLxLwwrLbsNKzNQiZad0UU%2FDC8zCMHw0N56iEYI5WN8mc8v5R2J%2BgBwX4ueQBO%2FfEtuhCph%2Fg%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:3:\"899\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$8.99\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"100\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.00\";}s:15:\"PercentageSaved\";s:2:\"10\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1493665189&atag=freetos-20&exp=2014-02-01T19%3A06%3A59Z&v=2&sig=hudebkugXqvw0T7cf2qPZNroYtKwQMpU5R8bB3W3%2BHw%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2169:\"<strong>WATCH OUT!</strong><br /><br />Side effects of reading this book include a  sudden surge of self-esteem and unprecedented decisiveness in making  marketing decisions. Also common are a lifetime addiction to web  automation and web data scraping.<br /><br />After reading this book, if you spend more than 4 hours with web bots a day, call a therapist right away.<br /><br /><br />I\'m  sure you\'ve wondered why your competitors\' books are selling better  than yours. In a perfect world governed by meritocracy, your books would  have been selling much better than your competitors\'. But Amazon is not  that perfect world. Amazon is a jungle where the street-smart prevail  and prosper.<br /><br />What if I tell you the key is marketing? \"Here we go  again,\" you roll your eyes: \"Who hasn\'t heard that before? Tell me  something I don\'t know.\"<br /><br />What if I tell you the key is marketing with web bots? Would I get your full attention?<br /><br />This  book may just be the ultimate answer to questions that have been  bothering you. I have no doubt it will put energy, wisdom and tangible  result in your next book marketing move.<br /><br /><strong>Free</strong><br /><br />When  you purchase the paperback of this book, you will get FIVE Kindle books  of my recent popular titles FREE! Included in the FIVE are as follows: <ul> <li>KDP\'s Best-Kept Secret Revealed: How to Embed Videos and Widgets in Your Book Description</li> <li>Social Networking inside Your Kindle Book Descriptions</li> <li>Likeable Marketing Begins at Your Amazon Page: How to Embed Facebook Likes in Book Descriptions</li> <li>Get Twitter Followers While Selling Your Books: How to Embed a Tweet Box in Your Book Description</li> <li>How to Embed Social Share Buttons in Your Kindle Book Pages</li> </ul> Click on \"M. Eigh\"(The Author Name) on top of this page and you will be able to preview those titles!<br /><br />All  you need to do is forward your Amazon purchase confirmation to me at  eigh.com at gmail.com dot com; I will send you the FIVE additional  Kindle books as soon as my schedule allows.<br /><br />FREE ebook offer is ONLY applicable to purchases of paperbacks.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("121", "42", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:56:\"Whispers, Contagion & Espionage: Web Marketing with Bots\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"November 4, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1SCXBPD13QKUP/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:9:\"Brook Par\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:57:\"Intriguing book, but I will never believe Web stats again\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1W415JP5WEAJK/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:7:\"BobbieK\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:40:\"Update your knowledge about the Internet\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A328S9RN3U5M68/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:10:\"Grady Harp\";s:7:\"address\";s:29:\"Los Angeles, CA United States\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:32:\"Data scraping for fun and profit\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 20, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A1E1LEVQ9VQNK/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:11:\"J. Chambers\";s:7:\"address\";s:22:\"Georgia, United States\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:18:\"A Real \"Work\" Book\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"November 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2XCTXX94AJ59R/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:37:\"M.E. Romana, Romantic Suspense Author\";s:7:\"address\";s:7:\"NC, USA\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:21:\"An Eye-Opener for Me!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"November 9, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2KUC7DFW7296W/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:4:\"SARA\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:31:\"The university of web marketing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"November 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1FBX5OGH0FTR7/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:11:\"Benny Carmi\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:15:\"very impressive\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2SODUPOSMJ2MN/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:5:\"Craig\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:42:\"really nice tricks on marketing automation\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 27, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2S3TY6DO8DQF8/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:6:\"Gabzen\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:34:\"An Indepth Look at the Big Picture\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"November 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2NJDH5KH6NXJU/ref=cm_cr_pr_pdp/191-0429999-0380864\";s:4:\"name\";s:14:\"Kevin Humphrey\";s:7:\"address\";s:10:\"Idaho, USA\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("122", "42", "asg_last_refresh_attempt", "1391195220");
INSERT INTO `wp_postmeta` VALUES("123", "42", "asg_update_timestamp", "1391195220");
INSERT INTO `wp_postmeta` VALUES("124", "43", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("125", "43", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("126", "43", "asg_item_id", "B007P8H80A");
INSERT INTO `wp_postmeta` VALUES("127", "43", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B007P8H80A\";s:13:\"DetailPageURL\";s:224:\"http://www.amazon.com/Secrets-Publishing-Success-Smashwords-Guides-ebook/dp/B007P8H80A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007P8H80A\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:234:\"http://www.amazon.com/Secrets-Publishing-Success-Smashwords-Guides-ebook/dp/tech-data/B007P8H80A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB007P8H80A%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB007P8H80A%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB007P8H80A%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B007P8H80A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B007P8H80A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B007P8H80A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007P8H80A\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"105\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"329\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"72\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"105\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/519mXApO%2BKL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"329\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:10:\"Mark Coker\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:4:\"2013\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:25:\"Mark Coker via Smashwords\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:25:\"Mark Coker via Smashwords\";s:13:\"NumberOfPages\";s:3:\"175\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-03-27\";s:9:\"Publisher\";s:25:\"Mark Coker via Smashwords\";s:11:\"ReleaseDate\";s:10:\"2012-03-27\";s:6:\"Studio\";s:25:\"Mark Coker via Smashwords\";s:5:\"Title\";s:55:\"Secrets to Ebook Publishing Success (Smashwords Guides)\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B007P8H80A&atag=freetos-20&exp=2014-02-01T19%3A07%3A00Z&v=2&sig=eadxqyVNT1JGB8LLlndg46Xw4uq%2B3tm1VdGtT2gqzwg%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3200:\"\"This book actually made me cry at the end and that is unusual for a non-fiction book. It just gave me the validation as a writer that I\'ve never had before. Seldom do I run across other writers in person and so reading Mark\'s book really was a confidence booster. I recommend this book to all writers especially those who are new. It\'s the added boost we all need to see our little \"babies\" rise from the literary crib to adulthood.\"<br />    ~  5-star Review by: Kathleen Morris on Sep. 27, 2012 at Smashwords<br /><br />Learn the 30 secrets of the bestselling self-published ebook authors.  Learn how to make your book more discoverable and more desirable to readers.  Learn how to reach readers around the globe at Amazon and other major retailers.<br /><br />This updated 2013 edition of The Secrets to Ebook Publishing Success has already helped tens of thousands of self-published ebook authors publish more professionally and with greater success.<br /><br />This ebook is a must-read for every writer, author, publisher and literary agent. Whether you\'re considering publishing a book for the first time, or you\'re a long-time veteran, this book will help you take your self-publishing to the next level.<br /><br />Includes a comprehensive glossary of e-publishing terms. No technical experience necessary!<br /><br />A great companion to Mark Coker\'s other popular e-publishing guides, The Smashwords Style Guide (how to format and publish an ebook) and The Smashwords Book Marketing Guide (how to market any book for free).<br /><br />Share the secrets. Enjoy!<br /><br />Table of Contents<br /><br />Preface<br />Introduction<br />The Secrets<br />Secret 1: Write a great book<br />Secret 2: Pinch your pennies<br />Secret 3: Create a great ebook cover<br />Secret 4: Practice metadata magic<br />Secret 5: Write another great book<br />Secret 6: Build reader trust<br />Secret 7: Embrace your obscurity<br />Secret 8: Spend your time wisely<br />Secret 9: Maximize distribution<br />Secret 10: Avoid exclusivity<br />Secret 11: Give (some of) your books away for FREE<br />Secret 12: Understand the algorithm<br />Secret 13: How retailers select titles for feature promotion<br />Secret 14: Patience pays<br />Secret 15: How books develop (the four behaviors)<br />Secret 16: Trust your customers and supply chain partners<br />Secret 17: Platform building starts yesterday<br />Secret 18: Architect for virality<br />Secret 19: Tweak your viral catalysts<br />Secret 20: Optimize discovery touch points<br />Secret 21: Practice the never-ending book launch<br />Secret 22: Think globally<br />Secret 23: Study the bestsellers<br />Secret 24: Develop a thick skin<br />Secret 25: Think beyond price<br />Secret 26: Pricing Strategy: Unit volume is a lever for success<br />Secret 27: Ebook publishing is easy, writing is difficult<br />Secret 28: Define your own success<br />Secret 29: Leverage preorders to increase sales<br />Secret 30: Share your secrets<br /><br />Appendix I – Glossary of E-Publishing Terms<br />Appendix II – Special acknowledgements for beta readers<br />Appendix III – Credits<br />Appendix IV – Reproduction rights (how to distribute this book freely)\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("128", "43", "asg_product_details", "a:10:{s:9:\"File Size\";s:7:\"1054 KB\";s:12:\"Print Length\";s:9:\"175 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:56:\"Mark Coker via Smashwords; 2013 edition (March 27, 2012)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B007P8H80A\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:7:\"Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("129", "43", "asg_star_rating", "4.6");
INSERT INTO `wp_postmeta` VALUES("130", "43", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:26:\"Good for Beginning Writers\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"April 1, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1U01JOXA2RT8Q/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:14:\"Benjamin Young\";s:7:\"address\";s:12:\"Pennsylvania\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:16:\"A one-stop shop!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 1, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AIR3NLDZCTFH3/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:19:\"Mimi Barbour \"Mimi\"\";s:7:\"address\";s:6:\"Canada\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:15:\"Right on target\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"June 5, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3S52D2ZFO41EU/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:17:\"Bruce E Arrington\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:12:\"Very Helpful\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 14, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1YC25TPU7U5OB/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:11:\"J.L. Gentry\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:19:\"Great starting book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"August 1, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1WA99339K9YJP/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:6:\"ioserg\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:19:\"Good place to start\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:12:\"June 9, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1G9J2U8KZ6NL0/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:48:\"K.M. Weiland, Author of Historical and Specul...\";s:7:\"address\";s:8:\"Nebraska\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:14:\"Very Good Info\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 14, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2MJZ0AYFXJOV3/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:10:\"Otter Life\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:45:\"Learn E-book Publishing Success from a Master\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 10, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2KXUZRT3HB2BC/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:15:\"Michael Edwards\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:27:\"Yes, I can publish my book!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"April 29, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3Q9UWPYO5SMU8/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:47:\"Nickie Cochran \"Author of The Heidelberg Ghost\"\";s:7:\"address\";s:20:\"Colorado Springs, CO\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:48:\"Less interesting than his \"Book Marketing Guide\"\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:12:\"May 11, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A213BSYFNHT7SE/ref=cm_cr_pr_pdp/182-4786025-6189551\";s:4:\"name\";s:14:\"Monique Sorgen\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("131", "43", "asg_last_refresh_attempt", "1391195223");
INSERT INTO `wp_postmeta` VALUES("132", "43", "asg_update_timestamp", "1391195223");
INSERT INTO `wp_postmeta` VALUES("133", "44", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("134", "44", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("135", "44", "asg_item_id", "B004XR57PE");
INSERT INTO `wp_postmeta` VALUES("136", "44", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B004XR57PE\";s:13:\"DetailPageURL\";s:218:\"http://www.amazon.com/Smashwords-Book-Marketing-Guide-Market-ebook/dp/B004XR57PE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004XR57PE\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:228:\"http://www.amazon.com/Smashwords-Book-Marketing-Guide-Market-ebook/dp/tech-data/B004XR57PE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB004XR57PE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB004XR57PE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB004XR57PE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B004XR57PE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B004XR57PE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B004XR57PE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB004XR57PE\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"113\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"353\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"78\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"113\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41P0F-j39GL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"353\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:10:\"Mark Coker\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:5:\"EISBN\";s:13:\"9781452300030\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:26:\"Mark Coker, via Smashwords\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:26:\"Mark Coker, via Smashwords\";s:13:\"NumberOfPages\";s:2:\"52\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2011-06-25\";s:9:\"Publisher\";s:26:\"Mark Coker, via Smashwords\";s:11:\"ReleaseDate\";s:10:\"2011-06-25\";s:6:\"Studio\";s:26:\"Mark Coker, via Smashwords\";s:5:\"Title\";s:85:\"Smashwords Book Marketing Guide - How to Market any Book for Free (Smashwords Guides)\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:198:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B004XR57PE&atag=freetos-20&exp=2014-02-01T19%3A07%3A03Z&v=2&sig=n%2BcshKZaVDWGt%2FOpwZK9WYSvXeJ7bFcWFXNXws9%2BvEc%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3712:\"Learn how to market any book.  This popular book marketing primer has helped over 100,000 authors and publishers dramatically improve their book marketing results.  <br /><br />The Smashwords Book Marketing Guide contains practical, easy-to-implement advice on how to market any book.  41 simple, do-it-yourself marketing tips explain not what you can do to market your book, but also explain the context and thinking behind each recommendation.  The marketing techniques apply equally well to both ebooks and print books. <br /><br />Here\'s what you\'ll learn in the Smashwords Book Marketing Guide:<br /><br />Table of Contents<br /><br />Introduction: About the Smashwords Book Marketing Guide<br />  Background on Smashwords<br />Setting expectations<br />How Smashwords helps authors and publishers market books<br />Adopting a proactive marketing mindset<br />Marketing starts now<br />Hyperlinks help readers discover books<br />The importance of authors helping authors<br /><br />41 Marketing Tips (all free to implement!)<br />Tip #1 – Update your email signature<br />Tip #2 – Post a notice on your web site or blog<br />Tip #3 – Contact your friends, family, co-workers and fans<br />Tip #4 – Post a notice to your social networks<br />Tip #5 – Update your message board signatures<br />Tip #6 – How to reach readers with Twitter<br />Tip #7 – Publish more than one book to create a multiplier effect<br />Tip #8 – Advertise your other books in each book you publish<br />Tip #9 – Make it easy for your readers to connect with you<br />Tip #10 – Issue a press release on a free PR wire service<br />Tip #11 – Join HARO, Help-a-reporter-online for free press leads<br />Tip #12 – Encourage fans to purchase and review your book<br />Tip #13 – Write thoughtful reviews for other books<br />Tip #14 – Participate in online forums<br />Tip #15 – Experiment with coupons<br />Tip #16 – Write a blog<br />Tip #17 – Write guest columns for blogs<br />Tip #18 – Invite other authors to post to your blog<br />Tip #19 – Do Q&A interviews of other authors on your blog<br />Tip #20 – Join the conversation on blogs<br />Tip #21 – Organize a blog tour<br />Tip #22 – Use Google Alerts to discover where the conversations are taking place<br />Tip #23 – Leverage YouTube videos to reach readers<br />Tip #24 – Print up business cards<br />Tip #25 – Encourage your fans to become affiliate marketers of your book<br />Tip #26 – Create a reader’s guide at the end of your book<br />Tip #27 – Insert sample chapters from your other books<br />Tip #28 – Do a sample chapters swap with another author<br />Tip #29 – Invite other authors to join you at Smashwords<br />Tip #30 – Promote your book to the top ebook listing sites<br />Tip #31 – Read the Secrets to Ebook Publishing Success<br />Tip #32 – Upgrade your cover image<br />Tip #33 – Share these marketing tips with your fellow authors! <br />Tip #34 – Create an online calling card with About.me<br />Tip #35 – Create a presentation and upload it to SlideShare.net<br />Tip #36 – Join LinkedIn, post links to your books<br />Tip #37 – Do a presentation at your local library on ebook publishing<br />Tip #38 – Tweak your Viral Catalysts to make your book more discoverable and desirable<br />Tip #39 – Link to every retailer to reach more readers<br />Tip #40 – Distribute your book as a preorder<br />Tip #41 – Publish a Smashwords Interview<br /><br />Other Kindle Books by Mark Coker<br />   Smashwords Style Guide (how to format and produce an ebook)<br />   The 10-Minute PR Checklist - How to Earn the Publicity You Deserve<br />   Boob Tube (a novel about soap operas)\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("137", "44", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:15:\"Solid but basic\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"November 25, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1YRS26JKPEFW5/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:13:\"erikcc \"ERIK\"\";s:7:\"address\";s:3:\"NYC\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:13:\"Too Much Hype\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"July 21, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A19YE99CKXSRWL/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:12:\"Carla Fister\";s:7:\"address\";s:19:\"Englewood, Colorado\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:24:\"You must read this book.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 12, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AXZOA632GTI02/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:30:\"Stephen A. Ives \"energyatwork\"\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:25:\"Just a long advertisement\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:13:\"July 28, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A2PPKOUDNFPD3/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:44:\"H. Kallinger \"Author of Hotel of Lost Souls\"\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:47:\"Simple, Easy To Implement Guide For All Authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 11, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ASPAW3P0CYZGC/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:17:\"brotherjoeradosti\";s:7:\"address\";s:9:\"Cadiz, KY\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:10:\"Great Tips\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"June 7, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2DAU3C204I5T6/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:8:\"Codazoda\";s:7:\"address\";s:11:\"SLC, UT USA\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:27:\"great for book bloggers too\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 13, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3SPZ6OWX04VJG/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:15:\"aobibliophile\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:16:\"Good for newbies\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 17, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A69GBB918D2PP/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:11:\"Isadore Ann\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:32:\"plenty of great promotional tips\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3OICJPFHWMFLV/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:9:\"MDMONLINE\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:10:\"So Helpful\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"August 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A37YULZM84HAJM/ref=cm_cr_pr_pdp/175-0228084-1679253\";s:4:\"name\";s:16:\"Sharman Castillo\";s:7:\"address\";s:5:\"Texas\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("138", "44", "asg_last_refresh_attempt", "1391195224");
INSERT INTO `wp_postmeta` VALUES("139", "44", "asg_update_timestamp", "1391195224");
INSERT INTO `wp_postmeta` VALUES("140", "45", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("141", "45", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("142", "45", "asg_item_id", "B00HMTMF1E");
INSERT INTO `wp_postmeta` VALUES("143", "45", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00HMTMF1E\";s:13:\"DetailPageURL\";s:226:\"http://www.amazon.com/Kindle-Publishing-Marketing-Selling-Nonfiction-ebook/dp/B00HMTMF1E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HMTMF1E\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:236:\"http://www.amazon.com/Kindle-Publishing-Marketing-Selling-Nonfiction-ebook/dp/tech-data/B00HMTMF1E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00HMTMF1E%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00HMTMF1E%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00HMTMF1E%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00HMTMF1E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00HMTMF1E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00HMTMF1E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HMTMF1E\";}}}s:9:\"SalesRank\";s:6:\"527117\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"57\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"121\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"378\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"57\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"57\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"83\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"121\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51O%2B9YvW7BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"378\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:17:\"Don A. Singletary\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:3:\"1.0\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:12:\"Sing Systems\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:12:\"Sing Systems\";s:13:\"NumberOfPages\";s:3:\"231\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2014-01-07\";s:9:\"Publisher\";s:12:\"Sing Systems\";s:11:\"ReleaseDate\";s:10:\"2014-01-07\";s:6:\"Studio\";s:12:\"Sing Systems\";s:5:\"Title\";s:51:\"Kindle Cash Publishing Marketing Selling Nonfiction\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:198:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00HMTMF1E&atag=freetos-20&exp=2014-02-01T19%3A07%3A04Z&v=2&sig=oLBSm5WThcs7oexb9RE1OnT2I1FkG%2BnA%2BZhoM8t%2FNHk%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2146:\"2014 Edition: Generate an Income Stream by Using Proven Methods<br /><b>See How the Pro\'s Find Best-Selling Nonfiction eBook Ideas</b><br />\n<br /><h2>See our \"Look Inside\" now for a writer-friendly technique of finding topics that Sell with top #rankings.</h2> -- How to see if a book might pay enough, before you \'take on the job\' of writing it.<br /><b>-- Simple ways to research for topics that sell before you invest time writing your books.</b>\n<br />\n<br /><h4>The \'no social media\' way to sell eBooks, and how to write them quickly.</h4><li>A Plan for writing profitable eBooks that you can repeat over and over again.</li><li>How to Plan your book Launch - Using Kindle Promotions (free).</li><li>Get a Fast Start by making a blueprint to write & market eBooks without wasting time.\n<br />\n<br /><h2>Don’t ask customers to “Like Me”, ask them to “Buy Now” SELL WITHOUT SOCIAL MEDIA</h2></li><li>No Advanced Computer skills or  Marketing Experience Required.</li><li>See how the pro\'s use real-time search to find topics that sell really well.</li><li><em>Start today to build Extra Income Streams from eBooks by writing nonfiction.</em>\n<br />\n<br /><b>Learn to “Go To School” by researching existing best-sellers on Kindle; save time by focusing on what works.</b>  \n<br />\n<br /><h4>Special sections of this book show you all about:</h4></li><li>Learn to use Kindle Promotions to get top #rankings in categories</li><li>Power Up Sales by Power Packing your \"Look Inside\"</li><li>Use our system to get legitimateReviews that are customer magnets.</li><li>How Use Your Your Sales Reports to fine-tune your listing for maximum sales. \n<br /> \n<br />Learn the business of writing short, nonfiction eBooks on specialized topics that are already selling eBooks.  Stop trying to guess what works and learn to research how a topic is selling before you write the book. The key to building a steady income stream from book sales - is to find what works, then just repeat it - over and over for higher royalties. Tips on writing great books and building your own business selling ebooks.  Let\'s get started, now!\n<br />\n<br /></li>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("144", "45", "asg_product_details", "a:10:{s:9:\"File Size\";s:7:\"2211 KB\";s:12:\"Print Length\";s:9:\"231 pages\";s:24:\"Page Numbers Source ISBN\";s:10:\"1494877430\";s:9:\"Publisher\";s:43:\"Sing Systems; 1.0 edition (January 7, 2014)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00HMTMF1E\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("145", "45", "asg_star_rating", "4.8");
INSERT INTO `wp_postmeta` VALUES("146", "45", "asg_customer_reviews", "a:5:{i:0;a:5:{s:5:\"title\";s:44:\"Sell Instant Nonfiction to a Target Audience\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 13, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A281NPSIMI1C2R/ref=cm_cr_pr_pdp/191-0439754-0435457\";s:4:\"name\";s:38:\"Rebecca of Amazon \"The Rebecca Review\"\";s:7:\"address\";s:19:\"The World of Amazon\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:21:\"Good book for authors\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"January 11, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ANY9CE09034TH/ref=cm_cr_pr_pdp/191-0439754-0435457\";s:4:\"name\";s:7:\"OdessaM\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:14:\"Worked for us!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 15, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3W0XF5FFD0DJ3/ref=cm_cr_pr_pdp/191-0439754-0435457\";s:4:\"name\";s:12:\"Carol Bryant\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:11:\"Kindle Cash\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 13, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A25I3V5O4DX8M3/ref=cm_cr_pr_pdp/191-0439754-0435457\";s:4:\"name\";s:22:\"Ritchey M. Marbury III\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:32:\"Great Book..lots of information.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 13, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A187YJ14PAJQT8/ref=cm_cr_pr_pdp/191-0439754-0435457\";s:4:\"name\";s:15:\"captain charlie\";s:7:\"address\";s:19:\"TALLAHASSEE, FL, US\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("147", "45", "asg_last_refresh_attempt", "1391195226");
INSERT INTO `wp_postmeta` VALUES("148", "45", "asg_update_timestamp", "1391195226");
INSERT INTO `wp_postmeta` VALUES("149", "46", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("150", "46", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("151", "46", "asg_item_id", "0988433648");
INSERT INTO `wp_postmeta` VALUES("152", "46", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"0988433648\";s:13:\"DetailPageURL\";s:208:\"http://www.amazon.com/The-Kindle-Publishing-Bible-Ebooks/dp/0988433648%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0988433648\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:218:\"http://www.amazon.com/The-Kindle-Publishing-Bible-Ebooks/dp/tech-data/0988433648%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D0988433648%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D0988433648%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D0988433648%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/0988433648%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/0988433648%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/0988433648%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";}}}s:9:\"SalesRank\";s:6:\"639647\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41C5GKIoAyL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}s:14:\"ItemAttributes\";a:23:{s:6:\"Author\";s:18:\"Tom Corson-Knowles\";s:7:\"Binding\";s:9:\"Paperback\";s:5:\"Brand\";s:32:\"Brand: Authentic Health Coaching\";s:3:\"EAN\";s:13:\"9780988433649\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9780988433649\";}s:7:\"Feature\";s:27:\"Used Book in Good Condition\";s:4:\"ISBN\";s:10:\"0988433648\";s:20:\"IsEligibleForTradeIn\";s:1:\"1\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"24\";s:6:\"Weight\";s:2:\"34\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:25:\"Authentic Health Coaching\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1297\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$12.97\";}s:12:\"Manufacturer\";s:25:\"Authentic Health Coaching\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"106\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"39\";s:6:\"Length\";s:3:\"882\";s:6:\"Weight\";s:2:\"40\";s:5:\"Width\";s:3:\"591\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-01-03\";s:9:\"Publisher\";s:25:\"Authentic Health Coaching\";s:6:\"Studio\";s:25:\"Authentic Health Coaching\";s:5:\"Title\";s:88:\"The Kindle Publishing Bible: How To Sell More Kindle Ebooks on Amazon (The Kindle Bible)\";s:12:\"TradeInValue\";a:3:{s:6:\"Amount\";s:2:\"79\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$0.79\";}}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"971\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$9.71\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:5:\"99910\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:7:\"$999.10\";}s:8:\"TotalNew\";s:2:\"11\";s:9:\"TotalUsed\";s:1:\"2\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/0988433648%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988433648\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:138:\"tRlB0Rb%2FsvjGWR%2F%2BqxbQf4FtYC%2FfFwjyOOOS8H6n%2FYhYmManJQyr2CqJeRDdSrEYaiG2NfUwiO%2BFut3R75%2FfYfhtn6Kq0YO4vhLVE6rwXIux2omB6zDcrw%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1167\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$11.67\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"130\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.30\";}s:15:\"PercentageSaved\";s:2:\"10\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=0988433648&atag=freetos-20&exp=2014-02-01T19%3A07%3A06Z&v=2&sig=r24DVIL5smV5U5tG63Gi29U%2B3SYKN%2BLBUn7NdwRe85s%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3808:\"<b><font align=center>How To Sell More Kindle Ebooks In 7 Days</font></b><p> <b><font align=center>I Believe Kindle Publishing Should Be Fun, Profitable And Very, Very Easy</font></b><p> <b>If you want your book to become a Kindle best seller I can show you how! Learn how to:</b><p> <b>Increase Your Book\'s Amazon And Google Search Traffic By 423% In 30 Minutes</b><p> If you\'re a self-published author without a large platform or following, you will never be able to promote more than the published authors with huge marketing budgets. But you can outrank them on Amazon search every time! Why? Because 99% of Kindle authors don\'t know how to increase their search engine rankings in Amazon and Google. But I do - and I\'m going to show you how in this book (it won\'t cost you a dime to implement these strategies).<p> Most authors (even the ones with publishers and big marketing budgets) have no idea how to do keyword research, tag their book, add the right search keywords when they publish their book or insert keywords in their book description without it sounding like it was written by a robot.<p> <b>For New Authors: Step-By-Step Instructions With Picture Tutorials</b><p> If you\'re a first-time Kindle publisher or technologically challenged then this book is for you! I even had my Grandma Ann Knowles follow the instructions step by step and she gave it a big thumbs up for easy to use instructions. The playing field has been leveled with ebook publishing - and if my Grandma can do it I guarantee you can too!<p> <b>For Existing Authors: How To Sell More Books In 5 Days Than You Did Last Month</b><p> I\'m going to share with you my KDP Select Free Promotion Marketing Formula for getting tens of thousands of readers to download your book in just 5 days. All you have to do is read the Marketing Formula instructions and follow them (it takes about 3 hours of work to get thousands of new readers).<p> <b>How To Sell On Kindle Using Your Book Description</b><p> If you think your book is going to sell itself think again! If you\'re a fiction author or novelist, you have to <b>show</b> your readers the story and engage them in it or they won\'t buy a book from an unknown author. And if you\'re a non-fiction author, you have to <b>tell</b> potential readers how your book is going to help them solve their problem fast or they\'ll click away without buying. I\'m going to show you the Show And Tell system for selling more books on Kindle by giving you readers what they want and overcoming objections in your book description!<p> Kindle marketing isn\'t about having a big marketing budget or publisher behind you - but you still need exposure and a great offer. This book will help you with get more exposure with Amazon search and other great marketing tips.<p> You also have to make buying your book an irresistible offer so that when browsers get done reading your book description they say, \"I have to buy this book!\" You can\'t do that without a strategic plan and a well-written book description.<p> <b>Bonus!</b> Video interviews with best-selling Kindle authors as they share their coveted book marketing strategies.<p> <b>About The Author</b><p> My poetry was first published at age 16 in Teen Ink magazine and I started writing books at age 19 but had no idea how to get my message out to anyone other than my friends and family. Finally, I discovered Amazon\'s Kindle Publishing platform and published my first book on Kindle on February 10, 2012.<p> Since then, I\'ve sold tens of thousands of ebooks on Kindle and now earn a full-time income as a part-time Kindle author. I\'ve since helped hundreds of self-published authors like myself sell more books on Kindle. If I can do it you can too!<p> Learn how to sell more books on Amazon today. Scroll up and <i>grab your copy today.</i>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("153", "46", "asg_product_details", "a:8:{s:6:\"Series\";s:16:\"The Kindle Bible\";s:9:\"Paperback\";s:9:\"106 pages\";s:9:\"Publisher\";s:43:\"Authentic Health Coaching (January 3, 2013)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"0988433648\";s:7:\"ISBN-13\";s:14:\"978-0988433649\";s:18:\"Product Dimensions\";s:22:\"0.2 x 5.9 x 8.9 inches\";s:15:\"Shipping Weight\";s:10:\"6.4 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("154", "46", "asg_star_rating", "4.8");
INSERT INTO `wp_postmeta` VALUES("155", "46", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:35:\"Excellent book for Kindle Marketing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"December 4, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A131JDD8TI0J4F/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:37:\"J. Testerman \"Bible Based Businesses\"\";s:7:\"address\";s:12:\"Clermont, FL\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:37:\"Review of The Kindle Publishing Bible\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:14:\"March 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1PTOGHTI4NJFX/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:22:\"Brian Kittrell, author\";s:7:\"address\";s:11:\"Brandon, MS\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:24:\"Good Information, BUT...\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:16:\"January 31, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3404Y8VWW547C/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:21:\"Corbett B. Coburn III\";s:7:\"address\";s:28:\"Alexandria, VA United States\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:32:\"I hate giving this book 5 stars!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 21, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2FIZ9WFRCD9IQ/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:12:\"Anna Fussell\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:54:\"Not a Bible, but a good book, especially for beginners\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"February 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ADEVBXUS0RSIR/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:48:\"Alain B. Burrese \"Author, Speaker, Mediator, ...\";s:7:\"address\";s:12:\"Missoula, MT\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:14:\"The Real Deal!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"December 1, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A4LHVU13WYBTU/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:9:\"Allan Cox\";s:7:\"address\";s:19:\"Chicago & San Diego\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:21:\"Just below average...\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:16:\"January 17, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3FQ3M3SDZQQJZ/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:10:\"chuckypita\";s:7:\"address\";s:34:\"South Jordan, UT & Albequerque, NM\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:34:\"Table of Contents menu not working\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:17:\"December 26, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AZC0XYVZX0D8Z/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:7:\"penname\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:49:\"Well Thought Out - Well Spoken and Very Thorough!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2KWDZVYEIWWSE/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:27:\"Lucidboomer \"Nick M. Walsh\"\";s:7:\"address\";s:10:\"Surrey, BC\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:38:\"Useful advices from real Kindle author\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 26, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ADE8LF74QV7UH/ref=cm_cr_pr_pdp/177-7816504-3826259\";s:4:\"name\";s:6:\"Herman\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("156", "46", "asg_last_refresh_attempt", "1391195228");
INSERT INTO `wp_postmeta` VALUES("157", "46", "asg_update_timestamp", "1391195228");
INSERT INTO `wp_postmeta` VALUES("158", "47", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("159", "47", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("160", "47", "asg_item_id", "0985586230");
INSERT INTO `wp_postmeta` VALUES("161", "47", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"0985586230\";s:13:\"DetailPageURL\";s:205:\"http://www.amazon.com/10-Keys-Ebook-Marketing-Success/dp/0985586230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0985586230\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:215:\"http://www.amazon.com/10-Keys-Ebook-Marketing-Success/dp/tech-data/0985586230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D0985586230%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D0985586230%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D0985586230%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/0985586230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/0985586230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/0985586230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";}}}s:9:\"SalesRank\";s:6:\"643563\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"312\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"69\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/4149htg5-%2BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"312\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/514XZ1yfm%2BL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/514XZ1yfm%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/514XZ1yfm%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/514XZ1yfm%2BL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"69\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/514XZ1yfm%2BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/514XZ1yfm%2BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"312\";}}}}s:14:\"ItemAttributes\";a:19:{s:6:\"Author\";s:11:\"Karen Baney\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9780985586232\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9780985586232\";}s:4:\"ISBN\";s:10:\"0985586230\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"787\";s:6:\"Length\";s:2:\"28\";s:6:\"Weight\";s:2:\"31\";s:5:\"Width\";s:3:\"492\";}s:5:\"Label\";s:11:\"Karen Baney\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:3:\"659\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.59\";}s:12:\"Manufacturer\";s:11:\"Karen Baney\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"124\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"40\";s:6:\"Length\";s:3:\"790\";s:6:\"Weight\";s:2:\"30\";s:5:\"Width\";s:3:\"490\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-03-01\";s:9:\"Publisher\";s:11:\"Karen Baney\";s:6:\"Studio\";s:11:\"Karen Baney\";s:5:\"Title\";s:34:\"10 Keys to Ebook Marketing Success\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"453\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$4.53\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:3:\"593\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$5.93\";}s:8:\"TotalNew\";s:2:\"12\";s:9:\"TotalUsed\";s:1:\"1\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/0985586230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0985586230\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:5:{s:14:\"OfferListingId\";s:132:\"g8dWqZnut3HK2vBpQZVca4Yq6nVHLgYL2BOJns%2FYT0Jc6T70ifXrVhMrK7Q%2B2zTL4I%2FDCeEiifPXzNZ4H5syewLjWwMlABxnuYunnJut30tmJrIJ3P%2FWsQ%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:3:\"659\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.59\";}s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=0985586230&atag=freetos-20&exp=2014-02-01T19%3A07%3A08Z&v=2&sig=uy5SqRUFLVpFJtJznkGzZ5P73a%2Fx2MWIAcjrewsy360%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1442:\"Is it really possible to make a living as a self-published or small press author?  Best-selling author, Karen Baney understands how hard it is to sell eBooks.  Her success didn’t come overnight, but instead it came through persistence and patience.  She applied the principles and tips of book marketing success that she now shares with you. “I want to help other authors break out of the grind of dismal book sales.  There are so many techniques from the world of business that we, as authors, can apply to our writing business.”  –Karen Baney This book is designed for the busy writer:  concise and information packed.  Well-organized, it is broken down into 10 key areas of eBook marketing.  Each key contains: • Success Tips – brief impactful statements that drive home important points • Do’s and don’ts for marketing and building your brand as an author • Concise lists summarizing each key • Marketing Minute—an opportunity to evaluate your own progress and apply what you just learned to your marketing plan. What makes Karen Baney a creditable authority?  In addition to 20 years in business, she holds a Masters of Business Administration from Arizona State University.  In her second year as a published author she achieved over 200,000 eBook downloads. Whether you’re a new or veteran author, 10 Keys to eBook Marketing Success can help you learn how to sell books online and improve your marketing plan.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("162", "47", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:27:\"A MUST-READ For New Authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1AZ7VA51PUG5G/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:28:\"R. S. Guthrie \"R.S. Guthrie\"\";s:7:\"address\";s:10:\"Denver, CO\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:40:\"MUST READ FOR ALL AUTHORS - NEW AND OLD!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"February 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A38ADCU7DLGD4V/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:9:\"E. Barnes\";s:7:\"address\";s:11:\"Mississippi\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:39:\"A Resource I Will Go To Again and Again\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"February 12, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1S9MVWQHME597/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:12:\"Readitwithme\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:19:\"Excellent Resource!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3TI77ERDFFP7C/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:13:\"Garry Rodgers\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:45:\"Looking forward to implementing these \"Keys\"!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 31, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2PSE8YPXENTJ1/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:11:\"Lori Ramsey\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:45:\"A must-have for the self-published author ...\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A33XSDDF6CGI3S/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:20:\"Matthew L. Patterson\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:15:\"Ebook marketing\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:18:\"September 10, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ALV0UIJEVXZ2G/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:19:\"J. Savoy \"J. Savoy\"\";s:7:\"address\";s:12:\"Richmond, VA\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:18:\"Excellent Resource\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"April 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A133NF1CPXGQWA/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:14:\"Aida E. Rivera\";s:7:\"address\";s:19:\"Forest Hill, MD, US\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:26:\"Very useful marketing tool\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"April 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1JF8J7T2OYZ34/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:36:\"Pamela Carmichael \"Christian Author\"\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:28:\"Great read for novice writer\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"February 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1KNA5OQC4919M/ref=cm_cr_pr_pdp/182-8959614-3236959\";s:4:\"name\";s:15:\"Richard Charron\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("163", "47", "asg_last_refresh_attempt", "1391195229");
INSERT INTO `wp_postmeta` VALUES("164", "47", "asg_update_timestamp", "1391195229");
INSERT INTO `wp_postmeta` VALUES("165", "48", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("166", "48", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("167", "48", "asg_item_id", "B00GPKHAFW");
INSERT INTO `wp_postmeta` VALUES("168", "48", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00GPKHAFW\";s:13:\"DetailPageURL\";s:227:\"http://www.amazon.com/Newbies-Guide-Publishing-Amazon-self-publishing-ebook/dp/B00GPKHAFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GPKHAFW\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:237:\"http://www.amazon.com/Newbies-Guide-Publishing-Amazon-self-publishing-ebook/dp/tech-data/B00GPKHAFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00GPKHAFW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00GPKHAFW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00GPKHAFW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00GPKHAFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00GPKHAFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00GPKHAFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00GPKHAFW\";}}}s:9:\"SalesRank\";s:6:\"205259\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"111\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"347\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"76\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"111\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51%2BSHTVe6jL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"347\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:12:\"Glen Chapman\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:3:\"102\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2014-01-18\";s:11:\"ReleaseDate\";s:10:\"2014-01-18\";s:5:\"Title\";s:104:\"The Newbie\'s Guide to Publishing on Amazon - A comprehensive guide to getting started in self-publishing\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00GPKHAFW&atag=freetos-20&exp=2014-02-01T19%3A07%3A09Z&v=2&sig=HCxZWdAfXo0b7HtGHeGxCtYOJPZ5%2BMRjauR9w9DFehI%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2968:\"<h2>25% off FOR A LIMITED TIME! Normally $3.99.</h2><h3><i>Do you want to quit your day job and follow your dream as a published writer?</i></h3><p>A comprehensive, hyperbole-free introduction to publishing your work on Amazon\'s KDP</p><p>*Now with bonus addendum \"The Power of Free on Amazon Kindle\"*</p><p>The rise of self-publishing on has recently allowed writers around the world to realize their dream of publishing their books in the world\'s largest book stores.</p><p>The facts speak for themselves - write and publish a book today and it can earn you the passive income you need to get writing on the next book...and the next one after that.</p><p>Glen Chapman (author of \"The Power of Free on Amazon Kindle\") outlines everything you need to know to publish and market your book, with a particular focus on Amazon, by far the biggest eBook store in the world. This is the guide he wishes he had read when he was starting out!</p><p>Including -</p><p>- Getting Started</p><p>- Formatting Your Book</p><p>- Creating Effective Book Covers that Sell</p><p>- Publishing Your First Book through KDP</p><p>- The importance of getting those first few sales to increase visibility</p><p>- Coming Up With the Perfect Title and Synopsis</p><p>- Pricing Strategy</p><p>- KDP Select ”\" Do You Go Exclusive or Play the Field?</p><p>- Should You Read Reviews of Your Books?</p><p>- The Value of Promoting Outside of Amazon</p><p>- Should You Take Advantage of KDP Select Free Days?</p><p>- Death & Taxes</p><p>- Amazon Alternatives</p><p>- The Importance of Genuine Reviews</p><p>- Paid Promotion ”\" Is it worth it?</p><p>- The Importance of Blogs</p><p>- Social Marketing</p><p>- Perma-Free</p><p>- Kindle Countdown Deals</p><p>- Those Pesky Refunds</p><p>- Fiction v Non-Fiction</p><p>- Print on Demand</p><p>- The Amazon algorithms</p><p>- Links & Resources</p><p>There are some fabulous publishing guides out there (such as Write.Publish.Repeat), but there are also a lot of hyped up books that overstate your chances of becoming a best-seller and sound like they are selling you an Ab-Roller or a ShamWow. Unless lightning just happens to strike in the right place, the only thing that will get you a best-seller is a lot of writing and a lot of clever promotion. It\'s a slow grind that is only for those passionate about writing. If you are looking for a source of income to replace your blog advertising or other get rich quick scheme, this is not the guide for you. If you can think of nothing better than using your words to weave magic for the widest possible audience (and get paid for it to boot!), this guide may just be up your alley.</p><h3>˃˃˃  Now is the time to establish a presence on Amazon - it\'s easier than you think to get started. If you have a novel ready to go, you could literally \'go live\' on Amazon within 24 hours from now! But that\'s just when the hard work begins...</h3><h2><u>Grab a copy today to get your copy for 25% off!</u></h2>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("169", "48", "asg_customer_reviews", "a:1:{i:0;a:5:{s:5:\"title\";s:11:\"Educational\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AZC3S0XGUEOTQ/ref=cm_cr_pr_pdp/180-9889995-3929753\";s:4:\"name\";s:5:\"Sarah\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("170", "48", "asg_last_refresh_attempt", "1391195230");
INSERT INTO `wp_postmeta` VALUES("171", "48", "asg_update_timestamp", "1391195230");
INSERT INTO `wp_postmeta` VALUES("172", "49", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("173", "49", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("174", "49", "asg_item_id", "1492241504");
INSERT INTO `wp_postmeta` VALUES("175", "49", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1492241504\";s:13:\"DetailPageURL\";s:216:\"http://www.amazon.com/Sold-eBooks-Amazons-Kindle-Self-Publishing/dp/1492241504%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1492241504\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:226:\"http://www.amazon.com/Sold-eBooks-Amazons-Kindle-Self-Publishing/dp/tech-data/1492241504%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1492241504%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1492241504%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1492241504%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1492241504%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1492241504%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1492241504%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";}}}s:9:\"SalesRank\";s:6:\"636667\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/510dVYh1LJL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51HdXHvrM7L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51HdXHvrM7L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51HdXHvrM7L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51HdXHvrM7L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51HdXHvrM7L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51HdXHvrM7L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}}s:14:\"ItemAttributes\";a:22:{s:6:\"Author\";s:14:\"Martin Crosbie\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781492241508\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781492241508\";}s:7:\"Edition\";s:1:\"1\";s:4:\"ISBN\";s:10:\"1492241504\";s:20:\"IsEligibleForTradeIn\";s:1:\"1\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"59\";s:6:\"Weight\";s:2:\"83\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1299\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$12.99\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"278\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"79\";s:6:\"Length\";s:3:\"866\";s:6:\"Weight\";s:2:\"97\";s:5:\"Width\";s:3:\"598\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-09-04\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:88:\"How I Sold 30,000 eBooks on Amazon\'s Kindle: An Easy-To-Follow Self-Publishing Guidebook\";s:12:\"TradeInValue\";a:3:{s:6:\"Amount\";s:2:\"71\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$0.71\";}}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"964\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$9.64\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:5:\"99910\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:7:\"$999.10\";}s:8:\"TotalNew\";s:2:\"11\";s:9:\"TotalUsed\";s:1:\"2\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1492241504%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1492241504\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:128:\"dCpSNAXpsT9bTzItoN%2BDli95FKd1oCgzc4Z4cOaXQMf0Xfdb4HWPg1WfjZvF2ee3FlnCVjn3F1zxMuHz%2Fj0jXPnO7heD4cNjvoZ0xUAuNuHEBv0qlHyyRQ%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1004\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$10.04\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"295\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$2.95\";}s:15:\"PercentageSaved\";s:2:\"23\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1492241504&atag=freetos-20&exp=2014-02-01T19%3A07%3A10Z&v=2&sig=KoRenZXauFac9nkKlOYPiVFGv3RXa9oIMAeuwcMVehU%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1486:\"<span> <span><strong>Outlines </strong>the methods the top 5% of successful self-published authors utilize to produce their eBooks in a professional, cost-effective manner.</span><br> <span><strong>Shows </strong>what happened after Amazon changed the rules and what you need to do right now to adjust your strategy.</span><br> <span><strong>How </strong>to adopt the philosophy that will allow promotional opportunities to come to you.<b> </b></span><br><span></span><br> <span>In February 2012 Martin Crosbie\'s self-published eBook \"My Temporary Life\" hit Amazon\'s top ten overall bestseller list. The next month Amazon posted a press release revealing that Crosbie had made $46,000 in one month, with one book. Prior to this, his novel was rejected one hundred and thirty times by traditional publishers and agents. In the months that followed, \"My Temporary Life\" and its sequel have been consistent sellers, often sitting atop Amazon\'s rankings. Crosbie\'s story has been mentioned in Publisher\'s Weekly, Forbes online, and other media outlets around the world. In fact, Amazon referred to him as one of their 2012 success stories in their year-end press release. \"How I Sold 30,000 eBooks on Amazon\'s Kindle-An Easy-To-Follow Self-Publishing Guidebook\" tells the story of how he became a full-time writer, detailing the specific steps he took to find and connect with his readers. Plus, it describes how he adjusted his strategy when Amazon changed their systems.</span></span>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("176", "49", "asg_product_details", "a:7:{s:9:\"Paperback\";s:9:\"278 pages\";s:9:\"Publisher\";s:74:\"CreateSpace Independent Publishing Platform; 1 edition (September 4, 2013)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1492241504\";s:7:\"ISBN-13\";s:14:\"978-1492241508\";s:18:\"Product Dimensions\";s:22:\"0.6 x 5.9 x 8.9 inches\";s:15:\"Shipping Weight\";s:11:\"15.5 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("177", "49", "asg_star_rating", "4.6");
INSERT INTO `wp_postmeta` VALUES("178", "49", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:34:\"It\'s a must read for ebook authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 30, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2SPF129OKGORN/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:15:\"Gisela Hausmann\";s:7:\"address\";s:14:\"Greenville, SC\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:32:\"Was Skeptical, but am Pleased...\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 7, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1FQ6HTY5VAPYB/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:3:\"NSW\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:74:\"Save your money! There are other much better books about selling on Amazon\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:16:\"November 9, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3MXPZC5MM4V1Z/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:7:\"lightly\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:43:\"This author has a proven record of success.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AN64OCWND67GZ/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:7:\"coquine\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:23:\"A Must for Every Writer\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 5, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3MST36P474IGZ/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:33:\"Karen Magill \"Author and Speaker\"\";s:7:\"address\";s:17:\"Vancouver, Canada\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:58:\"THIS is the book every INDIE should PURCHASE - RIGHT HERE!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 22, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A13FU9O4GT2CT3/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:14:\"Jackie Pynaert\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:31:\"Worth 30,000+ Stars! MUST READ!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1G4SYJULFPEFO/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:9:\"ABookADay\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:10:\"Worthwhile\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"November 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3BMRKD7MBV494/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:3:\"Dan\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:64:\"One of the best instructional ebooks - a must-buy for any author\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 14, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ATKQG6YDC9QQ5/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:48:\"Dianne Greenlay \"Author of Quintspinner -A Pi...\";s:7:\"address\";s:20:\"Saskatchewan, Canada\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:25:\"Lots of Great Information\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1JMSZEI0NDHYB/ref=cm_cr_pr_pdp/179-9451948-1891224\";s:4:\"name\";s:48:\"Roberta Kagan author of &#34;All My Love, Det...\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("179", "49", "asg_last_refresh_attempt", "1391195233");
INSERT INTO `wp_postmeta` VALUES("180", "49", "asg_update_timestamp", "1391195233");
INSERT INTO `wp_postmeta` VALUES("181", "50", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("182", "50", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("183", "50", "asg_item_id", "B0049H94PW");
INSERT INTO `wp_postmeta` VALUES("184", "50", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B0049H94PW\";s:13:\"DetailPageURL\";s:216:\"http://www.amazon.com/Book-Selling-Chargan-Marketing-Ideas-ebook/dp/B0049H94PW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0049H94PW\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:226:\"http://www.amazon.com/Book-Selling-Chargan-Marketing-Ideas-ebook/dp/tech-data/B0049H94PW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB0049H94PW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB0049H94PW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB0049H94PW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B0049H94PW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B0049H94PW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B0049H94PW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0049H94PW\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/419bq5m%2BNLL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:12:\"Philip Ragan\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:1:\"1\";s:6:\"Format\";s:12:\"Kindle eBook\";s:5:\"Label\";s:25:\"Chargan My Book Publisher\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:25:\"Chargan My Book Publisher\";s:13:\"NumberOfPages\";s:2:\"16\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2010-10-26\";s:9:\"Publisher\";s:25:\"Chargan My Book Publisher\";s:11:\"ReleaseDate\";s:10:\"2010-10-26\";s:6:\"Studio\";s:25:\"Chargan My Book Publisher\";s:5:\"Title\";s:58:\"My Book Isn\'t Selling! The Chargan Book of Marketing Ideas\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:198:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B0049H94PW&atag=freetos-20&exp=2014-02-01T19%3A07%3A14Z&v=2&sig=%2B%2FOmwt5WtlKlxEX%2BVpd8FNdRKondeBfQdcVQDeHr63M%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:286:\"So you\'ve published your book but it is not selling? The publishing world is highly competitive, and the advent of ebooks has changed the landscape further in 2010. How you do make your book stand out? This book contains practical ideas that you should pursue to start generating sales.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("185", "50", "asg_product_details", "a:10:{s:9:\"File Size\";s:5:\"81 KB\";s:12:\"Print Length\";s:8:\"16 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:55:\"Chargan My Book Publisher; 1 edition (October 26, 2010)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B0049H94PW\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("186", "50", "asg_star_rating", "3.2");
INSERT INTO `wp_postmeta` VALUES("187", "50", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:16:\"Slapped Together\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:18:\"September 17, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A39T45GR3HDFNM/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:12:\"Heather Hart\";s:7:\"address\";s:5:\"Texas\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:14:\"self promotion\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:13:\"July 31, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1G9OHBWSV5TR3/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:18:\"the procrastinator\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:23:\"Very little information\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:17:\"November 26, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AY952C463O3U0/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:11:\"Glen Bonnet\";s:7:\"address\";s:10:\"Texas, USA\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:8:\"Outdated\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:14:\"March 26, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A26PD4XKALXK0W/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:20:\"Mark LeGrand Messick\";s:7:\"address\";s:4:\"Utah\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:11:\"Superficial\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:16:\"January 24, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A33QIRC2I9JAD6/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:9:\"C.langman\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:26:\"I wanted to like it but...\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:17:\"November 23, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3O0NVU7IFFDTA/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:21:\"Jeanette S Cates, PhD\";s:7:\"address\";s:14:\"Austin, TX USA\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:19:\"Helpful Item (Book)\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:17:\"November 21, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A3XMYBGZ6926W/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:19:\"John Monyjok Maluth\";s:7:\"address\";s:16:\"Yei, South Sudan\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:7:\"Helpful\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 17, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/APZGETLH6EE5S/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:6:\"Methis\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:20:\"Thanks for the ideas\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3BHCEXOCJ0AGO/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:9:\"Sagitario\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:19:\"Simple and Sensible\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:15:\"August 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A26LIJJA8Z6SB6/ref=cm_cr_pr_pdp/180-0059473-0731064\";s:4:\"name\";s:22:\"Abby Campbell \"Author\"\";s:7:\"address\";s:18:\"Charlotte, NC, USA\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("188", "50", "asg_last_refresh_attempt", "1391195236");
INSERT INTO `wp_postmeta` VALUES("189", "50", "asg_update_timestamp", "1391195236");
INSERT INTO `wp_postmeta` VALUES("190", "51", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("191", "51", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("192", "51", "asg_item_id", "B00DFTQKHU");
INSERT INTO `wp_postmeta` VALUES("193", "51", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B00DFTQKHU\";s:13:\"DetailPageURL\";s:208:\"http://www.amazon.com/The-Power-Free-Amazon-Kindle-ebook/dp/B00DFTQKHU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00DFTQKHU\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:218:\"http://www.amazon.com/The-Power-Free-Amazon-Kindle-ebook/dp/tech-data/B00DFTQKHU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00DFTQKHU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00DFTQKHU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00DFTQKHU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00DFTQKHU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00DFTQKHU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00DFTQKHU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DFTQKHU\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"113\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/413lzGt53uL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"354\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"78\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/413lzGt53uL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"113\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/413lzGt53uL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"354\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:12:\"Glen Chapman\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"22\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-05\";s:11:\"ReleaseDate\";s:10:\"2013-12-05\";s:5:\"Title\";s:34:\"The Power of Free on Amazon Kindle\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00DFTQKHU&atag=freetos-20&exp=2014-02-01T19%3A07%3A16Z&v=2&sig=TrhZQNQ70QWI1wkl9tujb2dnePUtoD8P%2BjEAboqOLRE%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1632:\"<h2>Use the power of KDP Select free promotion to get more visibility and more paid sales!</h2><h3><i>In this brand new guide, Glen Chapman outlines not only the strategies and techniques for sending your book to the top of the Amazon Free Charts, but also gives you the marketing theory behind your potential strategy.</i></h3><p>There are more than enough guides out there on Amazon and on the various blogs telling you where to promote your free book.  Chapman\'s approach is slightly different - </p><p>- Where to concentrate your efforts and valuable time, in keeping with Pareto\'s law of 80/20.  Chapman details the best sites to focus on in terms of \'bang for your buck\' (or, more accurately \'bang for your time\') when you are executing your \'free\' strategy on KDP Select.</p><p>- Why \'free\' is just another marketing tool</p><p>- Why, despite the advent of free books, there will always be the majority of consumers who are prepared to pay for useful information or high-quality entertainment</p><p>Many bemoan the advent of KDP select and the \'free promotion\' in general, however you can\'t argue with results.  Nascent self-publishers have almost all had the same experience when launching themselves on the Amazon platform - successfully launch your book with a cleverly executed free period on KDP select and you will go on to move significantly higher numbers of books in the period following.  Not only will that particular title go on to rank higher and sell more units, any other books by the same author will get the \'halo effect\' and see a greater number of sales.</p><h2><u>Scroll up and grab a copy today.</u></h2>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("194", "51", "asg_product_details", "a:9:{s:9:\"File Size\";s:7:\"1292 KB\";s:12:\"Print Length\";s:8:\"22 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00DFTQKHU\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("195", "51", "asg_star_rating", "4");
INSERT INTO `wp_postmeta` VALUES("196", "51", "asg_customer_reviews", "a:8:{i:0;a:5:{s:5:\"title\";s:41:\"Good on the theory, light on the \"How To\"\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"June 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3HTD7YTMDGNOX/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:47:\"Tim B \"Author, Tactics Time 1001 Chess Tactics\"\";s:7:\"address\";s:34:\"Colorado Springs, CO United States\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:28:\"Concrete facts show the way!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3SNXC3U260ZTZ/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:19:\"Jack G Hardy \"Jack\"\";s:7:\"address\";s:9:\"Miami, FL\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:28:\"Gets you thinking about free\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"July 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A15O7GZ9946BR8/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:11:\"Nick Vulich\";s:7:\"address\";s:4:\"Iowa\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:39:\"Bullseye, but not the target I expected\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:12:\"July 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A32YDTH8HJ7UW2/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:45:\"David Loeff author of &#34;Orphan\'s Gold&#34;\";s:7:\"address\";s:13:\"Colorado, USA\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:18:\"Great, short read!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 14, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A19II7FRM5VVQI/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:17:\"Desiree\'s Shelves\";s:7:\"address\";s:17:\"Worcester, MA USA\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:11:\"informative\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:15:\"August 27, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1EVU0GVWXNJOI/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:12:\"Glad Doggett\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:69:\"If you don\'t have time to sort through other blogs about this subject\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:13:\"July 30, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3912PN9KKWSMQ/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:49:\"matthew stillman \"born and raised in book stacks\"\";s:7:\"address\";s:18:\"new york, new york\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:48:\"A must read for those thinking of using KDP Free\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"June 27, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2JL1JV1DHNG6V/ref=cm_cr_pr_pdp/183-3451545-2183523\";s:4:\"name\";s:9:\"G. lawley\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("197", "51", "asg_last_refresh_attempt", "1391195238");
INSERT INTO `wp_postmeta` VALUES("198", "51", "asg_update_timestamp", "1391195238");
INSERT INTO `wp_postmeta` VALUES("199", "52", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("200", "52", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("201", "52", "asg_item_id", "B00B2UMFAA");
INSERT INTO `wp_postmeta` VALUES("202", "52", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00B2UMFAA\";s:13:\"DetailPageURL\";s:206:\"http://www.amazon.com/Make-Your-Book-Covers-Save-ebook/dp/B00B2UMFAA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B2UMFAA\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:216:\"http://www.amazon.com/Make-Your-Book-Covers-Save-ebook/dp/tech-data/B00B2UMFAA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00B2UMFAA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00B2UMFAA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00B2UMFAA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00B2UMFAA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00B2UMFAA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00B2UMFAA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2UMFAA\";}}}s:9:\"SalesRank\";s:6:\"188273\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"313\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"69\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51OQWfFV6JL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"313\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:9:\"Erik Kopp\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:15:\"EK Publications\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:15:\"EK Publications\";s:13:\"NumberOfPages\";s:2:\"60\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-01-17\";s:9:\"Publisher\";s:15:\"EK Publications\";s:11:\"ReleaseDate\";s:10:\"2013-01-17\";s:6:\"Studio\";s:15:\"EK Publications\";s:5:\"Title\";s:54:\"How To Make Your Own Book Covers and Save $1,000\'s !!!\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00B2UMFAA&atag=freetos-20&exp=2014-02-01T19%3A07%3A18Z&v=2&sig=fTIkvoqFFJxA%2FtzzKqDEkt6RpRWjZVPgvCoDtnVR2ew%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1892:\"<h2>A Step By Step Guide To Making Your Own eBook and Print Book Covers Without Big Expense.</h2><br /><br /><b>Would you like to create your own eBook and print book covers without having to hire a graphic designer? But you are <br /><br />hesitant because you think you need buy and learn expensive software and the result will look \"home made\"?</b> <br /><br />Wouldn\'t it be cool to make your own professional looking eBook and print book covers using software you already have and know how to <br /><br />use?<br /><br />This is definitely within your reach.  Making your own book covers is a lot of fun and it is not as hard or complicated or expensive <br /><br />as you think. <br /><br />The fact is, common software you may already have provides a great tool for making excellent book covers.  MS PowerPoint is the <br /><br />perfect tools for producing superior book covers as it is geared towards graphical presentations and has the utilities needed to <br /><br />merge colors, textures, fonts and images together in visually pleasing presentations which can be suitably formatted as book covers.<br /><br />This book will provide you with: <br /><br />• How to use software you are already familiar with to produce top notch book covers which compete with the best. <br />• Technical instructions for setting up and formatting both eBook and Print Book covers to meet publishing requirements.<br />• Creative design guidelines for producing eye catching book covers in eBook and Print Book sizes. <br />• Examples of real books on sale now created using this method.<br />• Valuable tool to allow you to maintain control over your book cover designs and keep your costs down.<br /><br />Making your own book covers is also a lot of fun!!<br /><br />You can do this too - even if you\'ve never done it before. <br /><br />Give it a try - you will be very glad you did!!\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("203", "52", "asg_last_refresh_attempt", "1391195240");
INSERT INTO `wp_postmeta` VALUES("204", "52", "asg_update_timestamp", "1391195240");
INSERT INTO `wp_postmeta` VALUES("205", "53", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("206", "53", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("207", "53", "asg_item_id", "B00DENBRXE");
INSERT INTO `wp_postmeta` VALUES("208", "53", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00DENBRXE\";s:13:\"DetailPageURL\";s:229:\"http://www.amazon.com/EBook-Publishing-Marketing-Promotion-Spreadsheets-ebook/dp/B00DENBRXE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00DENBRXE\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:239:\"http://www.amazon.com/EBook-Publishing-Marketing-Promotion-Spreadsheets-ebook/dp/tech-data/B00DENBRXE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00DENBRXE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00DENBRXE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00DENBRXE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00DENBRXE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00DENBRXE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00DENBRXE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DENBRXE\";}}}s:9:\"SalesRank\";s:6:\"246912\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51eU-no6alL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51eU-no6alL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51eU-no6alL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:11:\"Lee Mellott\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:21:\"Lil Black Dress Press\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:21:\"Lil Black Dress Press\";s:13:\"NumberOfPages\";s:2:\"53\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-06-13\";s:9:\"Publisher\";s:21:\"Lil Black Dress Press\";s:11:\"ReleaseDate\";s:10:\"2013-06-13\";s:6:\"Studio\";s:21:\"Lil Black Dress Press\";s:5:\"Title\";s:92:\"EBook Publishing: 101+ EBook Marketing Tips With Promotion Spreadsheets! (Kindle Publishing)\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00DENBRXE&atag=freetos-20&exp=2014-02-01T19%3A07%3A20Z&v=2&sig=WsHXLQhclDSfjtpGxQ8DoU2fgDQVS5gKzmcokpcRdb0%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2413:\"<b>Do You Want to Sky Rocket Your EBook Sales? </b><br /><br />Amazon\'s KDP Select offers publishers a unique opportunity to become a best selling author. In this book you will discover how to use KDP Select to your advantage to enjoy as many sales as possible.<br /><br /><b>\"EBook Publishing: 101+ EBook Marketing Tips With Promotion Spreadsheets!\"</b> includes over 101+ marketing tips to kick your promo into high gear PLUS a step by step KDP Select promotion plan with Quick and Easy Spreadsheets!<br /><br />This is the exact plan I use to get thousands of downloads on my KDP Select days. Using all free, quality methods, one of my books alone enjoyed over 22,000 downloads (which resulted in hundreds of sales) in just 2 days with KDP Select!<br /><br />In the marketing tips section you will discover:<br /><b></b><ul><li><b>Increase your productivity</b> - (how long should you work for, how you can burn calories and get fit while writing your book...+more!)</li><li><b>Plan ahead to save time and effort </b>- (easy tip for picking pen names, mind mapping tools...+ more!)</li><li><b>Work smarter not harder </b>- (quick character generator, how customer reviews on competitors books can help you write yours...+ more!)</li><li><b>Create good book descriptions</b> - (a call to action can increase sales, attention grabbing headlines pique interest...+ more!)</li><li><b>Handy Tools for eBooks</b> - (check your rankings all in one place, count up your Kindle book sales in an instant...+ more!)</li><li><b>Top Ten Writer Resources</b> - (get inspired with classic free literature, need grammar or style help - find it here...+ more!)</li><li><b>And so much more! Over 101+ marketing tips to help kick your promotion into high gear!</b></li></ul>  <br /><b>In addition the book includes my SECRET SAUCE!  </b><br /><br />The book includes a step by step KDP Select promotion activity plan with the Quick and Easy Downloadable Spreadsheets!  These spreadsheets will totally organize you, giving you maximum mileage for your efforts!<br /><br />You will LOVE how easy it is to open up your spreadsheets and follow the activities to promote your KDP Select days.  KDP Select Promo days have never been easier and more effective!<br /><br /><b>Want to increase your downloads and sales?<br /><br />Grab your copy of \"EBook Publishing: 101+ EBook Marketing Tips With Promotion Spreadsheets!\" today!</b>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("209", "53", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:23:\"71 Ebook Marketing tips\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:15:\"August 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AGNQ8MX6V3L58/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:15:\"ed1300 \"ed1300\"\";s:7:\"address\";s:10:\"Boston, Ma\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:22:\"Great value for money.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2QOJD2OEB3O8J/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:17:\"Richard McChesney\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:57:\"Good information, I can overlook the \"Infomercial\" aspect\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 16, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2RTTXK44Q2EG3/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:15:\"Steven M. Bohne\";s:7:\"address\";s:8:\"Michigan\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:36:\"Great Resource With Actionable Ideas\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1B812J3QAD4X8/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:15:\"Robert E. Picha\";s:7:\"address\";s:14:\"So. California\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:13:\"Very Helpful!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A28QNL70K7XL6R/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:14:\"Cynthia Tucker\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:51:\"Great information on ebook publishing and marketing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"November 5, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A260XUSXP59RDU/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:25:\"Marg Ruttan \"Marg Ruttan\"\";s:7:\"address\";s:22:\"Edson, Alberta, Canada\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:29:\"Great Resource for any Writer\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2DU95DBAWNBJB/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:10:\"Star Riley\";s:7:\"address\";s:17:\"HOLLYWOOD, FL, US\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:16:\"Ebook Publishing\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:15:\"October 7, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A37UW8HLI03KVQ/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:30:\"S. Utley \"the nerdy organizer\"\";s:7:\"address\";s:12:\"Newburgh, IN\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:53:\"Very useful and necessary for fiction self publishers\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:18:\"September 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1WCGEMD4EC1UE/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:12:\"Faisal Kadri\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:18:\"Excellent resource\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1W83TUWXOYIMC/ref=cm_cr_pr_pdp/191-4169035-5962138\";s:4:\"name\";s:12:\"Diana Heuser\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("210", "53", "asg_last_refresh_attempt", "1391195241");
INSERT INTO `wp_postmeta` VALUES("211", "53", "asg_update_timestamp", "1391195241");
INSERT INTO `wp_postmeta` VALUES("212", "54", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("213", "54", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("214", "54", "asg_item_id", "1484889215");
INSERT INTO `wp_postmeta` VALUES("215", "54", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1484889215\";s:13:\"DetailPageURL\";s:220:\"http://www.amazon.com/EBook-Millionaire-Complete-Selling-EBooks-FAST/dp/1484889215%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1484889215\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:230:\"http://www.amazon.com/EBook-Millionaire-Complete-Selling-EBooks-FAST/dp/tech-data/1484889215%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1484889215%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1484889215%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1484889215%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1484889215%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1484889215%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1484889215%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";}}}s:9:\"SalesRank\";s:7:\"1943615\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51nRdAcE3SL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51q0wG5od3L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51q0wG5od3L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51q0wG5od3L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51q0wG5od3L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51q0wG5od3L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51q0wG5od3L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}}s:14:\"ItemAttributes\";a:19:{s:6:\"Author\";s:18:\"Mr James Calthorpe\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781484889213\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781484889213\";}s:4:\"ISBN\";s:10:\"1484889215\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"12\";s:6:\"Weight\";s:2:\"19\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:3:\"799\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$7.99\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:2:\"52\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"12\";s:6:\"Length\";s:3:\"900\";s:6:\"Weight\";s:2:\"29\";s:5:\"Width\";s:3:\"600\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-04-08\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:75:\"EBook Millionaire: Your Complete Guide to Making Money Selling EBooks-FAST!\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"542\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$5.42\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:4:\"1954\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$19.54\";}s:8:\"TotalNew\";s:2:\"14\";s:9:\"TotalUsed\";s:1:\"5\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1484889215%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484889215\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:138:\"9hs%2FqQ9hFBhR8QXWRf2KVUQ68JlBe%2BlEia4XkiRoQ22s9%2FTaSZ%2FUOCzDkdTb1V1eZTMa1Dqv2hLPh5FKuptr9GBKFq%2FoiWnfvw%2BgUz8rF1yNPBv3q03I%2FA%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:3:\"759\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$7.59\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:2:\"40\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$0.40\";}s:15:\"PercentageSaved\";s:1:\"5\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1484889215&atag=freetos-20&exp=2014-02-01T19%3A07%3A21Z&v=2&sig=cuhGuiMn2s5GQ9zjgLVnlIdqW9LACDgNF6W7GlHWq9I%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1820:\"Ebook Millionaire is a complete step by step guide to building a massive revenue stream through selling your books online-either via your own blog or via Amazon Kindle and other e-readers.<p> Many books on Kindle never sell more than one or two copies- not because they are not well written but because they are not well marketed. This book will teach authors the almost guaranteed method of success in self publishing starting from before the book is written: Market research- to guarantee you have a pool of hungry buyers desperate for your book-before you have even written a word!<p> It also teaches you both external and internal marketing. Many authors are good writers but are not very good at marketing. Internal marketing is optimising the Kindle platform to get more sales, more reviews, get your books listed high on the sales rankings and being seen by more people.<p> External marketing will explain in an easy to follow format how to blog, how to use Twitter, the importance of Facebook and the value of traditional marketing systems.<p> E-book Millionaire is not another \"get rich quick\" guide. This book follows the exact system used by the author to create a regular five figure monthly income from these same methods. The steps are simple but the information world changes all the time and the simple things often get overlooked.<p> If these are not done properly your book will be lost amongst the thousands vying for the browsers attention.<p> This book will help you immensely if you are looking to publish your first book, if you already have published a book but it is not selling yet or if you are looking to create a serious self publishing empire with multiple titles in multiple genres.<p> If you are serious about online book sales and have not read this book, you are simply losing money!<p>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("216", "54", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:37:\"Worth more than $2.99- by a long shot\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AKVKOB474SBJ4/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:16:\"Greener pastures\";s:7:\"address\";s:11:\"Atlanta, GA\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:35:\"Authorship and Publishing Evolution\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"December 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AAEO0DFYDQ0CB/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:19:\"Blane J. Nasveschuk\";s:7:\"address\";s:15:\"Rutland, VT USA\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:14:\"I can do this!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 26, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A37G07IUMRGTL6/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:7:\"Elana W\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:42:\"EBook Millionaire full of very useful info\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 23, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36XHYH6U80ZAF/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:14:\"Anise E. Quinn\";s:7:\"address\";s:15:\"El Paso, TX USA\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:10:\"Great Book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 29, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1M7VKKT8FY9V0/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:13:\"Conroy Dennis\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:33:\"Great read about how to publish..\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AGR98IRFC8FIG/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:14:\"Rodger D Sharp\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:17:\"Good Information!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A11UIV2PIXHRGA/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:7:\"Tanisha\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:11:\"So Helpful!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:11:\"May 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A5UDG2N8KT8ZC/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:13:\"J. Calvin \"J\"\";s:7:\"address\";s:13:\"San Diego, CA\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:12:\"Helpful tips\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"April 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A30A6ECJCR0X28/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:16:\"Tracey Blackmore\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:34:\"Solid product with Some Good Ideas\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 30, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ADXK79DO4PW1E/ref=cm_cr_pr_pdp/183-9899661-1152152\";s:4:\"name\";s:12:\"Eric Michael\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("217", "54", "asg_last_refresh_attempt", "1391195242");
INSERT INTO `wp_postmeta` VALUES("218", "54", "asg_update_timestamp", "1391195242");
INSERT INTO `wp_postmeta` VALUES("219", "55", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("220", "55", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("221", "55", "asg_item_id", "B00B2YUQ16");
INSERT INTO `wp_postmeta` VALUES("222", "55", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00B2YUQ16\";s:13:\"DetailPageURL\";s:211:\"http://www.amazon.com/10-Keys-Ebook-Marketing-Success-ebook/dp/B00B2YUQ16%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B2YUQ16\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:221:\"http://www.amazon.com/10-Keys-Ebook-Marketing-Success-ebook/dp/tech-data/B00B2YUQ16%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00B2YUQ16%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00B2YUQ16%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00B2YUQ16%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00B2YUQ16%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00B2YUQ16%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00B2YUQ16%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B2YUQ16\";}}}s:9:\"SalesRank\";s:5:\"53150\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"115\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"359\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"22\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"79\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"115\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51BSuNntxYL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"359\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:11:\"Karen Baney\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:5:\"EISBN\";s:13:\"9780985586225\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:34:\"Author Services International, LLC\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:34:\"Author Services International, LLC\";s:13:\"NumberOfPages\";s:3:\"124\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-11-09\";s:9:\"Publisher\";s:34:\"Author Services International, LLC\";s:11:\"ReleaseDate\";s:10:\"2013-11-09\";s:6:\"Studio\";s:34:\"Author Services International, LLC\";s:5:\"Title\";s:34:\"10 Keys to Ebook Marketing Success\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00B2YUQ16&atag=freetos-20&exp=2014-02-01T19%3A07%3A22Z&v=2&sig=Nc0e9jl5qZHzpc1VhYQU29zaNKZ9rR1kNUxF2JTFXPo%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1597:\"<h3>Is it really possible to make a living as a self-published or small press author? </h3><p>Best-selling author, Karen Baney <b>understands how hard it is to sell eBooks</b>.  Her success didn’t come overnight, but instead it came through persistence and patience.  She applied the principles and tips of book marketing success that she now shares with you.</p><p><b><i>“I want to help other authors break out of the grind of dismal book sales.  There are so many techniques from the world of business that we, as authors, can apply to our writing business.”</i>  –Karen Baney</b></p><p>This book is designed for the busy writer:  concise and information packed.  <b>Well-organized</b>, it is broken down into 10 key areas of eBook marketing.  Each key contains:</p>\n<br /><li>Success Tips – brief impactful statements that drive home important points</li>\n<br /><li>Do’s and don’ts for marketing and building your brand as an author</li>\n<br /><li>Concise lists summarizing each key</li>\n<br /><li>Marketing Minute—an opportunity to evaluate your own progress and apply what you just learned to your marketing plan.</li>\n<br /><p><b>What makes Karen Baney a creditable authority?</b>  In addition to 20 years in business, she holds a Masters of Business Administration from Arizona State University.  In her <b>second year</b> as a published author she achieved over 200,000 eBook downloads.</p><p>Whether you’re a new or veteran author, <i>10 Keys to eBook Marketing Success</i> can help you <b>learn how to sell books online </b>and improve your marketing plan.</p>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("223", "55", "asg_product_details", "a:10:{s:9:\"File Size\";s:6:\"461 KB\";s:12:\"Print Length\";s:9:\"124 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:53:\"Author Services International, LLC (November 9, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00B2YUQ16\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("224", "55", "asg_star_rating", "4.5");
INSERT INTO `wp_postmeta` VALUES("225", "55", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:27:\"A MUST-READ For New Authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1AZ7VA51PUG5G/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:28:\"R. S. Guthrie \"R.S. Guthrie\"\";s:7:\"address\";s:10:\"Denver, CO\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:40:\"MUST READ FOR ALL AUTHORS - NEW AND OLD!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"February 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A38ADCU7DLGD4V/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:9:\"E. Barnes\";s:7:\"address\";s:11:\"Mississippi\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:39:\"A Resource I Will Go To Again and Again\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"February 12, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1S9MVWQHME597/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:12:\"Readitwithme\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:19:\"Excellent Resource!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3TI77ERDFFP7C/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:13:\"Garry Rodgers\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:45:\"Looking forward to implementing these \"Keys\"!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 31, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2PSE8YPXENTJ1/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:11:\"Lori Ramsey\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:45:\"A must-have for the self-published author ...\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A33XSDDF6CGI3S/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:20:\"Matthew L. Patterson\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:15:\"Ebook marketing\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:18:\"September 10, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ALV0UIJEVXZ2G/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:19:\"J. Savoy \"J. Savoy\"\";s:7:\"address\";s:12:\"Richmond, VA\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:18:\"Excellent Resource\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"April 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A133NF1CPXGQWA/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:14:\"Aida E. Rivera\";s:7:\"address\";s:19:\"Forest Hill, MD, US\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:26:\"Very useful marketing tool\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"April 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1JF8J7T2OYZ34/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:36:\"Pamela Carmichael \"Christian Author\"\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:28:\"Great read for novice writer\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"February 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1KNA5OQC4919M/ref=cm_cr_pr_pdp/178-6979376-4277162\";s:4:\"name\";s:15:\"Richard Charron\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("226", "55", "asg_last_refresh_attempt", "1391195244");
INSERT INTO `wp_postmeta` VALUES("227", "55", "asg_update_timestamp", "1391195244");
INSERT INTO `wp_postmeta` VALUES("228", "56", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("229", "56", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("230", "56", "asg_item_id", "B00CIXM6FO");
INSERT INTO `wp_postmeta` VALUES("231", "56", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00CIXM6FO\";s:13:\"DetailPageURL\";s:230:\"http://www.amazon.com/Self-Publish-Selling-Marketing-Facebook-Techniques-ebook/dp/B00CIXM6FO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00CIXM6FO\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:240:\"http://www.amazon.com/Self-Publish-Selling-Marketing-Facebook-Techniques-ebook/dp/tech-data/B00CIXM6FO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00CIXM6FO%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00CIXM6FO%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00CIXM6FO%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00CIXM6FO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00CIXM6FO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00CIXM6FO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CIXM6FO\";}}}s:9:\"SalesRank\";s:6:\"712488\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"108\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"337\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"74\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"108\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51c8XQ5ZXPL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"337\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:21:\"WorkNine Publications\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"44\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-04-24\";s:11:\"ReleaseDate\";s:10:\"2013-04-24\";s:5:\"Title\";s:191:\"How To Self-Publish and Really Make Money Selling Your Book on Amazon with Kindle eBook Marketing Tactics, Facebook, Twitter, and Blog Marketing Techniques: The Essential Author Success Guide\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00CIXM6FO&atag=freetos-20&exp=2014-02-01T19%3A07%3A25Z&v=2&sig=HHnvDNvCfO2gk25mQ4fL7z6mT0zsBkGbU67hKuqNkZU%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2045:\"<h2><br />The Essential Author Success Guide says it all in the title—it is an essential tool for every author\'s success not only as a writer but as a marketer. <br /></h2><br /><br />The book contains the following categories:<br /><br />• Self-publishing vs. Traditional Publishing: It compares and contrasts the two and clearly defnes the pros and cons for emerging writers.<br /><br />• The Five Steps of Self-Publishing: It provides five practical steps that are easily applicable, while offering helpful suggestions on who to partner with.<br /><br />• How to Market Your Book: It gives helpful advice on how to catch the attention of readers and buyers.<br /><br />• Kindle Direct Publishing: It answers writer\'s questions on how to publish books directly through kindle and how to successfully do it.<br /><br />• Social Media Marketing: It explores the benefts of social media such as facebook, twitter, and youtube, and investigates ways writers can use these media to their full advantage.<br /><br />•Boost Your Book Sales with a Virtual Book Tour: It demystifes a Book Blog Tour and shows exactly how writers can use this to enhance their book sales.<br /><br />• Community Marketing: It draws writers\' attention to more traditional forms of marketing such as fundraising and public speaking.<br /><br />• How to Get Book Reviews: It emphasizes how critical good book reviews are to the success of each book, and offers suggestions on how to gain such positive reviews.<br /><br />• Free Marketing Strategies: It presents even more insightful ideas on how and where to market self-published books.<br /><br />• Total Marketing Plan: It enables writers to combine good writing with an excellent marketing plan to ensure the success of their books.<br /><br />\"Self-publishing has never been more easy or possible, and yet talented, enthusiastic writers are often at a loss at how to market their work. The Essential Author Success Guide is a compact, information-rich book designed to empower writers\' success.\"\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("232", "56", "asg_customer_reviews", "a:4:{i:0;a:5:{s:5:\"title\";s:16:\"clear and useful\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A6K5LBGRLY953/ref=cm_cr_pr_pdp/186-8572306-4334407\";s:4:\"name\";s:22:\"FRANCOIS RALPH \"FRANC\"\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:16:\"Great Investment\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A32EK8YJDTV8ZT/ref=cm_cr_pr_pdp/186-8572306-4334407\";s:4:\"name\";s:11:\"Thomas Dole\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:21:\"This book was helpful\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A35J964GU741TG/ref=cm_cr_pr_pdp/186-8572306-4334407\";s:4:\"name\";s:12:\"J. Pemberton\";s:7:\"address\";s:10:\"Denver, CO\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:13:\"A good start.\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:15:\"August 20, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1W2SDR84A028H/ref=cm_cr_pr_pdp/186-8572306-4334407\";s:4:\"name\";s:7:\"j.smith\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("233", "56", "asg_last_refresh_attempt", "1391195246");
INSERT INTO `wp_postmeta` VALUES("234", "56", "asg_update_timestamp", "1391195246");
INSERT INTO `wp_postmeta` VALUES("235", "57", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("236", "57", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("237", "57", "asg_item_id", "B0090SR3SK");
INSERT INTO `wp_postmeta` VALUES("238", "57", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B0090SR3SK\";s:13:\"DetailPageURL\";s:214:\"http://www.amazon.com/Kindle-Marketing-Made-Easy-Promote-ebook/dp/B0090SR3SK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0090SR3SK\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:224:\"http://www.amazon.com/Kindle-Marketing-Made-Easy-Promote-ebook/dp/tech-data/B0090SR3SK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB0090SR3SK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB0090SR3SK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB0090SR3SK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B0090SR3SK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B0090SR3SK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B0090SR3SK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0090SR3SK\";}}}s:9:\"SalesRank\";s:6:\"365620\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"375\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"22\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"82\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51kvN1JpbdL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"375\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:15:\"Andrew Macarthy\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"70\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-08-20\";s:11:\"ReleaseDate\";s:10:\"2012-08-20\";s:5:\"Title\";s:128:\"Kindle Marketing Made Easy: How to Promote Like A Pro, Get Rave Reviews, Sell More E-Books on Amazon, and Make Money With Kindle\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B0090SR3SK&atag=freetos-20&exp=2014-02-01T19%3A07%3A27Z&v=2&sig=s9isno5Nk2bjBsxCCg1ofbtPkLfJbOwWwx2iA8fOLTk%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2525:\"<b>Having A Hard Time Selling E-Books on Amazon?</b><br />Published your book on Kindle but no one\'s buying? No reviews and languishing at the bottom of Amazon\'s search results? Don\'t know how to promote your e-book to the masses, or don\'t even know where to begin? <i>Kindle Marketing Made Easy</i> can help!<br /><br />Brought to you by the author of the Amazon Kindle Bestseller, <i>500 Social Media Marketing Tips, Kindle Marketing Made Easy</i> is your essential Kindle publishing guide, teaching you how to get your fiction or non-fiction e-book ranking higher in Amazon search, encourage rave reviews, promote your work like a pro, and ultimately sell more Kindle e-Books on Amazon!<br /><br /><b>Here\'s Just A Little of What You Will Discover:</b><br /><br /><ul><li>How to craft a killer book title and description that will get your book FOUND on Amazon.</li><li>How to design a professional book cover that will POP from the screen in search results.</li><li>A FREE Kindle e-book template to create a professional cover in minutes!</li><li>How to use free promos to improve your book\'s ranking, get reviews, and encourage sales.</li><li>E-book pricing strategy to earn you the maximum amount of profit possible.</li><li>How to promote your e-book online and in the real world in mere minutes a week.</li><li>The two-word strategy that will increase your book sales - guaranteed!</li><li>A template to have your book formatted and ready to publish on Kindle in minutes!</li><li>... And lots more!</li></ul><br /><b>The Facts About Kindle eBook Sales - A.K.A Why Your E-Book Isn\'t Selling</b><br /><ul><li>Authors who received help with story editing, formatting, copy editing and proofreading make 13% more money than the average self-publisher.</li><li>A professional cover design can boost earnings by a further 34%.</li><li>10% of all self-publishers - the ones with a great e-book marketing strategy - make 75% of ALL the money, and 50% of self-published e-books make less than $500 a year. Which group would you rather be in?</li></ul><div><div><b>Make Positive Changes In Minutes!</b><br /><i>Kindle Marketing Made Easy</i> features essential advice that will immediately benefit your Kindle marketing plan, and help you build on it in just minutes per day. Don\'t miss out! Buy your copy and start the journey to increased book sales today!</div><br /> </div><div><b>P.S. </b>No Kindle? No worries! Buy <i>Kindle Marketing Made Easy </i>to enjoy on Kindle for PC, iPhone, and Android devices too!</div>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("239", "57", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:37:\"Best book on Kindle publishing so far\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 22, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1FH9PLV8VNK6I/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:15:\"Edward Antrobus\";s:7:\"address\";s:16:\"Fort Collins, CO\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:48:\"One of the better ones I;ve read on this subject\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 19, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A16K0MF7ERTDY7/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:48:\"Mark J. Orr \"author of &#34;Stress-Free Retir...\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:20:\"Read this last night\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"January 16, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AT98Q24UD2JM6/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:15:\"Wayne Kernochan\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:10:\"A good buy\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"December 3, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1ZF0DDESOFHS0/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:16:\"Secret Narrative\";s:7:\"address\";s:15:\"London, England\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:23:\"Things to keep in mind.\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"September 9, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2PVKPI5E5JTOO/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:11:\"J. Flanagan\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:30:\"Packed full of creative tips !\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 21, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2Y5GM0X9HZ8DF/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:45:\"Bettyann Vakauza \"wheelchair confined writer\"\";s:7:\"address\";s:19:\"Southwestern NH USA\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:64:\"Some useful and interesting ideas, but seriously needs an editor\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:17:\"November 19, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2N30A1180SLWL/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:20:\"Moscow Writers Group\";s:7:\"address\";s:14:\"Moscow, Russia\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:21:\"A Good Place to Start\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:17:\"December 14, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2ZOXC3XX5L6A2/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:12:\"Diana Lubick\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:60:\"A very good guide on Kindle Marketing-short and to the point\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 9, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A25J0NFMWROVD6/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:6:\"Adyzaf\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:14:\"Quite helpfull\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"September 4, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1DHO55JXLJU2I/ref=cm_cr_pr_pdp/178-6649545-0521742\";s:4:\"name\";s:10:\"John Hicks\";s:7:\"address\";s:19:\"Newcastle Australia\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("240", "57", "asg_last_refresh_attempt", "1391195248");
INSERT INTO `wp_postmeta` VALUES("241", "57", "asg_update_timestamp", "1391195248");
INSERT INTO `wp_postmeta` VALUES("242", "58", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("243", "58", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("244", "58", "asg_item_id", "1626525358");
INSERT INTO `wp_postmeta` VALUES("245", "58", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1626525358\";s:13:\"DetailPageURL\";s:214:\"http://www.amazon.com/Fine-Print-Self-Publishing-Fifth-Edition/dp/1626525358%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1626525358\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:224:\"http://www.amazon.com/Fine-Print-Self-Publishing-Fifth-Edition/dp/tech-data/1626525358%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1626525358%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1626525358%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1626525358%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1626525358%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1626525358%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1626525358%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";}}}s:9:\"SalesRank\";s:5:\"32065\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"105\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"327\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"49\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"72\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"105\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/510UzNMbX8L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"327\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BNjlA339L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BNjlA339L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"48\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51%2BNjlA339L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"48\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51%2BNjlA339L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"70\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51%2BNjlA339L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"102\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51%2BNjlA339L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"319\";}}}}s:14:\"ItemAttributes\";a:22:{s:6:\"Author\";s:11:\"Mark Levine\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781626525351\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781626525351\";}s:7:\"Edition\";s:3:\"5th\";s:4:\"ISBN\";s:10:\"1626525358\";s:20:\"IsEligibleForTradeIn\";s:1:\"1\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:1:\"0\";s:6:\"Length\";s:1:\"0\";s:6:\"Weight\";s:2:\"83\";s:5:\"Width\";s:1:\"0\";}s:5:\"Label\";s:28:\"Bascom Hill Publishing Group\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1695\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$16.95\";}s:12:\"Manufacturer\";s:28:\"Bascom Hill Publishing Group\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"268\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"70\";s:6:\"Length\";s:3:\"840\";s:6:\"Weight\";s:2:\"90\";s:5:\"Width\";s:3:\"540\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2014-01-07\";s:9:\"Publisher\";s:28:\"Bascom Hill Publishing Group\";s:6:\"Studio\";s:28:\"Bascom Hill Publishing Group\";s:5:\"Title\";s:136:\"The Fine Print of Self-Publishing, Fifth Edition: A Primer on Contracts, Printing Costs, Royalties, Distribution, E-Books, and Marketing\";s:12:\"TradeInValue\";a:3:{s:6:\"Amount\";s:3:\"176\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.76\";}}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"949\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$9.49\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:5:\"99911\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:7:\"$999.11\";}s:8:\"TotalNew\";s:1:\"8\";s:9:\"TotalUsed\";s:1:\"1\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1626525358%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1626525358\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:136:\"IY4AlAwE7%2FgZhbah5Vk7hR3AeCrrLab66zfLx%2B%2Fp%2BlER6VIQqdsBK5VVxfpKB%2BFBr4PdU9v12VSmu9BGiil6D6BPKSpAgyUyq1eA%2Fv1KlZXVVl1MvljepQ%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1349\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$13.49\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"346\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$3.46\";}s:15:\"PercentageSaved\";s:2:\"20\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:1:\"0\";s:12:\"MaximumHours\";s:1:\"0\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1626525358&atag=freetos-20&exp=2014-02-01T19%3A07%3A28Z&v=2&sig=XhjKYOgDq8PERwaLgj0O0zaqGcLOPt6%2BzJHiJUKREjQ%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:594:\"<i>The Fine Print of Self-Publishing,</i> now in its fifth edition, has been lauded by industry professionals as the go-to book for authors considering self-publishing. <i>The Fine Print</i> has helped thousands of authors understand self-publishing companies\' services, contract terms, printing markups, and royalty calculations. This latest edition includes new chapters on e-book publishing and book marketing, as well as updated head-to-head comparisons of major self-publishing service providers, including free book-publishing companies to consider and self-publishing companies to avoid.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("246", "58", "asg_product_details", "a:7:{s:9:\"Paperback\";s:9:\"268 pages\";s:9:\"Publisher\";s:59:\"Bascom Hill Publishing Group; 5th edition (January 7, 2014)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1626525358\";s:7:\"ISBN-13\";s:14:\"978-1626525351\";s:18:\"Product Dimensions\";s:22:\"8.4 x 5.4 x 0.7 inches\";s:15:\"Shipping Weight\";s:11:\"14.4 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("247", "58", "asg_star_rating", "4.8");
INSERT INTO `wp_postmeta` VALUES("248", "58", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:31:\"Save yourself hundreds of hours\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"January 17, 2009\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1V7RL4ODXXWDM/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:40:\"Jennifer Bogart \"@ Quiverfullfamily.com\"\";s:7:\"address\";s:15:\"Alberta, Canada\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:59:\"Whole concept seems unwise... Not for the do-it-yourselfer.\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:17:\"November 18, 2011\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2PJIC8DBQIS80/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:13:\"Optimus Rhyme\";s:7:\"address\";s:7:\"NJ, USA\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:20:\"Self-publishing must\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 3, 2010\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A17TLUFO9S72AB/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:4:\"Kate\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:47:\"Not really helpful, if you want to self publish\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:13:\"March 8, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AA90W95STFGAC/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:2:\"jj\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:51:\"If you plan to self-publish, here is your handbook.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:11:\"May 6, 2010\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1Q8E5BPS5CEWF/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:26:\"S. Maroney \"Sandy Maroney\"\";s:7:\"address\";s:25:\"Concord, CA United States\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:63:\"Good introduction to self publishing but lacking in perspective\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:17:\"November 30, 2010\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1SPM61AG6DNFV/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:6:\"rlwest\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:50:\"5++ Star resource for writers who want to publish!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 9, 2008\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A21NVBFIEQWDSG/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:19:\"Armchair Interviews\";s:7:\"address\";s:15:\"Minneapolis, MN\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:31:\"The Fine Art of Self-Publishing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"April 29, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A37K85WVN5UTTQ/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:8:\"DMaroney\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:63:\"The Most Current, Objective and Useful Self-Publishing Resource\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"March 7, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A182L9OX8YZG1E/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:32:\"Amy Vancourt \"life/career coach\"\";s:7:\"address\";s:10:\"Denver, CO\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:21:\"Don\'t Buy This Book!!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 18, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3GYTFF0TO16FC/ref=cm_cr_pr_pdp/182-6055550-4296858\";s:4:\"name\";s:5:\"nacho\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("249", "58", "asg_last_refresh_attempt", "1391195250");
INSERT INTO `wp_postmeta` VALUES("250", "58", "asg_update_timestamp", "1391195250");
INSERT INTO `wp_postmeta` VALUES("251", "59", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("252", "59", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("253", "59", "asg_item_id", "B00FOD5TJA");
INSERT INTO `wp_postmeta` VALUES("254", "59", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00FOD5TJA\";s:13:\"DetailPageURL\";s:221:\"http://www.amazon.com/eBook-Publishing-Promotion-Adoni-Chairman-ebook/dp/B00FOD5TJA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FOD5TJA\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:231:\"http://www.amazon.com/eBook-Publishing-Promotion-Adoni-Chairman-ebook/dp/tech-data/B00FOD5TJA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00FOD5TJA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00FOD5TJA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00FOD5TJA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00FOD5TJA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00FOD5TJA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00FOD5TJA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FOD5TJA\";}}}s:9:\"SalesRank\";s:7:\"1790901\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"68\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51MAMlyDP6L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:9:\"Sol Adoni\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:5:\"EISBN\";s:13:\"9781630132002\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:16:\"Adoni Publishing\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:16:\"Adoni Publishing\";s:13:\"NumberOfPages\";s:2:\"76\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-10-06\";s:9:\"Publisher\";s:16:\"Adoni Publishing\";s:11:\"ReleaseDate\";s:10:\"2013-10-06\";s:6:\"Studio\";s:16:\"Adoni Publishing\";s:5:\"Title\";s:76:\"eBook Publishing - eBook Promotion by Sol Adoni Chairman of Adoni Publishing\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00FOD5TJA&atag=freetos-20&exp=2014-02-01T19%3A07%3A30Z&v=2&sig=HeIMUHVEZaK7ydTsdaeSIZTilZjByalzCInwJB1rcLA%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:415:\"Sol Adoni is a pioneer of the eBook Industry. He has published hundreds of eBooks and has  millions of eBooks downloaded over almost 20 years of eBook Publishing.\n<br />\n<br />Sol Adoni the honorary chairman of Adoni Publishing explains how to properly format an eBook today and how to promote it.\n<br />\n<br />A short read filled with essential information by an expert in the emerging industry of eBook Publishing\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("255", "59", "asg_customer_reviews", "a:1:{i:0;a:5:{s:5:\"title\";s:17:\"Very Informative!\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 27, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3REE7I2Q5UGF8/ref=cm_cr_pr_pdp/188-1706120-8608221\";s:4:\"name\";s:15:\"Michelle Ousley\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("256", "59", "asg_last_refresh_attempt", "1391195251");
INSERT INTO `wp_postmeta` VALUES("257", "59", "asg_update_timestamp", "1391195251");
INSERT INTO `wp_postmeta` VALUES("258", "60", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("259", "60", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("260", "60", "asg_item_id", "B00HB3HCZU");
INSERT INTO `wp_postmeta` VALUES("261", "60", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00HB3HCZU\";s:13:\"DetailPageURL\";s:223:\"http://www.amazon.com/Self-Publishing-Scams-BULLSH-Promote-Market-ebook/dp/B00HB3HCZU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HB3HCZU\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:233:\"http://www.amazon.com/Self-Publishing-Scams-BULLSH-Promote-Market-ebook/dp/tech-data/B00HB3HCZU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00HB3HCZU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00HB3HCZU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00HB3HCZU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00HB3HCZU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00HB3HCZU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00HB3HCZU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HB3HCZU\";}}}s:9:\"SalesRank\";s:6:\"118322\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"67\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"142\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/61CznV83iBL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"445\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"27\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"67\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"67\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"98\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/61CznV83iBL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"142\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/61CznV83iBL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"445\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:10:\"S.R. Tooms\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Creator\";s:9:\"Lady Spud\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:10:\"S.R. Tooms\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:10:\"S.R. Tooms\";s:13:\"NumberOfPages\";s:2:\"65\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-31\";s:9:\"Publisher\";s:10:\"S.R. Tooms\";s:11:\"ReleaseDate\";s:10:\"2013-12-31\";s:6:\"Studio\";s:10:\"S.R. Tooms\";s:5:\"Title\";s:85:\"Self-Publishing: Scams, Lies, and BULLSH*T - How NOT to Promote and Market Your Ebook\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:198:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00HB3HCZU&atag=freetos-20&exp=2014-02-01T19%3A07%3A31Z&v=2&sig=O5NSW6R3PNpAV4oDY%2F%2B7xAPi5X16btlu92EwF%2FI7mF8%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2046:\"From the author of <b>several Top 100 Kindle eBooks</b> (in their darkly comedic and satirical genres) comes this humorous, yet highly informative booklet which explores the darker side of self-publishing - revealing the many follies and pitfalls; the endless swindles and bamboozles which lurk in the shadowy, slimeball encrusted corners...<br /><br /><br /><br />It is tailor-made for anyone fitting the following descriptions:<br /><br /><br />-Beginning authors trying to get a foot in the door (building your platform)<br /><br />-Writers who have been bilked out of hundreds of dollars (perhaps more!) on faulty marketing or advertising scams<br /><br />-Anyone interested in taking the self-publishing or self-marketing route<br /><br />-Those who wish to understand the common run of the mill schemes which endlessly plague the rapidly expanding marketplace<br /><br />-People wise enough to realize a little knowledge goes a long way<br /><br /><br /><br />This is not a book which states \"Follow my ten simple steps and you too can become a best-selling author!\"<br /><br />I am not here to make idle promises, tug at your heart-strings, or pander to your desires - no, no, far from it in fact. For I too grew tired of the deceitful programs, the misleading systems, the fake and fruitless guides that are all too prevalent in this booming industry. I do not whisper sweet nothings in your ear or guarantee success if you purchase my products...I am here to expose the widespread time sinks many, if not all, beginning writers fall victim to. Spare yourself the frustration of countless failed attempts, only to end up clutching handfuls of hair which you have unknowingly ripped from your own head! And that, fair reader, is a hard look to pull off.<br /><br /><br /><br />With this book, I hope you will utilize the age old maxim of \"Learn from the mistakes of others - you don\'t have time to make them all on your own.\"<br /><br /><br /><br />Now come with me and let us take a look inside this depraved activity we call promotion...\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("262", "60", "asg_product_details", "a:10:{s:9:\"File Size\";s:6:\"508 KB\";s:12:\"Print Length\";s:8:\"65 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:30:\"S.R. Tooms (December 31, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00HB3HCZU\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("263", "60", "asg_star_rating", "4");
INSERT INTO `wp_postmeta` VALUES("264", "60", "asg_customer_reviews", "a:3:{i:0;a:5:{s:5:\"title\";s:34:\"Enjoyable and somewhat informative\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"January 22, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AQ10VDIFDIU7R/ref=cm_cr_pr_pdp/176-3439769-4853628\";s:4:\"name\";s:2:\"TJ\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:23:\"Learn through laughter!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 16, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A39G9505LFCMEI/ref=cm_cr_pr_pdp/176-3439769-4853628\";s:4:\"name\";s:16:\"AshleyBookBinger\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:68:\"Entertaining, some good points, but too negative to be really useful\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:16:\"January 15, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A6Y68P1WQPT1I/ref=cm_cr_pr_pdp/176-3439769-4853628\";s:4:\"name\";s:18:\"Charlotte the Bold\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("265", "60", "asg_last_refresh_attempt", "1391195253");
INSERT INTO `wp_postmeta` VALUES("266", "60", "asg_update_timestamp", "1391195253");
INSERT INTO `wp_postmeta` VALUES("267", "61", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("268", "61", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("269", "61", "asg_item_id", "B0084UZ4SQ");
INSERT INTO `wp_postmeta` VALUES("270", "61", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B0084UZ4SQ\";s:13:\"DetailPageURL\";s:210:\"http://www.amazon.com/Ways-Promote-Your-eBook-Online-ebook/dp/B0084UZ4SQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0084UZ4SQ\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:220:\"http://www.amazon.com/Ways-Promote-Your-eBook-Online-ebook/dp/tech-data/B0084UZ4SQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB0084UZ4SQ%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB0084UZ4SQ%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB0084UZ4SQ%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B0084UZ4SQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B0084UZ4SQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B0084UZ4SQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0084UZ4SQ\";}}}s:9:\"SalesRank\";s:6:\"222623\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"375\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"22\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"82\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51w%2Bsc36x0L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"375\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:15:\"Andrew Macarthy\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:3:\"119\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-05-19\";s:11:\"ReleaseDate\";s:10:\"2012-05-19\";s:5:\"Title\";s:113:\"500 Ways to Promote Your eBook Online: Internet eBook Marketing Tips to Sales Success for Kindle, Kobo, and More!\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B0084UZ4SQ&atag=freetos-20&exp=2014-02-01T19%3A07%3A34Z&v=2&sig=QSru8zJaRRZ4IC7Bf2GmzmeZP%2BdPWn%2BzZwRj5diUEas%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:593:\"Have you published an eBook but having trouble getting sales? Wondering how to harness the power of the Internet to promote your novel, short story, or non-fiction title to millions of potential customers? This book can help!<br /><br />500 Ways to Promote Your eBook Online provides hundreds of simply-written expert tips, sharing secrets about how to build your readership via social media spaces, attract and engage with customers, optimize your book\'s cover and blurb, and sell more copies!<br /><br />Your readers are out there, go and get them with 500 Ways to Promote Your eBook Online.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("271", "61", "asg_product_details", "a:8:{s:9:\"File Size\";s:6:\"328 KB\";s:12:\"Print Length\";s:9:\"119 pages\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B0084UZ4SQ\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("272", "61", "asg_star_rating", "4.1");
INSERT INTO `wp_postmeta` VALUES("273", "61", "asg_customer_reviews", "a:9:{i:0;a:5:{s:5:\"title\";s:12:\"No thanks...\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:12:\"June 5, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A32YXHGJ2S5PQU/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:11:\"S. Canfield\";s:7:\"address\";s:11:\"Northern CA\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:16:\"Good Compilation\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:14:\"March 17, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A14G649XXU8U4Z/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:20:\"Christian Playwright\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:18:\"Lots of good ideas\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:12:\"May 23, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A350COGDFIC2NE/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:21:\"rabsparks \"rabsparks\"\";s:7:\"address\";s:6:\"MD USA\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:11:\"Very Useful\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 15, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36QI6W1SC5GYG/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:11:\"Wendy Scott\";s:7:\"address\";s:11:\"New Zealand\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:37:\"500 Ways to Promote Your eBook Online\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"November 2, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1HIOVSH9COHVQ/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:23:\"G. Stacey \"Greg Stacey\"\";s:7:\"address\";s:2:\"UK\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:52:\"Helpful information, great ideas to get you started.\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 30, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AY952C463O3U0/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:11:\"Glen Bonnet\";s:7:\"address\";s:10:\"Texas, USA\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:24:\"For of Great Information\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 17, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3ECC1WPX2PZW9/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:37:\"Mark Clayborne \"Credit Repair Expert\"\";s:7:\"address\";s:11:\"Los Angeles\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:26:\"This book is very helpful!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"June 2, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A21WNT3KI9EY0R/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:15:\"Carolyn Collins\";s:7:\"address\";s:15:\"Miami Beach, FL\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:28:\"Teach an old dog new tricks!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 28, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A258SUUU64XDF8/ref=cm_cr_pr_pdp/184-2276047-8655242\";s:4:\"name\";s:25:\"Jacqueline Druga \"Jackie\"\";s:7:\"address\";s:14:\"Pittsburgh, PA\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("274", "61", "asg_last_refresh_attempt", "1391195256");
INSERT INTO `wp_postmeta` VALUES("275", "61", "asg_update_timestamp", "1391195256");
INSERT INTO `wp_postmeta` VALUES("276", "62", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("277", "62", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("278", "62", "asg_item_id", "B0073T1C6W");
INSERT INTO `wp_postmeta` VALUES("279", "62", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B0073T1C6W\";s:13:\"DetailPageURL\";s:214:\"http://www.amazon.com/How-Write-Publish-Ebooks-Questions-ebook/dp/B0073T1C6W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0073T1C6W\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:224:\"http://www.amazon.com/How-Write-Publish-Ebooks-Questions-ebook/dp/tech-data/B0073T1C6W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB0073T1C6W%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB0073T1C6W%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB0073T1C6W%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B0073T1C6W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B0073T1C6W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B0073T1C6W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0073T1C6W\";}}}s:9:\"SalesRank\";s:6:\"324509\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"334\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51mBQlmKXSL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"334\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:11:\"Jim Edwards\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"55\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-01-30\";s:11:\"ReleaseDate\";s:10:\"2012-01-30\";s:5:\"Title\";s:85:\"How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B0073T1C6W&atag=freetos-20&exp=2014-02-01T19%3A07%3A36Z&v=2&sig=KJuFV1oYfsLeBE6wB1Sf%2FLKGwaDcYVJFF%2FzTycMTUdE%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1674:\"If you\'re an <b>Ebook Author who wants</b> to know the <i>secrets </i>of<b> Ebook Marketing, Ebook Writing, and ebook publishing,</b> then you\'re about to discover how to get your own profitable, money-making ebook right now!<br /><br /><b>\"How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask \" - gives you the answers to 20 important questions and challenges every Ebook Author faces, including:</b><br /><ul><li><b>How do I hire someone to write my ebook for me?</b> (and get GREAT content),,,</li><li>Can you still make money with ebooks in today\'s market? (is it too crowded?)...</li><li><b>What are the best ebook topics that will sell?</b> (and which ones suck?)...</li><li>How do I get my ebook published? (do I need a publisher?)...</li><li><b>Can I publish my fiction story or a novel as an ebook and actually sell it?</b></li><li>What software do I need to write and publish my ebook? (tip: you probably <i>already </i>have it on your computer!)</li><li><b>How do you write a \"how to\" ebook?</b> (so people LOVE it and want to buy more?)</li><li>What is a good subject to write an Ebook on that people would be willing to pay for? (so <i>you </i>can cash-in with Kindle!)...</li></ul><b>... and MUCH more!</b><br /><br />So, if you\'re serious about wanting your own profitable, money-making ebook and you want to know how to write and publish ebooks, then you need to<b> grab a copy of \"How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask \" right now</b>, because Ebook Marketing Expert, Jim Edwards, will reveal to you how every Ebook Author, regardless of experience level, can succeed - Today!\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("280", "62", "asg_product_details", "a:9:{s:9:\"File Size\";s:6:\"198 KB\";s:12:\"Print Length\";s:8:\"55 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B0073T1C6W\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:7:\"Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("281", "62", "asg_star_rating", "4.7");
INSERT INTO `wp_postmeta` VALUES("282", "62", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:48:\"High Praise...to the point, simple and objective\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 1, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3JOGUHYHZV8LD/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:24:\"J. Crouse \"Entrepreneur\"\";s:7:\"address\";s:2:\"SC\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:32:\"Quick but very informative intro\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"February 5, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3DXGA84MHLED0/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:11:\"Louis Szabo\";s:7:\"address\";s:13:\"Paris, France\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:22:\"Useful Tips from a Pro\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 6, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2YGZ2R5JRVMGG/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:13:\"Marcia Avalon\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:45:\"Quick and easy read with valuable information\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 9, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1UKQK8LFXVL2Y/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:4:\"Ryan\";s:7:\"address\";s:28:\"SAN DIEGO, CA, United States\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:43:\"Very informative book - you can\'t go wrong!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 11, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A15X3XQK3SOECP/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:14:\"Gayle Atherton\";s:7:\"address\";s:19:\"NORTH HILLS, CA, US\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:9:\"Excellent\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A34HEO2ZBAW98W/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:16:\"RCTX \"RC GREENE\"\";s:7:\"address\";s:24:\"Dallas/Fort Worth TX USA\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:47:\"simple nuts & bolts answers for e-books writers\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 16, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3AHNO7VF9D854/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:18:\"Ralph L. Greenberg\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:41:\"Very well written book on writing ebooks.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 30, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AG0S6JI5D53NN/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:24:\"Dale Knutson \"doesitall\"\";s:7:\"address\";s:7:\"Hoey SK\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:11:\"Informative\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 29, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A76V29GXVO70P/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:5:\"Frank\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:10:\"Great info\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 29, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AXMKM8AMAIKKF/ref=cm_cr_pr_pdp/178-0650614-6008523\";s:4:\"name\";s:8:\"diva3180\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("283", "62", "asg_last_refresh_attempt", "1391195258");
INSERT INTO `wp_postmeta` VALUES("284", "62", "asg_update_timestamp", "1391195258");
INSERT INTO `wp_postmeta` VALUES("285", "63", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("286", "63", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("287", "63", "asg_item_id", "B00DH29VF8");
INSERT INTO `wp_postmeta` VALUES("288", "63", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B00DH29VF8\";s:13:\"DetailPageURL\";s:209:\"http://www.amazon.com/The-Kindle-Book-Sales-Formula-ebook/dp/B00DH29VF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00DH29VF8\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:219:\"http://www.amazon.com/The-Kindle-Book-Sales-Formula-ebook/dp/tech-data/B00DH29VF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00DH29VF8%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00DH29VF8%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00DH29VF8%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00DH29VF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00DH29VF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00DH29VF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DH29VF8\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"115\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"360\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"22\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"79\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"115\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51XnrbMdrOL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"360\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:11:\"Ian Stables\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"72\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2014-01-14\";s:11:\"ReleaseDate\";s:10:\"2014-01-14\";s:5:\"Title\";s:147:\"The Kindle Book Sales Formula: How to sell books on amazon the right way - The methods proven to work best (How to Write a Book and Sell It Series)\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:200:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00DH29VF8&atag=freetos-20&exp=2014-02-01T19%3A07%3A38Z&v=2&sig=dAWmziNlffGX981BP0I%2Bc%2FQMRbq%2BcnHAV%2BpcHAcyObY%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3482:\"<h2>Sell a lot more Kindle ebooks using methods proven to give the best results.</h2>\n<br />If you\'re selling ebooks on Amazon, you\'re about to find out the very best ways of how to promote your book, and actually selling ebooks on Amazon, The author has found these, more than anything else, to deliver the best results.\n<br />\n<br /><b>PLEASE NOTE: This is for non-fiction Kindle ebooks, not fiction.</b>\n<br />\n<br />I have learned all these methods and strategies through trial and error. I know what works and what doesn\'t. These are all the methods I\'ve used to sell a lot of Kindle ebooks on Amazon.\n<br />\n<br />In this book, I explain step-by-step what I do so you can get similar results. I make sure you fully understand by using explanations, examples, and pictures. I tell you everything I know that works best. <b>If it\'s not in this book, chances are I\'ve found it not to give decent results.</b>\n<br />\n<br /><h2>You\'ll learn...</h2>\n<br /><b>What you must have first to get the very best results</b>\n<br />This step is simple, but important. If you try to succeed without this, your results will be poor. <b>It\'s not difficult.</b>\n<br />\n<br /><h2>Be found</h2>\n<br /><b>The best ways of getting the most people to see your book. (It\'s not having a website or blog. It\'s all on Amazon.)</b>\n<br />\n<br /><b>The secret to using the best keywords</b>\n<br />This is how to know what the best keywords are and where to place them for the best results.\n<br />\n<br />I\'ll teach you a little trick to make your book appear higher in search results.\n<br />\n<br /><b>How to select the best category for the most sales</b>\n<br />If you pick the wrong category, it\'ll either be too competitive and result in low sales, or not be competitive enough and give you little or no results.\n<br />\n<br />I\'ll show you how to use, what I call, <b>the category climbing method</b>. It\'s the best way of building up sales.\n<br />\n<br /><b>Make your sales high by using the book promotion duo</b>\n<br />These are the only two Kindle ebook marketing strategies I use. That\'s because they work better than many other methods I\'ve learned. These two book promotion methods work together far more powerfully than on their own. <b>Together, you\'ll find they deliver excellent results.</b>\n<br />\n<br /><h2>How to sell ebooks on Amazon the best way</h2>\n<br /><b>Easily create book titles that practically sell ebooks on their own</b>\n<br />You\'ll discover the thing that makes all non-fiction Kindle ebooks sell the most. You\'ll be able to turn this knowledge to good use by using the powerful feature/benefit formula.\n<br />\n<br />To help you, I\'ll also show you a good little method for creating book titles.\n<br />\n<br /><b>Sell more books by writing book descriptions that get the sale</b>\n<br />This is how to sell books using a description writing method that works. I give you the template that I\'ve found works the best.\n<br />\n<br />You\'ll also find out about the list that you can use over and over again.\n<br />\n<br /><b>Increase your sales by making sure of two important things</b>\n<br />Having these two, really do make a difference to Kindle ebook sales results.\n<br />\n<br /><b>The checklist</b>\n<br />At the end of the book, I lay it all out for you in an easy to follow step-by-step checklist.\n<br />\n<br /><h2>You can either continue to sell your Kindle ebooks using the methods you are using now, or you can start using what works and delivers the best sales results.</h2>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("289", "63", "asg_customer_reviews", "a:7:{i:0;a:5:{s:5:\"title\";s:48:\"Full of helpful tips to help you sell you ebooks\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 21, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2M1QC9AFD0KPC/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:11:\"Buckeyegirl\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:23:\"Informative and Helpful\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ASQS1HW3EQ92X/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:14:\"Summerbaby2020\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:35:\"Outstanding tips for ebook success!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"August 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1V746N3UQA4UL/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:48:\"Christee Gabour Atwood \"In Celebration of Ela...\";s:7:\"address\";s:9:\"Louisiana\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:12:\"Informative.\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"July 11, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A27J8XIAGLBC6R/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:11:\"chris brown\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:12:\"Helpful Book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3MJT1L3R0P4H8/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:11:\"TomeTracker\";s:7:\"address\";s:3:\"USA\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:29:\"The Kindle Book Sales Formula\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 30, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/APY27XHCNL4RC/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:5:\"Susan\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:10:\"Great tips\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 14, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3HAO7VDPHRTQ2/ref=cm_cr_pr_pdp/189-2346055-7052459\";s:4:\"name\";s:5:\"lziol\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("290", "63", "asg_last_refresh_attempt", "1391195259");
INSERT INTO `wp_postmeta` VALUES("291", "63", "asg_update_timestamp", "1391195259");
INSERT INTO `wp_postmeta` VALUES("292", "64", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("293", "64", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("294", "64", "asg_item_id", "1489590498");
INSERT INTO `wp_postmeta` VALUES("295", "64", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1489590498\";s:13:\"DetailPageURL\";s:210:\"http://www.amazon.com/Self-Publish-Your-eBook-Start-Finish/dp/1489590498%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1489590498\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:220:\"http://www.amazon.com/Self-Publish-Your-eBook-Start-Finish/dp/tech-data/1489590498%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1489590498%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1489590498%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1489590498%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1489590498%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1489590498%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1489590498%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";}}}s:9:\"SalesRank\";s:7:\"3265564\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51ivdCDJx-L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61z4xCVl6BL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61z4xCVl6BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/61z4xCVl6BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/61z4xCVl6BL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/61z4xCVl6BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/61z4xCVl6BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}}s:14:\"ItemAttributes\";a:19:{s:6:\"Author\";s:15:\"James Calthorpe\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781489590497\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781489590497\";}s:4:\"ISBN\";s:10:\"1489590498\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"20\";s:6:\"Weight\";s:2:\"28\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:3:\"699\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.99\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:2:\"88\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"20\";s:6:\"Length\";s:3:\"900\";s:6:\"Weight\";s:2:\"41\";s:5:\"Width\";s:3:\"600\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-05-01\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:98:\"How to Self-Publish Your eBook From Start to Finish: Everything You Need to Know to Get to The Top\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"484\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$4.84\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:4:\"2261\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$22.61\";}s:8:\"TotalNew\";s:2:\"13\";s:9:\"TotalUsed\";s:1:\"4\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1489590498%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1489590498\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:128:\"YFdKvY8xxARRGI5KIfiguFsuZ0bB8FPEhborbmis0i0J2IwH8Jlfi2qeLDFjUUh8PGV94YW9oF6Y0lK%2FFjHjEJH8DqUDtXeb%2FNApETiJ7TZ3XEGdUziMfg%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:3:\"664\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.64\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:2:\"35\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$0.35\";}s:15:\"PercentageSaved\";s:1:\"5\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:200:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1489590498&atag=freetos-20&exp=2014-02-01T19%3A07%3A39Z&v=2&sig=neosl8%2F4GzaftcZitIl3AM%2F%2FUg6PLI9trs7%2B0GamIaw%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2344:\"\"How to Self-Publish Your eBook\" is everything you need to know from start to finishing about publishing on all the main platforms. So you have written your book and you are excited about getting it out there and selling, but now what? Basically you have two choices: 1. You can spend months trying to learn everything there is to learn about publishing your own eBook  or 2. You can read \"How to Self-Publish Your eBook from Start to Finish\" by James Calthorpe and turbo charge your sales from day 1 James who is also the author of eBook Millionaire (a bestselling book on how to market your eBook) takes you through everything you need to know from start to finish on self-publishing your eBook. This book focuses on eBooks and so if you are interested in publishing your book the traditional way then this book is not for you! This book is for you however if: You want to shortcut the whole publishing process You want to maximise your sales from day 1 You want to save a lot of time, frustration and money You want to know the truth about which companies are best to work with and which platforms work for you What you spend your time on and what tasks actually make you money A personal note from the author: \"I wrote this book because it took me so long to find all the pitfalls of self-publishing which cost me a lot of time and money. Finding out what I should be doing to get it right was painful. I wish I had this book when I started publishing my books as I would have made very different decisions and a lot more sales and I would have saved myself months\". James takes you through all the platforms and how to get the best out of them as well as the various tips, hints and techniques you can use to hit your publishing goals quickly. You will learn everything you need to know to prepare your book, who to work with and where the real money is in self-publishing. You will learn: How to load your book quickly and efficiently onto all the main retail outlets How to set your price effectively Which web sites to go to in order to get the best and most up to date information Which companies to use and when to use them based on your goals and YOUR outcomes How to set up your book so you get the most sales you can as soon as you can You can get more book sales! Just apply what you learn here and you will be set up for success.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("296", "64", "asg_product_details", "a:7:{s:9:\"Paperback\";s:8:\"88 pages\";s:9:\"Publisher\";s:57:\"CreateSpace Independent Publishing Platform (May 1, 2013)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1489590498\";s:7:\"ISBN-13\";s:14:\"978-1489590497\";s:18:\"Product Dimensions\";s:22:\"0.2 x 5.9 x 8.9 inches\";s:15:\"Shipping Weight\";s:10:\"6.6 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("297", "64", "asg_star_rating", "4.6");
INSERT INTO `wp_postmeta` VALUES("298", "64", "asg_customer_reviews", "a:5:{i:0;a:5:{s:5:\"title\";s:63:\"Very comprehensive and highly informative for e-book publishing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"June 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A24PMY25BH3X5T/ref=cm_cr_pr_pdp/188-7589963-1911104\";s:4:\"name\";s:16:\"Valerie Caraotta\";s:7:\"address\";s:15:\"CONYERS, GA, US\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:21:\"the title says it all\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"June 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A10T2OBOYC2JC7/ref=cm_cr_pr_pdp/188-7589963-1911104\";s:4:\"name\";s:48:\"Kassi Pontious \"Kassi Pontious - Author of Yo...\";s:7:\"address\";s:9:\"Utah, USA\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:68:\"Definitely worth to recommend for somebody who wants to self publish\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:15:\"August 21, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A16RO2JYASXXFD/ref=cm_cr_pr_pdp/188-7589963-1911104\";s:4:\"name\";s:7:\"Mariusz\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:12:\"Good details\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"June 16, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AJS0WYC0J5PV0/ref=cm_cr_pr_pdp/188-7589963-1911104\";s:4:\"name\";s:7:\"JAY JAY\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:12:\"Useful info.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1TQDSWRMS05IE/ref=cm_cr_pr_pdp/188-7589963-1911104\";s:4:\"name\";s:10:\"lovetoread\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("299", "64", "asg_last_refresh_attempt", "1391195261");
INSERT INTO `wp_postmeta` VALUES("300", "64", "asg_update_timestamp", "1391195261");
INSERT INTO `wp_postmeta` VALUES("301", "65", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("302", "65", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("303", "65", "asg_item_id", "B00G1BSNNS");
INSERT INTO `wp_postmeta` VALUES("304", "65", "asg_amazon_data", "a:12:{s:4:\"ASIN\";s:10:\"B00G1BSNNS\";s:13:\"DetailPageURL\";s:220:\"http://www.amazon.com/Marketing-Tutorial-Training-Computer-Tutorials/dp/B00G1BSNNS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00G1BSNNS\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:230:\"http://www.amazon.com/Marketing-Tutorial-Training-Computer-Tutorials/dp/tech-data/B00G1BSNNS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00G1BSNNS%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00G1BSNNS%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00G1BSNNS%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00G1BSNNS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00G1BSNNS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00G1BSNNS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G1BSNNS\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"75\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"160\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"500\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:4:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"30\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"75\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"75\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:3:\"110\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"160\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51rq4dtJZrL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"500\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41NnGH6EAuL._SL30_.jpg\";s:6:\"Height\";s:2:\"22\";s:5:\"Width\";s:2:\"30\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41NnGH6EAuL._SL75_.jpg\";s:6:\"Height\";s:2:\"56\";s:5:\"Width\";s:2:\"75\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41NnGH6EAuL._SL75_.jpg\";s:6:\"Height\";s:2:\"56\";s:5:\"Width\";s:2:\"75\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41NnGH6EAuL._SL110_.jpg\";s:6:\"Height\";s:2:\"82\";s:5:\"Width\";s:3:\"110\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41NnGH6EAuL._SL160_.jpg\";s:6:\"Height\";s:3:\"119\";s:5:\"Width\";s:3:\"160\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41NnGH6EAuL.jpg\";s:6:\"Height\";s:3:\"260\";s:5:\"Width\";s:3:\"350\";}}i:2;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41DVbM1ih7L._SL30_.jpg\";s:6:\"Height\";s:2:\"21\";s:5:\"Width\";s:2:\"30\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41DVbM1ih7L._SL75_.jpg\";s:6:\"Height\";s:2:\"52\";s:5:\"Width\";s:2:\"75\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41DVbM1ih7L._SL75_.jpg\";s:6:\"Height\";s:2:\"52\";s:5:\"Width\";s:2:\"75\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41DVbM1ih7L._SL110_.jpg\";s:6:\"Height\";s:2:\"76\";s:5:\"Width\";s:3:\"110\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41DVbM1ih7L._SL160_.jpg\";s:6:\"Height\";s:3:\"111\";s:5:\"Width\";s:3:\"160\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41DVbM1ih7L.jpg\";s:6:\"Height\";s:3:\"242\";s:5:\"Width\";s:3:\"350\";}}i:3;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51Iba4rqnWL._SL30_.jpg\";s:6:\"Height\";s:2:\"23\";s:5:\"Width\";s:2:\"30\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51Iba4rqnWL._SL75_.jpg\";s:6:\"Height\";s:2:\"56\";s:5:\"Width\";s:2:\"75\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51Iba4rqnWL._SL75_.jpg\";s:6:\"Height\";s:2:\"56\";s:5:\"Width\";s:2:\"75\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51Iba4rqnWL._SL110_.jpg\";s:6:\"Height\";s:2:\"83\";s:5:\"Width\";s:3:\"110\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51Iba4rqnWL._SL160_.jpg\";s:6:\"Height\";s:3:\"120\";s:5:\"Width\";s:3:\"160\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51Iba4rqnWL.jpg\";s:6:\"Height\";s:3:\"263\";s:5:\"Width\";s:3:\"350\";}}}}s:14:\"ItemAttributes\";a:19:{s:7:\"Binding\";s:14:\"Office Product\";s:5:\"Brand\";s:12:\"How To Gurus\";s:3:\"EAN\";s:13:\"0700814410322\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"0700814410322\";}s:7:\"Feature\";a:5:{i:0;s:72:\"Learn brand-new skills, switch careers, get a raise, explore new hobbies\";i:1;s:62:\"Find the answers you need with our easy to use Video Tutorials\";i:2;s:96:\"Learn What You Want, When You Want, Play, pause, rewind and repeat the training videos as needed\";i:3;s:96:\"High resolution training movies for picture-perfect viewing. For Windows XP, XP Pro, Vista, 7, 8\";i:4;s:102:\"Over 11 hours of Video Based Training on 1 DVD-ROM 129 individual video lessons with all working files\";}s:5:\"Label\";s:12:\"How To Gurus\";s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"7999\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$79.99\";}s:12:\"Manufacturer\";s:12:\"How To Gurus\";s:5:\"Model\";s:21:\"HTG-Market_eBooks-DVD\";s:3:\"MPN\";s:21:\"HTG-Market_eBooks-DVD\";s:15:\"PackageQuantity\";s:1:\"1\";s:10:\"PartNumber\";s:21:\"HTG-Market_eBooks-DVD\";s:12:\"ProductGroup\";s:14:\"Office Product\";s:15:\"ProductTypeName\";s:20:\"EDUCATIONAL_SUPPLIES\";s:9:\"Publisher\";s:12:\"How To Gurus\";s:6:\"Studio\";s:12:\"How To Gurus\";s:5:\"Title\";s:116:\"Marketing eBooks Tutorial Training Course on 1 DVD, 11 Hours in 129 Video Lessons, Computer Software Video Tutorials\";s:3:\"UPC\";s:12:\"700814410322\";s:7:\"UPCList\";a:1:{s:14:\"UPCListElement\";s:12:\"700814410322\";}}s:12:\"OfferSummary\";a:5:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:4:\"4977\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$49.77\";}s:8:\"TotalNew\";s:1:\"1\";s:9:\"TotalUsed\";s:1:\"0\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:3:{s:11:\"TotalOffers\";s:1:\"0\";s:15:\"TotalOfferPages\";s:1:\"0\";s:13:\"MoreOffersUrl\";s:1:\"0\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00G1BSNNS&atag=freetos-20&exp=2014-02-01T19%3A07%3A42Z&v=2&sig=FcUtRTh%2BCpNJvqnFzTPIGASLFubyjczqfw4aC3vE6Zs%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1434:\"After You have created your eBook you will need to Find your Audience and Market your eBook or Digital Product effectively. This title is aimed specifically at eBooks and other Digital Products that are delivered as downloads on the Internet. Because of this Download Delivery there are several Special and Specific Marketing Techniques You Need to Know to Sell Successfully. \n\nIt is not enough to create your eBook and put it up onto the usual places, Amazon Kindle, Barnes & Noble Nook, and others. Even with great a Great Title and Content and with announcements to your Social Networks you still may not be reaching your full Potential Market. You need to Increase your Exposure and fill in the gaps with Marketing. Plus to be really Successful you will want to automate as much of the process as possible so that you can spend your time creating new eBooks and other products instead of maintaining your marketing.\n\nAs you follow along, you learn by doing, mastering the programs at your own pace. You are provided with a dynamic educational tool - an information rich resource you can refer to again and again.\n\nSections include: • About eBook Marketing• The Importance of Titles • Determining Your Market • Manufacturing • Using Kunaki • Your Sales Web Site • Your email Auto-responder • Article Writing •  Your eBook Blog • Driving Traffic to Sales Page • Forums, Social Media • More Traffic Ideas •\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("305", "65", "asg_last_refresh_attempt", "1391195262");
INSERT INTO `wp_postmeta` VALUES("306", "65", "asg_update_timestamp", "1391195262");
INSERT INTO `wp_postmeta` VALUES("307", "66", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("308", "66", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("309", "66", "asg_item_id", "B00G8OY2RE");
INSERT INTO `wp_postmeta` VALUES("310", "66", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B00G8OY2RE\";s:13:\"DetailPageURL\";s:210:\"http://www.amazon.com/How-Book-eBook-Promotion-Adoni-ebook/dp/B00G8OY2RE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00G8OY2RE\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:220:\"http://www.amazon.com/How-Book-eBook-Promotion-Adoni-ebook/dp/tech-data/B00G8OY2RE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00G8OY2RE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00G8OY2RE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00G8OY2RE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00G8OY2RE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00G8OY2RE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00G8OY2RE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00G8OY2RE\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"68\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51v5Z5vQDtL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:9:\"Sol Adoni\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:16:\"Adoni Publishing\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:16:\"Adoni Publishing\";s:13:\"NumberOfPages\";s:2:\"44\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-10-26\";s:9:\"Publisher\";s:16:\"Adoni Publishing\";s:11:\"ReleaseDate\";s:10:\"2013-10-26\";s:6:\"Studio\";s:16:\"Adoni Publishing\";s:5:\"Title\";s:30:\"How to Book of eBook Promotion\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00G8OY2RE&atag=freetos-20&exp=2014-02-01T19%3A07%3A42Z&v=2&sig=plWofrj9zDglds4uGFNx6kg92foscslGsiSbW77SR0U%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1116:\"So you wrote an eBook and it\'s not selling well.\n<br />\n<br />That\'s why you need to read this book, How to Book of eBook Promotion. Written by one of the founders of the eBook Industry, Sol Adoni, who has been creating and selling eBooks through a massive network of websites dedicated to promoting and selling eBooks for almost 20 years..\n<br />\n<br />Sol Adoni explains the various techniques a self-published author or small Publishng Company can use to PROMOTE EBOOKS and compete with the big companies.\n<br />\n<br />Sol Adoni explains the almost twenty year history of eBooks and chronicles how he used search engines, social media, print, radio and videos to promote and sell eBooks.\n<br />\n<br />If you have written an eBook and want to self publish it and promote it, this is a MUST READ. It also has vital information to help smaller publishers compete in today\'s world of social media, kindles, nooks and google.\n<br />\n<br />A short read packed by vital knowledge by a founder of the digital revolution of eBooks.\n<br />\n<br />Look for Sol Adoni\'s other eBooks on eBook Publishng and Marketing on Amazon.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("311", "66", "asg_product_details", "a:10:{s:9:\"File Size\";s:7:\"1442 KB\";s:12:\"Print Length\";s:8:\"44 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:35:\"Adoni Publishing (October 26, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00G8OY2RE\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("312", "66", "asg_last_refresh_attempt", "1391195264");
INSERT INTO `wp_postmeta` VALUES("313", "66", "asg_update_timestamp", "1391195264");
INSERT INTO `wp_postmeta` VALUES("314", "67", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("315", "67", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("316", "67", "asg_item_id", "B00HGN16UC");
INSERT INTO `wp_postmeta` VALUES("317", "67", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00HGN16UC\";s:13:\"DetailPageURL\";s:225:\"http://www.amazon.com/Marketing-Business-System-Thorough-Integrated-ebook/dp/B00HGN16UC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HGN16UC\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:235:\"http://www.amazon.com/Marketing-Business-System-Thorough-Integrated-ebook/dp/tech-data/B00HGN16UC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00HGN16UC%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00HGN16UC%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00HGN16UC%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00HGN16UC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00HGN16UC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00HGN16UC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HGN16UC\";}}}s:9:\"SalesRank\";s:6:\"698368\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"314\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"69\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51lCgLx79AL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"314\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:15:\"Neil Kokemuller\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"16\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-18\";s:11:\"ReleaseDate\";s:10:\"2013-12-18\";s:5:\"Title\";s:102:\"Marketing as a Business System: A Guide to a Thorough, Integrated Marketing Function for Your Business\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:198:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00HGN16UC&atag=freetos-20&exp=2014-02-01T19%3A07%3A44Z&v=2&sig=A%2Fe%2Bv6IMrp3y1ttBkPJ1BBRTCKwngr3KVA%2FiDtYAtZ4%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:418:\"A Marketing guide ebook that offers a thorough overview of all key facets of the Marketing process. Offers helpful insights to all types of businesses, including small businesses, online operators and marketing professionals.\n<br />\n<br />Learn how market research, solution development, promotion, customer service and relationship management all intertwine in your effort to build and maintain a loyal customer base.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("318", "67", "asg_customer_reviews", "a:4:{i:0;a:5:{s:5:\"title\";s:46:\"Marketing as a Business System Neil Kokemuller\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 31, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A23VFXIMLUSHAV/ref=cm_cr_pr_pdp/190-4937098-1614925\";s:4:\"name\";s:30:\"Tony R. Parsons \"tony parsons\"\";s:7:\"address\";s:10:\"emporia KS\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:31:\"Marketing as a Business System.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AUMQCNTV3KZE2/ref=cm_cr_pr_pdp/190-4937098-1614925\";s:4:\"name\";s:12:\"Robin Butler\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:27:\"Great overview of the topic\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 12, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2Q6KCK7N0PP8P/ref=cm_cr_pr_pdp/190-4937098-1614925\";s:4:\"name\";s:5:\"Sarah\";s:7:\"address\";s:11:\"Seattle, WA\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:22:\"Marketing de-mystified\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"January 4, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3U8TDJLOPTL41/ref=cm_cr_pr_pdp/190-4937098-1614925\";s:4:\"name\";s:12:\"Chris Graham\";s:7:\"address\";s:14:\"Manchester, UK\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("319", "67", "asg_last_refresh_attempt", "1391195265");
INSERT INTO `wp_postmeta` VALUES("320", "67", "asg_update_timestamp", "1391195265");
INSERT INTO `wp_postmeta` VALUES("321", "68", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("322", "68", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("323", "68", "asg_item_id", "0988522810");
INSERT INTO `wp_postmeta` VALUES("324", "68", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"0988522810\";s:13:\"DetailPageURL\";s:200:\"http://www.amazon.com/How-Make-Money-With-Ebooks/dp/0988522810%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0988522810\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:210:\"http://www.amazon.com/How-Make-Money-With-Ebooks/dp/tech-data/0988522810%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D0988522810%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D0988522810%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D0988522810%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/0988522810%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/0988522810%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/0988522810%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";}}}s:9:\"SalesRank\";s:7:\"1579898\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51GibapfKhL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51GibapfKhL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51GibapfKhL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/515PfZULthL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/515PfZULthL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/515PfZULthL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/515PfZULthL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/515PfZULthL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/515PfZULthL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}}s:14:\"ItemAttributes\";a:23:{s:6:\"Author\";s:6:\"BJ Min\";s:7:\"Binding\";s:9:\"Paperback\";s:5:\"Brand\";s:32:\"Brand: Hot Methods, Incorporated\";s:3:\"EAN\";s:13:\"9780988522817\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9780988522817\";}s:7:\"Feature\";s:27:\"Used Book in Good Condition\";s:4:\"ISBN\";s:10:\"0988522810\";s:20:\"IsEligibleForTradeIn\";s:1:\"1\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"35\";s:6:\"Weight\";s:2:\"51\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:25:\"Hot Methods, Incorporated\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1999\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$19.99\";}s:12:\"Manufacturer\";s:25:\"Hot Methods, Incorporated\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"166\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"60\";s:6:\"Length\";s:3:\"890\";s:6:\"Weight\";s:2:\"49\";s:5:\"Width\";s:3:\"600\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2012-12-02\";s:9:\"Publisher\";s:25:\"Hot Methods, Incorporated\";s:6:\"Studio\";s:25:\"Hot Methods, Incorporated\";s:5:\"Title\";s:117:\"How To Make Money With Ebooks - Your Step-By-Step Guide To Create and Sell Your Ebook on Kindle, Nook, and iBookstore\";s:12:\"TradeInValue\";a:3:{s:6:\"Amount\";s:2:\"55\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$0.55\";}}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:4:\"1490\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$14.90\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:5:\"99910\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:7:\"$999.10\";}s:8:\"TotalNew\";s:2:\"12\";s:9:\"TotalUsed\";s:1:\"2\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/0988522810%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D0988522810\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:138:\"FnAT4AUbjK4ZMvA7heJztwFndCZdWRWbFNolGHNg%2FxL8Gb58RS%2FKd81%2BGnV3Et%2FGVyuHJ2bJgtFB3%2F57%2B108KrlX5GEpN%2FopiuguBezXcWBd5Kg19qfXcQ%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1799\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$17.99\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"200\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$2.00\";}s:15:\"PercentageSaved\";s:2:\"10\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=0988522810&atag=freetos-20&exp=2014-02-01T19%3A07%3A45Z&v=2&sig=8%2FAfK3mMIuLefwy9cdZGpUFhNLYKyNbGUzBkJQhqpQw%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3411:\"<b>If you want to publish your eBook on all the eBook stores (Amazon.com\'s Kindle, BarnesandNoble.com\'s Nook, Apple\'s iBookstore, and more), then get \"How to Make Money with Ebooks\" now.</b><div><b></b></div><div><b></b></div><div><b></b></div><div><b></b></div><div><b></b></div><div><b></b><div><b></b><div><b></b><div><b></b><div><b></b><div><div><b></b></div><div><b></b><div><div><b></b></div><div><b></b></div><div><b>Here\'s What You Get Inside \"How To Make Money With Ebooks\":</b><ul><li>Discover how to find the right topic that can help sell your eBook.</li><li>Uncover how to find the BEST title so your eBook can stand out in the marketplace.</li><li>Find out how to create great content whether you write it yourself or hire someone else to do it for you.</li><li>How to sell your eBook on ALL the major eBook platforms such as Amazon.com\'s Kindle Store, BarnesandNoble.com\'s Nook Store, Apple\'s iBookstore, Google Play Store, and much more.</li><li>How to market your eBook the right way without spending a lot of money.</li><li>Gain greater reach, impact, and profits by learning how to scale up your business by creating more eBooks the right way.</li><li>Discover how to outsource your work so majority of the work (if not all) can be done by others.</li></ul><b>What\'s Unique About This Book?</b></div><div><ul><li>Discover how to sell your eBook on ALL the major eBook platforms (Kindle, Nook, iBookstore, Google Play Store, etc) instead of just one eBook platform.</li><li>Learn how to publish your eBook from an eBook publisher and author\'s point of view since the author has both experiences.</li><li>Get the exact blueprint that has allowed the author BJ Min to launch 2 publishing companies to produce over 250+ eBooks in fiction & non-fiction genres.</li><li>Get a complete step-by-step formula to succeed in the eBook business.</li><li>Access to step-by-step image tutorials to guide you to get real life results.</li><li>Excellent resource for aspiring authors, authors because this book helps anyone publish their first eBook on all the major platforms.</li><li>Comprehensive resource for eBook publishers because this is also a great guideline to start a publishing company.</li><li>Fantastic resource for internet marketers and business owners because the eBook platforms are a great way to generate leads for your business.</li><li>Gain instant credibility and expertise as an authority in your niche by becoming an author of an eBook/book in your field.</li></ul></div><div><b>Bonus Chapter:</b></div><div><ul><li>You also get a BONUS chapter</li><li>How to Sell a Physical Book on Amazon.com\'s Bookstore!</li><li>You will discover how to turn your eBook into a PHYSICAL BOOK and sell it on Amazon.com\'s BOOKS section.</li><li>After checking out the bonus chapter, now you can become an author of a real book and an eBook! About author:</li></ul></div><div><b>About the Author:</b></div><div><ul><li>BJ Min is the publisher of two eBook publishing companies that has published 250+ eBooks in fiction and non-fiction categories on Amazon.com\'s Kindle, BarnesandNoble.com\'s Nook, Apple\'s iBookstore, and more.</li></ul></div><div><b>If you want to make and sell your eBook on all the eBook stores (Amazon.com\'s Kindle, BarnesandNoble.com\'s Nook, Apple\'s iBookstore, and more), then get \"How to Make Money with Ebooks\" now!</b></div></div></div></div></div></div></div></div></div>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("325", "68", "asg_product_details", "a:7:{s:9:\"Paperback\";s:9:\"166 pages\";s:9:\"Publisher\";s:44:\"Hot Methods, Incorporated (December 2, 2012)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"0988522810\";s:7:\"ISBN-13\";s:14:\"978-0988522817\";s:18:\"Product Dimensions\";s:22:\"0.4 x 5.9 x 8.9 inches\";s:15:\"Shipping Weight\";s:10:\"7.8 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("326", "68", "asg_star_rating", "4.4");
INSERT INTO `wp_postmeta` VALUES("327", "68", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:47:\"Solid Resource for Building Your Digital Empire\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"November 3, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1H1N0YU16H6P3/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:16:\"Anthony Metivier\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:126:\"How To Make Money With EBooks-Your Step-By-Step Guide To Create and Sell Your EBook on Kindle, Nook, and iBookstore by B.J.MIN\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"November 5, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AM79PTM4ZP9K1/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:20:\"S. ROYSTONE NEVERSON\";s:7:\"address\";s:30:\"Trinidad And Tobago, Caribbean\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:7:\"Superb!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 10, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2U6H820ARDB7Y/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:15:\"Amazon Customer\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:52:\"Compelling overview on how to create an eBook empire\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 26, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A32PFQMWYV2K3Y/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:4:\"E.G.\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:40:\"Guide for how to make money with ebooks!\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:14:\"March 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3M129G3T63FDB/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:7:\"Maurice\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:17:\"A Useful Resource\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:14:\"March 23, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2HVU3WFPAPT0X/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:7:\"ArthurW\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:23:\"Read it in one sitting!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1CGJ7EY5DY5TI/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:10:\"Vicky Hall\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:22:\"A Great Motivator Book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A20GUDPD7VKCQK/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:11:\"Carl Foster\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:21:\"Some Worthwhile tips.\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"January 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A37GBS5CHVPE1Q/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:12:\"James gabler\";s:7:\"address\";s:12:\"Florida, USA\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:10:\"Good Book!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"January 9, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2ZT8T5LRBZXW7/ref=cm_cr_pr_pdp/191-1759609-7951157\";s:4:\"name\";s:19:\"aosbo001 \"aosbo001\"\";s:7:\"address\";s:7:\"GA, USA\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("328", "68", "asg_last_refresh_attempt", "1391195267");
INSERT INTO `wp_postmeta` VALUES("329", "68", "asg_update_timestamp", "1391195267");
INSERT INTO `wp_postmeta` VALUES("330", "69", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("331", "69", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("332", "69", "asg_item_id", "1118342909");
INSERT INTO `wp_postmeta` VALUES("333", "69", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1118342909\";s:13:\"DetailPageURL\";s:209:\"http://www.amazon.com/Publishing-E-Books-For-Dummies-Luke/dp/1118342909%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1118342909\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:219:\"http://www.amazon.com/Publishing-E-Books-For-Dummies-Luke/dp/tech-data/1118342909%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1118342909%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1118342909%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1118342909%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1118342909%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1118342909%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1118342909%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";}}}s:9:\"SalesRank\";s:5:\"70673\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"60\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"127\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"398\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"24\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"60\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"60\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"88\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"127\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/512AHc5z%2BmL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"398\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51B2AncxqpL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"24\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51B2AncxqpL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"60\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51B2AncxqpL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"60\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51B2AncxqpL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"88\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51B2AncxqpL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"127\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51B2AncxqpL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"398\";}}}}s:14:\"ItemAttributes\";a:22:{s:6:\"Author\";s:8:\"Ali Luke\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781118342909\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781118342909\";}s:7:\"Edition\";s:1:\"1\";s:4:\"ISBN\";s:10:\"1118342909\";s:20:\"IsEligibleForTradeIn\";s:1:\"1\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:2:\"63\";s:6:\"Length\";s:3:\"926\";s:6:\"Weight\";s:3:\"103\";s:5:\"Width\";s:3:\"742\";}s:5:\"Label\";s:11:\"For Dummies\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"2499\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$24.99\";}s:12:\"Manufacturer\";s:11:\"For Dummies\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"312\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"79\";s:6:\"Length\";s:3:\"921\";s:6:\"Weight\";s:3:\"101\";s:5:\"Width\";s:3:\"740\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2012-09-11\";s:9:\"Publisher\";s:11:\"For Dummies\";s:6:\"Studio\";s:11:\"For Dummies\";s:5:\"Title\";s:30:\"Publishing E-Books For Dummies\";s:12:\"TradeInValue\";a:3:{s:6:\"Amount\";s:3:\"547\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$5.47\";}}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:4:\"1326\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$13.26\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:4:\"1330\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$13.30\";}s:8:\"TotalNew\";s:2:\"46\";s:9:\"TotalUsed\";s:2:\"18\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1118342909%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1118342909\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:130:\"COEeGLbMRn0m%2BXKQpDtSEqy25sOROs5UjiNReBYq7Esu6jsBumCodoWz9i89z3teGpMOan0BJKLdhjsB%2BoztlVKkwpfnC%2FG5Gl45t6RqM9RSw2KczRYKug%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1493\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$14.93\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:4:\"1006\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$10.06\";}s:15:\"PercentageSaved\";s:2:\"40\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:1:\"0\";s:12:\"MaximumHours\";s:1:\"0\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1118342909&atag=freetos-20&exp=2014-02-01T19%3A07%3A48Z&v=2&sig=8Uqa9h92tD3YKuvgbb1tFEBCdqpMwIry%2FB8cL83O1co%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1477:\"Publish, market, and sell your own e-book.<br>Although creating an e-book seems fairly straightforward, it is not. You need to select and create a variety of formats that will be read on a variety of e-reader devices--and market and sell your book in a variety of ways. <br><br>Before you take the plunge, get this practical guide. With clear instruction and sensible advice, it will help you navigate the often confusing, time-consuming, and costly world of self-publishing an e-book. The book gives you solid marketing tips for selling your e-book, including using blogging and social media and how to build an online platform. It also discusses key technologies you\'ll encounter, including Smashwords, iBooks Author, Amazon, Microsoft Word, Open Office, Calibre, WordPress, E-junkie, and others.<br><ul><li>Helps readers navigate the confusing, time-consuming, and often costly world of self-publishing an e-book </li><li>Provides both technical how-tos as well solid marketing advice on how to sell your e-book using Facebook, Twitter, Goodreads, and other social media sites </li><li>Covers essential technologies, such as Smashwords, iBooks Author, Amazon, Microsoft Word, Open Office, Calibre, WordPress, and E-junkie </li><li>Explores e-book devices, including Kindle, Kobo, Sony Reader, Nook, iPad, and other tablets </li><li>Delves into the nitty-gritty of e-book formats Before you self-publish your e-book, start first with Publishing eBooks For Dummies.</li></ul>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("334", "69", "asg_product_details", "a:7:{s:9:\"Paperback\";s:9:\"312 pages\";s:9:\"Publisher\";s:43:\"For Dummies; 1 edition (September 11, 2012)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1118342909\";s:7:\"ISBN-13\";s:14:\"978-1118342909\";s:18:\"Product Dimensions\";s:22:\"9.3 x 7.4 x 0.6 inches\";s:15:\"Shipping Weight\";s:8:\"1 pounds\";}");
INSERT INTO `wp_postmeta` VALUES("335", "69", "asg_star_rating", "4.6");
INSERT INTO `wp_postmeta` VALUES("336", "69", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:58:\"One of the best, if not the best book available on e-books\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 17, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1NS6O584WD5FJ/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:12:\"William Polm\";s:7:\"address\";s:5:\"North\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:43:\"The best book I\'ve found on self-publishing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"December 6, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1LGPI5MGNF6LM/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:18:\"Catherine McCallum\";s:7:\"address\";s:8:\"Tasmania\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:16:\"Tremendous Value\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 25, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3TI77ERDFFP7C/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:13:\"Garry Rodgers\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:18:\"A much needed book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 9, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2TBRIIGGRO307/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:11:\"Jade Craven\";s:7:\"address\";s:18:\"Geelong, Australia\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:26:\"Want to publish an e-book?\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 15, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2XZ09BBFNP3AK/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:7:\"Richard\";s:7:\"address\";s:24:\"Toronto, Ontario, Canada\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:46:\"Very thorough! Dummies books never disappoint.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1ECFW1EU774WG/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:25:\"celtic melody \"bookfiend\"\";s:7:\"address\";s:7:\"Chicago\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:25:\"Clear how-to-do-it manual\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 31, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1N52NWLDKUO2S/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:47:\"Jack Zavada \"published author & web site owner\"\";s:7:\"address\";s:12:\"Streator, IL\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:19:\"Good reference book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1A46LLJBW9KPP/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:30:\"Barbara K. Langley \"Cuentista\"\";s:7:\"address\";s:16:\"Independence, MO\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:34:\"Great book to get into epublishing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 20, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3U6H1QE65ABOC/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:17:\"Margaret Rochford\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:35:\"Excellent reference, well organized\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:12:\"July 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AOT1TMLA5PQSD/ref=cm_cr_pr_pdp/186-1659125-2864032\";s:4:\"name\";s:14:\"Roy F. Johnson\";s:7:\"address\";s:26:\"Columbia, TN United States\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("337", "69", "asg_last_refresh_attempt", "1391195270");
INSERT INTO `wp_postmeta` VALUES("338", "69", "asg_update_timestamp", "1391195270");
INSERT INTO `wp_postmeta` VALUES("339", "70", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("340", "70", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("341", "70", "asg_item_id", "B00HBTG0GQ");
INSERT INTO `wp_postmeta` VALUES("342", "70", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00HBTG0GQ\";s:13:\"DetailPageURL\";s:216:\"http://www.amazon.com/Hooping-Kids-Sarah-Maccarelli-Jordan-ebook/dp/B00HBTG0GQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HBTG0GQ\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:226:\"http://www.amazon.com/Hooping-Kids-Sarah-Maccarelli-Jordan-ebook/dp/tech-data/B00HBTG0GQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00HBTG0GQ%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00HBTG0GQ%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00HBTG0GQ%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00HBTG0GQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00HBTG0GQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00HBTG0GQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00HBTG0GQ\";}}}s:9:\"SalesRank\";s:6:\"872561\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"313\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"69\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51QOnHODn4L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"313\";}}}s:14:\"ItemAttributes\";a:12:{s:6:\"Author\";s:23:\"Sarah Maccarelli Jordan\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Creator\";s:16:\"Ashutosh Khandha\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"49\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2014-01-07\";s:11:\"ReleaseDate\";s:10:\"2014-01-07\";s:5:\"Title\";s:17:\"Hooping with Kids\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00HBTG0GQ&atag=freetos-20&exp=2014-02-01T19%3A07%3A50Z&v=2&sig=Ay3wz4oZWZ6Ex7b62C%2FeX9CVlK9sSeq%2BXC4lpr8bYjM%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:545:\"Ready to go to work with a smile on your face? Interested in helping kids while earning $100 an hour? In this kindle Ebook you learn:\n<br />\n<br />*How to get started on this fun career that helps kids (and you!) become healthier through hooping, even if you have no experience.\n<br />\n<br />*Marketing secrets to book yourself solid \n<br />\n<br />*How to create a lesson plan, where to teach & more\n<br />\n<br />Bonus: Purchase this Ebook for your chance to win a Kindle! The author is giving one lucky ready a kindle after 500 copies are sold.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("343", "70", "asg_product_details", "a:9:{s:9:\"File Size\";s:7:\"1226 KB\";s:12:\"Print Length\";s:8:\"49 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00HBTG0GQ\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("344", "70", "asg_star_rating", "5");
INSERT INTO `wp_postmeta` VALUES("345", "70", "asg_customer_reviews", "a:3:{i:0;a:5:{s:5:\"title\";s:14:\"Fabulous Book!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 20, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A24ZGXGXH3TKTS/ref=cm_cr_pr_pdp/177-4052255-9758744\";s:4:\"name\";s:12:\"Mark Sedlock\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:4:\"Yay!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3IR6QHCGNCVBT/ref=cm_cr_pr_pdp/177-4052255-9758744\";s:4:\"name\";s:15:\"Vanessa Hazzard\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:7:\"Love it\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ASUF7P3H4199P/ref=cm_cr_pr_pdp/177-4052255-9758744\";s:4:\"name\";s:14:\"Yvonne Downing\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("346", "70", "asg_last_refresh_attempt", "1391195273");
INSERT INTO `wp_postmeta` VALUES("347", "70", "asg_update_timestamp", "1391195273");
INSERT INTO `wp_postmeta` VALUES("348", "71", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("349", "71", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("350", "71", "asg_item_id", "B00AWHA9XO");
INSERT INTO `wp_postmeta` VALUES("351", "71", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00AWHA9XO\";s:13:\"DetailPageURL\";s:220:\"http://www.amazon.com/Kindle-Ebook-Marketing-Directory-Thomson-ebook/dp/B00AWHA9XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00AWHA9XO\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:230:\"http://www.amazon.com/Kindle-Ebook-Marketing-Directory-Thomson-ebook/dp/tech-data/B00AWHA9XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00AWHA9XO%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00AWHA9XO%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00AWHA9XO%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00AWHA9XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00AWHA9XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00AWHA9XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00AWHA9XO\";}}}s:9:\"SalesRank\";s:6:\"930528\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"110\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"343\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"75\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"110\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51e2%2BnaFOKL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"343\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:13:\"James Thomson\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:1:\"1\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:12:\"Cabana Books\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:12:\"Cabana Books\";s:13:\"NumberOfPages\";s:2:\"19\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-01-02\";s:9:\"Publisher\";s:12:\"Cabana Books\";s:11:\"ReleaseDate\";s:10:\"2013-01-02\";s:6:\"Studio\";s:12:\"Cabana Books\";s:5:\"Title\";s:32:\"Kindle Ebook Marketing Directory\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00AWHA9XO&atag=freetos-20&exp=2014-02-01T19%3A07%3A53Z&v=2&sig=JymOT4Mp4X6S%2BVqLxArvvdoH2%2BWcxjeuNm6RrvvUuzw%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:131:\"Directory of over 50 web sites where you can submit your free ebook promotions to in order to maximize your exposure and downloads.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("352", "71", "asg_product_details", "a:10:{s:9:\"File Size\";s:6:\"228 KB\";s:12:\"Print Length\";s:8:\"19 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:41:\"Cabana Books; 1 edition (January 2, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00AWHA9XO\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("353", "71", "asg_star_rating", "4");
INSERT INTO `wp_postmeta` VALUES("354", "71", "asg_customer_reviews", "a:3:{i:0;a:5:{s:5:\"title\";s:15:\"Great directory\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"January 7, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AY9P13ZUN7I8N/ref=cm_cr_pr_pdp/179-1756620-6783036\";s:4:\"name\";s:15:\"Amazon Customer\";s:7:\"address\";s:11:\"Kansas City\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:54:\"Definitely be using this when I get my ebook finished!\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"February 4, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3RVOT9J4OIESO/ref=cm_cr_pr_pdp/179-1756620-6783036\";s:4:\"name\";s:5:\"Sarah\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:61:\"Useful advice but not much care in putting together the Ebook\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:14:\"August 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1RXANQJ4TPWP1/ref=cm_cr_pr_pdp/179-1756620-6783036\";s:4:\"name\";s:34:\"Sheri Fresonke Harper \"sfharper59\"\";s:7:\"address\";s:25:\"Orlando, FL United States\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("355", "71", "asg_last_refresh_attempt", "1391195275");
INSERT INTO `wp_postmeta` VALUES("356", "71", "asg_update_timestamp", "1391195275");
INSERT INTO `wp_postmeta` VALUES("357", "72", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("358", "72", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("359", "72", "asg_item_id", "1484854888");
INSERT INTO `wp_postmeta` VALUES("360", "72", "asg_amazon_data", "a:12:{s:4:\"ASIN\";s:10:\"1484854888\";s:13:\"DetailPageURL\";s:208:\"http://www.amazon.com/Writing-And-Marketing-Books-Ebooks/dp/1484854888%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1484854888\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:218:\"http://www.amazon.com/Writing-And-Marketing-Books-Ebooks/dp/tech-data/1484854888%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1484854888%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1484854888%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1484854888%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1484854888%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1484854888%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1484854888%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51AoGJMPKsL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}s:14:\"ItemAttributes\";a:17:{s:6:\"Author\";s:12:\"Steven Lucas\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781484854884\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781484854884\";}s:4:\"ISBN\";s:10:\"1484854888\";s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:3:\"699\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.99\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfPages\";s:2:\"44\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"10\";s:6:\"Length\";s:3:\"900\";s:6:\"Weight\";s:2:\"26\";s:5:\"Width\";s:3:\"600\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-04-30\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:122:\"Writing And Marketing Books And Ebooks - One Step At A Time: An easy guide to writing and marketing your written creations\";}s:12:\"OfferSummary\";a:5:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"664\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.64\";}s:8:\"TotalNew\";s:1:\"1\";s:9:\"TotalUsed\";s:1:\"0\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1484854888%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1484854888\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:130:\"0GPLURWfeA7BY1Vvr2XH7ZJWSE5VU8soci6Z8US9qEAw2K7MHE%2F%2BScxy2rMfzIXOeIIgLxS5HkusG5kLtR9T8WqFcrNOkUQf4yRid%2BluJwuCWExQ97gpYQ%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:3:\"664\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$6.64\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:2:\"35\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$0.35\";}s:15:\"PercentageSaved\";s:1:\"5\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1484854888&atag=freetos-20&exp=2014-02-01T19%3A07%3A55Z&v=2&sig=0uZ6tdzs1hBos1JqstadIzi8j2ISuiBXJc5MCcYbKoY%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:775:\"Everybody seems to be writing ebooks these days and so many authors seem to be making a bit of a hash of it. The typesetting and layout could spoil it. The cover may make it a non-seller and the additional marketing that goes into many books these days is nearly non-existent. Here is the answer to the new authors prayers. A \'one step at a time\' guide to creating an ebook that you will be pleased and proud to call your own and that readers will want to buy. How to make the changes your ebook manuscript might need to change it to the print version - Go ahead and do it, increase your potential market. Marketing ideas that will help you to shift even more units. All the information you need and provided to you by someone who\'s been there and done it and still doing it.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("361", "72", "asg_customer_reviews", "a:1:{i:0;a:5:{s:5:\"title\";s:4:\"yuck\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:16:\"October 26, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A33C6NQ1MNEPYG/ref=cm_cr_pr_pdp/177-9832665-6562958\";s:4:\"name\";s:9:\"crablover\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("362", "72", "asg_last_refresh_attempt", "1391195276");
INSERT INTO `wp_postmeta` VALUES("363", "72", "asg_update_timestamp", "1391195276");
INSERT INTO `wp_postmeta` VALUES("364", "73", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("365", "73", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("366", "73", "asg_item_id", "B007L9UXDC");
INSERT INTO `wp_postmeta` VALUES("367", "73", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B007L9UXDC\";s:13:\"DetailPageURL\";s:217:\"http://www.amazon.com/eBook-Publishing-Guide-Publish-Online-ebook/dp/B007L9UXDC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007L9UXDC\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:227:\"http://www.amazon.com/eBook-Publishing-Guide-Publish-Online-ebook/dp/tech-data/B007L9UXDC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB007L9UXDC%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB007L9UXDC%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB007L9UXDC%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B007L9UXDC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B007L9UXDC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B007L9UXDC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007L9UXDC\";}}}s:9:\"SalesRank\";s:6:\"369636\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"387\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"85\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51eSipvsb-L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"387\";}}}s:14:\"ItemAttributes\";a:14:{s:6:\"Author\";s:15:\"Brian Maroevich\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:5:\"Label\";s:23:\"Avalanche Holdings Inc.\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:23:\"Avalanche Holdings Inc.\";s:13:\"NumberOfPages\";s:2:\"74\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-03-15\";s:9:\"Publisher\";s:23:\"Avalanche Holdings Inc.\";s:11:\"ReleaseDate\";s:10:\"2012-03-15\";s:6:\"Studio\";s:23:\"Avalanche Holdings Inc.\";s:5:\"Title\";s:86:\"eBook Publishing Guide: How To Write an eBook & Publish It Online In Less Than 7 days!\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B007L9UXDC&atag=freetos-20&exp=2014-02-01T19%3A07%3A56Z&v=2&sig=PstgNR6nQBW2RBV6h9dqEIna6%2B7m8xhrKjWTbusJeh4%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1981:\"This eBook on how to write and publish en eBook will help you get your first eBook listed for sale starting with the Kindle Store, Lulu, and Barnes and Noble.<br /><br />But it\'s more than just that. I take you through the basics: writing tips, finding niches that you can sell your eBook in using simple and free tools, and more.<br /><br />This is not for the advanced eBook writer or publisher, although I am certain there might be a few nuggets for them as well. <br /><br />It\'s for the person just starting out in the eBook writing and marketing journey.<br /><br />I\'ve taken great pains to be sure that everything is simple to understand and implement and I am certain you\'ll enjoy the eBook and the journey...<br /><br />Table of Contents:<br /><br />Why publish your eBooks online? 4<br />Reason #1: We live in a modern world 4<br />Reason #2: The market for eBooks has exploded 5<br />Reason #3: There’s money to be made 5<br /><br />Does eBook Design Matter? 7<br /><br />What Makes A Quality eBook! 7<br /><br />Your Best Solutions 8<br /><br />How do you write an eBook that sells? 12<br /><br />#1 The Basic Layouts of your eBook: The Cover 13<br />#2 The Basic Layouts of your eBook: Table of Contents 18<br />#3 The Basic Layouts of your eBook: Copyright & Disclaimer 19<br />#4 The Basic Layouts of your eBook: Formatting 20<br />#5 The Basic Layouts of your eBook: Bonuses & about the Author 24<br />Major Principle #1: Write with result-oriented focus 26<br />Major Principle #2: Write with plain simple language 29<br />Major Principle #3: Write with a lot of spacing 30<br /><br />What you should do right now! 34<br />Step 1: Research niches 34<br />Step 2: Start writing using basic layout and principles 35<br />Step 3: Publish using the step-by-step guides 37<br /><br />How do you publish your eBook? 38<br />Step-by-Step: How to publish on Kindle Store 38<br />Step-by-Step: How to publish on Lulu.com 50<br />Step-by-Step: How to publish on BN.com 63\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("368", "73", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:18:\"I was skeptical...\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 19, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2UAIWAT6YFMMH/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:7:\"CTgreen\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:26:\"I think it\'s making sense.\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:12:\"May 12, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3SWZZAU570OXG/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:5:\"Beham\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:18:\"Very useful e-book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 26, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2I1VKN4402CRI/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:5:\"Uma G\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:24:\"Very helpful information\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"November 5, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2D7NE7NI1RE4U/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:7:\"ElaineZ\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:23:\"Lot of good information\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:12:\"May 14, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3723UCZLHHZF2/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:25:\"Diana J. Larson \"learner\"\";s:7:\"address\";s:9:\"Provo, UT\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:36:\"The best book on eBook publishing!!!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A22TI0EKLA6XCR/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:14:\"David Malmberg\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:52:\"Great info for a first-time e-book writer/publisher!\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:13:\"June 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2MZB9J19KEC3K/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:16:\"Margaret Johnson\";s:7:\"address\";s:27:\"St. Louis, MO United States\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:27:\"I like it because it tries.\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:14:\"April 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A146RCM93CHZK5/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:14:\"Robert De Long\";s:7:\"address\";s:18:\"ALMA, ARKANSAS, US\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:12:\"Very helpful\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1T2CBMAWM8SMY/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:18:\"Theresa Lineweaver\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:17:\"Publishing Ebooks\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2JQYINBJ9QVML/ref=cm_cr_pr_pdp/185-8686565-1581160\";s:4:\"name\";s:10:\"Zanyonenow\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("369", "73", "asg_last_refresh_attempt", "1391195277");
INSERT INTO `wp_postmeta` VALUES("370", "73", "asg_update_timestamp", "1391195277");
INSERT INTO `wp_postmeta` VALUES("371", "74", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("372", "74", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("373", "74", "asg_item_id", "B009VO9YGW");
INSERT INTO `wp_postmeta` VALUES("374", "74", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B009VO9YGW\";s:13:\"DetailPageURL\";s:209:\"http://www.amazon.com/All-Know-About-Book-Marketing-ebook/dp/B009VO9YGW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB009VO9YGW\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:219:\"http://www.amazon.com/All-Know-About-Book-Marketing-ebook/dp/tech-data/B009VO9YGW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB009VO9YGW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB009VO9YGW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB009VO9YGW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B009VO9YGW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B009VO9YGW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B009VO9YGW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB009VO9YGW\";}}}s:9:\"SalesRank\";s:7:\"1874847\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"334\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/31Ranqbz7WL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"334\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:12:\"Laina Turner\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:13:\"Five Seas Ink\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:13:\"Five Seas Ink\";s:13:\"NumberOfPages\";s:2:\"29\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-10-22\";s:9:\"Publisher\";s:13:\"Five Seas Ink\";s:11:\"ReleaseDate\";s:10:\"2012-10-22\";s:6:\"Studio\";s:13:\"Five Seas Ink\";s:5:\"Title\";s:33:\"All I Know About e-Book Marketing\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B009VO9YGW&atag=freetos-20&exp=2014-02-01T19%3A07%3A57Z&v=2&sig=68jI%2BujsNXSPTyqcqNbDqaeQnywv0iCt0WDm2v4Vk24%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:403:\"All I know about e-Book marketing, is a short book, because I, by no means, claim to know all there is to know about e-book marketing, nor am I even an expert. What I am is experienced in what not to do, enough that I have somehow stumbled on to a few things that actually work and I want to pass that on to other authors. I hope this book will give you at least a few nuggets of helpful of information.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("375", "74", "asg_product_details", "a:10:{s:9:\"File Size\";s:6:\"102 KB\";s:12:\"Print Length\";s:8:\"29 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:32:\"Five Seas Ink (October 22, 2012)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B009VO9YGW\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("376", "74", "asg_last_refresh_attempt", "1391195279");
INSERT INTO `wp_postmeta` VALUES("377", "74", "asg_update_timestamp", "1391195279");
INSERT INTO `wp_postmeta` VALUES("378", "75", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("379", "75", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("380", "75", "asg_item_id", "B00BSG4LXW");
INSERT INTO `wp_postmeta` VALUES("381", "75", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00BSG4LXW\";s:13:\"DetailPageURL\";s:213:\"http://www.amazon.com/Ways-Sell-Nonfiction-Kindle-Books-ebook/dp/B00BSG4LXW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BSG4LXW\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:223:\"http://www.amazon.com/Ways-Sell-Nonfiction-Kindle-Books-ebook/dp/tech-data/B00BSG4LXW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00BSG4LXW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00BSG4LXW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00BSG4LXW%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00BSG4LXW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00BSG4LXW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00BSG4LXW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BSG4LXW\";}}}s:9:\"SalesRank\";s:5:\"14239\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"376\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"83\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51uxnDZGOcL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"376\";}}}s:14:\"ItemAttributes\";a:12:{s:6:\"Author\";s:11:\"Steve Scott\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:9:\"Version 2\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:3:\"108\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-11-23\";s:11:\"ReleaseDate\";s:10:\"2013-11-23\";s:5:\"Title\";s:44:\"61 Ways to Sell More Nonfiction Kindle Books\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00BSG4LXW&atag=freetos-20&exp=2014-02-01T19%3A08%3A00Z&v=2&sig=u%2F9W7R1nnFyCqmm3pdeNnqmDsx%2BIQiKQomuUu4KsmoM%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2981:\"<h2>Want to Sell More Nonfiction Kindle Books?</h2>\n<br /><i>What\'s the secret to success with Amazon\'s Kindle publishing?</i>  It all starts with having a \"system\" for selling more books.  As you probably know, it\'s getting harder and harder to compete in the Kindle marketplace.  That\'s why you need a <b><i>proven</i></b> plan for increasing your daily sales volume.  \n<br />\n<br />In \"<b>61 Ways to Sell More Nonfiction Kindle Books</b>\" you\'ll learn what Steve Scott does to average 100+ sales EVERY day. <b> (Proof Inside!)</b>    \n<br />\n<br /><h2>Take Your Nonfiction Kindle Business to the NEXT Level...</h2>\n<br />Kindle publishing seems like an easy process.  You write a book, publish it and then watch the money pour into your bank account.  Unfortunately the reality is far from this dream.\n<br />\n<br />There\'s a simple truth about Kindle publishing – It\'s not a \'get rich quick\' strategy.  Sure, you can complete a book in a few days, but it\'s not easy to get people to actually buy it.  \n<br />\n<br />The people who succeed on Amazon understand the balance between quality content and great marketing.  Moreover, they know how to build an audience of long-term customers who buy every new offer.\n<br />\n<br />The good news is it\'s not hard to improve your Kindle success.  Amazon has built an amazing platform that\'s designed to help you sell more books.   Understand how it works and you\'ll produce one best-seller after the other.\n<br />\n<br /><h2>DISCOVER:: 61 Strategies for Selling More Books</h2>\n<br />\"<b>61 Ways to Sell More Nonfiction Kindle Books</b>\" details a variety of techniques that will increase your daily sales volume.    \n<br />\n<br />Inside this guide you\'ll discover:\n<br /><ul><li><b>10 Pillars of a Rock-Solid Kindle Business (Strategies #1 to #10)</b></li>\n<br /><li>4 Rules of Internal Book Marketing (Strategies #11 to #14)</li>\n<br /><li><b>Maximize Your Amazon Book Listing (Strategies #15 to #21)</b></li>\n<br /><li>Using the Author Page to Sell More Books (Strategies #22 to #27)</li>\n<br /><li><b>Increase Book Sales with Free KDP Select Promotions (Strategies #28 to #32)</b></li>\n<br /><li>How Pricing Affects Your Total Books Sales (Strategies #33 to #37)</li>\n<br /><li><b>How to Build a Loyal Audience with an Author Platform (Strategies #38 to #41)</b></li>\n<br /><li>Why an Email List is the Ultimate Author Platform (Strategies #42 to #46)</li>\n<br /><li><b>Advanced Book Sales Techniques (Strategies #47 to #52)</b></li>\n<br /><li>Follow \"White-Hat\" Kindle Practices (Strategies #53 to #58)</li>\n<br /><li><b>The Mindset of a Best-Selling Kindle Author (Strategies #59 to #61)</b></li></ul>\n<br />You <i>can</i> get more book sales!  Just apply a few of these techniques and you\'ll get more customers, downloads and reviews.\n<br />\n<br /><h2>Would You Like To Know More?</h2>\n<br />Download now and take your Kindle business to the next level.\n<br />\n<br />Scroll to the top of the page and select the <i>buy</i> button.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("382", "75", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:19:\"Excellent resource!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3FYY27VC97MC4/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:12:\"Francesca CH\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:33:\"Full of Useful, Actionable Advice\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"April 9, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1CRUVT19S866D/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:32:\"Praveen Puri \"Minimalist writer\"\";s:7:\"address\";s:12:\"Chicago Area\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:13:\"A great book!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1OIKRBOMDY7R0/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:14:\"Donald Nichols\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:42:\"Best Book Thus Far For Marketing On Kindle\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"April 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AQUVFUXOUUXBV/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:5:\"J. L.\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:31:\"A goldmine of promotional ideas\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A686XLRP2EV39/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:13:\"Derek Doepker\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:35:\"Concise and well-written strategies\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1Y09V41TR8OUO/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:17:\"Darren Cottingham\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:52:\"Steve is Awesome! Publishing My own Kindle Books Now\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A33OHAF1JXAAX2/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:12:\"James Pruitt\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:31:\"A jam-packed information source\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:11:\"May 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3RW3P1GA207PT/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:11:\"Hedonwriter\";s:7:\"address\";s:25:\"Dickson, TN United States\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:62:\"The only way to sell non-fiction books is to write more books?\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:15:\"August 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2OUE5JNVGVM46/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:43:\"Destination Infinity \"Destination Infinity\"\";s:7:\"address\";s:14:\"Chennai, India\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:67:\"I am only half way through and I had to stop and write this review.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"April 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3GOWR8JHI7MD0/ref=cm_cr_pr_pdp/180-6907357-4901840\";s:4:\"name\";s:7:\"Sherrie\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("383", "75", "asg_last_refresh_attempt", "1391195281");
INSERT INTO `wp_postmeta` VALUES("384", "75", "asg_update_timestamp", "1391195281");
INSERT INTO `wp_postmeta` VALUES("385", "76", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("386", "76", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("387", "76", "asg_item_id", "B00ATL0M5I");
INSERT INTO `wp_postmeta` VALUES("388", "76", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00ATL0M5I\";s:13:\"DetailPageURL\";s:219:\"http://www.amazon.com/Ninja-Book-Marketing-Strategies-Tactics-ebook/dp/B00ATL0M5I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00ATL0M5I\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:229:\"http://www.amazon.com/Ninja-Book-Marketing-Strategies-Tactics-ebook/dp/tech-data/B00ATL0M5I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00ATL0M5I%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00ATL0M5I%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00ATL0M5I%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00ATL0M5I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00ATL0M5I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00ATL0M5I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ATL0M5I\";}}}s:9:\"SalesRank\";s:6:\"259084\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"123\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"385\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"85\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"123\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51MMEE4tVUL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"385\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:18:\"Tom Corson-Knowles\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:20:\"Book Marketing Group\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:20:\"Book Marketing Group\";s:13:\"NumberOfPages\";s:3:\"104\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-16\";s:9:\"Publisher\";s:20:\"Book Marketing Group\";s:11:\"ReleaseDate\";s:10:\"2013-12-16\";s:6:\"Studio\";s:20:\"Book Marketing Group\";s:5:\"Title\";s:97:\"Ninja Book Marketing Strategies: How To Sell More Books In 8 Days Using 8 Ninja Marketing Tactics\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00ATL0M5I&atag=freetos-20&exp=2014-02-01T19%3A08%3A01Z&v=2&sig=QHQfxR%2B5DDo5tH18ALsVZgCPAB7huil4DH44iGFexQo%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3107:\"How To Sell More Books On Amazon In Just 8 Days<br /><br /><b>I Believe Every Author Can Become A Book Marketing Ninja With This System</b><br /><br />You could be just 8 days away from record book sales. Learn how to:<br /><br />Attract Thousands of Readers With These Free Marketing Strategies<br />Whether you\'re a brand new author or have been selling books by the thousands, you\'ve never seen these book marketing strategies anywhere else.<br /><br />Use Secret Amazon Analytics Technology To Increase Sales by 73%<br />I stumbled upon this simple trick that allows you to track ALL of your traffic to your Amazon book page. Using this technique, I\'ve been able to test every marketing strategy I could get my hands on to help sell more books. Learn the one simple change that increased my conversions by 73% in a week.<br /><br />Learn The Ninja System For KDP Select Marketing Success<br />Using my list of 43 free marketing resources, my friend launched a simple fitness book... and just in 8 days 14,428 people downloaded the book for free and he made over 400 sales. Not only that, but his book became the #1 Weight Loss book in the Paid Kindle Store and #320 overall in the Kindle Store with over 200 sales a day at $4.99!<br /><br />Dominate Your Niche or Genre By Bundling<br />If you\'re a serial author then you\'ve probably already written several books and have hundreds of more ideas in your head. Learn the proven system for bundling your books to provide readers easier access to your work and grow your book sales exponentially with very little extra work. This is the secret strategy that every multiple New York Times bestselling author uses!<br /><br />How To Market A Book Like A Professional<br />The problem is most authors don\'t know how to market their books properly. They either don\'t do any marketing or spend all their time, money and energy on marketing strategies that don\'t even more! Ninjas understand that writing a bestselling book is more about selling than it is about writing! Writing is the prerequisite for success - but marketing is what makes books sell.<br /><br />How To Get Your New Books Featured As An Amazon Hot New Release<br />Learn the system for getting Amazon to promote your new books for you! Only three books make it into the Hot New Release section for each category - and Amazon promotes them heavily. Find out what it takes to get there and you can dramatically improve your new book launches and sales.<br /><br />How To Use Amazon Listmania To Skyrocket Your Sales<br />Learn how to use a simple Listmania list to sell more books on Amazon fast. No more expensive book marketing strategies or ads are needed!<br /><br /><br /><b>About The Author</b><br /><br />Tom Corson-Knowles is the bestselling author of The Kindle Publishing Bible and The Kindle Formatting Bible, among others. Tom is an avid entrepreneur and loves helping other authors succeed by marketing effectively directly to readers instead of hoping, wishing and praying for more sales.<br /><br />Learn how to sell more books on Amazon today. Scroll up and grab your copy today.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("389", "76", "asg_product_details", "a:10:{s:9:\"File Size\";s:6:\"524 KB\";s:12:\"Print Length\";s:9:\"104 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:40:\"Book Marketing Group (December 16, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00ATL0M5I\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("390", "76", "asg_star_rating", "4.6");
INSERT INTO `wp_postmeta` VALUES("391", "76", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:50:\"Contains brilliant ideas I have not seen elsewhere\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 14, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3HTD7YTMDGNOX/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:47:\"Tim B \"Author, Tactics Time 1001 Chess Tactics\"\";s:7:\"address\";s:34:\"Colorado Springs, CO United States\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:30:\"Talk About Bang for Your Buck!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 28, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1FHCYWYNA9XFQ/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:49:\"Barbara Grassey \"Author, Dont Make Me Slap You\"\";s:7:\"address\";s:21:\"Floridas Gulf Coast\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:19:\"Simply magnificent!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 10, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A205G81N7F982W/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:15:\"Ruan Oosthuizen\";s:7:\"address\";s:12:\"South Africa\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:23:\"Not for the experienced\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:14:\"April 19, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2YH7DB40SR6IP/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:8:\"PaleFire\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:16:\"a disappointment\";s:4:\"star\";s:3:\"2.0\";s:4:\"date\";s:14:\"April 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1T1LC4J7ZTW2D/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:34:\"Emily H. Sturgill \"Emily Sturgill\"\";s:7:\"address\";s:11:\"Detroit, Mi\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:38:\"If You Write for Kindle, BUY THIS BOOK\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 28, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1ZW0UPEQ4XOG3/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:25:\"Nancy Hendrickson \"Nancy\"\";s:7:\"address\";s:13:\"San Diego, CA\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:34:\"Great Book For Authors & Marketers\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 28, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1TKT9RDR8X9UF/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:19:\"Walter B. Podgurski\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:24:\"Really made me get going\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:15:\"January 3, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AWN6F8PQN28CY/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:8:\"W. Marks\";s:7:\"address\";s:10:\"Boston, MA\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:46:\"A must read book for Kindle publishers/Authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AC7R8K0WKJTCA/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:6:\"Shahar\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:9:\"The BEST!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 23, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2E9A7HNHUZVTE/ref=cm_cr_pr_pdp/190-6362320-2145308\";s:4:\"name\";s:48:\"Scott \"Married to an awesome woman and have o...\";s:7:\"address\";s:31:\"Philadelphia, MS, United States\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("392", "76", "asg_last_refresh_attempt", "1391195283");
INSERT INTO `wp_postmeta` VALUES("393", "76", "asg_update_timestamp", "1391195283");
INSERT INTO `wp_postmeta` VALUES("394", "77", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("395", "77", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("396", "77", "asg_item_id", "1470080206");
INSERT INTO `wp_postmeta` VALUES("397", "77", "asg_amazon_data", "a:12:{s:4:\"ASIN\";s:10:\"1470080206\";s:13:\"DetailPageURL\";s:210:\"http://www.amazon.com/Pocket-Guide-Writing-eBook-Marketing/dp/1470080206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1470080206\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:220:\"http://www.amazon.com/Pocket-Guide-Writing-eBook-Marketing/dp/tech-data/1470080206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1470080206%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1470080206%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1470080206%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1470080206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1470080206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1470080206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"387\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"85\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41BKRbcTRXL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"387\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41wj1leG7PL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41wj1leG7PL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41wj1leG7PL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41wj1leG7PL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"85\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41wj1leG7PL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41wj1leG7PL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"386\";}}}}s:14:\"ItemAttributes\";a:19:{s:6:\"Author\";s:22:\"MR Robert K. Teske Jr.\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781470080204\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781470080204\";}s:4:\"ISBN\";s:10:\"1470080206\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:4:\"1087\";s:6:\"Length\";s:1:\"8\";s:6:\"Weight\";s:2:\"24\";s:5:\"Width\";s:3:\"839\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1995\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$19.95\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:2:\"34\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:1:\"8\";s:6:\"Length\";s:4:\"1100\";s:6:\"Weight\";s:2:\"31\";s:5:\"Width\";s:3:\"850\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2012-02-23\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:52:\"A Pocket Guide To Writing an eBook & eBook Marketing\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:4:\"1456\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$14.56\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:4:\"3333\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$33.33\";}s:8:\"TotalNew\";s:2:\"10\";s:9:\"TotalUsed\";s:1:\"2\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1470080206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1470080206\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:126:\"5nGJmvLWdBeDFffnlZOYg%2B9Qn2so3JTDhYmCYFf2bSUFDgPgGWE8p6tPeZOUD7ev4ffhFK0nomJX0ghxQAa1IbCwHTxeYiJYWaFYvccdZrdNRfDQdRLpsg%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1796\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$17.96\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"199\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.99\";}s:15:\"PercentageSaved\";s:2:\"10\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1470080206&atag=freetos-20&exp=2014-02-01T19%3A08%3A03Z&v=2&sig=%2FqH1RbKMUo0djDgvABtNwZIbQebaaEFbZM8B2sCP2TY%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1109:\"Have you ever wanted to write and publish a digital book? Here\'s a basic pocket handbook to writing and marketing an eBook that doesn\'t take a Ph.D to understand. It\'s in simple, easy to understand English. It\'s not true that everything that has been said has already been written. Since that unfortunate axiom came into use, the whole universe has changed. Technology has changed, ideas have changed, and the mindsets of entire nations have changed. The fact is that this is the perfect time to write an eBook. What the publishing industry needs are people who can tap into the world as it is today – innovative thinkers who can make the leap into the new millennium and figure out how to solve old problems in a new way. Within the contents of this Pocket Guide is everything your really need to know if you\'ve ever want to create a Digital Book, presently known as an eBook: * Why Write an eBook? * How to Write an eBook * Overcoming Writer’s Block * Choosing an eBook Compiler * Rating eBook Compilers * Steps to Publishing Success * How to Price Your eBook * Bonus: eBooks are Promotional Powerhouses\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("398", "77", "asg_product_details", "a:7:{s:9:\"Paperback\";s:8:\"34 pages\";s:9:\"Publisher\";s:63:\"CreateSpace Independent Publishing Platform (February 23, 2012)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1470080206\";s:7:\"ISBN-13\";s:14:\"978-1470080204\";s:18:\"Product Dimensions\";s:23:\"0.1 x 8.4 x 10.9 inches\";s:15:\"Shipping Weight\";s:8:\"5 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("399", "77", "asg_last_refresh_attempt", "1391195285");
INSERT INTO `wp_postmeta` VALUES("400", "77", "asg_update_timestamp", "1391195285");
INSERT INTO `wp_postmeta` VALUES("401", "78", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("402", "78", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("403", "78", "asg_item_id", "B00C9V3MXK");
INSERT INTO `wp_postmeta` VALUES("404", "78", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00C9V3MXK\";s:13:\"DetailPageURL\";s:226:\"http://www.amazon.com/EBook-Millionaire-Complete-Selling-EBooks-FAST-ebook/dp/B00C9V3MXK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00C9V3MXK\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:236:\"http://www.amazon.com/EBook-Millionaire-Complete-Selling-EBooks-FAST-ebook/dp/tech-data/B00C9V3MXK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00C9V3MXK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00C9V3MXK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00C9V3MXK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00C9V3MXK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00C9V3MXK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00C9V3MXK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00C9V3MXK\";}}}s:9:\"SalesRank\";s:5:\"72766\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"312\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"47\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"69\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"100\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51KEwfPfULL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"312\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:15:\"James Calthorpe\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:2:\"52\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-04-08\";s:11:\"ReleaseDate\";s:10:\"2013-04-08\";s:5:\"Title\";s:75:\"EBook Millionaire: Your Complete Guide to Making Money Selling EBooks-FAST!\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00C9V3MXK&atag=freetos-20&exp=2014-02-01T19%3A08%3A05Z&v=2&sig=p9oIdCvHRp06P5La%2BR7FxpFg8N1u6pF8ICMC8YjSyZ4%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2179:\"<center> <h2>Ebook Millionaire is a complete step by step guide to building a massive revenue stream through selling your books online-either via your own blog or via Amazon Kindle and other e-readers. </h2> </center> <P><b> eBook Millionaire is the accompanying book to \"How to Self-Publish Your eBook From Start to Finish; Everything You Need to Know to Get to The Top\" which covers how to best set your book up on all the main sites. <P> Many books on Kindle never sell more than one or two copies</b>- not because they are not well written but because they are not well marketed. This book will teach authors the almost guaranteed method of success in self-publishing starting from before the book is written: <b>Market research- to guarantee you have a pool of hungry buyers desperate for your book-before you have even written a word! </b> <P>It also teaches you both external and internal marketing. Many authors are good writers but are not very good at marketing. Internal marketing is optimising the Kindle platform to get more sales, more reviews, get your books listed high on the sales rankings and being seen by more people. <P>External marketing will explain in an easy to follow format how to blog, how to use Twitter, the importance of Facebook and the value of traditional marketing systems. <P> E-book Millionaire is not another \"get rich quick\" guide. This book follows the exact system used by the author to create a regular five figure monthly income from these same methods. The steps are simple but the information world changes all the time and the simple things often get overlooked. <P> <b>If these are not done properly your book will be lost amongst the thousands vying for the browsers attention. </b> <P>This book will help you immensely if you are looking to publish your first book, if you already have published a book but it is not selling yet or if you are looking to create a serious self-publishing empire with multiple titles in multiple genres. <P> <b>If you are serious about online book sales and have not read this book, you are simply losing money! </b> <P> <b>So go back up to the top and click \"buy\"! so you can sell more books! </b>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("405", "78", "asg_product_details", "a:8:{s:9:\"File Size\";s:6:\"397 KB\";s:12:\"Print Length\";s:8:\"52 pages\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00C9V3MXK\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("406", "78", "asg_star_rating", "4.8");
INSERT INTO `wp_postmeta` VALUES("407", "78", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:37:\"Worth more than $2.99- by a long shot\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AKVKOB474SBJ4/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:16:\"Greener pastures\";s:7:\"address\";s:11:\"Atlanta, GA\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:35:\"Authorship and Publishing Evolution\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"December 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AAEO0DFYDQ0CB/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:19:\"Blane J. Nasveschuk\";s:7:\"address\";s:15:\"Rutland, VT USA\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:14:\"I can do this!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 26, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A37G07IUMRGTL6/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:7:\"Elana W\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:42:\"EBook Millionaire full of very useful info\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"November 23, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36XHYH6U80ZAF/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:14:\"Anise E. Quinn\";s:7:\"address\";s:15:\"El Paso, TX USA\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:10:\"Great Book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 29, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1M7VKKT8FY9V0/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:13:\"Conroy Dennis\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:33:\"Great read about how to publish..\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AGR98IRFC8FIG/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:14:\"Rodger D Sharp\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:17:\"Good Information!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A11UIV2PIXHRGA/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:7:\"Tanisha\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:11:\"So Helpful!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:11:\"May 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A5UDG2N8KT8ZC/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:13:\"J. Calvin \"J\"\";s:7:\"address\";s:13:\"San Diego, CA\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:12:\"Helpful tips\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"April 15, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A30A6ECJCR0X28/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:16:\"Tracey Blackmore\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:34:\"Solid product with Some Good Ideas\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 30, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ADXK79DO4PW1E/ref=cm_cr_pr_pdp/177-4695996-8685406\";s:4:\"name\";s:12:\"Eric Michael\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("408", "78", "asg_last_refresh_attempt", "1391195288");
INSERT INTO `wp_postmeta` VALUES("409", "78", "asg_update_timestamp", "1391195288");
INSERT INTO `wp_postmeta` VALUES("410", "79", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("411", "79", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("412", "79", "asg_item_id", "1939183006");
INSERT INTO `wp_postmeta` VALUES("413", "79", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1939183006\";s:13:\"DetailPageURL\";s:207:\"http://www.amazon.com/Get-Your-Book-Published-Contracts/dp/1939183006%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1939183006\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:217:\"http://www.amazon.com/Get-Your-Book-Published-Contracts/dp/tech-data/1939183006%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1939183006%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1939183006%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1939183006%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1939183006%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1939183006%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1939183006%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";}}}s:9:\"SalesRank\";s:7:\"5594291\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/511X0vNhjsL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}s:14:\"ItemAttributes\";a:19:{s:6:\"Author\";s:16:\"David Welday III\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781939183002\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781939183002\";}s:4:\"ISBN\";s:10:\"1939183006\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"752\";s:6:\"Length\";s:2:\"39\";s:6:\"Weight\";s:2:\"20\";s:5:\"Width\";s:3:\"500\";}s:5:\"Label\";s:21:\"HigherLife Publishing\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1295\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$12.95\";}s:12:\"Manufacturer\";s:21:\"HigherLife Publishing\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"128\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"40\";s:6:\"Length\";s:3:\"730\";s:6:\"Weight\";s:1:\"2\";s:5:\"Width\";s:3:\"480\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-03-25\";s:9:\"Publisher\";s:21:\"HigherLife Publishing\";s:6:\"Studio\";s:21:\"HigherLife Publishing\";s:5:\"Title\";s:132:\"Get Your Book Published!: From Contracts to Covers, Editing to eBooks, Marketing and Sales, What Every Writer and Author Should Know\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"595\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$5.95\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:3:\"754\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$7.54\";}s:8:\"TotalNew\";s:2:\"23\";s:9:\"TotalUsed\";s:2:\"13\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1939183006%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1939183006\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:130:\"RvwiCO8sY03CEgm7w3aNwxNbfblm1ZrptZWF%2BETs2SIirt7ECl5hoILodleQJtF0KqR3IT%2FkGQG1S26ARInLwJ79mKf1wFHLVm0AoUl24WGVBXgEBy6%2FGw%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1166\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$11.66\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"129\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.29\";}s:15:\"PercentageSaved\";s:2:\"10\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:1:\"0\";s:12:\"MaximumHours\";s:1:\"0\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1939183006&atag=freetos-20&exp=2014-02-01T19%3A08%3A08Z&v=2&sig=%2F7SQOAZiSqkmvhNYPQ0SDG90UWVZxf84FzPgc6F9%2BCk%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:955:\"Whether you are a CEO, who\'s written a book to position yourself as a thought leader in your field, or a soccer mom, who wants to write the great American novel, <em>Get Your Book Published! </em> gives you vital keys to publish and market like an expert.<br>This book will help you:<br><ul><li>Understand the different types of publishing options available</li><li>Plot the development of your book from editing to cover design</li><li>Navigate the terms of a publishing contract</li><li>Understand the role of the literary agent</li><li>Avoid land mines that derail and defeat so many authors</li><li>Decide how best to tailor and format your message <em>(mobile apps, eBooks, on-line courses, blog articles)</em> </li><li>Learn the sales channels where your book can best be sold</li><li>Build a foundation for marketing that will get you noticed</li></ul><br><strong> If you want to publish properly and profitably, this is the book to read! </strong>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("414", "79", "asg_product_details", "a:7:{s:9:\"Paperback\";s:9:\"128 pages\";s:9:\"Publisher\";s:38:\"HigherLife Publishing (March 25, 2013)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1939183006\";s:7:\"ISBN-13\";s:14:\"978-1939183002\";s:18:\"Product Dimensions\";s:20:\"0.4 x 5 x 7.5 inches\";s:15:\"Shipping Weight\";s:10:\"0.3 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("415", "79", "asg_last_refresh_attempt", "1391195289");
INSERT INTO `wp_postmeta` VALUES("416", "79", "asg_update_timestamp", "1391195289");
INSERT INTO `wp_postmeta` VALUES("417", "80", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("418", "80", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("419", "80", "asg_item_id", "B00ETR9POM");
INSERT INTO `wp_postmeta` VALUES("420", "80", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00ETR9POM\";s:13:\"DetailPageURL\";s:213:\"http://www.amazon.com/online-places-promote-kindle-free-ebook/dp/B00ETR9POM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00ETR9POM\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:223:\"http://www.amazon.com/online-places-promote-kindle-free-ebook/dp/tech-data/B00ETR9POM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00ETR9POM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00ETR9POM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00ETR9POM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00ETR9POM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00ETR9POM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00ETR9POM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00ETR9POM\";}}}s:9:\"SalesRank\";s:6:\"899112\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"111\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"346\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"76\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"111\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51hoAbKbbjL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"346\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";a:2:{i:0;s:14:\"Shabbir Hazari\";i:1;s:23:\"Rasheeda Shabbir Hazari\";}s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:24:\"Kindle Marketing Masters\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:24:\"Kindle Marketing Masters\";s:13:\"NumberOfPages\";s:2:\"25\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-08-27\";s:9:\"Publisher\";s:24:\"Kindle Marketing Masters\";s:11:\"ReleaseDate\";s:10:\"2013-08-27\";s:6:\"Studio\";s:24:\"Kindle Marketing Masters\";s:5:\"Title\";s:138:\"153+ free online places to promote your kindle book when it\'s free. Exact Links - Time Saver - Big Exposure (Kindle Book Marketing Series)\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:198:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00ETR9POM&atag=freetos-20&exp=2014-02-01T19%3A08%3A10Z&v=2&sig=%2FXZkHV%2BGN55NHyJdBeKiTmCOeaJlFUv8o8%2B5z8A4hpU%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:451:\"The biggest challenge for Kindle eBook Writer is not the writer books but to reach to the audience and marketing of his/her book. Author can use Amazon KDP Select Program to offer his/her book for free as a Promotional Activity. One can offer free for 5 days in every 90 days. More downloads readers’ do, more exposure your book and you will get. Here I present lot of sources to jumpstart your Kindle Book Marketing and get lot and lot of exposure.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("421", "80", "asg_customer_reviews", "a:3:{i:0;a:5:{s:5:\"title\";s:4:\"Why?\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:16:\"October 25, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A163YYYL2O4L5C/ref=cm_cr_pr_pdp/189-8535723-1490806\";s:4:\"name\";s:40:\"D. Polner \"Entrepreneur, but Dad first.\"\";s:7:\"address\";s:24:\"Benton, AR United States\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:17:\"Oh my... I\'m torn\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:15:\"October 4, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2P4HZY1FAHXZS/ref=cm_cr_pr_pdp/189-8535723-1490806\";s:4:\"name\";s:9:\"Babycakes\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:11:\"Very Useful\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:17:\"December 26, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AUGVH5YZNI328/ref=cm_cr_pr_pdp/189-8535723-1490806\";s:4:\"name\";s:3:\"ZRM\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("422", "80", "asg_last_refresh_attempt", "1391195290");
INSERT INTO `wp_postmeta` VALUES("423", "80", "asg_update_timestamp", "1391195290");
INSERT INTO `wp_postmeta` VALUES("424", "81", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("425", "81", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("426", "81", "asg_item_id", "B00FP1XSFI");
INSERT INTO `wp_postmeta` VALUES("427", "81", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00FP1XSFI\";s:13:\"DetailPageURL\";s:211:\"http://www.amazon.com/Bible-eBook-Promotion-Sol-Adoni-ebook/dp/B00FP1XSFI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FP1XSFI\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:221:\"http://www.amazon.com/Bible-eBook-Promotion-Sol-Adoni-ebook/dp/tech-data/B00FP1XSFI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00FP1XSFI%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00FP1XSFI%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00FP1XSFI%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00FP1XSFI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00FP1XSFI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00FP1XSFI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00FP1XSFI\";}}}s:9:\"SalesRank\";s:7:\"1775807\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"68\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41czTCRF3eL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:9:\"Sol Adoni\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:16:\"Adoni Publishing\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:16:\"Adoni Publishing\";s:13:\"NumberOfPages\";s:2:\"44\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-10-06\";s:9:\"Publisher\";s:16:\"Adoni Publishing\";s:11:\"ReleaseDate\";s:10:\"2013-10-06\";s:6:\"Studio\";s:16:\"Adoni Publishing\";s:5:\"Title\";s:24:\"Bible Of eBook Promotion\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00FP1XSFI&atag=freetos-20&exp=2014-02-01T19%3A08%3A11Z&v=2&sig=HrBKXeJQ6e2z7efaKxvPov1jsTF4Z7CaNCAQPUixMEs%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:972:\"Bible of eBook Promotion.\n<br />\n<br />Written by one of the founders of the eBook Industry, Sol Adoni, who has been creating and selling eBooks through a massive network of websites dedicated to promoting and selling eBooks.\n<br />\n<br />Sol Adoni explains the various techniques an self-published author or small Publishng Company can use to PROMOTE EBOOKS with the big companies.\n<br />\n<br />Sol Adoni explains the almost twenty year history of eBooks and chronicles how he used search engines, social media, print, radio and videos to promote and sell eBooks.\n<br />\n<br />If you have written an eBook and want to self publish it, this is a MUST READ. It also has vital information to help smaller publishers compete in today\'s world of social media, kindles, nooks and google.\n<br />\n<br />A short read packed by vital knowledge by a founder of the digital revolution.\n<br />\n<br />Look for Sol Adoni\'s other eBooks on eBook Publishng and Marketing on Amazon.\n<br />\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("428", "81", "asg_product_details", "a:10:{s:9:\"File Size\";s:7:\"1286 KB\";s:12:\"Print Length\";s:8:\"44 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:9:\"Publisher\";s:34:\"Adoni Publishing (October 6, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00FP1XSFI\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("429", "81", "asg_star_rating", "1");
INSERT INTO `wp_postmeta` VALUES("430", "81", "asg_customer_reviews", "a:1:{i:0;a:5:{s:5:\"title\";s:19:\"Grossly overpriced.\";s:4:\"star\";s:3:\"1.0\";s:4:\"date\";s:17:\"November 13, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A35LV9KV3QWI29/ref=cm_cr_pr_pdp/188-9755291-2691133\";s:4:\"name\";s:42:\"D. L. Graham \"Heaven\'s Garden Productions\"\";s:7:\"address\";s:3:\"USA\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("431", "81", "asg_last_refresh_attempt", "1391195293");
INSERT INTO `wp_postmeta` VALUES("432", "81", "asg_update_timestamp", "1391195293");
INSERT INTO `wp_postmeta` VALUES("433", "82", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("434", "82", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("435", "82", "asg_item_id", "B0075L8BNA");
INSERT INTO `wp_postmeta` VALUES("436", "82", "asg_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B0075L8BNA\";s:13:\"DetailPageURL\";s:225:\"http://www.amazon.com/allEbook-Marketing-Smashwords-Italian-Edition-ebook/dp/B0075L8BNA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0075L8BNA\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:235:\"http://www.amazon.com/allEbook-Marketing-Smashwords-Italian-Edition-ebook/dp/tech-data/B0075L8BNA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB0075L8BNA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB0075L8BNA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB0075L8BNA%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B0075L8BNA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B0075L8BNA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B0075L8BNA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB0075L8BNA\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"113\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"353\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"53\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"78\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"113\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51FZ%2BimmVYL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"353\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:10:\"Mark Coker\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Creator\";s:18:\"Giuseppe Meligrana\";s:6:\"Format\";s:12:\"Kindle eBook\";s:5:\"Label\";s:25:\"Mark Coker via Smashwords\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"Italian\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:25:\"Mark Coker via Smashwords\";s:13:\"NumberOfPages\";s:2:\"50\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-02-03\";s:9:\"Publisher\";s:25:\"Mark Coker via Smashwords\";s:11:\"ReleaseDate\";s:10:\"2012-02-03\";s:6:\"Studio\";s:25:\"Mark Coker via Smashwords\";s:5:\"Title\";s:74:\"Guida all\'Ebook Marketing Smashwords (Smashwords Guides) (Italian Edition)\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B0075L8BNA&atag=freetos-20&exp=2014-02-01T19%3A08%3A13Z&v=2&sig=OJyYruR6txPJfEVllpC8AfpWyDMqeDEFxWlo2tQYfaA%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3405:\"Questa Guida gratuita vuole aiutare autori ed editori a promuovere e vendere i propri ebook su Smashwords ma anche su tutti gli altri negozi virtuali. La Guida, partendo da come Smashwords aiuta gli autori a promuovere l\'ebook, dà 30 utilissimi suggerimenti per costruire autonomamente e gratuitamente un ottimo ebook marketing. Perciò è utile a tutti gli autori e non solo a quelli che pubblicano su Smashwords.<br /><br />Traduzione italiana a cura di Giuseppe Meligrana<br /><br />PER INIZIARE<br /><br />Introduzione. Informazioni sulla Guida all’ebook Marketing Smashwords<br />Due parole su Smashwords<br />Impostazione delle aspettative<br />Come Smashwords aiuta autori ed editori a commercializzare i loro ebook<br />Adottare una mentalità marketing attiva<br />Il marketing deve iniziare subito. Create il vostro social network<br />I link aiutano i lettori a scoprire i vostri ebook<br />L’importanza dell’aiuto reciproco tra autori<br /><br />30 suggerimenti per un marketing gratuito<br />Suggerimento 1: Aggiornare la firma e-mail<br />Suggerimento 2: Postare la notizia sul vostro sito o blog<br />Suggerimento 3: Contattare i vostri amici, familiari, collaboratori, soci e fan<br />Suggerimento 4: Mettere un avviso sui vostri social network<br />Suggerimento 5: Aggiornare le firme nei forum<br />Suggerimento 6: Raccogliere lettori con Twitter<br />Suggerimento 7: Pubblicare più di un ebook su Smashwords per creare un effetto moltiplicatore<br />Suggerimento 8: Pubblicizzare gli altri ebook in ogni ebook che pubblicate<br />Suggerimento 9: Facilitare i lettori a connettersi con voi<br />Suggerimento 10: Pubblicare un comunicato stampa e diffonderlo ovunque<br />Suggerimento 11: Aiutare i giornalisti on-line<br />Suggerimento 12. Incoraggiare i vostri fan ad acquistare e recensire il vostro ebook<br />Suggerimento 13. Scrivere recensioni per altri ebook su Smashwords<br />Suggerimento 14: Partecipare ai forum online<br />Suggerimento 15: Sperimentare i buoni sconto<br />Suggerimento 16: Scrivere un blog<br />Suggerimento 17: Scrivere nelle colonne degli ospiti dei blog<br />Suggerimento 18: Invitare altri autori a postare sul vostro blog<br />Suggerimento 19: Fare interviste ad altri autori sul vostro blog<br />Suggerimento 20: Partecipare alle conversazioni sui blog<br />Suggerimento 21: Organizzare un blog tour<br />Suggerimento 22: Usare Google Alert per scoprire dove le conversazioni hanno luogo<br />Suggerimento 23: Usare i video YouTube per conquistare i lettori<br />Suggerimento 24: Stampare biglietti da visita<br />Suggerimento 25: Incoraggiare i fan a fare marketing per i vostri ebook<br />Suggerimento 26: Creare una Guida per il lettore alla fine del vostro ebook<br />Suggerimento 27: Inserire interi capitoli di altri vostri ebook alla fine di ogni ebook<br />Suggerimento 28: Fare uno scambio di titoli o di capitoli con un altro autore alla fine di ogni ebook<br />Suggerimento 29: Invitare altri autori ad unirsi a voi in Smashwords<br />Suggerimento 30: Promuovere il vostro ebook sui siti o nei luoghi reali di maggiore “interesse ebook”<br /><br />Appendice<br />Le otto cose che dovete fare con un ebook<br />Le sette cose che non dovete fare con un ebook<br /><br />L’autore<br />Biografia<br />Altre opere di Mark Coker pubblicate in Smashwords<br />Collegarsi con Mark Coker<br />Collegarsi con i colleghi autori Smashwords\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("437", "82", "asg_last_refresh_attempt", "1391195294");
INSERT INTO `wp_postmeta` VALUES("438", "82", "asg_update_timestamp", "1391195294");
INSERT INTO `wp_postmeta` VALUES("439", "83", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("440", "83", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("441", "83", "asg_item_id", "B00DO9HJF8");
INSERT INTO `wp_postmeta` VALUES("442", "83", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00DO9HJF8\";s:13:\"DetailPageURL\";s:200:\"http://www.amazon.com/How-To-Market-A-Book-ebook/dp/B00DO9HJF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00DO9HJF8\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:210:\"http://www.amazon.com/How-To-Market-A-Book-ebook/dp/tech-data/B00DO9HJF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00DO9HJF8%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00DO9HJF8%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00DO9HJF8%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00DO9HJF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00DO9HJF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00DO9HJF8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00DO9HJF8\";}}}s:9:\"SalesRank\";s:5:\"62349\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"108\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51TMNzySifL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"337\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"51\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"74\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51TMNzySifL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"108\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51TMNzySifL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"337\";}}}s:14:\"ItemAttributes\";a:12:{s:6:\"Author\";s:11:\"Joanna Penn\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:1:\"1\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:3:\"278\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-09\";s:11:\"ReleaseDate\";s:10:\"2013-12-09\";s:5:\"Title\";s:20:\"How To Market A Book\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00DO9HJF8&atag=freetos-20&exp=2014-02-01T19%3A08%3A15Z&v=2&sig=sJ4B%2BPIM9vXWRtni7AduTuJpvtWSeWgFoBDFT1gJMRk%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:3655:\"<b>The first job of an author is, of course, to write great books, but these days, their second job is to market them.</b><br /><br />Marketing isn\'t a skill that most authors have naturally, and there is little formal training. But when your book hits the shelves, and the sales don\'t start rolling in, there\'s only two things an author can do. Keep writing more books and ... Get to grips with marketing. <br /><br /><b>This book is for authors who want to sell more books</b>, but it\'s also for those writers who want to think more like an entrepreneur. It\'s for traditionally published authors who want to take control of their future, and for self-published authors who want to jump-start a career. <br /><br />**<br /><i>\"Joanna Penn\'s How to Market a Book is the most up to date, personable guide to modern book marketing I know. Packed with tips from the charming and well-informed Penn, it\'s an essential guide for indie authors who want to keep up with the ever-shifting world of book marketing.\"</i><br /><br />Joel Friedlander, TheBookDesigner.com, A Self-Publisher\'s Companion<br /><br />** <br />There are some <b>short-term tactics </b>for those who want to kick up immediate sales, but the focus of the book is more about <b>instilling values and marketing principles that will help your long-term career</b> as a writer. <br /><br />It\'s also about <b>going beyond just the book</b>, because the methods in this guide can take you from being an author into professional speaking, making money from other products and creating opportunities that you can\'t even imagine yet. <br /><br />There are no rules in this game, but learning this kind of <b>authentic marketing</b> has certainly changed my life, so read on and I\'ll share everything I know with you.<br /><br /><br />How To Market A Book covers an extensive range of marketing principles, strategies and tactics: <br /><br /><ul><li><b>Part 1: Marketing Principles</b> - including myths, how to balance your time, co-opetition and generosity </li></ul><ul><li><b>Part 2: Prerequisites for Success</b> - including an understanding of yourself and your target market, professional editing and cover design, your book page on the retailer websites, pricing and the use of free</li></ul><ul><li><b>Part 3: No Platform Needed - Short-term Marketing</b> - including how to get book reviews, paid advertising, using traditional media and tips for TV, radio and press releases </li></ul><ul><li><b>Part 4: The Author Platform - Long-term Marketing</b> - including the reasons why a platform is a good thing, author branding, your author website, list-building and email marketing, content marketing and blogging, audio and podcasting, video and book trailers, social networking, professional speaking, and becoming an author-entrepreneur. </li></ul><ul><li><b>Part 5: Launching Your Book</b> - including how launching has changed, soft launch, launch spikes, post launch and relaunches as well as lessons learned from some major book launches. </li></ul><br />Plus/ <b>tips for when you get overwhelmed </b>and plenty more links to further resources. <br /><br />**<br /><br /><i>\"Right now, self-publishing is a wide open opportunity for writers. But it\'s a confusing and increasingly competitive field. Joanna Penn is one of the guides I rely on to help me navigate the maze, make better marketing decisions, and sell more books. If you read this book, she\'ll do the same for you.\"</i><br /><br />Mark McGuinness, Coach and author of Resilience: Facing Down Rejection and Criticism on the Road to Success<br /><br />**<br /><b>Click to sample or buy the book now.<br />             </b>\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("443", "83", "asg_product_details", "a:9:{s:9:\"File Size\";s:6:\"595 KB\";s:12:\"Print Length\";s:9:\"278 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00DO9HJF8\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:7:\"Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("444", "83", "asg_star_rating", "4.9");
INSERT INTO `wp_postmeta` VALUES("445", "83", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:52:\"Joanna not only talks the talk but walks the walk...\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2EX1NIVAENBHZ/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:12:\"James Minter\";s:7:\"address\";s:14:\"Cheltenham, UK\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:36:\"Interesting, informative, invaluable\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1QUQJ8U92AZC4/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:5:\"Gilly\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:64:\"excellent guide on book marketing and brand building for authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AKVB8G2299EYS/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:16:\"GRIGORY RYZHAKOV\";s:7:\"address\";s:10:\"London, UK\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:18:\"Lots of good tips!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36JDVLIN8VBL3/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:29:\"Derek Murphy \"(Creativindie)\"\";s:7:\"address\";s:88:\"I rarely stay in the same country for long, currently migrating through Europe and Asia.\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:34:\"Marketing for authors by an author\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A31DPTQFIRG4ZS/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:23:\"turnerpage \"turnerpage\"\";s:7:\"address\";s:13:\"Hampshire, UK\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:23:\"An All-Inclusive Guide.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 11, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2IHDQ6F9UCU74/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:26:\"DerekAlanWilkinson Dot Com\";s:7:\"address\";s:14:\"Charleston, WV\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:24:\"Glad that i purchased it\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 17, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2V1PV0LH1TARE/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:6:\"Guitry\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:51:\"Best book on the subject (in my limited experience)\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 10, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36QZ59YFK3CEO/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:8:\"A. Smith\";s:7:\"address\";s:20:\"West Tisbury, MA USA\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:14:\"A MUST READ!!!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 2, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1YMDHRAZ26OKX/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:48:\"Aleshia Robinson \"Author of Love, God & Tattoos\"\";s:7:\"address\";s:11:\"Atlanta, GA\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:9:\"Excellent\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 30, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2IIX40X7L0VUL/ref=cm_cr_pr_pdp/192-9282381-3190819\";s:4:\"name\";s:15:\"Christine Nolfi\";s:7:\"address\";s:14:\"South Carolina\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("446", "83", "asg_last_refresh_attempt", "1391195297");
INSERT INTO `wp_postmeta` VALUES("447", "83", "asg_update_timestamp", "1391195297");
INSERT INTO `wp_postmeta` VALUES("448", "84", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("449", "84", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("450", "84", "asg_item_id", "B00BN98V6M");
INSERT INTO `wp_postmeta` VALUES("451", "84", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00BN98V6M\";s:13:\"DetailPageURL\";s:211:\"http://www.amazon.com/How-Market-Your-eBook-Marketing-ebook/dp/B00BN98V6M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BN98V6M\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:221:\"http://www.amazon.com/How-Market-Your-eBook-Marketing-ebook/dp/tech-data/B00BN98V6M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00BN98V6M%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00BN98V6M%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00BN98V6M%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00BN98V6M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00BN98V6M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00BN98V6M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00BN98V6M\";}}}s:9:\"SalesRank\";s:7:\"1144894\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"19\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"46\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"68\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:2:\"99\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41Rsaol3mGL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"310\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:15:\"Richard Hopkins\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:1:\"1\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:15:\"Richard Hopkins\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:15:\"Richard Hopkins\";s:13:\"NumberOfPages\";s:1:\"7\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-02-28\";s:9:\"Publisher\";s:15:\"Richard Hopkins\";s:11:\"ReleaseDate\";s:10:\"2013-02-28\";s:6:\"Studio\";s:15:\"Richard Hopkins\";s:5:\"Title\";s:58:\"How To Market Your eBook - A Marketing Project Report 2013\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00BN98V6M&atag=freetos-20&exp=2014-02-01T19%3A08%3A17Z&v=2&sig=HQvchUI9GrUCum7sAZ4B0Fw9fhljY25sdOq7M%2BgATi0%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:841:\"Many endeavor to market their eBooks in many different ways. However, it\'s evident that most persons tend to follow the crowd in marketing. They do what others are doing to market their books. Research shows that a particular marketing tunnel can become crowded, and thus become weak as to deliver the same returns on investment as it used to over time.<br /><br />There is the need to discover and learn a new marketing channel to reach your target audience - if you\'re to experience great returns on your investment of having self-published a book. In this marketing report, you will become aware of a new link, an untapped vast marketing channel that would give your product massive great returns. Therefore, this report will guide you on how to implement \'out of the box\' marketing strategy for your book and thus earn much good returns.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("452", "84", "asg_product_details", "a:9:{s:9:\"File Size\";s:6:\"564 KB\";s:12:\"Print Length\";s:7:\"7 pages\";s:9:\"Publisher\";s:46:\"Richard Hopkins; 1 edition (February 28, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00BN98V6M\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:11:\"Not Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("453", "84", "asg_last_refresh_attempt", "1391195299");
INSERT INTO `wp_postmeta` VALUES("454", "84", "asg_update_timestamp", "1391195299");
INSERT INTO `wp_postmeta` VALUES("455", "85", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("456", "85", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("457", "85", "asg_item_id", "B00CXTNZOE");
INSERT INTO `wp_postmeta` VALUES("458", "85", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00CXTNZOE\";s:13:\"DetailPageURL\";s:216:\"http://www.amazon.com/Increase-Book-Sales-Social-Marketing-ebook/dp/B00CXTNZOE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00CXTNZOE\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:226:\"http://www.amazon.com/Increase-Book-Sales-Social-Marketing-ebook/dp/tech-data/B00CXTNZOE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00CXTNZOE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00CXTNZOE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00CXTNZOE%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00CXTNZOE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00CXTNZOE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00CXTNZOE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00CXTNZOE\";}}}s:9:\"SalesRank\";s:6:\"617622\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"65\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"140\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"436\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"26\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"65\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"65\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"96\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"140\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51xHfQFCLNL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"436\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:12:\"Erin McBride\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:5:\"EISBN\";s:13:\"9781301206995\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:15:\"Baby Duck Books\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:15:\"Baby Duck Books\";s:13:\"NumberOfPages\";s:2:\"60\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-05-21\";s:9:\"Publisher\";s:15:\"Baby Duck Books\";s:11:\"ReleaseDate\";s:10:\"2013-05-21\";s:6:\"Studio\";s:15:\"Baby Duck Books\";s:5:\"Title\";s:49:\"Increase e-Book Sales with Social Media Marketing\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00CXTNZOE&atag=freetos-20&exp=2014-02-01T19%3A08%3A19Z&v=2&sig=wqOCF6eGGKDX99o%2FBNRWblXCj4IN1wF8Z7JPghvRnJk%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:290:\"Increase your e-book sales with better social media marketing. This easy-to-read, and short guide will walk you through the basics of how to use social media to reach your target audience without preaching to the choir. Includes Facebook, LinkedIn, Twitter, Google Plus, Blogging, and more!\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("459", "85", "asg_product_details", "a:9:{s:9:\"File Size\";s:6:\"205 KB\";s:12:\"Print Length\";s:8:\"60 pages\";s:9:\"Publisher\";s:30:\"Baby Duck Books (May 21, 2013)\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00CXTNZOE\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:11:\"Not Enabled\";s:7:\"Lending\";s:11:\"Not Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("460", "85", "asg_star_rating", "5");
INSERT INTO `wp_postmeta` VALUES("461", "85", "asg_customer_reviews", "a:2:{i:0;a:5:{s:5:\"title\";s:12:\"Awesome info\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AGZRGFDBQDMZU/ref=cm_cr_pr_pdp/185-4009525-3213666\";s:4:\"name\";s:20:\"reviews \"Mythoughts\"\";s:7:\"address\";s:2:\"NY\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:27:\"great intro to social media\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"August 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3JBJAY6F4CXFL/ref=cm_cr_pr_pdp/185-4009525-3213666\";s:4:\"name\";s:8:\"Rebecker\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("462", "85", "asg_last_refresh_attempt", "1391195301");
INSERT INTO `wp_postmeta` VALUES("463", "85", "asg_update_timestamp", "1391195301");
INSERT INTO `wp_postmeta` VALUES("464", "86", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("465", "86", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("466", "86", "asg_item_id", "B00B1KTTKK");
INSERT INTO `wp_postmeta` VALUES("467", "86", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00B1KTTKK\";s:13:\"DetailPageURL\";s:222:\"http://www.amazon.com/The-Strategic-Marketing-Process-Activities-ebook/dp/B00B1KTTKK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B1KTTKK\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:232:\"http://www.amazon.com/The-Strategic-Marketing-Process-Activities-ebook/dp/tech-data/B00B1KTTKK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00B1KTTKK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00B1KTTKK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00B1KTTKK%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00B1KTTKK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00B1KTTKK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00B1KTTKK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00B1KTTKK\";}}}s:9:\"SalesRank\";s:6:\"590288\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"387\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"23\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"58\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"85\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"124\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/41gENHSuGxL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"387\";}}}s:14:\"ItemAttributes\";a:13:{s:6:\"Author\";s:13:\"Moderandi Inc\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:1:\"2\";s:5:\"EISBN\";s:13:\"9780988743120\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:3:\"166\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-01-04\";s:11:\"ReleaseDate\";s:10:\"2013-01-04\";s:5:\"Title\";s:102:\"The Strategic Marketing Process - How to Structure Your Marketing Activities to Achieve Better Results\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00B1KTTKK&atag=freetos-20&exp=2014-02-01T19%3A08%3A21Z&v=2&sig=0UnVXkuF7uLIvF%2FJMKH10HZZtqsIPXccrmD2XTX2aRs%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:398:\"This guide defines a marketing process that you can use to put structure around your daily, monthly and annual marketing and sales activities.<br /><br />The process covers more than just traditional marketing and ties together all go-to-market business activities: strategic planning, financial planning and measurement, creative development, marketing execution and sales, and customer retention.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("468", "86", "asg_last_refresh_attempt", "1391195302");
INSERT INTO `wp_postmeta` VALUES("469", "86", "asg_update_timestamp", "1391195302");
INSERT INTO `wp_postmeta` VALUES("470", "87", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("471", "87", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("472", "87", "asg_item_id", "1482651130");
INSERT INTO `wp_postmeta` VALUES("473", "87", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1482651130\";s:13:\"DetailPageURL\";s:215:\"http://www.amazon.com/Freaking-Idiots-Writing-Kindle-Bestseller/dp/1482651130%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1482651130\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:225:\"http://www.amazon.com/Freaking-Idiots-Writing-Kindle-Bestseller/dp/tech-data/1482651130%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1482651130%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1482651130%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1482651130%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1482651130%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1482651130%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1482651130%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";}}}s:9:\"SalesRank\";s:7:\"4949375\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51eguK%2BddvL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/516HxiWEy0L._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/516HxiWEy0L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/516HxiWEy0L._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/516HxiWEy0L._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/516HxiWEy0L._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/516HxiWEy0L.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}}s:14:\"ItemAttributes\";a:20:{s:6:\"Author\";s:11:\"Nick Vulich\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781482651133\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781482651133\";}s:7:\"Edition\";s:11:\"1st Edition\";s:4:\"ISBN\";s:10:\"1482651130\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"16\";s:6:\"Weight\";s:2:\"23\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1599\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$15.99\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:2:\"66\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"15\";s:6:\"Length\";s:3:\"900\";s:6:\"Weight\";s:2:\"33\";s:5:\"Width\";s:3:\"600\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-02-27\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:139:\"Freaking Idiots Guide to Writing a Kindle Bestseller: Tips & Tricks to Make your Book A Bestseller in Its Category (Freaking Idiots Guides)\";}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:4:\"1156\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$11.56\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:4:\"5239\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$52.39\";}s:8:\"TotalNew\";s:1:\"8\";s:9:\"TotalUsed\";s:1:\"2\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1482651130%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1482651130\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:136:\"%2BryaqyiykId5T%2BOie2dja%2BwE%2B73BDXvuLnFw7IVQbl18d%2BclZ3GsHYb8K5OHbE0RZwSXDbhH09XlCXM4sWtRI8QcZ2eYrupoU0S49X2FOJXJYejC3rrw%2FA%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1439\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$14.39\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"160\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.60\";}s:15:\"PercentageSaved\";s:2:\"10\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1482651130&atag=freetos-20&exp=2014-02-01T19%3A08%3A22Z&v=2&sig=1kwLDIBzaguEMrvfShd7%2FNIsmpe5MyimFk6UtK3qCSw%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2461:\"<b>Are you the author of a nonfiction or self-help book?</b><br><br> What would you say if I told you this one simple trick in writing your book description could easily help you sell an extra hundred books each and every month?<br><br> The thing to remember when you write a nonfiction book description is -<b> It’s all about the customer</b>. If you can show the customer you can help them get what they want, you will have them eating out of your hands.<br><br> There are a lot of Kindle advice books out there. All of them are trying to tell you how to write a book the fastest, that you need to search Google keywords for the latest hottest topics, and that you need to spend hours every day implementing a social media campaign to help people find your book.<br><br> <b>What would you say if I told you that was all a bunch of Bullshit?</b><br><br> I sold over 150 copies of my first book in three weeks without resorting to a single one of those tactics.<br><br> The fact is - Amazon does over 90 percent of the work for you in marketing your book. Before you go off site to sell books, you need to optimize all of Amazon\'s marketing tools.<br><br> <b>Here are just a few of the topics this book is going to cover.</b><br><br> 1) Creating covers that demand attention <br> 2) How to write a title that will reach out and slap you customer in the face <br> 3) How to write a book description that will make them want to buy your book - NOW! <br> 4) Why you need a compelling \"Meet the Author\" page, and how you can use it to position yourself as an expert in your subject matter<br> 5) How to add tags to your book<br> 6) Why you need customer reviews, and how you can get more of them<br> 7) All you need to know about KDP Select <br> 8) Pricing strategies to sell more books<br><br> <b>If you are the author of a non-fiction how to or advice book, this guide will help you sell more books.</b><br><br> <b>About the Author </b><br><br> Nick Vulich is the author of eight Kindle books including <i>Freaking Idiots Guide to Selling on eBay, How anyone can make $100 or more everyday selling on eBay</i>. Nick has worked in e-commerce for over thirteen years, selling both on eBay and Amazon. He also edits several successful blogs including Digital History Project and Retro Iowa.<br><br>   His latest book <i>Freaking Idiots Guide to Making Money with Fiverr, How people are making $1000 a month providing simple services</i> is now available on Kindle.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("474", "87", "asg_product_details", "a:8:{s:6:\"Series\";s:22:\"Freaking Idiots Guides\";s:9:\"Paperback\";s:8:\"66 pages\";s:9:\"Publisher\";s:84:\"CreateSpace Independent Publishing Platform; 1st Edition edition (February 27, 2013)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1482651130\";s:7:\"ISBN-13\";s:14:\"978-1482651133\";s:18:\"Product Dimensions\";s:22:\"0.2 x 5.9 x 8.9 inches\";s:15:\"Shipping Weight\";s:10:\"5.3 ounces\";}");
INSERT INTO `wp_postmeta` VALUES("475", "87", "asg_star_rating", "4.2");
INSERT INTO `wp_postmeta` VALUES("476", "87", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:41:\"Basic overview with a few good highlights\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:16:\"February 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3FYY27VC97MC4/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:12:\"Francesca CH\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:32:\"Certainly this is going to help!\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"February 2, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2JYAO7G2LWH25/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:8:\"Logic101\";s:7:\"address\";s:12:\"Planet Earth\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:14:\"Thorough guide\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"February 3, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A283KQWMSZ6ES/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:4:\"Mark\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:64:\"New (and not so new) Authors Will Benefit From Reading This Book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"October 5, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3CCJHAG2GG966/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:8:\"Britinus\";s:7:\"address\";s:18:\"S. California, USA\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:19:\"Good advice, but...\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:12:\"July 8, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A235IS8COAHMM3/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:10:\"Traci Otte\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:5:\"Great\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"July 7, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1LUEHLAH569VX/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:5:\"Krazy\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:61:\"Great introduction ...I really enjoyed the section on reviews\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"July 1, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A26MHWRDUSIFT6/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:48:\"Trudy Scott, author of The Antianxiety Food S...\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:57:\"Most Clear And Concise How To Write A Kindle Best Seller!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3LTVPU076TI3Q/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:24:\"Sippriano \"Love To Read\"\";s:7:\"address\";s:13:\"United States\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:10:\"Great book\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 27, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A23PEDPYB8D170/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:1:\"x\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:19:\"Excellent Resource!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"January 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A228E3KMAQ395V/ref=cm_cr_pr_pdp/179-4882919-8231112\";s:4:\"name\";s:10:\"nhgirl1970\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("477", "87", "asg_last_refresh_attempt", "1391195304");
INSERT INTO `wp_postmeta` VALUES("478", "87", "asg_update_timestamp", "1391195304");
INSERT INTO `wp_postmeta` VALUES("479", "88", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("480", "88", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("481", "88", "asg_item_id", "B00D9IDSJU");
INSERT INTO `wp_postmeta` VALUES("482", "88", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B00D9IDSJU\";s:13:\"DetailPageURL\";s:229:\"http://www.amazon.com/Kindle-Bestseller-Secrets-Bestselling-Non-Fiction-ebook/dp/B00D9IDSJU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00D9IDSJU\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:239:\"http://www.amazon.com/Kindle-Bestseller-Secrets-Bestselling-Non-Fiction-ebook/dp/tech-data/B00D9IDSJU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB00D9IDSJU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB00D9IDSJU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00D9IDSJU%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B00D9IDSJU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B00D9IDSJU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B00D9IDSJU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB00D9IDSJU\";}}}s:9:\"SalesRank\";s:5:\"62510\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"114\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"357\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"54\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"79\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"114\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51cFJaqVGXL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"357\";}}}s:14:\"ItemAttributes\";a:11:{s:6:\"Author\";s:13:\"Derek Doepker\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:13:\"NumberOfPages\";s:3:\"107\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-26\";s:11:\"ReleaseDate\";s:10:\"2013-12-26\";s:5:\"Title\";s:91:\"Kindle Bestseller Secrets: 10 Tricks Bestselling Non-Fiction Authors Use To Dominate Kindle\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:192:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00D9IDSJU&atag=freetos-20&exp=2014-02-01T19%3A08%3A24Z&v=2&sig=k1RGcVgXuWwYzleX5YudnmEMYLweNKrVTCzR3YPhDEE%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2905:\"<b>\"Your book is better than all of the other \"how to\" kindle guidebooks put together!   I own at least 50 and yours is FAR superior to ALL of the others.\" - Author Gary Yantis</b>\n<br />\n<br /><h2>Want Your Kindle Book To Be A #1 Bestseller?</h2>\n<br />You\'re about to discover the secrets I used to go from struggling self published author to outranking the biggest publishers, hitting #1 best seller status in one of the most competitive categories, and doing it all without a big budget, fan base or spending hours on promotions. \n<br />\n<br />Results like this shouldn\'t be possible for someone self publishing.  But they are when you use the step-by-step blueprint revealed in this book.\n<br />\n<br />Don\'t waste another second of your time or hard earned dollar marketing your book until you know:\n<br />\n<br />• How bestselling authors guarantee they\'ll make a lot of sales before they write a single word.  Almost all \"average\" authors skip this step and are doomed from the start!  \n<br />\n<br />• How to see what books people crave so you deliver a red-hot book people will beg you to buy!\n<br />\n<br />• How to position yourself in a niche so you’re seen as hands-down the *best* choice among the competition!\n<br />\n<br />• How to utilize simple psychological tactics in your description that practically FORCE people to buy your book!\n<br />\n<br />• How to get your books in front of thousands and thousands of fans on a shoestring budget.  Note: This trick helped shoot my book up to #1 bestseller in under a week!\n<br />\n<br />• How to use a 5 second “trick” to sell more books and increase your royalties by up to 500%!\n<br />\n<br />• How to double, triple, or even quadruple your income from every single book you sell!\n<br />\n<br />• And much more!\n<br />\n<br />If you wish you could call yourself a bestselling author...\n<br />\n<br />If you wish you never had to waste another second or dollar on ineffective marketing techniques...\n<br />\n<br />If you wish you knew the strategies you can use to literally outsell the biggest names in ALL of book publishing...\n<br />\n<br />Then Kindle Bestseller Secrets is the book you\'ve wished for.  Click buy today!\n<br />\n<br /><b>About The Author:</b>\n<br />\n<br />I\'ve earned over $5,383 in royalties in 11 days from a single kindle book, taught over 1,300 students from all over the world how to market their kindle books, and regularly network with many of the world\'s top kindle authors.  \n<br />\n<br />When you buy Kindle Bestseller Secrets, you\'re not only getting my insights, but the distilled wisdom from numerous bestselling kindle authors all revealed in one book.  I created this book to be the \"go-to\" guide on kindle self publishing and marketing.  It is the book I wish I had when I first got into publishing, and now I\'m giving back to fellow authors by offering my best insights in one easy to read guide.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("483", "88", "asg_product_details", "a:9:{s:9:\"File Size\";s:6:\"789 KB\";s:12:\"Print Length\";s:9:\"107 pages\";s:25:\"Simultaneous Device Usage\";s:9:\"Unlimited\";s:7:\"Sold by\";s:31:\" Amazon Digital Services, Inc.\";s:8:\"Language\";s:7:\"English\";s:4:\"ASIN\";s:10:\"B00D9IDSJU\";s:14:\"Text-to-Speech\";s:7:\"Enabled\";s:5:\"X-Ray\";s:7:\"Enabled\";s:7:\"Lending\";s:7:\"Enabled\";}");
INSERT INTO `wp_postmeta` VALUES("484", "88", "asg_star_rating", "4.7");
INSERT INTO `wp_postmeta` VALUES("485", "88", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:91:\"Kindle Bestseller Secrets: 10 Tricks Bestselling Non-Fiction Authors Use To Dominate Kindle\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AM79PTM4ZP9K1/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:20:\"S. ROYSTONE NEVERSON\";s:7:\"address\";s:30:\"Trinidad And Tobago, Caribbean\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:62:\"Easy to read, informative information on Kindle Book Marketing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 18, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A15O7GZ9946BR8/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:11:\"Nick Vulich\";s:7:\"address\";s:4:\"Iowa\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:37:\"Really good book for Kindle marketing\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"December 24, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AXR1SRGSEECG5/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:48:\"Eddie Coronado \"Author of &#34;MANIFEST YOUR ...\";s:7:\"address\";s:17:\"New York City, NY\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:49:\"Simply a great book. One of the best of its kind.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"December 6, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/ALTPNZ4MVHIVZ/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:15:\"Henry A. Palmer\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:23:\"Great info, tips galore\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"October 14, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A16G75DEM8SNZD/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:48:\"Sandra K. Gibbs Bouie \"Sandra K. Bouie, Freel...\";s:7:\"address\";s:9:\"Ohio, USA\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:50:\"How To Write Kindle Book That Will Be Best Seller!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 21, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3VIZ99VZ8HSIK/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:17:\"Thordur \"Thordur\"\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:30:\"advice for NON-FICTION authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:16:\"October 16, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/A6TVEQY3WJ10P/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:4:\"Lori\";s:7:\"address\";s:30:\"GRAND LEDGE, MI, United States\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:12:\"Solid Advice\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:17:\"December 12, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A129CLOPE6382X/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:48:\"Angela (a.k.a S.M. Welles) \"author and gamer ...\";s:7:\"address\";s:11:\"Safford, AZ\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:9:\"Pure gold\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 21, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1AQF96R73ZK5U/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:25:\"Helen C. Page \"Duncreavy\"\";s:7:\"address\";s:13:\"San Francisco\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:20:\"Delivers as Promised\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:16:\"January 16, 2014\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A3ABV1NEY4RFA5/ref=cm_cr_pr_pdp/188-9371645-1695613\";s:4:\"name\";s:9:\"anonymous\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("486", "88", "asg_last_refresh_attempt", "1391195307");
INSERT INTO `wp_postmeta` VALUES("487", "88", "asg_update_timestamp", "1391195307");
INSERT INTO `wp_postmeta` VALUES("488", "89", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("489", "89", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("490", "89", "asg_item_id", "B007D3STJG");
INSERT INTO `wp_postmeta` VALUES("491", "89", "asg_amazon_data", "a:11:{s:4:\"ASIN\";s:10:\"B007D3STJG\";s:13:\"DetailPageURL\";s:216:\"http://www.amazon.com/Market-Your-EBooks-Resources-Authors-ebook/dp/B007D3STJG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007D3STJG\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:226:\"http://www.amazon.com/Market-Your-EBooks-Resources-Authors-ebook/dp/tech-data/B007D3STJG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3DB007D3STJG%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3DB007D3STJG%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3DB007D3STJG%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/B007D3STJG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/B007D3STJG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/B007D3STJG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3DB007D3STJG\";}}}s:9:\"SalesRank\";s:6:\"616880\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51GllyP2RML.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"375\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"22\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"56\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"82\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51GllyP2RML._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"120\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51GllyP2RML.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"375\";}}}s:14:\"ItemAttributes\";a:16:{s:6:\"Author\";s:11:\"Mike McCann\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:7:\"Edition\";s:1:\"1\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:20:\"Global Business Cafe\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:20:\"Global Business Cafe\";s:13:\"NumberOfPages\";s:3:\"179\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2012-02-23\";s:9:\"Publisher\";s:20:\"Global Business Cafe\";s:11:\"ReleaseDate\";s:10:\"2012-02-23\";s:6:\"Studio\";s:20:\"Global Business Cafe\";s:5:\"Title\";s:73:\"How to Market Your EBooks, Over 300 Resources to Help Authors Sell EBooks\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:194:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B007D3STJG&atag=freetos-20&exp=2014-02-01T19%3A08%3A27Z&v=2&sig=Ivso27MCa2ISLZdZwG7AhX5WawB3Dc8q%2BdFcA7pfPmY%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:1677:\"You’ve written an eBook. Now what? Mike McCann shares award-winning steps and techniques for marketing eBooks into a full time income in \"How to Market Your EBooks.\"<br /><br />“Mike has more than 300 hyperlinked resources an eBook author can immediately use. ” <br />Mark Winters<br />Austin, TX<br /><br />“I can be busy eight hours+/day from the ideas Mike includes in this eBook…”<br />Carol Jenkins<br />Richmond, VA<br /><br />“Mike has many techniques on marketing an eBook in one place. More than I’ve seen.”<br />Jason Williard<br />Tacoma, WA<br /><br />\"How to Market Your EBooks\" guides eBook (and print) authors through creating a marketing plan and strategy for the digital world while developing a full-time comfortable income.<br /><br />In \"How to Market Your EBooks,\" learn how to reach out and “connect” with readers by:<br />• developing a professional website and blog<br />• implementing an effective publicity plan<br />• having effective guest appearances on radio and TV<br />• creating and populating a YouTube channel for promoting your eBook<br />• effectively and creatively using social networking channels and,<br />• participating in blog tours and book video trailers without traveling.<br /><br />\"How to Market Your EBooks\" also reveals little known techniques on how to use “sales nodes” and “price pulsing” to increase eBook sales.<br /><br />Readers of \"How to Market Your EBooks\" are invited to join the monthly eBook marketing updates (details on last page of book). If you want to sell eBooks with the opportunity to create a full-time income, then \"How to Market Your EBooks\" is for you!<br />\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("492", "89", "asg_customer_reviews", "a:5:{i:0;a:5:{s:5:\"title\";s:35:\"Solid, Valuable, Meaningful Content\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"March 21, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1K4RR9RMQAY1Q/ref=cm_cr_pr_pdp/190-9965978-8301033\";s:4:\"name\";s:17:\"Robert Alan Black\";s:7:\"address\";s:10:\"Athens, GA\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:19:\"A valuable resource\";s:4:\"star\";s:3:\"4.0\";s:4:\"date\";s:14:\"March 30, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1WRHX5S04UT6L/ref=cm_cr_pr_pdp/190-9965978-8301033\";s:4:\"name\";s:25:\"Doug Briggs \"Doug Briggs\"\";s:7:\"address\";s:12:\"La Porte, TX\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:25:\"What a wonderful resource\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:14:\"April 23, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A39FE01PYV3R0S/ref=cm_cr_pr_pdp/190-9965978-8301033\";s:4:\"name\";s:11:\"@fredfelton\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:25:\"Was I expecting too much?\";s:4:\"star\";s:3:\"3.0\";s:4:\"date\";s:12:\"May 19, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AYHN143TK8ZP2/ref=cm_cr_pr_pdp/190-9965978-8301033\";s:4:\"name\";s:20:\"Mishael Austin Witty\";s:7:\"address\";s:13:\"Kentucky, USA\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:20:\"A Wonderful Resource\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:12:\"May 18, 2012\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A27LBL1TY75NR7/ref=cm_cr_pr_pdp/190-9965978-8301033\";s:4:\"name\";s:15:\"Amazon Customer\";s:7:\"address\";s:24:\"LEWES, DE, United States\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("493", "89", "asg_last_refresh_attempt", "1391195308");
INSERT INTO `wp_postmeta` VALUES("494", "89", "asg_update_timestamp", "1391195308");
INSERT INTO `wp_postmeta` VALUES("495", "90", "asg_version", "04.02.01");
INSERT INTO `wp_postmeta` VALUES("496", "90", "asg_amazon_market", "US");
INSERT INTO `wp_postmeta` VALUES("497", "90", "asg_item_id", "1490590919");
INSERT INTO `wp_postmeta` VALUES("498", "90", "asg_amazon_data", "a:13:{s:4:\"ASIN\";s:10:\"1490590919\";s:13:\"DetailPageURL\";s:194:\"http://www.amazon.com/How-To-Market-A-Book/dp/1490590919%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1490590919\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:7:{i:0;a:2:{s:11:\"Description\";s:17:\"Technical Details\";s:3:\"URL\";s:204:\"http://www.amazon.com/How-To-Market-A-Book/dp/tech-data/1490590919%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}i:1;a:2:{s:11:\"Description\";s:20:\"Add To Baby Registry\";s:3:\"URL\";s:212:\"http://www.amazon.com/gp/registry/baby/add-item.html%3Fasin.0%3D1490590919%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}i:2;a:2:{s:11:\"Description\";s:23:\"Add To Wedding Registry\";s:3:\"URL\";s:215:\"http://www.amazon.com/gp/registry/wedding/add-item.html%3Fasin.0%3D1490590919%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}i:3;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.com/gp/registry/wishlist/add-item.html%3Fasin.0%3D1490590919%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}i:4;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.com/gp/pdp/taf/1490590919%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}i:5;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.com/review/product/1490590919%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}i:6;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.com/gp/offer-listing/1490590919%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";}}}s:9:\"SalesRank\";s:5:\"70188\";s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:2:{i:0;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/51XAL6Ky6JL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}i:1;a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"variant\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51CCZCuLY%2BL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"20\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51CCZCuLY%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:62:\"http://ecx.images-amazon.com/images/I/51CCZCuLY%2BL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"50\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51CCZCuLY%2BL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"73\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:63:\"http://ecx.images-amazon.com/images/I/51CCZCuLY%2BL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"107\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:55:\"http://ecx.images-amazon.com/images/I/51CCZCuLY%2BL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"333\";}}}}s:14:\"ItemAttributes\";a:22:{s:6:\"Author\";s:11:\"Joanna Penn\";s:7:\"Binding\";s:9:\"Paperback\";s:3:\"EAN\";s:13:\"9781490590912\";s:7:\"EANList\";a:1:{s:14:\"EANListElement\";s:13:\"9781490590912\";}s:7:\"Edition\";s:1:\"1\";s:4:\"ISBN\";s:10:\"1490590919\";s:20:\"IsEligibleForTradeIn\";s:1:\"1\";s:14:\"ItemDimensions\";a:4:{s:6:\"Height\";s:3:\"890\";s:6:\"Length\";s:2:\"59\";s:6:\"Weight\";s:2:\"83\";s:5:\"Width\";s:3:\"591\";}s:5:\"Label\";s:43:\"CreateSpace Independent Publishing Platform\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:3:{i:0;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:7:\"Unknown\";}i:1;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:17:\"Original Language\";}i:2;a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}}s:9:\"ListPrice\";a:3:{s:6:\"Amount\";s:4:\"1295\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$12.95\";}s:12:\"Manufacturer\";s:43:\"CreateSpace Independent Publishing Platform\";s:13:\"NumberOfItems\";s:1:\"1\";s:13:\"NumberOfPages\";s:3:\"278\";s:17:\"PackageDimensions\";a:4:{s:6:\"Height\";s:2:\"70\";s:6:\"Length\";s:3:\"890\";s:6:\"Weight\";s:3:\"105\";s:5:\"Width\";s:3:\"600\";}s:12:\"ProductGroup\";s:4:\"Book\";s:15:\"ProductTypeName\";s:9:\"ABIS_BOOK\";s:15:\"PublicationDate\";s:10:\"2013-08-09\";s:9:\"Publisher\";s:43:\"CreateSpace Independent Publishing Platform\";s:6:\"Studio\";s:43:\"CreateSpace Independent Publishing Platform\";s:5:\"Title\";s:20:\"How To Market A Book\";s:12:\"TradeInValue\";a:3:{s:6:\"Amount\";s:3:\"178\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$1.78\";}}s:12:\"OfferSummary\";a:6:{s:14:\"LowestNewPrice\";a:3:{s:6:\"Amount\";s:3:\"961\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$9.61\";}s:15:\"LowestUsedPrice\";a:3:{s:6:\"Amount\";s:3:\"962\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$9.62\";}s:8:\"TotalNew\";s:2:\"14\";s:9:\"TotalUsed\";s:1:\"7\";s:16:\"TotalCollectible\";s:1:\"0\";s:16:\"TotalRefurbished\";s:1:\"0\";}s:6:\"Offers\";a:4:{s:11:\"TotalOffers\";s:1:\"1\";s:15:\"TotalOfferPages\";s:1:\"1\";s:13:\"MoreOffersUrl\";s:187:\"http://www.amazon.com/gp/offer-listing/1490590919%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D386001%26creativeASIN%3D1490590919\";s:5:\"Offer\";a:3:{s:8:\"Merchant\";a:1:{s:4:\"Name\";s:10:\"Amazon.com\";}s:15:\"OfferAttributes\";a:1:{s:9:\"Condition\";s:3:\"New\";}s:12:\"OfferListing\";a:7:{s:14:\"OfferListingId\";s:130:\"Ug7UpT3vllugMJHUNBrFBs%2FTJvY2fbB06AesejmwAi0ahR9XvagH3x%2F7ELO83XI%2FMWwMQC28CgmHX9FzKbfgFkT2GC7fY6Jkz9B8WXwj5vXn5POKkzmxcQ%3D%3D\";s:5:\"Price\";a:3:{s:6:\"Amount\";s:4:\"1083\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:6:\"$10.83\";}s:11:\"AmountSaved\";a:3:{s:6:\"Amount\";s:3:\"212\";s:12:\"CurrencyCode\";s:3:\"USD\";s:14:\"FormattedPrice\";s:5:\"$2.12\";}s:15:\"PercentageSaved\";s:2:\"16\";s:12:\"Availability\";s:25:\"Usually ships in 24 hours\";s:22:\"AvailabilityAttributes\";a:3:{s:16:\"AvailabilityType\";s:3:\"now\";s:12:\"MinimumHours\";s:2:\"24\";s:12:\"MaximumHours\";s:2:\"24\";}s:31:\"IsEligibleForSuperSaverShipping\";s:1:\"1\";}}}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:196:\"http://www.amazon.com/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=1490590919&atag=freetos-20&exp=2014-02-01T19%3A08%3A28Z&v=2&sig=OX%2F6RelxeNe%2FoqeB2eRwqii2Xs1HT7L3wM3a6kYFSYw%3D\";s:10:\"HasReviews\";s:4:\"true\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:1:{i:0;a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:2646:\"<b>                  The first job of an author is, of course, to write great books, but these days, their second job is to market them. </b><br><br>Marketing isn\'t a skill that most authors have naturally, and there is little formal training. But when your book hits the shelves, and the sales don\'t start rolling in, there\'s only two things an author can do. Keep writing more books and ... Get to grips with marketing. <br><br><b>This book is for authors who want to sell more books, but it\'s also for those writers who want to think more like an entrepreneur. </b><br><br>It\'s for traditionally published authors who want to take control of their future, and for self-published authors who want to jump-start a career. <br><br>There are some <b>short-term tactics</b> for those who want to kick up immediate sales, but the focus of the book is more about <b>instilling values and marketing principles</b> that will help your long-term career as a writer. <br><br>It\'s also about <b>going beyond just the book</b>, because the methods in this guide can take you from being an author into professional speaking, making money from other products and creating opportunities that you can\'t even imagine yet. <br><br>There are no rules in this game, but learning this kind of authentic marketing has certainly changed my life, so read on and I\'ll share everything I know with you. <br><br>How To Market A Book covers an extensive range of marketing principles, strategies and tactics:     <br><br><b>* Part 1: Marketing Principles</b> - including myths, how to balance your time, co-opetition and generosity     <br><b>* Part 2: Prerequisites for Success</b> - including an understanding of yourself and your target market, professional editing and cover design, your book page on the retailer websites, pricing and the use of free     <br><b>* Part 3: No Platform Needed - Short-term Marketing</b> - including how to get book reviews, paid advertising, using traditional media and tips for TV, radio and press releases <br><b>* Part 4: The Author Platform - Long-term Marketing</b> - including the reasons why a platform is a good thing, author branding, your author website, list-building and email marketing, content marketing and blogging, audio and podcasting, video and book trailers, social networking, professional speaking, and becoming an author-entrepreneur.     <br><b>Part 5: Launching Your Book</b> - including how launching has changed, soft launch, launch spikes, post launch and relaunches as well as lessons learned from some major book launches. Plus/ tips for when you get overwhelmed and plenty more links to further resources.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}}");
INSERT INTO `wp_postmeta` VALUES("499", "90", "asg_product_details", "a:7:{s:9:\"Paperback\";s:9:\"278 pages\";s:9:\"Publisher\";s:71:\"CreateSpace Independent Publishing Platform; 1 edition (August 9, 2013)\";s:8:\"Language\";s:7:\"English\";s:7:\"ISBN-10\";s:10:\"1490590919\";s:7:\"ISBN-13\";s:14:\"978-1490590912\";s:18:\"Product Dimensions\";s:22:\"0.6 x 5.9 x 8.9 inches\";s:15:\"Shipping Weight\";s:8:\"1 pounds\";}");
INSERT INTO `wp_postmeta` VALUES("500", "90", "asg_star_rating", "4.9");
INSERT INTO `wp_postmeta` VALUES("501", "90", "asg_customer_reviews", "a:10:{i:0;a:5:{s:5:\"title\";s:52:\"Joanna not only talks the talk but walks the walk...\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2EX1NIVAENBHZ/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:12:\"James Minter\";s:7:\"address\";s:14:\"Cheltenham, UK\";}s:4:\"text\";s:0:\"\";}i:1;a:5:{s:5:\"title\";s:36:\"Interesting, informative, invaluable\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1QUQJ8U92AZC4/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:5:\"Gilly\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:2;a:5:{s:5:\"title\";s:64:\"excellent guide on book marketing and brand building for authors\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"July 22, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:66:\"/gp/pdp/profile/AKVB8G2299EYS/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:16:\"GRIGORY RYZHAKOV\";s:7:\"address\";s:10:\"London, UK\";}s:4:\"text\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:18:\"Lots of good tips!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 29, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36JDVLIN8VBL3/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:29:\"Derek Murphy \"(Creativindie)\"\";s:7:\"address\";s:88:\"I rarely stay in the same country for long, currently migrating through Europe and Asia.\";}s:4:\"text\";s:0:\"\";}i:4;a:5:{s:5:\"title\";s:34:\"Marketing for authors by an author\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:13:\"June 28, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A31DPTQFIRG4ZS/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:23:\"turnerpage \"turnerpage\"\";s:7:\"address\";s:13:\"Hampshire, UK\";}s:4:\"text\";s:0:\"\";}i:5;a:5:{s:5:\"title\";s:23:\"An All-Inclusive Guide.\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 11, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2IHDQ6F9UCU74/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:26:\"DerekAlanWilkinson Dot Com\";s:7:\"address\";s:14:\"Charleston, WV\";}s:4:\"text\";s:0:\"\";}i:6;a:5:{s:5:\"title\";s:24:\"Glad that i purchased it\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 17, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2V1PV0LH1TARE/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:6:\"Guitry\";s:7:\"address\";s:0:\"\";}s:4:\"text\";s:0:\"\";}i:7;a:5:{s:5:\"title\";s:51:\"Best book on the subject (in my limited experience)\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:18:\"September 10, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A36QZ59YFK3CEO/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:8:\"A. Smith\";s:7:\"address\";s:20:\"West Tisbury, MA USA\";}s:4:\"text\";s:0:\"\";}i:8;a:5:{s:5:\"title\";s:14:\"A MUST READ!!!\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:17:\"September 2, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A1YMDHRAZ26OKX/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:48:\"Aleshia Robinson \"Author of Love, God & Tattoos\"\";s:7:\"address\";s:11:\"Atlanta, GA\";}s:4:\"text\";s:0:\"\";}i:9;a:5:{s:5:\"title\";s:9:\"Excellent\";s:4:\"star\";s:3:\"5.0\";s:4:\"date\";s:15:\"August 30, 2013\";s:6:\"author\";a:3:{s:3:\"url\";s:67:\"/gp/pdp/profile/A2IIX40X7L0VUL/ref=cm_cr_pr_pdp/186-5541237-6949256\";s:4:\"name\";s:15:\"Christine Nolfi\";s:7:\"address\";s:14:\"South Carolina\";}s:4:\"text\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("502", "90", "asg_last_refresh_attempt", "1391195310");
INSERT INTO `wp_postmeta` VALUES("503", "90", "asg_update_timestamp", "1391195310");
INSERT INTO `wp_postmeta` VALUES("504", "41", "asg_UK_amazon_data", "a:10:{s:4:\"ASIN\";s:10:\"B00HEWI7AM\";s:13:\"DetailPageURL\";s:211:\"http://www.amazon.co.uk/Ebook-Marketing-Convert-A-Book-ebook/dp/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dbrooks-21%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HEWI7AM\";s:9:\"ItemLinks\";a:1:{s:8:\"ItemLink\";a:4:{i:0;a:2:{s:11:\"Description\";s:15:\"Add To Wishlist\";s:3:\"URL\";s:216:\"http://www.amazon.co.uk/gp/registry/wishlist/add-item.html%3Fasin.0%3DB00HEWI7AM%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dbrooks-21%26linkCode%3Dxm2%26camp%3D2025%26creative%3D12734%26creativeASIN%3DB00HEWI7AM\";}i:1;a:2:{s:11:\"Description\";s:13:\"Tell A Friend\";s:3:\"URL\";s:181:\"http://www.amazon.co.uk/gp/pdp/taf/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dbrooks-21%26linkCode%3Dxm2%26camp%3D2025%26creative%3D12734%26creativeASIN%3DB00HEWI7AM\";}i:2;a:2:{s:11:\"Description\";s:20:\"All Customer Reviews\";s:3:\"URL\";s:185:\"http://www.amazon.co.uk/review/product/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dbrooks-21%26linkCode%3Dxm2%26camp%3D2025%26creative%3D12734%26creativeASIN%3DB00HEWI7AM\";}i:3;a:2:{s:11:\"Description\";s:10:\"All Offers\";s:3:\"URL\";s:187:\"http://www.amazon.co.uk/gp/offer-listing/B00HEWI7AM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dbrooks-21%26linkCode%3Dxm2%26camp%3D2025%26creative%3D12734%26creativeASIN%3DB00HEWI7AM\";}}}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"110\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"344\";}s:9:\"ImageSets\";a:1:{s:8:\"ImageSet\";a:7:{s:11:\"@attributes\";a:1:{s:8:\"Category\";s:7:\"primary\";}s:11:\"SwatchImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL30_.jpg\";s:6:\"Height\";s:2:\"30\";s:5:\"Width\";s:2:\"21\";}s:10:\"SmallImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:14:\"ThumbnailImage\";a:3:{s:3:\"URL\";s:60:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL75_.jpg\";s:6:\"Height\";s:2:\"75\";s:5:\"Width\";s:2:\"52\";}s:9:\"TinyImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL110_.jpg\";s:6:\"Height\";s:3:\"110\";s:5:\"Width\";s:2:\"76\";}s:11:\"MediumImage\";a:3:{s:3:\"URL\";s:61:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL._SL160_.jpg\";s:6:\"Height\";s:3:\"160\";s:5:\"Width\";s:3:\"110\";}s:10:\"LargeImage\";a:3:{s:3:\"URL\";s:53:\"http://ecx.images-amazon.com/images/I/31npp2LJmOL.jpg\";s:6:\"Height\";s:3:\"500\";s:5:\"Width\";s:3:\"344\";}}}s:14:\"ItemAttributes\";a:15:{s:6:\"Author\";s:14:\"Convert A Book\";s:7:\"Binding\";s:14:\"Kindle Edition\";s:6:\"Format\";s:12:\"Kindle eBook\";s:14:\"IsAdultProduct\";s:1:\"0\";s:5:\"Label\";s:14:\"Convert A Book\";s:9:\"Languages\";a:1:{s:8:\"Language\";a:2:{s:4:\"Name\";s:7:\"English\";s:4:\"Type\";s:9:\"Published\";}}s:12:\"Manufacturer\";s:14:\"Convert A Book\";s:13:\"NumberOfPages\";s:1:\"3\";s:12:\"ProductGroup\";s:6:\"eBooks\";s:15:\"ProductTypeName\";s:11:\"ABIS_EBOOKS\";s:15:\"PublicationDate\";s:10:\"2013-12-17\";s:9:\"Publisher\";s:14:\"Convert A Book\";s:11:\"ReleaseDate\";s:10:\"2013-12-17\";s:6:\"Studio\";s:14:\"Convert A Book\";s:5:\"Title\";s:15:\"Ebook Marketing\";}s:15:\"CustomerReviews\";a:2:{s:9:\"IFrameURL\";s:193:\"http://www.amazon.co.uk/reviews/iframe?akid=AKIAJULJCU4YH7LDDYQA&alinkCode=xm2&asin=B00HEWI7AM&atag=brooks-21&exp=2014-02-01T19%3A08%3A58Z&v=2&sig=2AhCPHHb46uhzuPWC8a9ltN5mdCM5YjeKGWIg8gNxdc%3D\";s:10:\"HasReviews\";s:5:\"false\";}s:16:\"EditorialReviews\";a:1:{s:15:\"EditorialReview\";a:3:{s:6:\"Source\";s:19:\"Product Description\";s:7:\"Content\";s:93:\"A few simple tricks to help you leap over the competition - Ebook publishing tips and tricks.\";s:16:\"IsLinkSuppressed\";s:1:\"0\";}}}");
INSERT INTO `wp_postmeta` VALUES("505", "41", "asg_UK_update_timestamp", "1391195338");
INSERT INTO `wp_postmeta` VALUES("506", "41", "lazy_seo_meta_key", "");
INSERT INTO `wp_postmeta` VALUES("507", "41", "lazy_seo_meta_key_geo", "geo1");
INSERT INTO `wp_postmeta` VALUES("508", "91", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("509", "91", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("510", "91", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("511", "91", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("512", "91", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("513", "91", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("514", "91", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("515", "91", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("517", "90", "_edit_lock", "1391196474:1");
INSERT INTO `wp_postmeta` VALUES("520", "41", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("522", "41", "_edit_lock", "1391196617:1");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2013-12-06 17:13:19", "2013-12-06 17:13:19", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png\"><img class=\"alignleft size-full wp-image-19\" alt=\"jimmy-157594_150\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png\" width=\"111\" height=\"150\" /></a>Internet Marketing as we all know it is pretty crowded with funny people making lots of huge bombastic claims over their nonsense crappy books and stuff. You might have come across ebooks making claims like \"how to make $XXX in 2 weeks\" or \"anyone can earn money at home\".\r\n\r\nBeing guilty of myself, I have literally spent gazillion amount of money into these internet marketing ebooks when I started out but only to find it later at those free-for-all ebooks directories, free membership sites or even those giveaway sites.  Though it\'s a sad experience to see youself spending money into something which could be downloaded somewhere over the Internet for free, there are still some good ebooks and materials which you should buy. Here are some of the guidelines which you should know of before you start your spending spree.\r\n\r\nDon\'t Spend Money On Junk Don\'t spend your money on something that tells you that with no experience you can make a lot of money. Typically this stuff is nothing more than trying to sell you pie in the sky. You can always learn and equipped yourself with knowledge from other free ebooks, newsletters or forums before spending your money on these ebooks.<!--more-->\r\n\r\nOnly Buy From The Experts Who Are Successful Themselves The most advertised ebooks are not always the best. Good stuff will naturally come to you either by way of constant good reviews from other Internet Marketers, word of mouth, buzz from forums or discussion boards and even testimonials from the actual people who use them. Thus, you should always buy from the recognized experts who have had tons of experience under their belt and also reputable results to back up their claims.\r\n\r\nBuy Only On What You Actually Need. It\'s no point to spend your hard earned money on whatever ebooks or internet marketing materials which you come across, however good the claims are on the sales copy. Remember, good sales copy is supposed to play around the prospects\' psychology behaviors into believing their actual claims. That\'s why professional copywriters charge tens of thousands for great sales copy because they do bring in lots of sales just by selling hype. You should only spend money on ebooks which could help you move on in your business. For example, if you feel that you are lack in copywriting skills, then you ought to buy copywriting materials from the professionals.\r\n\r\nTaking Action Is The Best Action You Can Make. Let\'s face it, how many of us who could spend a bomb in our internet marketing materials but only to find it lying around in our computer hard disk for ages? The fact is, no matter how good or how expensive or even how reputable the ebooks that you\'ve bought, it doesn\'t matter until you make the first step into implementing the materials which you learn from the ebooks. If you are new to Internet Marketing, then you should only buy ebooks that will teach you step by step in setting up your Internet Marketing business. Otherwise, stay away from them.\r\n\r\nHardcopy VS Intangible Books There had been discussions going on which debate just how good are those Internet Marketing books found on the bookstores compared to those on the Internet. While I couldn\'t agree more on some of the great Internet Marketing books you can find on the bookshelves, but in reality, most of the books I found cover only general concepts of the Internet Marketing. For example, in the business or internet marketing section of the bookstore, you might find stuff like \"how to make money online\" if you are looking for a book on internet marketing, but you can find a more specific ebook on the internet on \"How to Get Successful Reciprocal Linking\" or something like that. Both of these are related to Internet Marketing, but the latter tends to be more specific in their scope. Like what I\'ve mentioned in the previous point, you should know what you are lack of and buy ebooks that will help you move forward in your business. If you are just starting out, internet marketing books in the bookstore will serve just as good as the newbie ebooks online.\r\n\r\nAs a conclusion, make sure you know who you can trust online before buying from them. There are lots of these self-proclaim internet Marketing Gurus who are just like the average Joe struggling to make money online. Remember, there are bunch of those great forums and discussion boards which not only you could find great pieces of information, but also the chance to pose questions as well.\r\n\r\n&nbsp;", "Can You Make Money With Ebooks?", "", "publish", "open", "open", "", "hello-world", "", "", "2014-01-31 18:17:52", "2014-01-31 18:17:52", "", "0", "http://blogsforsales.com/ebooks/?p=1", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("2", "1", "2013-12-06 17:13:19", "2013-12-06 17:13:19", "How do you react when your plans fall through?  Do you roll with the punches?  Or does anxiety keep you from enjoying life?  To a great extent, our personality determines how we deal with stress in our lives, but here are 5 things to help keep your stress under control:\r\n\r\n1.    Sleep more.  It’s very common in our society to exist on less than 6 hours of sleep a night.  But experts keep telling us we need at least 8 hours.  Not just to rest our bodies, but to rejuvenate our minds.  “Tired” and “cranky” seem to go hand in hand.  Don’t use your bedroom to watch the news or finish up some work from the office.  Make that room your haven, a place to relax and escape the day.  Have a hot cup of tea, take a warm bath, or read a paperback to help you unwind.\r\n\r\n2.    Have faith.  Saying a short prayer in times of stress can give you a sense of calm, especially when the situation is one you really have no control over.  Studies have shown that people who trust in a higher power have lower blood pressure.  Being able to forgive people also can affect your blood pressure.  Holding a grudge is not good for your health!\r\n\r\n3.    Turn it off.  The convenience that cell phones have added to our lives can actually be a double-edged sword.  We depend on them so much it seems we can’t live without them.  This increased accessibility means not only can our loved ones reach us at any time, but so can work.  If your employer legitimately needs to have your cell phone number, make sure you set clear limits on when you can and cannot be reached.  Your time off is yours.\r\n\r\n4.    Take a holiday.  It doesn’t have to be a fancy vacation resort.  A day at the beach, or an afternoon at the park will do.  Just anywhere you can be and not think about the bills, work, or whatever tensions you may have.  It’s important to take time for yourself, so do it!  You’ll feel better with a fresh outlook.\r\n\r\n5.    Treat yourself.  Sign up for a yoga class at your local gym or community center.  The costs are nominal, and you’ll feel more relaxed after even just one session.  A monthly massage or a spa treatment is also a great way to recharge.  You’ll walk out feeling like a million dollar bowl of jelly.\r\n\r\nStress is unavoidable.  But what we do about it is up to us.  Experiment with these suggestions and see what works for you!", "Home", "", "publish", "open", "open", "", "sample-page", "", "", "2013-12-08 12:57:17", "2013-12-08 12:57:17", "", "0", "http://blogsforsales.com/ebooks/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2013-12-08 12:50:50", "2013-12-08 12:50:50", "", "str__0008_sky", "", "inherit", "closed", "open", "", "str__0008_sky", "", "", "2013-12-08 12:50:50", "2013-12-08 12:50:50", "", "0", "http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/str__0008_sky.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2013-12-08 12:55:23", "2013-12-08 12:55:23", " ", "", "", "publish", "closed", "open", "", "14", "", "", "2014-01-31 19:27:39", "2014-01-31 19:27:39", "", "0", "http://blogsforsales.com/ebooks/?p=14", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2013-12-08 12:55:54", "2013-12-08 12:55:54", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\r\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like piña coladas. (And gettin\' caught in the rain.)</blockquote>\r\n...or something like this:\r\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\r\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/ebooks/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Home", "", "inherit", "closed", "open", "", "2-revision-v1", "", "", "2013-12-08 12:55:54", "2013-12-08 12:55:54", "", "2", "http://blogsforsales.com/ebooks/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2013-12-08 12:56:57", "2013-12-08 12:56:57", "How do you react when your plans fall through?  Do you roll with the punches?  Or does anxiety keep you from enjoying life?  To a great extent, our personality determines how we deal with stress in our lives, but here are 5 things to help keep your stress under control:\n\n1.    Sleep more.  It’s very common in our society to exist on less than 6 hours of sleep a night.  But experts keep telling us we need at least 8 hours.  Not just to rest our bodies, but to rejuvenate our minds.  “Tired” and “cranky” seem to go hand in hand.  Don’t use your bedroom to watch the news or finish up some work from the office.  Make that room your haven, a place to relax and escape the day.  Have a hot cup of tea, take a warm bath, or read a paperback to help you unwind.\n\n2.    Have faith.  Saying a short prayer in times of stress can give you a sense of calm, especially when the situation is one you really have no control over.  Studies have shown that people who trust in a higher power have lower blood pressure.  Being able to forgive people also can affect your blood pressure.  Holding a grudge is not good for your health!\n\n\n3.    Turn it off.  The convenience that cell phones have added to our lives can actually be a double-edged sword.  We depend on them so much it seems we can’t live without them.  This increased accessibility means not only can our loved ones reach us at any time, but so can work.  If your employer legitimately needs to have your cell phone number, make sure you set clear limits on when you can and cannot be reached.  Your time off is yours.\n\n4.    Take a holiday.  It doesn’t have to be a fancy vacation resort.  A day at the beach, or an afternoon at the park will do.  Just anywhere you can be and not think about the bills, work, or whatever tensions you may have.  It’s important to take time for yourself, so do it!  You’ll feel better with a fresh outlook.\n\n\n5.    Treat yourself.  Sign up for a yoga class at your local gym or community center.  The costs are nominal, and you’ll feel more relaxed after even just one session.  A monthly massage or a spa treatment is also a great way to recharge.  You’ll walk out feeling like a million dollar bowl of jelly.\n\nStress is unavoidable.  But what we do about it is up to us.  Experiment with these suggestions and see what works for you!", "Home", "", "inherit", "closed", "open", "", "2-autosave-v1", "", "", "2013-12-08 12:56:57", "2013-12-08 12:56:57", "", "2", "http://blogsforsales.com/ebooks/2-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2013-12-08 12:57:17", "2013-12-08 12:57:17", "How do you react when your plans fall through?  Do you roll with the punches?  Or does anxiety keep you from enjoying life?  To a great extent, our personality determines how we deal with stress in our lives, but here are 5 things to help keep your stress under control:\r\n\r\n1.    Sleep more.  It’s very common in our society to exist on less than 6 hours of sleep a night.  But experts keep telling us we need at least 8 hours.  Not just to rest our bodies, but to rejuvenate our minds.  “Tired” and “cranky” seem to go hand in hand.  Don’t use your bedroom to watch the news or finish up some work from the office.  Make that room your haven, a place to relax and escape the day.  Have a hot cup of tea, take a warm bath, or read a paperback to help you unwind.\r\n\r\n2.    Have faith.  Saying a short prayer in times of stress can give you a sense of calm, especially when the situation is one you really have no control over.  Studies have shown that people who trust in a higher power have lower blood pressure.  Being able to forgive people also can affect your blood pressure.  Holding a grudge is not good for your health!\r\n\r\n3.    Turn it off.  The convenience that cell phones have added to our lives can actually be a double-edged sword.  We depend on them so much it seems we can’t live without them.  This increased accessibility means not only can our loved ones reach us at any time, but so can work.  If your employer legitimately needs to have your cell phone number, make sure you set clear limits on when you can and cannot be reached.  Your time off is yours.\r\n\r\n4.    Take a holiday.  It doesn’t have to be a fancy vacation resort.  A day at the beach, or an afternoon at the park will do.  Just anywhere you can be and not think about the bills, work, or whatever tensions you may have.  It’s important to take time for yourself, so do it!  You’ll feel better with a fresh outlook.\r\n\r\n5.    Treat yourself.  Sign up for a yoga class at your local gym or community center.  The costs are nominal, and you’ll feel more relaxed after even just one session.  A monthly massage or a spa treatment is also a great way to recharge.  You’ll walk out feeling like a million dollar bowl of jelly.\r\n\r\nStress is unavoidable.  But what we do about it is up to us.  Experiment with these suggestions and see what works for you!", "Home", "", "inherit", "closed", "open", "", "2-revision-v1", "", "", "2013-12-08 12:57:17", "2013-12-08 12:57:17", "", "2", "http://blogsforsales.com/ebooks/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2014-01-31 18:14:40", "2014-01-31 18:14:40", "Internet Marketing as we all know it is pretty crowded with funny people making lots of huge bombastic claims over their nonsense crappy books and stuff. You might have come across ebooks making claims like \"how to make $XXX in 2 weeks\" or \"anyone can earn money at home\".\r\n\r\nBeing guilty of myself, I have literally spent gazillion amount of money into these internet marketing ebooks when I started out but only to find it later at those free-for-all ebooks directories, free membership sites or even those giveaway sites.  Though it\'s a sad experience to see youself spending money into something which could be downloaded somewhere over the Internet for free, there are still some good ebooks and materials which you should buy. Here are some of the guidelines which you should know of before you start your spending spree.\r\n\r\nDon\'t Spend Money On Junk Don\'t spend your money on something that tells you that with no experience you can make a lot of money. Typically this stuff is nothing more than trying to sell you pie in the sky. You can always learn and equipped yourself with knowledge from other free ebooks, newsletters or forums before spending your money on these ebooks.\r\n\r\nOnly Buy From The Experts Who Are Successful Themselves The most advertised ebooks are not always the best. Good stuff will naturally come to you either by way of constant good reviews from other Internet Marketers, word of mouth, buzz from forums or discussion boards and even testimonials from the actual people who use them. Thus, you should always buy from the recognized experts who have had tons of experience under their belt and also reputable results to back up their claims.\r\n\r\nBuy Only On What You Actually Need. It\'s no point to spend your hard earned money on whatever ebooks or internet marketing materials which you come across, however good the claims are on the sales copy. Remember, good sales copy is supposed to play around the prospects\' psychology behaviors into believing their actual claims. That\'s why professional copywriters charge tens of thousands for great sales copy because they do bring in lots of sales just by selling hype. You should only spend money on ebooks which could help you move on in your business. For example, if you feel that you are lack in copywriting skills, then you ought to buy copywriting materials from the professionals.\r\n\r\nTaking Action Is The Best Action You Can Make. Let\'s face it, how many of us who could spend a bomb in our internet marketing materials but only to find it lying around in our computer hard disk for ages? The fact is, no matter how good or how expensive or even how reputable the ebooks that you\'ve bought, it doesn\'t matter until you make the first step into implementing the materials which you learn from the ebooks. If you are new to Internet Marketing, then you should only buy ebooks that will teach you step by step in setting up your Internet Marketing business. Otherwise, stay away from them.\r\n\r\nHardcopy VS Intangible Books There had been discussions going on which debate just how good are those Internet Marketing books found on the bookstores compared to those on the Internet. While I couldn\'t agree more on some of the great Internet Marketing books you can find on the bookshelves, but in reality, most of the books I found cover only general concepts of the Internet Marketing. For example, in the business or internet marketing section of the bookstore, you might find stuff like \"how to make money online\" if you are looking for a book on internet marketing, but you can find a more specific ebook on the internet on \"How to Get Successful Reciprocal Linking\" or something like that. Both of these are related to Internet Marketing, but the latter tends to be more specific in their scope. Like what I\'ve mentioned in the previous point, you should know what you are lack of and buy ebooks that will help you move forward in your business. If you are just starting out, internet marketing books in the bookstore will serve just as good as the newbie ebooks online.\r\n\r\nAs a conclusion, make sure you know who you can trust online before buying from them. There are lots of these self-proclaim internet Marketing Gurus who are just like the average Joe struggling to make money online. Remember, there are bunch of those great forums and discussion boards which not only you could find great pieces of information, but also the chance to pose questions as well.\r\n\r\n&nbsp;", "Hello world!", "", "inherit", "closed", "open", "", "1-revision-v1", "", "", "2014-01-31 18:14:40", "2014-01-31 18:14:40", "", "1", "http://blogsforsales.com/ebooks/1-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2014-01-31 18:16:00", "2014-01-31 18:16:00", "", "jimmy-157594_150", "", "inherit", "closed", "open", "", "jimmy-157594_150", "", "", "2014-01-31 18:16:00", "2014-01-31 18:16:00", "", "1", "http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2014-01-31 18:17:01", "2014-01-31 18:17:01", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png\"><img class=\"alignleft size-full wp-image-19\" alt=\"jimmy-157594_150\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png\" width=\"111\" height=\"150\" /></a>Internet Marketing as we all know it is pretty crowded with funny people making lots of huge bombastic claims over their nonsense crappy books and stuff. You might have come across ebooks making claims like \"how to make $XXX in 2 weeks\" or \"anyone can earn money at home\".\r\n\r\nBeing guilty of myself, I have literally spent gazillion amount of money into these internet marketing ebooks when I started out but only to find it later at those free-for-all ebooks directories, free membership sites or even those giveaway sites.  Though it\'s a sad experience to see youself spending money into something which could be downloaded somewhere over the Internet for free, there are still some good ebooks and materials which you should buy. Here are some of the guidelines which you should know of before you start your spending spree.\r\n\r\nDon\'t Spend Money On Junk Don\'t spend your money on something that tells you that with no experience you can make a lot of money. Typically this stuff is nothing more than trying to sell you pie in the sky. You can always learn and equipped yourself with knowledge from other free ebooks, newsletters or forums before spending your money on these ebooks.\r\n\r\nOnly Buy From The Experts Who Are Successful Themselves The most advertised ebooks are not always the best. Good stuff will naturally come to you either by way of constant good reviews from other Internet Marketers, word of mouth, buzz from forums or discussion boards and even testimonials from the actual people who use them. Thus, you should always buy from the recognized experts who have had tons of experience under their belt and also reputable results to back up their claims.\r\n\r\nBuy Only On What You Actually Need. It\'s no point to spend your hard earned money on whatever ebooks or internet marketing materials which you come across, however good the claims are on the sales copy. Remember, good sales copy is supposed to play around the prospects\' psychology behaviors into believing their actual claims. That\'s why professional copywriters charge tens of thousands for great sales copy because they do bring in lots of sales just by selling hype. You should only spend money on ebooks which could help you move on in your business. For example, if you feel that you are lack in copywriting skills, then you ought to buy copywriting materials from the professionals.\r\n\r\nTaking Action Is The Best Action You Can Make. Let\'s face it, how many of us who could spend a bomb in our internet marketing materials but only to find it lying around in our computer hard disk for ages? The fact is, no matter how good or how expensive or even how reputable the ebooks that you\'ve bought, it doesn\'t matter until you make the first step into implementing the materials which you learn from the ebooks. If you are new to Internet Marketing, then you should only buy ebooks that will teach you step by step in setting up your Internet Marketing business. Otherwise, stay away from them.\r\n\r\nHardcopy VS Intangible Books There had been discussions going on which debate just how good are those Internet Marketing books found on the bookstores compared to those on the Internet. While I couldn\'t agree more on some of the great Internet Marketing books you can find on the bookshelves, but in reality, most of the books I found cover only general concepts of the Internet Marketing. For example, in the business or internet marketing section of the bookstore, you might find stuff like \"how to make money online\" if you are looking for a book on internet marketing, but you can find a more specific ebook on the internet on \"How to Get Successful Reciprocal Linking\" or something like that. Both of these are related to Internet Marketing, but the latter tends to be more specific in their scope. Like what I\'ve mentioned in the previous point, you should know what you are lack of and buy ebooks that will help you move forward in your business. If you are just starting out, internet marketing books in the bookstore will serve just as good as the newbie ebooks online.\r\n\r\nAs a conclusion, make sure you know who you can trust online before buying from them. There are lots of these self-proclaim internet Marketing Gurus who are just like the average Joe struggling to make money online. Remember, there are bunch of those great forums and discussion boards which not only you could find great pieces of information, but also the chance to pose questions as well.\r\n\r\n&nbsp;", "Can You Make Money With Ebooks?", "", "inherit", "closed", "open", "", "1-revision-v1", "", "", "2014-01-31 18:17:01", "2014-01-31 18:17:01", "", "1", "http://blogsforsales.com/ebooks/1-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2014-01-31 18:17:52", "2014-01-31 18:17:52", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png\"><img class=\"alignleft size-full wp-image-19\" alt=\"jimmy-157594_150\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2013/12/jimmy-157594_150.png\" width=\"111\" height=\"150\" /></a>Internet Marketing as we all know it is pretty crowded with funny people making lots of huge bombastic claims over their nonsense crappy books and stuff. You might have come across ebooks making claims like \"how to make $XXX in 2 weeks\" or \"anyone can earn money at home\".\r\n\r\nBeing guilty of myself, I have literally spent gazillion amount of money into these internet marketing ebooks when I started out but only to find it later at those free-for-all ebooks directories, free membership sites or even those giveaway sites.  Though it\'s a sad experience to see youself spending money into something which could be downloaded somewhere over the Internet for free, there are still some good ebooks and materials which you should buy. Here are some of the guidelines which you should know of before you start your spending spree.\r\n\r\nDon\'t Spend Money On Junk Don\'t spend your money on something that tells you that with no experience you can make a lot of money. Typically this stuff is nothing more than trying to sell you pie in the sky. You can always learn and equipped yourself with knowledge from other free ebooks, newsletters or forums before spending your money on these ebooks.<!--more-->\r\n\r\nOnly Buy From The Experts Who Are Successful Themselves The most advertised ebooks are not always the best. Good stuff will naturally come to you either by way of constant good reviews from other Internet Marketers, word of mouth, buzz from forums or discussion boards and even testimonials from the actual people who use them. Thus, you should always buy from the recognized experts who have had tons of experience under their belt and also reputable results to back up their claims.\r\n\r\nBuy Only On What You Actually Need. It\'s no point to spend your hard earned money on whatever ebooks or internet marketing materials which you come across, however good the claims are on the sales copy. Remember, good sales copy is supposed to play around the prospects\' psychology behaviors into believing their actual claims. That\'s why professional copywriters charge tens of thousands for great sales copy because they do bring in lots of sales just by selling hype. You should only spend money on ebooks which could help you move on in your business. For example, if you feel that you are lack in copywriting skills, then you ought to buy copywriting materials from the professionals.\r\n\r\nTaking Action Is The Best Action You Can Make. Let\'s face it, how many of us who could spend a bomb in our internet marketing materials but only to find it lying around in our computer hard disk for ages? The fact is, no matter how good or how expensive or even how reputable the ebooks that you\'ve bought, it doesn\'t matter until you make the first step into implementing the materials which you learn from the ebooks. If you are new to Internet Marketing, then you should only buy ebooks that will teach you step by step in setting up your Internet Marketing business. Otherwise, stay away from them.\r\n\r\nHardcopy VS Intangible Books There had been discussions going on which debate just how good are those Internet Marketing books found on the bookstores compared to those on the Internet. While I couldn\'t agree more on some of the great Internet Marketing books you can find on the bookshelves, but in reality, most of the books I found cover only general concepts of the Internet Marketing. For example, in the business or internet marketing section of the bookstore, you might find stuff like \"how to make money online\" if you are looking for a book on internet marketing, but you can find a more specific ebook on the internet on \"How to Get Successful Reciprocal Linking\" or something like that. Both of these are related to Internet Marketing, but the latter tends to be more specific in their scope. Like what I\'ve mentioned in the previous point, you should know what you are lack of and buy ebooks that will help you move forward in your business. If you are just starting out, internet marketing books in the bookstore will serve just as good as the newbie ebooks online.\r\n\r\nAs a conclusion, make sure you know who you can trust online before buying from them. There are lots of these self-proclaim internet Marketing Gurus who are just like the average Joe struggling to make money online. Remember, there are bunch of those great forums and discussion boards which not only you could find great pieces of information, but also the chance to pose questions as well.\r\n\r\n&nbsp;", "Can You Make Money With Ebooks?", "", "inherit", "closed", "open", "", "1-revision-v1", "", "", "2014-01-31 18:17:52", "2014-01-31 18:17:52", "", "1", "http://blogsforsales.com/ebooks/1-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2014-01-31 18:22:06", "2014-01-31 18:22:06", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/business-163461_640.jpg\"><img class=\"alignleft size-thumbnail wp-image-23\" alt=\"business-163461_640\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/business-163461_640-150x150.jpg\" width=\"150\" height=\"150\" /></a>When you put your all into learning something that  you  need  to know, you can bet that other people can  benefit  from  what  you have learned. Internet marketing is one of those topics that lots  of people need help with. So once  you\'ve  gained  knowledge  and experience writing and selling an internet marketing ebook  might be a good opportunity for you.\r\n\r\nIn order to make money in ebook publishing, you have  to  have  a product that people want. How-to  books  that  fill  a  need  are undoubtedly best-selling  ebooks.  An  internet  marketing  ebook falls into that category.\r\n\r\nThere is nothing worse than an internet marketing ebook or how-to ebook that is filled with junk. Thus, in order for your  internet marketing ebook to be a best  seller,  it  has  to  offer  useful information. If  it  doesn\'t,  you\'ll  get  return  requests  and charge-backs left and right. Besides, if you don\'t  have  quality content in your internet marketing ebook, you  can\'t  comfortably offer a money back guarantee which is actually a vital aspect  of marketing ebooks for profit.<!--more-->\r\n\r\nEvery ebook, especially an internet  marketing  ebook,  needs  to have a clear purpose before you begin to  write  it.  Decide  who your target audience will be - who will buy your book?  Selecting a niche market to sell your internet marketing ebook to  is  half the battle. When you narrow your market  rather  than  trying  to satisfy the masses, you will have a much higher  quality  product and less competition. The trick to producing a best seller is  to provide a solution to an existing problem that isn\'t  effectively solved by numerous competitors.\r\n\r\nAdd value to your internet marketing ebook by  offering  freebies as  bonuses  for  buying  the  ebook  right  away.  A  customer\'s perceived value is very  important.  Examples  of  bonuses  might include things like a report  on  how  to  set  up  an  affiliate program for an ebook, how to manage a pay-per-click campaign,  or how  to  write  results-oriented  sales  copy  for  an   internet marketing website.\r\n\r\nRealize that if your internet marketing ebook is  going  to  make money, you\'ve got to apply the internet marketing principles that will get your ebook noticed, walk the prospect through the  sales process and close  the  sale.  The  first  principle  is  driving traffic to your website. Whatever internet  marketing  techniques you use to accomplish that, targeted traffic is vital.  Once  you have visitors at your website the sales process kicks in.\r\n\r\nLong-copy sales letters  are  undoubtedly  best  for  selling  an internet marketing ebook or any  other  ebook  for  that  matter. Short copy just doesn\'t cut it. You see,  when  you  are  selling information products online, like an  internet  marketing  ebook, you don\'t have the advantage of a face-to-face sales opportunity. Your web copy has to accomplish the sales for you.\r\n\r\nTo close  the  sale,  the  copy  must  convey  a  unique  selling proposition - one or more things that stand out apart  from  your competition. It has to be attractive and compelling to your well-defined target market  with  headlines  and  subheads  that  grab attention by  stating  the  product\'s  benefit  or  solution,  or invoking curiosity. Your pricing strategy  and  relative  bonuses must give readers a high perceived value so they  feel  they  are getting an internet marketing ebook and additional information or products that are worth what they are paying.\r\n\r\nThe sales copy also has to build credibility  either  by  stating the  author\'s  credentials,  using  testimonials,  or  both.  The reader\'s objections also have to be countered by the sales  copy. This can be accomplished  by  addressing  them  directly  and  by offering a money back guarantee.\r\n\r\nA long-copy sales letter for selling an internet marketing  ebook or another \"how to\" ebook that creates a  sense  of  urgency  can result in immediate sales. People have a tendency to  be  impulse shoppers so creating urgency by offering a \"limited  time\"  price or bonuses or making the product available  only  for  a  limited time will prompt the close of the sale.\r\n\r\nAnother factor to consider  when  writing  sales  copy  for  your internet marketing ebook is, buyers want to know they can contact you. When you provide  valid,  easy-to-find  contact  information your credibility increases tremendously and as a result  so  will your sales for your internet marketing ebook  or  any  ebook  you choose to publish.\r\n\r\n&nbsp;\r\n\r\n&nbsp;", "Boosting Your Ebook Sales", "", "publish", "closed", "open", "", "boosting-your-ebook-sales", "", "", "2014-01-31 19:30:04", "2014-01-31 19:30:04", "", "0", "http://blogsforsales.com/ebooks/?p=22", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2014-01-31 18:21:38", "2014-01-31 18:21:38", "", "business-163461_640", "", "inherit", "closed", "open", "", "business-163461_640", "", "", "2014-01-31 18:21:38", "2014-01-31 18:21:38", "", "22", "http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/business-163461_640.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2014-01-31 18:22:06", "2014-01-31 18:22:06", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/business-163461_640.jpg\"><img class=\"alignleft size-thumbnail wp-image-23\" alt=\"business-163461_640\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/business-163461_640-150x150.jpg\" width=\"150\" height=\"150\" /></a>When you put your all into learning something that  you  need  to know, you can bet that other people can  benefit  from  what  you have learned. Internet marketing is one of those topics that lots  of people need help with. So once  you\'ve  gained  knowledge  and experience writing and selling an internet marketing ebook  might be a good opportunity for you.\r\n\r\nIn order to make money in ebook publishing, you have  to  have  a product that people want. How-to  books  that  fill  a  need  are undoubtedly best-selling  ebooks.  An  internet  marketing  ebook falls into that category.\r\n\r\nThere is nothing worse than an internet marketing ebook or how-to ebook that is filled with junk. Thus, in order for your  internet marketing ebook to be a best  seller,  it  has  to  offer  useful information. If  it  doesn\'t,  you\'ll  get  return  requests  and charge-backs left and right. Besides, if you don\'t  have  quality content in your internet marketing ebook, you  can\'t  comfortably offer a money back guarantee which is actually a vital aspect  of marketing ebooks for profit.<!--more-->\r\n\r\nEvery ebook, especially an internet  marketing  ebook,  needs  to have a clear purpose before you begin to  write  it.  Decide  who your target audience will be - who will buy your book?  Selecting a niche market to sell your internet marketing ebook to  is  half the battle. When you narrow your market  rather  than  trying  to satisfy the masses, you will have a much higher  quality  product and less competition. The trick to producing a best seller is  to provide a solution to an existing problem that isn\'t  effectively solved by numerous competitors.\r\n\r\nAdd value to your internet marketing ebook by  offering  freebies as  bonuses  for  buying  the  ebook  right  away.  A  customer\'s perceived value is very  important.  Examples  of  bonuses  might include things like a report  on  how  to  set  up  an  affiliate program for an ebook, how to manage a pay-per-click campaign,  or how  to  write  results-oriented  sales  copy  for  an   internet marketing website.\r\n\r\nRealize that if your internet marketing ebook is  going  to  make money, you\'ve got to apply the internet marketing principles that will get your ebook noticed, walk the prospect through the  sales process and close  the  sale.  The  first  principle  is  driving traffic to your website. Whatever internet  marketing  techniques you use to accomplish that, targeted traffic is vital.  Once  you have visitors at your website the sales process kicks in.\r\n\r\nLong-copy sales letters  are  undoubtedly  best  for  selling  an internet marketing ebook or any  other  ebook  for  that  matter. Short copy just doesn\'t cut it. You see,  when  you  are  selling information products online, like an  internet  marketing  ebook, you don\'t have the advantage of a face-to-face sales opportunity. Your web copy has to accomplish the sales for you.\r\n\r\nTo close  the  sale,  the  copy  must  convey  a  unique  selling proposition - one or more things that stand out apart  from  your competition. It has to be attractive and compelling to your well-defined target market  with  headlines  and  subheads  that  grab attention by  stating  the  product\'s  benefit  or  solution,  or invoking curiosity. Your pricing strategy  and  relative  bonuses must give readers a high perceived value so they  feel  they  are getting an internet marketing ebook and additional information or products that are worth what they are paying.\r\n\r\nThe sales copy also has to build credibility  either  by  stating the  author\'s  credentials,  using  testimonials,  or  both.  The reader\'s objections also have to be countered by the sales  copy. This can be accomplished  by  addressing  them  directly  and  by offering a money back guarantee.\r\n\r\nA long-copy sales letter for selling an internet marketing  ebook or another \"how to\" ebook that creates a  sense  of  urgency  can result in immediate sales. People have a tendency to  be  impulse shoppers so creating urgency by offering a \"limited  time\"  price or bonuses or making the product available  only  for  a  limited time will prompt the close of the sale.\r\n\r\nAnother factor to consider  when  writing  sales  copy  for  your internet marketing ebook is, buyers want to know they can contact you. When you provide  valid,  easy-to-find  contact  information your credibility increases tremendously and as a result  so  will your sales for your internet marketing ebook  or  any  ebook  you choose to publish.\r\n\r\n&nbsp;\r\n\r\n&nbsp;", "Boosting Your Ebook Sales", "", "inherit", "closed", "open", "", "22-revision-v1", "", "", "2014-01-31 18:22:06", "2014-01-31 18:22:06", "", "22", "http://blogsforsales.com/ebooks/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2014-01-31 18:24:51", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "open", "", "", "", "", "2014-01-31 18:24:51", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/ebooks/?p=25", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2014-01-31 18:28:38", "2014-01-31 18:28:38", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/scribbling-152216_640.png\"><img class=\"alignleft size-thumbnail wp-image-27\" alt=\"scribbling-152216_640\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/scribbling-152216_640-150x150.png\" width=\"150\" height=\"150\" /></a>Sound familiar? No! Oh, get real! We\'ve all experienced this phenomenon when we absolutely have to write something, particularly on deadline. I\'m talking about. . . . .uh, I can\'t think of what the word is .. . oh, yes, it\'s on the tip of my tongue . . . it\'s:\r\n\r\nWRITER\'S BLOCK!!!!\r\n\r\nWhew! I feel better just getting that out of my head and onto the page!\r\n\r\nWriter\'s block is the patron demon of the blank page. You may think you know EXACTLY what you\'re going to write, but as soon as that evil white screen appears before you, your mind suddenly goes completely blank. I\'m not talking about Zen meditation stare-at-the-wall-until-enlightenment-hits kind of blank.\r\n\r\nI\'m talking about sweat trickling down the back of your neck, anguish and panic and suffering kind of blank. The tighter the deadline, the worse the anguish of writer\'s block gets.\r\n\r\nHaving said that, let me say it again. \"The tighter the deadline, the worse the anguish of writer\'s block gets.\" Now, can you figure out what might possibly be causing this horrible plunge into speechlessness?\r\n\r\nThe answer is obvious: FEAR! You are terrified of that blank page. You are terrified you have absolutely nothing of value to say. You are afraid of the fear of writer\'s block itself!<!--more-->\r\n\r\nIt doesn’t necessarily matter if you\'ve done a decade of research and all you have to do is string sentences you can repeat in your sleep together into coherent paragraphs. Writer\'s block can strike anyone at any time. Based in fear, it raises our doubts about our own self-worth, but it\'s sneaky. It\'s writer\'s block, after all, so it doesn\'t just come and let you know that. No, it makes you feel like an idiot who just had your frontal lobes removed through your sinuses. If you dared to put forth words into the greater world, they would surely come out as gibberish!\r\n\r\nLet\'s try and be rational with this irrational demon. Let\'s make a list of what might possibly be beneath this terrible and terrifying condition.\r\n\r\n1. Perfectionism. You must absolutely produce a masterpiece of literature straight off in the first draft. Otherwise, you qualify as a complete failure.\r\n\r\n2. Editing instead of composing. There\'s your monkey-mind sitting on your shoulder, yelling as soon as you type \"I was born?,\" no, not that, that\'s wrong! That\'s stupid! Correct, correct, correct, correct?\r\n\r\n3. Self-consciousness. How can you think, let alone write, when all you can manage to do is pry the fingers of writer\'s block away from your throat enough so you can gasp in a few shallow breaths? You\'re not focusing on what you\'re trying to write, your focusing on those gnarly fingers around your windpipe.\r\n\r\n4. Can\'t get started. It\'s always the first sentence that\'s the hardest. As writers, we all know how EXTREMELY important the first sentence is. It must be brilliant! It must be unique! It must hook your reader\'s from the start! There\'s no way we can get into writing the piece until we get past this impossible first sentence.\r\n\r\n5. Shattered concentration. You\'re cat is sick. You suspect your mate is cheating on you. Your electricity might be turned off any second. You have a crush on the local UPS deliveryman. You have a dinner party planned for your in-laws. You . . . Need I say more. How can you possibly concentrate with all this mental clutter?\r\n\r\n6. Procrastination. It\'s your favourite hobby. It\'s your soul mate. It’s the reason you\'ve knitted 60 argyle sweaters or made 300 bookcases in your garage workshop. It\'s the reason you never run out of Brie.\r\n\r\nFACE IT? IT’S ONE OF THE REASONS YOU HAVE WRITER\'S BLOCK!\r\n\r\nHow to Overcome Writer\'s Block\r\n\r\nOkay. I can hear that herd of you running away from this article as fast as you can. Absurd! you huff. Never in a million years, you fume. Writer\'s block is absolutely, undeniably, scientifically proven to be impossible to overcome.\r\n\r\nOh, just get over it! Well, I guess it\'s not that easy. So try to sit down for just a few minutes and listen. All you have to do is listen? You don\'t have to actually write a single word.\r\n\r\nAh, there you all are again. I am beginning to make you out now that the cloud of dust is settling.\r\n\r\nI am here to tell you that WRITER\'S BLOCK CAN BE OVERCOME.\r\n\r\nPlease, remain seated.\r\n\r\nThere are ways to trick this nasty demon. Pick one, pick several, and give them a try. Soon, before you even have a chance for your heartbeat to accelerate, guess what? You\'re writing.\r\n\r\nHere are some tried and true methods of overcoming writer\'s block:\r\n\r\n1. Be prepared. The only thing to fear is fear itself. (I know, that\'s a cliché but as soon as you start writing, feel free to improve on it.) If you spend some time mulling over your project before you actually sit down to write, you may be able to circumvent the worst of the crippling panic.\r\n\r\n2. Forget perfectionism. No one ever writes a masterpiece in the first draft. Don\'t put any expectations on your writing at all! In fact, tell yourself you\'re going to write absolute garbage, and then give yourself permission to happily stink up your writing room.\r\n\r\n3. Compose instead of editing. Never, never write your first draft with your monkey-mind sitting on your shoulder, making snide editorial comments. Composing is a magical process. It surpasses the conscious mind by galaxies. It\'s even incomprehensible to the conscious, editorial, monkey-mind. So prepare an ambush. Sit down at your computer or your desk. Take a deep breath and blow out all your thoughts. Let your finger hover over your keyboard or pick up your pen. And then pull a fake: appear to be about to begin to write, but instead, using your thumb and index finger of your dominant hand, flick that little annoying ugly monkey back into the barrel of laughs it came from. Then jump in ? quickly! Write, scribble, scream, howl, let everything loose, as long as you do it with a pen or your computer keyboard.\r\n\r\n4. Forget the first sentence. You can sweat over that all-important one-liner when you\'ve finished your piece. Skip it! Go for the middle or even the end. Start wherever you can. Chances are, when you read it over, the first line will be blinking its little neon lights right at you from the depths of your composition.\r\n\r\n5. Concentration. This is a hard one. Life throws us so many curve balls. How about thinking about your writing time as a little vacation from all those annoying worries. Banish them! Create a space, perhaps even a physical one, where nothing exists except the single present moment. If one of those irritating worries gets by you, stomp on it like you would an ugly bug!\r\n\r\n6. Stop procrastinating. Write an outline. Keep your research notes within sight. Use someone else\'s writing to get going. Babble incoherently on paper or on the computer if you have to.\r\n\r\nJust do it! (I know, I stole that line from somewhere?). Tack up anything that could possibly help you to get going: notes, outlines, pictures of your grandmother. Put the cookie you will be allowed to eat when you finish your first draft within sight, but out of reach. Then pick up the same type of writing that you need to write, and read it. Then read it again. Soon, trust me, the fear will slowly fade away. As soon as it does, grab your keyboard, and get writing!", "Overcoming Writers Block", "", "publish", "closed", "open", "", "overcoming-writers-block", "", "", "2014-01-31 18:28:38", "2014-01-31 18:28:38", "", "0", "http://blogsforsales.com/ebooks/?p=26", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2014-01-31 18:27:56", "2014-01-31 18:27:56", "", "scribbling-152216_640", "", "inherit", "closed", "open", "", "scribbling-152216_640", "", "", "2014-01-31 18:27:56", "2014-01-31 18:27:56", "", "26", "http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/scribbling-152216_640.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2014-01-31 18:28:38", "2014-01-31 18:28:38", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/scribbling-152216_640.png\"><img class=\"alignleft size-thumbnail wp-image-27\" alt=\"scribbling-152216_640\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/scribbling-152216_640-150x150.png\" width=\"150\" height=\"150\" /></a>Sound familiar? No! Oh, get real! We\'ve all experienced this phenomenon when we absolutely have to write something, particularly on deadline. I\'m talking about. . . . .uh, I can\'t think of what the word is .. . oh, yes, it\'s on the tip of my tongue . . . it\'s:\r\n\r\nWRITER\'S BLOCK!!!!\r\n\r\nWhew! I feel better just getting that out of my head and onto the page!\r\n\r\nWriter\'s block is the patron demon of the blank page. You may think you know EXACTLY what you\'re going to write, but as soon as that evil white screen appears before you, your mind suddenly goes completely blank. I\'m not talking about Zen meditation stare-at-the-wall-until-enlightenment-hits kind of blank.\r\n\r\nI\'m talking about sweat trickling down the back of your neck, anguish and panic and suffering kind of blank. The tighter the deadline, the worse the anguish of writer\'s block gets.\r\n\r\nHaving said that, let me say it again. \"The tighter the deadline, the worse the anguish of writer\'s block gets.\" Now, can you figure out what might possibly be causing this horrible plunge into speechlessness?\r\n\r\nThe answer is obvious: FEAR! You are terrified of that blank page. You are terrified you have absolutely nothing of value to say. You are afraid of the fear of writer\'s block itself!<!--more-->\r\n\r\nIt doesn’t necessarily matter if you\'ve done a decade of research and all you have to do is string sentences you can repeat in your sleep together into coherent paragraphs. Writer\'s block can strike anyone at any time. Based in fear, it raises our doubts about our own self-worth, but it\'s sneaky. It\'s writer\'s block, after all, so it doesn\'t just come and let you know that. No, it makes you feel like an idiot who just had your frontal lobes removed through your sinuses. If you dared to put forth words into the greater world, they would surely come out as gibberish!\r\n\r\nLet\'s try and be rational with this irrational demon. Let\'s make a list of what might possibly be beneath this terrible and terrifying condition.\r\n\r\n1. Perfectionism. You must absolutely produce a masterpiece of literature straight off in the first draft. Otherwise, you qualify as a complete failure.\r\n\r\n2. Editing instead of composing. There\'s your monkey-mind sitting on your shoulder, yelling as soon as you type \"I was born?,\" no, not that, that\'s wrong! That\'s stupid! Correct, correct, correct, correct?\r\n\r\n3. Self-consciousness. How can you think, let alone write, when all you can manage to do is pry the fingers of writer\'s block away from your throat enough so you can gasp in a few shallow breaths? You\'re not focusing on what you\'re trying to write, your focusing on those gnarly fingers around your windpipe.\r\n\r\n4. Can\'t get started. It\'s always the first sentence that\'s the hardest. As writers, we all know how EXTREMELY important the first sentence is. It must be brilliant! It must be unique! It must hook your reader\'s from the start! There\'s no way we can get into writing the piece until we get past this impossible first sentence.\r\n\r\n5. Shattered concentration. You\'re cat is sick. You suspect your mate is cheating on you. Your electricity might be turned off any second. You have a crush on the local UPS deliveryman. You have a dinner party planned for your in-laws. You . . . Need I say more. How can you possibly concentrate with all this mental clutter?\r\n\r\n6. Procrastination. It\'s your favourite hobby. It\'s your soul mate. It’s the reason you\'ve knitted 60 argyle sweaters or made 300 bookcases in your garage workshop. It\'s the reason you never run out of Brie.\r\n\r\nFACE IT? IT’S ONE OF THE REASONS YOU HAVE WRITER\'S BLOCK!\r\n\r\nHow to Overcome Writer\'s Block\r\n\r\nOkay. I can hear that herd of you running away from this article as fast as you can. Absurd! you huff. Never in a million years, you fume. Writer\'s block is absolutely, undeniably, scientifically proven to be impossible to overcome.\r\n\r\nOh, just get over it! Well, I guess it\'s not that easy. So try to sit down for just a few minutes and listen. All you have to do is listen? You don\'t have to actually write a single word.\r\n\r\nAh, there you all are again. I am beginning to make you out now that the cloud of dust is settling.\r\n\r\nI am here to tell you that WRITER\'S BLOCK CAN BE OVERCOME.\r\n\r\nPlease, remain seated.\r\n\r\nThere are ways to trick this nasty demon. Pick one, pick several, and give them a try. Soon, before you even have a chance for your heartbeat to accelerate, guess what? You\'re writing.\r\n\r\nHere are some tried and true methods of overcoming writer\'s block:\r\n\r\n1. Be prepared. The only thing to fear is fear itself. (I know, that\'s a cliché but as soon as you start writing, feel free to improve on it.) If you spend some time mulling over your project before you actually sit down to write, you may be able to circumvent the worst of the crippling panic.\r\n\r\n2. Forget perfectionism. No one ever writes a masterpiece in the first draft. Don\'t put any expectations on your writing at all! In fact, tell yourself you\'re going to write absolute garbage, and then give yourself permission to happily stink up your writing room.\r\n\r\n3. Compose instead of editing. Never, never write your first draft with your monkey-mind sitting on your shoulder, making snide editorial comments. Composing is a magical process. It surpasses the conscious mind by galaxies. It\'s even incomprehensible to the conscious, editorial, monkey-mind. So prepare an ambush. Sit down at your computer or your desk. Take a deep breath and blow out all your thoughts. Let your finger hover over your keyboard or pick up your pen. And then pull a fake: appear to be about to begin to write, but instead, using your thumb and index finger of your dominant hand, flick that little annoying ugly monkey back into the barrel of laughs it came from. Then jump in ? quickly! Write, scribble, scream, howl, let everything loose, as long as you do it with a pen or your computer keyboard.\r\n\r\n4. Forget the first sentence. You can sweat over that all-important one-liner when you\'ve finished your piece. Skip it! Go for the middle or even the end. Start wherever you can. Chances are, when you read it over, the first line will be blinking its little neon lights right at you from the depths of your composition.\r\n\r\n5. Concentration. This is a hard one. Life throws us so many curve balls. How about thinking about your writing time as a little vacation from all those annoying worries. Banish them! Create a space, perhaps even a physical one, where nothing exists except the single present moment. If one of those irritating worries gets by you, stomp on it like you would an ugly bug!\r\n\r\n6. Stop procrastinating. Write an outline. Keep your research notes within sight. Use someone else\'s writing to get going. Babble incoherently on paper or on the computer if you have to.\r\n\r\nJust do it! (I know, I stole that line from somewhere?). Tack up anything that could possibly help you to get going: notes, outlines, pictures of your grandmother. Put the cookie you will be allowed to eat when you finish your first draft within sight, but out of reach. Then pick up the same type of writing that you need to write, and read it. Then read it again. Soon, trust me, the fear will slowly fade away. As soon as it does, grab your keyboard, and get writing!", "Overcoming Writers Block", "", "inherit", "closed", "open", "", "26-revision-v1", "", "", "2014-01-31 18:28:38", "2014-01-31 18:28:38", "", "26", "http://blogsforsales.com/ebooks/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2014-01-31 18:29:32", "2014-01-31 18:29:32", " ", "", "", "publish", "closed", "open", "", "29", "", "", "2014-01-31 19:27:39", "2014-01-31 19:27:39", "", "0", "http://blogsforsales.com/ebooks/?p=29", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2014-01-31 18:29:32", "2014-01-31 18:29:32", " ", "", "", "publish", "closed", "open", "", "30", "", "", "2014-01-31 19:27:39", "2014-01-31 19:27:39", "", "0", "http://blogsforsales.com/ebooks/?p=30", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2014-01-31 18:31:12", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "open", "", "", "", "", "2014-01-31 18:31:12", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/ebooks/?p=31", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2014-01-31 18:34:09", "2014-01-31 18:34:09", "<span style=\"color: #000000;\"><a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/e-book-158406_150.png\"><img class=\"alignleft size-full wp-image-34\" alt=\"e-book-158406_150\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/e-book-158406_150.png\" width=\"150\" height=\"136\" /></a>The hardest part of writing is the first sentence. When you look at the whole project, it seems like an impossible task. That\'s why you have to break it down into manageable tasks. Think of climbing a mountain. You are standing at the foot of it and looking up at its summit vanishing into the clouds. How can you possibly scale such an immense and dangerous mountain?</span>\r\n\r\n<span style=\"color: #000000;\">There is only one way to climb a mountain ? step by step.</span>\r\n\r\n<span style=\"color: #000000;\">Now think of writing your ebook in the same light. You must create it step by step, and one day, you will take that last step and find yourself standing on the summit with your head in the clouds.</span>\r\n\r\n<span style=\"color: #000000;\">The first thing you have to do, as if you actually were a mountain climber, is to get organized. Instead of climbing gear, however, you must organize your thoughts. There are some steps you should take before you begin. Once you\'ve gone through the following list, you will be ready to actually begin writing your ebook.<!--more--></span>\r\n\r\n<span style=\"color: #000000;\">Beginning Steps to Writing an ebook</span>\r\n\r\n<span style=\"color: #000000;\">First, figure out your ebook\'s working title. Jot down a few different titles, and eventually, you\'ll find that one that will grow on you. Titles help you to focus your writing on your topic; they guide you in anticipating and answering your reader\'s queries. Many non-fiction books also have subtitles. Aim for clarity in your titles, but cleverness always helps to sell books ? as long as it\'s not too cute. For example, Remedies for Insomnia: twenty different ways to count sheep. Or: Get off that couch: fifteen exercise plans to whip you into shape.</span>\r\n\r\n<span style=\"color: #000000;\">Next, write out a thesis statement. Your thesis is a sentence or two stating exactly what problem you are addressing and how your book will solve that problem. All chapters spring forth from your thesis statement. Once you\'ve got your thesis statement fine-tuned, you\'ve built your foundation. From that foundation, your book will grow, chapter by chapter.</span>\r\n\r\n<span style=\"color: #000000;\">Your thesis will keep you focused while you write your ebook. Remember: all chapters must support your thesis statement. If they don\'t, they don\'t belong in your book. For example, your thesis statement could read: We\'ve all experienced insomnia at times in our lives, but there are twenty proven techniques and methods to give you back a good night\'s sleep.</span>\r\n\r\n<span style=\"color: #000000;\">Once you have your thesis, before you start to write, make sure there is a good reason to write your book. Ask yourself some questions:</span>\r\n\r\n<span style=\"color: #000000;\">* Does your book present useful information and is that information currently relevant?</span>\r\n\r\n<span style=\"color: #000000;\">* Will you book positively affect the lives of your readers?</span>\r\n\r\n<span style=\"color: #000000;\">* Is your book dynamic and will it keep the reader\'s attention?</span>\r\n\r\n<span style=\"color: #000000;\">* Does you book answer questions that are meaningful and significant?</span>\r\n\r\n<span style=\"color: #000000;\">If you can answer yes to these questions, you can feel confident about the potential of your ebook.</span>\r\n\r\n<span style=\"color: #000000;\">Another important step is to figure out who your target audience is. It is this group of people you will be writing to, and this group will dictate many elements of your book, such as style, tone, diction, and even length. Figure out the age range of your readers, their general gender, what they are most interested in, and even the socio-economic group they primarily come from. Are they people who read fashion magazines or book reviews? Do they write letters in longhand or spend hours every day online. The more you can pin down your target audience, the easier it will be to write your book for them.</span>\r\n\r\n<span style=\"color: #000000;\">Next, make a list of the reasons you are writing your ebook. Do you want to promote your business? Do you want to bring quality traffic to your website? Do you want to enhance your reputation?</span>\r\n\r\n<span style=\"color: #000000;\">Then write down your goals in terms of publishing. Do you want to sell it as a product on your website, or do you want to offer it as a free gift for filling out a survey or for ordering a product? Do you want to use the chapters to create an e-course, or use your ebook to attract affiliates around the world? The more you know upfront, the easier the actual writing will be.</span>\r\n\r\n<span style=\"color: #000000;\">Decide on the format of your chapters. In non-fiction, keep the format from chapter to chapter fairly consistent. Perhaps you plan to use an introduction to your chapter topic, and then divide it into four subhead topics. Or you may plan to divide it into five parts, each one beginning with a relevant anecdote.</span>\r\n\r\n<span style=\"color: #000000;\">How to make your ebook \"user friendly\"</span>\r\n\r\n<span style=\"color: #000000;\">You must figure out how to keep your writing engaging. Often anecdotes, testimonials, little stories, photos, graphs, advice, and tips will keep the reader turning the pages. Sidebars are useful for quick, accessible information, and they break up the density of the page.</span>\r\n\r\n<span style=\"color: #000000;\">Write with a casual, conversational tone rather than a formal tone such as textbook diction. Reader\'s respond to the feeling that you are having a conversation with them. Break up the length and structure of your sentences so you don?t hypnotize your readers into sleep. Sentences that are all the same length and structure tend to be a good aid for insomnia!</span>\r\n\r\n<span style=\"color: #000000;\">Good writing takes practice. It takes lots and lots of practice. Make a schedule to write at least a page a day. Read books and magazines about the process of writing, and jot down tips that jump out at you. The art of writing is a lifetime process; the more you write (and read), the better your writing will become. The better your writing becomes, the bigger your sales figures.</span>\r\n\r\n<span style=\"color: #000000;\">In an ebook that is read on the screen, be aware that you must give your reader\'s eye a break. You can do this by utilizing white space. In art classes, white space is usually referred to as \"negative space.\" Reader\'s eyes need to rest in the cool white oasis you create on your page. If your page is too dense, your reader will quit out of it as soon as their eyes begin to tear.</span>\r\n\r\n<span style=\"color: #000000;\">Make use of lists, both bulleted and numbered. This makes your information easy to absorb, and gives the reader a mental break from dissecting your paragraphs one after the other.</span>\r\n\r\n<span style=\"color: #000000;\">Finally, decide on an easy-to-read design. Find a font that\'s easy on the eyes, and stick to that font family. Using dozens of fonts will only tire your readers out before they\'ve gotten past your introduction. Use at least one and a half line spacing, and text large enough to be read easily on the screen, but small enough so that the whole page can be seen on a computer screen. You will have to experiment with this to find the right combination.</span>\r\n\r\n<span style=\"color: #000000;\">Of course, don\'t forget to run a spell and grammar check. You are judged by something as minor as correct punctuation, so don?t mess up a great book by tossing out semicolons randomly, or stringing sentences together with commas. (By the way, that\'s called a \"comma splice.\")</span>\r\n\r\n<span style=\"color: #000000;\">Last of all, create an index and a bibliography. That\'s it! You\'ve written a book! Now all you have to do is publish your ebook online, and wait for download request from your website visitors. </span>\r\n\r\n&nbsp;\r\n\r\n<span style=\"color: #000000;\"> </span>", "Writing Your First Ebook", "", "publish", "closed", "open", "", "writing-your-first-ebook", "", "", "2014-01-31 19:43:06", "2014-01-31 19:43:06", "", "0", "http://blogsforsales.com/ebooks/?p=32", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2014-01-31 18:34:09", "2014-01-31 18:34:09", "<span style=\"color: #000000;\">The hardest part of writing is the first sentence. When you look at the whole project, it seems like an impossible task. That\'s why you have to break it down into manageable tasks. Think of climbing a mountain. You are standing at the foot of it and looking up at its summit vanishing into the clouds. How can you possibly scale such an immense and dangerous mountain?</span>\r\n\r\n<span style=\"color: #000000;\">There is only one way to climb a mountain ? step by step.</span>\r\n\r\n<span style=\"color: #000000;\">Now think of writing your ebook in the same light. You must create it step by step, and one day, you will take that last step and find yourself standing on the summit with your head in the clouds.</span>\r\n\r\n<span style=\"color: #000000;\">The first thing you have to do, as if you actually were a mountain climber, is to get organized. Instead of climbing gear, however, you must organize your thoughts. There are some steps you should take before you begin. Once you\'ve gone through the following list, you will be ready to actually begin writing your ebook.</span>\r\n\r\n<span style=\"color: #000000;\">Beginning Steps to Writing an ebook</span>\r\n\r\n<span style=\"color: #000000;\">First, figure out your ebook\'s working title. Jot down a few different titles, and eventually, you\'ll find that one that will grow on you. Titles help you to focus your writing on your topic; they guide you in anticipating and answering your reader\'s queries. Many non-fiction books also have subtitles. Aim for clarity in your titles, but cleverness always helps to sell books ? as long as it\'s not too cute. For example, Remedies for Insomnia: twenty different ways to count sheep. Or: Get off that couch: fifteen exercise plans to whip you into shape.</span>\r\n\r\n<span style=\"color: #000000;\">Next, write out a thesis statement. Your thesis is a sentence or two stating exactly what problem you are addressing and how your book will solve that problem. All chapters spring forth from your thesis statement. Once you\'ve got your thesis statement fine-tuned, you\'ve built your foundation. From that foundation, your book will grow, chapter by chapter.</span>\r\n\r\n<span style=\"color: #000000;\">Your thesis will keep you focused while you write your ebook. Remember: all chapters must support your thesis statement. If they don\'t, they don\'t belong in your book. For example, your thesis statement could read: We\'ve all experienced insomnia at times in our lives, but there are twenty proven techniques and methods to give you back a good night\'s sleep.</span>\r\n\r\n<span style=\"color: #000000;\">Once you have your thesis, before you start to write, make sure there is a good reason to write your book. Ask yourself some questions:</span>\r\n\r\n<span style=\"color: #000000;\">* Does your book present useful information and is that information currently relevant?</span>\r\n\r\n<span style=\"color: #000000;\">* Will you book positively affect the lives of your readers?</span>\r\n\r\n<span style=\"color: #000000;\">* Is your book dynamic and will it keep the reader\'s attention?</span>\r\n\r\n<span style=\"color: #000000;\">* Does you book answer questions that are meaningful and significant?</span>\r\n\r\n<span style=\"color: #000000;\">If you can answer yes to these questions, you can feel confident about the potential of your ebook.</span>\r\n\r\n<span style=\"color: #000000;\">Another important step is to figure out who your target audience is. It is this group of people you will be writing to, and this group will dictate many elements of your book, such as style, tone, diction, and even length. Figure out the age range of your readers, their general gender, what they are most interested in, and even the socio-economic group they primarily come from. Are they people who read fashion magazines or book reviews? Do they write letters in longhand or spend hours every day online. The more you can pin down your target audience, the easier it will be to write your book for them.</span>\r\n\r\n<span style=\"color: #000000;\">Next, make a list of the reasons you are writing your ebook. Do you want to promote your business? Do you want to bring quality traffic to your website? Do you want to enhance your reputation?</span>\r\n\r\n<span style=\"color: #000000;\">Then write down your goals in terms of publishing. Do you want to sell it as a product on your website, or do you want to offer it as a free gift for filling out a survey or for ordering a product? Do you want to use the chapters to create an e-course, or use your ebook to attract affiliates around the world? The more you know upfront, the easier the actual writing will be.</span>\r\n\r\n<span style=\"color: #000000;\">Decide on the format of your chapters. In non-fiction, keep the format from chapter to chapter fairly consistent. Perhaps you plan to use an introduction to your chapter topic, and then divide it into four subhead topics. Or you may plan to divide it into five parts, each one beginning with a relevant anecdote.</span>\r\n\r\n<span style=\"color: #000000;\">How to make your ebook \"user friendly\"</span>\r\n\r\n<span style=\"color: #000000;\">You must figure out how to keep your writing engaging. Often anecdotes, testimonials, little stories, photos, graphs, advice, and tips will keep the reader turning the pages. Sidebars are useful for quick, accessible information, and they break up the density of the page.</span>\r\n\r\n<span style=\"color: #000000;\">Write with a casual, conversational tone rather than a formal tone such as textbook diction. Reader\'s respond to the feeling that you are having a conversation with them. Break up the length and structure of your sentences so you don?t hypnotize your readers into sleep. Sentences that are all the same length and structure tend to be a good aid for insomnia!</span>\r\n\r\n<span style=\"color: #000000;\">Good writing takes practice. It takes lots and lots of practice. Make a schedule to write at least a page a day. Read books and magazines about the process of writing, and jot down tips that jump out at you. The art of writing is a lifetime process; the more you write (and read), the better your writing will become. The better your writing becomes, the bigger your sales figures.</span>\r\n\r\n<span style=\"color: #000000;\">In an ebook that is read on the screen, be aware that you must give your reader\'s eye a break. You can do this by utilizing white space. In art classes, white space is usually referred to as \"negative space.\" Reader\'s eyes need to rest in the cool white oasis you create on your page. If your page is too dense, your reader will quit out of it as soon as their eyes begin to tear.</span>\r\n\r\n<span style=\"color: #000000;\">Make use of lists, both bulleted and numbered. This makes your information easy to absorb, and gives the reader a mental break from dissecting your paragraphs one after the other.</span>\r\n\r\n<span style=\"color: #000000;\">Finally, decide on an easy-to-read design. Find a font that\'s easy on the eyes, and stick to that font family. Using dozens of fonts will only tire your readers out before they\'ve gotten past your introduction. Use at least one and a half line spacing, and text large enough to be read easily on the screen, but small enough so that the whole page can be seen on a computer screen. You will have to experiment with this to find the right combination.</span>\r\n\r\n<span style=\"color: #000000;\">Of course, don\'t forget to run a spell and grammar check. You are judged by something as minor as correct punctuation, so don?t mess up a great book by tossing out semicolons randomly, or stringing sentences together with commas. (By the way, that\'s called a \"comma splice.\")</span>\r\n\r\n<span style=\"color: #000000;\">Last of all, create an index and a bibliography. That\'s it! You\'ve written a book! Now all you have to do is publish your ebook online, and wait for download request from your website visitors. </span>\r\n\r\n&nbsp;\r\n\r\n<span style=\"color: #000000;\"> </span>", "Writing Your First Ebook", "", "inherit", "closed", "open", "", "32-revision-v1", "", "", "2014-01-31 18:34:09", "2014-01-31 18:34:09", "", "32", "http://blogsforsales.com/ebooks/32-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2014-01-31 18:36:41", "2014-01-31 18:36:41", "", "e-book-158406_150", "", "inherit", "closed", "open", "", "e-book-158406_150", "", "", "2014-01-31 18:36:41", "2014-01-31 18:36:41", "", "32", "http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/e-book-158406_150.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("35", "1", "2014-01-31 18:36:56", "2014-01-31 18:36:56", "<span style=\"color: #000000;\"><a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/e-book-158406_150.png\"><img class=\"alignleft size-full wp-image-34\" alt=\"e-book-158406_150\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/e-book-158406_150.png\" width=\"150\" height=\"136\" /></a>The hardest part of writing is the first sentence. When you look at the whole project, it seems like an impossible task. That\'s why you have to break it down into manageable tasks. Think of climbing a mountain. You are standing at the foot of it and looking up at its summit vanishing into the clouds. How can you possibly scale such an immense and dangerous mountain?</span>\r\n\r\n<span style=\"color: #000000;\">There is only one way to climb a mountain ? step by step.</span>\r\n\r\n<span style=\"color: #000000;\">Now think of writing your ebook in the same light. You must create it step by step, and one day, you will take that last step and find yourself standing on the summit with your head in the clouds.</span>\r\n\r\n<span style=\"color: #000000;\">The first thing you have to do, as if you actually were a mountain climber, is to get organized. Instead of climbing gear, however, you must organize your thoughts. There are some steps you should take before you begin. Once you\'ve gone through the following list, you will be ready to actually begin writing your ebook.<!--more--></span>\r\n\r\n<span style=\"color: #000000;\">Beginning Steps to Writing an ebook</span>\r\n\r\n<span style=\"color: #000000;\">First, figure out your ebook\'s working title. Jot down a few different titles, and eventually, you\'ll find that one that will grow on you. Titles help you to focus your writing on your topic; they guide you in anticipating and answering your reader\'s queries. Many non-fiction books also have subtitles. Aim for clarity in your titles, but cleverness always helps to sell books ? as long as it\'s not too cute. For example, Remedies for Insomnia: twenty different ways to count sheep. Or: Get off that couch: fifteen exercise plans to whip you into shape.</span>\r\n\r\n<span style=\"color: #000000;\">Next, write out a thesis statement. Your thesis is a sentence or two stating exactly what problem you are addressing and how your book will solve that problem. All chapters spring forth from your thesis statement. Once you\'ve got your thesis statement fine-tuned, you\'ve built your foundation. From that foundation, your book will grow, chapter by chapter.</span>\r\n\r\n<span style=\"color: #000000;\">Your thesis will keep you focused while you write your ebook. Remember: all chapters must support your thesis statement. If they don\'t, they don\'t belong in your book. For example, your thesis statement could read: We\'ve all experienced insomnia at times in our lives, but there are twenty proven techniques and methods to give you back a good night\'s sleep.</span>\r\n\r\n<span style=\"color: #000000;\">Once you have your thesis, before you start to write, make sure there is a good reason to write your book. Ask yourself some questions:</span>\r\n\r\n<span style=\"color: #000000;\">* Does your book present useful information and is that information currently relevant?</span>\r\n\r\n<span style=\"color: #000000;\">* Will you book positively affect the lives of your readers?</span>\r\n\r\n<span style=\"color: #000000;\">* Is your book dynamic and will it keep the reader\'s attention?</span>\r\n\r\n<span style=\"color: #000000;\">* Does you book answer questions that are meaningful and significant?</span>\r\n\r\n<span style=\"color: #000000;\">If you can answer yes to these questions, you can feel confident about the potential of your ebook.</span>\r\n\r\n<span style=\"color: #000000;\">Another important step is to figure out who your target audience is. It is this group of people you will be writing to, and this group will dictate many elements of your book, such as style, tone, diction, and even length. Figure out the age range of your readers, their general gender, what they are most interested in, and even the socio-economic group they primarily come from. Are they people who read fashion magazines or book reviews? Do they write letters in longhand or spend hours every day online. The more you can pin down your target audience, the easier it will be to write your book for them.</span>\r\n\r\n<span style=\"color: #000000;\">Next, make a list of the reasons you are writing your ebook. Do you want to promote your business? Do you want to bring quality traffic to your website? Do you want to enhance your reputation?</span>\r\n\r\n<span style=\"color: #000000;\">Then write down your goals in terms of publishing. Do you want to sell it as a product on your website, or do you want to offer it as a free gift for filling out a survey or for ordering a product? Do you want to use the chapters to create an e-course, or use your ebook to attract affiliates around the world? The more you know upfront, the easier the actual writing will be.</span>\r\n\r\n<span style=\"color: #000000;\">Decide on the format of your chapters. In non-fiction, keep the format from chapter to chapter fairly consistent. Perhaps you plan to use an introduction to your chapter topic, and then divide it into four subhead topics. Or you may plan to divide it into five parts, each one beginning with a relevant anecdote.</span>\r\n\r\n<span style=\"color: #000000;\">How to make your ebook \"user friendly\"</span>\r\n\r\n<span style=\"color: #000000;\">You must figure out how to keep your writing engaging. Often anecdotes, testimonials, little stories, photos, graphs, advice, and tips will keep the reader turning the pages. Sidebars are useful for quick, accessible information, and they break up the density of the page.</span>\r\n\r\n<span style=\"color: #000000;\">Write with a casual, conversational tone rather than a formal tone such as textbook diction. Reader\'s respond to the feeling that you are having a conversation with them. Break up the length and structure of your sentences so you don?t hypnotize your readers into sleep. Sentences that are all the same length and structure tend to be a good aid for insomnia!</span>\r\n\r\n<span style=\"color: #000000;\">Good writing takes practice. It takes lots and lots of practice. Make a schedule to write at least a page a day. Read books and magazines about the process of writing, and jot down tips that jump out at you. The art of writing is a lifetime process; the more you write (and read), the better your writing will become. The better your writing becomes, the bigger your sales figures.</span>\r\n\r\n<span style=\"color: #000000;\">In an ebook that is read on the screen, be aware that you must give your reader\'s eye a break. You can do this by utilizing white space. In art classes, white space is usually referred to as \"negative space.\" Reader\'s eyes need to rest in the cool white oasis you create on your page. If your page is too dense, your reader will quit out of it as soon as their eyes begin to tear.</span>\r\n\r\n<span style=\"color: #000000;\">Make use of lists, both bulleted and numbered. This makes your information easy to absorb, and gives the reader a mental break from dissecting your paragraphs one after the other.</span>\r\n\r\n<span style=\"color: #000000;\">Finally, decide on an easy-to-read design. Find a font that\'s easy on the eyes, and stick to that font family. Using dozens of fonts will only tire your readers out before they\'ve gotten past your introduction. Use at least one and a half line spacing, and text large enough to be read easily on the screen, but small enough so that the whole page can be seen on a computer screen. You will have to experiment with this to find the right combination.</span>\r\n\r\n<span style=\"color: #000000;\">Of course, don\'t forget to run a spell and grammar check. You are judged by something as minor as correct punctuation, so don?t mess up a great book by tossing out semicolons randomly, or stringing sentences together with commas. (By the way, that\'s called a \"comma splice.\")</span>\r\n\r\n<span style=\"color: #000000;\">Last of all, create an index and a bibliography. That\'s it! You\'ve written a book! Now all you have to do is publish your ebook online, and wait for download request from your website visitors. </span>\r\n\r\n&nbsp;\r\n\r\n<span style=\"color: #000000;\"> </span>", "Writing Your First Ebook", "", "inherit", "closed", "open", "", "32-revision-v1", "", "", "2014-01-31 18:36:56", "2014-01-31 18:36:56", "", "32", "http://blogsforsales.com/ebooks/32-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2014-01-31 18:56:38", "2014-01-31 18:56:38", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover.jpg\"><img class=\"alignleft size-thumbnail wp-image-37\" alt=\"Ecover\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover-150x150.jpg\" width=\"150\" height=\"150\" /></a>Have you ever wondered what all the hype is about e-books?  Why are they so popular?  Would you be able to write your own e-book?  These are just a few of the questions we will answer in today’s article.\r\n\r\nE-books are found almost everywhere on the internet. There are even libraries where you can download free e-books onto your computer. Many of these e-books are free because they are in the public domain, but there are some that have been written specifically to boost advertising.\r\n\r\nWe are now living in the “information age” where people want to get valuable input quickly and easily. This is where e-books lead the way in a world where information is so often sought after. The contribution of e-books to the internet marketplace is one of the forerunning advertisement methods in use today.\r\n\r\nHow is it used to promote your business?\r\n\r\nBy offering e-books to those people who visit your site, you are allowing your visitors to know a bit more about the product/service you are promoting. By writing on a topic that you are familiar with you set yourself up as an expert in your particular field.<!--more-->\r\n\r\nBy using a form to capture your visitor’s names and email addresses you are also building up your very own opt-in mailing list. Is it any wonder that so many people are using this as a viral marketing tool?\r\n\r\nPerhaps you are wondering how you too can get on the bandwagon of writing e-books to help boost the traffic to your website or organization.\r\n\r\nObviously, first you must write the e-book. What should you write your e-book on? Your e-book should be based on information that you are already familiar with.  Do you have a particular niche that you would like to promote?  Then write according to your expertise.\r\n\r\nFor example, if you are a dog lover, you could write a book about taking proper care of canines, or write about a particular type of dog that you are familiar with.  It is more advantageous to write about something concerning your particular market but writing about a complimentary market could also bring you leads that you can use to boost your business.\r\n\r\nThe important point is to get your name out in the public eye of the internet community so that they will look to you for the expert advice that you can offer.\r\n\r\nWhat if you cannot write a book?  You may have ideas and know what you want to talk about but you are unable to compose your thoughts in a clear, precise manner.  In this situation, all is not lost.  You can hire, usually for a small fee, someone else to write the book for you. This is called “ghost writing” and is actually a very common practice.\r\n\r\nTo hire a ghost writer it is your responsibility to make sure that he/she knows what it is you wish to convey in your e-book and they will go about and write the book for you. You pay them to write the e-book but it is your name that appears as the author.\r\n\r\nNow that you have the knowledge, the rest is up to you. The power behind e-books is the leverage it will give you in the internet marketplace. Get started today.\r\n\r\n&nbsp;", "The Power Behind E-books", "", "publish", "closed", "open", "", "36", "", "", "2014-01-31 19:04:38", "2014-01-31 19:04:38", "", "0", "http://blogsforsales.com/ebooks/?p=36", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2014-01-31 18:56:15", "2014-01-31 18:56:15", "", "Ecover", "", "inherit", "closed", "open", "", "ecover", "", "", "2014-01-31 18:56:15", "2014-01-31 18:56:15", "", "36", "http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2014-01-31 18:56:38", "2014-01-31 18:56:38", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover.jpg\"><img class=\"alignleft size-thumbnail wp-image-37\" alt=\"Ecover\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover-150x150.jpg\" width=\"150\" height=\"150\" /></a>Have you ever wondered what all the hype is about e-books?  Why are they so popular?  Would you be able to write your own e-book?  These are just a few of the questions we will answer in today’s article.\r\n\r\nE-books are found almost everywhere on the internet. There are even libraries where you can download free e-books onto your computer. Many of these e-books are free because they are in the public domain, but there are some that have been written specifically to boost advertising.\r\n\r\nWe are now living in the “information age” where people want to get valuable input quickly and easily. This is where e-books lead the way in a world where information is so often sought after. The contribution of e-books to the internet marketplace is one of the forerunning advertisement methods in use today.\r\n\r\nHow is it used to promote your business?\r\n\r\nBy offering e-books to those people who visit your site, you are allowing your visitors to know a bit more about the product/service you are promoting. By writing on a topic that you are familiar with you set yourself up as an expert in your particular field.<!--more-->\r\n\r\nBy using a form to capture your visitor’s names and email addresses you are also building up your very own opt-in mailing list. Is it any wonder that so many people are using this as a viral marketing tool?\r\n\r\nPerhaps you are wondering how you too can get on the bandwagon of writing e-books to help boost the traffic to your website or organization.\r\n\r\nObviously, first you must write the e-book. What should you write your e-book on? Your e-book should be based on information that you are already familiar with.  Do you have a particular niche that you would like to promote?  Then write according to your expertise.\r\n\r\nFor example, if you are a dog lover, you could write a book about taking proper care of canines, or write about a particular type of dog that you are familiar with.  It is more advantageous to write about something concerning your particular market but writing about a complimentary market could also bring you leads that you can use to boost your business.\r\n\r\nThe important point is to get your name out in the public eye of the internet community so that they will look to you for the expert advice that you can offer.\r\n\r\nWhat if you cannot write a book?  You may have ideas and know what you want to talk about but you are unable to compose your thoughts in a clear, precise manner.  In this situation, all is not lost.  You can hire, usually for a small fee, someone else to write the book for you. This is called “ghost writing” and is actually a very common practice.\r\n\r\nTo hire a ghost writer it is your responsibility to make sure that he/she knows what it is you wish to convey in your e-book and they will go about and write the book for you. You pay them to write the e-book but it is your name that appears as the author.\r\n\r\nNow that you have the knowledge, the rest is up to you. The power behind e-books is the leverage it will give you in the internet marketplace. Get started today.\r\n\r\n&nbsp;", "", "", "inherit", "closed", "open", "", "36-revision-v1", "", "", "2014-01-31 18:56:38", "2014-01-31 18:56:38", "", "36", "http://blogsforsales.com/ebooks/36-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("39", "1", "2014-01-31 19:04:38", "2014-01-31 19:04:38", "<a href=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover.jpg\"><img class=\"alignleft size-thumbnail wp-image-37\" alt=\"Ecover\" src=\"http://blogsforsales.com/ebooks/wp-content/uploads/2014/01/Ecover-150x150.jpg\" width=\"150\" height=\"150\" /></a>Have you ever wondered what all the hype is about e-books?  Why are they so popular?  Would you be able to write your own e-book?  These are just a few of the questions we will answer in today’s article.\r\n\r\nE-books are found almost everywhere on the internet. There are even libraries where you can download free e-books onto your computer. Many of these e-books are free because they are in the public domain, but there are some that have been written specifically to boost advertising.\r\n\r\nWe are now living in the “information age” where people want to get valuable input quickly and easily. This is where e-books lead the way in a world where information is so often sought after. The contribution of e-books to the internet marketplace is one of the forerunning advertisement methods in use today.\r\n\r\nHow is it used to promote your business?\r\n\r\nBy offering e-books to those people who visit your site, you are allowing your visitors to know a bit more about the product/service you are promoting. By writing on a topic that you are familiar with you set yourself up as an expert in your particular field.<!--more-->\r\n\r\nBy using a form to capture your visitor’s names and email addresses you are also building up your very own opt-in mailing list. Is it any wonder that so many people are using this as a viral marketing tool?\r\n\r\nPerhaps you are wondering how you too can get on the bandwagon of writing e-books to help boost the traffic to your website or organization.\r\n\r\nObviously, first you must write the e-book. What should you write your e-book on? Your e-book should be based on information that you are already familiar with.  Do you have a particular niche that you would like to promote?  Then write according to your expertise.\r\n\r\nFor example, if you are a dog lover, you could write a book about taking proper care of canines, or write about a particular type of dog that you are familiar with.  It is more advantageous to write about something concerning your particular market but writing about a complimentary market could also bring you leads that you can use to boost your business.\r\n\r\nThe important point is to get your name out in the public eye of the internet community so that they will look to you for the expert advice that you can offer.\r\n\r\nWhat if you cannot write a book?  You may have ideas and know what you want to talk about but you are unable to compose your thoughts in a clear, precise manner.  In this situation, all is not lost.  You can hire, usually for a small fee, someone else to write the book for you. This is called “ghost writing” and is actually a very common practice.\r\n\r\nTo hire a ghost writer it is your responsibility to make sure that he/she knows what it is you wish to convey in your e-book and they will go about and write the book for you. You pay them to write the e-book but it is your name that appears as the author.\r\n\r\nNow that you have the knowledge, the rest is up to you. The power behind e-books is the leverage it will give you in the internet marketplace. Get started today.\r\n\r\n&nbsp;", "The Power Behind E-books", "", "inherit", "closed", "open", "", "36-revision-v1", "", "", "2014-01-31 19:04:38", "2014-01-31 19:04:38", "", "36", "http://blogsforsales.com/ebooks/36-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2014-01-31 19:05:08", "2014-01-31 19:05:08", " ", "", "", "publish", "closed", "open", "", "40", "", "", "2014-01-31 19:27:39", "2014-01-31 19:27:39", "", "0", "http://blogsforsales.com/ebooks/?p=40", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("41", "1", "2014-01-31 19:06:59", "2014-01-31 19:06:59", "A few simple tricks to help you leap over the competition - Ebook publishing tips and tricks.", "Ebook Marketing", "", "publish", "closed", "open", "", "ebook-marketing", "", "", "2014-01-31 19:30:17", "2014-01-31 19:30:17", "", "0", "http://blogsforsales.com/ebooks/ebook-marketing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2014-02-03 12:36:36", "2014-02-03 12:36:36", "WATCH OUT!\n\nSide effects of reading this book include a sudden surge of self-esteem and unprecedented decisiveness in making marketing decisions. Also common are a lifetime addiction to web automation and web data scraping.\n<!--more-->\nAfter reading this book, if you spend more than 4 hours with web bots a day, call a therapist right away.\n\nI&#039;m sure you&#039;ve wondered why your competitors&#039; books are selling better than yours. In a perfect world governed by meritocracy, your books would have been selling much better than your competitors&#039;. But Amazon is not that perfect world. Amazon is a jungle where the street-smart prevail and prosper.\n\nWhat if I tell you the key is marketing? &quot;Here we go again,&quot; you roll your eyes: &quot;Who hasn&#039;t heard that before? Tell me something I don&#039;t know.&quot;\n\nWhat if I tell you the key is marketing with web bots? Would I get your full attention?\n\nThis book may just be the ultimate answer to questions that have been bothering you. I have no doubt it will put energy, wisdom and tangible result in your next book marketing move.\n\nFree\n\nWhen you purchase the paperback of this book, you will get FIVE Kindle books of my recent popular titles FREE! Included in the FIVE are as follows: KDP&#039;s Best-Kept Secret Revealed: How to Embed Videos and Widgets in Your Book Description Social Networking inside Your Kindle Book Descriptions Likeable Marketing Begins at Your Amazon Page: How to Embed Facebook Likes in Book Descriptions Get Twitter Followers While Selling Your Books: How to Embed a Tweet Box in Your Book Description How to Embed Social Share Buttons in Your Kindle Book Pages Click on &quot;M. Eigh&quot;(The Author Name) on top of this page and you will be able to preview those titles!\n\nAll you need to do is forward your Amazon purchase confirmation to me at eigh.com at gmail.com dot com; I will send you the FIVE additional Kindle books as soon as my schedule allows.\n\nFREE ebook offer is ONLY applicable to purchases of paperbacks.", "Whispers, Contagion and Espionage: Web Marketing with Bots", "", "future", "closed", "open", "", "whispers-contagion-and-espionage-web-marketing-with-bots", "", "", "2014-02-03 12:36:36", "2014-02-03 12:36:36", "", "0", "http://blogsforsales.com/ebooks/whispers-contagion-and-espionage-web-marketing-with-bots/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2014-02-03 16:35:18", "2014-02-03 16:35:18", "&quot;This book actually made me cry at the end and that is unusual for a non-fiction book. It just gave me the validation as a writer that I&#039;ve never had before. Seldom do I run across other writers in person and so reading Mark&#039;s book really was a confidence booster. I recommend this book to all writers especially those who are new. It&#039;s the added boost we all need to see our little &quot;babies&quot; rise from the literary crib to adulthood.&quot;\n~ 5-star Review by: Kathleen Morris on Sep. 27, 2012 at Smashwords\n\nLearn the 30 secrets of the bestselling self-published ebook authors. Learn how to make your book more discoverable and more desirable to readers. Learn how to reach readers around the globe at Amazon and other major retailers.\n<!--more-->\nThis updated 2013 edition of The Secrets to Ebook Publishing Success has already helped tens of thousands of self-published ebook authors publish more professionally and with greater success.\n\nThis ebook is a must-read for every writer, author, publisher and literary agent. Whether you&#039;re considering publishing a book for the first time, or you&#039;re a long-time veteran, this book will help you take your self-publishing to the next level.\n\nIncludes a comprehensive glossary of e-publishing terms. No technical experience necessary!\n\nA great companion to Mark Coker&#039;s other popular e-publishing guides, The Smashwords Style Guide (how to format and publish an ebook) and The Smashwords Book Marketing Guide (how to market any book for free).\n\nShare the secrets. Enjoy!\n\nTable of Contents\n\nPreface\nIntroduction\nThe Secrets\nSecret 1: Write a great book\nSecret 2: Pinch your pennies\nSecret 3: Create a great ebook cover\nSecret 4: Practice metadata magic\nSecret 5: Write another great book\nSecret 6: Build reader trust\nSecret 7: Embrace your obscurity\nSecret 8: Spend your time wisely\nSecret 9: Maximize distribution\nSecret 10: Avoid exclusivity\nSecret 11: Give (some of) your books away for FREE\nSecret 12: Understand the algorithm\nSecret 13: How retailers select titles for feature promotion\nSecret 14: Patience pays\nSecret 15: How books develop (the four behaviors)\nSecret 16: Trust your customers and supply chain partners\nSecret 17: Platform building starts yesterday\nSecret 18: Architect for virality\nSecret 19: Tweak your viral catalysts\nSecret 20: Optimize discovery touch points\nSecret 21: Practice the never-ending book launch\nSecret 22: Think globally\nSecret 23: Study the bestsellers\nSecret 24: Develop a thick skin\nSecret 25: Think beyond price\nSecret 26: Pricing Strategy: Unit volume is a lever for success\nSecret 27: Ebook publishing is easy, writing is difficult\nSecret 28: Define your own success\nSecret 29: Leverage preorders to increase sales\nSecret 30: Share your secrets\n\nAppendix I – Glossary of E-Publishing Terms\nAppendix II – Special acknowledgements for beta readers\nAppendix III – Credits\nAppendix IV – Reproduction rights (how to distribute this book freely)", "Secrets to Ebook Publishing Success (Smashwords Guides)", "Secrets to Ebook Publishing Success (Smashwords Guides) - Kindle edition by Mark Coker. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Secrets to Ebook Publishing Success (Smashwords Guides).", "future", "closed", "open", "", "secrets-to-ebook-publishing-success-smashwords-guides", "", "", "2014-02-03 16:35:18", "2014-02-03 16:35:18", "", "0", "http://blogsforsales.com/ebooks/secrets-to-ebook-publishing-success-smashwords-guides/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2014-02-04 12:01:03", "2014-02-04 12:01:03", "Learn how to market any book. This popular book marketing primer has helped over 100,000 authors and publishers dramatically improve their book marketing results.\n\nThe Smashwords Book Marketing Guide contains practical, easy-to-implement advice on how to market any book. 41 simple, do-it-yourself marketing tips explain not what you can do to market your book, but also explain the context and thinking behind each recommendation. The marketing techniques apply equally well to both ebooks and print books.\n<!--more-->\nHere&#039;s what you&#039;ll learn in the Smashwords Book Marketing Guide:\n\nTable of Contents\n\nIntroduction: About the Smashwords Book Marketing Guide\nBackground on Smashwords\nSetting expectations\nHow Smashwords helps authors and publishers market books\nAdopting a proactive marketing mindset\nMarketing starts now\nHyperlinks help readers discover books\nThe importance of authors helping authors\n\n41 Marketing Tips (all free to implement!)\nTip #1 – Update your email signature\nTip #2 – Post a notice on your web site or blog\nTip #3 – Contact your friends, family, co-workers and fans\nTip #4 – Post a notice to your social networks\nTip #5 – Update your message board signatures\nTip #6 – How to reach readers with Twitter\nTip #7 – Publish more than one book to create a multiplier effect\nTip #8 – Advertise your other books in each book you publish\nTip #9 – Make it easy for your readers to connect with you\nTip #10 – Issue a press release on a free PR wire service\nTip #11 – Join HARO, Help-a-reporter-online for free press leads\nTip #12 – Encourage fans to purchase and review your book\nTip #13 – Write thoughtful reviews for other books\nTip #14 – Participate in online forums\nTip #15 – Experiment with coupons\nTip #16 – Write a blog\nTip #17 – Write guest columns for blogs\nTip #18 – Invite other authors to post to your blog\nTip #19 – Do Q&amp;A interviews of other authors on your blog\nTip #20 – Join the conversation on blogs\nTip #21 – Organize a blog tour\nTip #22 – Use Google Alerts to discover where the conversations are taking place\nTip #23 – Leverage YouTube videos to reach readers\nTip #24 – Print up business cards\nTip #25 – Encourage your fans to become affiliate marketers of your book\nTip #26 – Create a reader’s guide at the end of your book\nTip #27 – Insert sample chapters from your other books\nTip #28 – Do a sample chapters swap with another author\nTip #29 – Invite other authors to join you at Smashwords\nTip #30 – Promote your book to the top ebook listing sites\nTip #31 – Read the Secrets to Ebook Publishing Success\nTip #32 – Upgrade your cover image\nTip #33 – Share these marketing tips with your fellow authors!\nTip #34 – Create an online calling card with About.me\nTip #35 – Create a presentation and upload it to SlideShare.net\nTip #36 – Join LinkedIn, post links to your books\nTip #37 – Do a presentation at your local library on ebook publishing\nTip #38 – Tweak your Viral Catalysts to make your book more discoverable and desirable\nTip #39 – Link to every retailer to reach more readers\nTip #40 – Distribute your book as a preorder\nTip #41 – Publish a Smashwords Interview\n\nOther Kindle Books by Mark Coker\nSmashwords Style Guide (how to format and produce an ebook)\nThe 10-Minute PR Checklist - How to Earn the Publicity You Deserve\nBoob Tube (a novel about soap operas)", "Smashwords Book Marketing Guide - How to Market any Book for Free (Smashwords Guides)", "", "future", "closed", "open", "", "smashwords-book-marketing-guide-how-to-market-any-book-for-free-smashwords-guides", "", "", "2014-02-04 12:01:03", "2014-02-04 12:01:03", "", "0", "http://blogsforsales.com/ebooks/smashwords-book-marketing-guide-how-to-market-any-book-for-free-smashwords-guides/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2014-02-04 16:53:19", "2014-02-04 16:53:19", "2014 Edition: Generate an Income Stream by Using Proven Methods\nSee How the Pro&#039;s Find Best-Selling Nonfiction eBook Ideas\n\nSee our &quot;Look Inside&quot; now for a writer-friendly technique of finding topics that Sell with top #rankings. -- How to see if a book might pay enough, before you &#039;take on the job&#039; of writing it.\n-- Simple ways to research for topics that sell before you invest time writing your books.\n<!--more-->\nThe &#039;no social media&#039; way to sell eBooks, and how to write them quickly.A Plan for writing profitable eBooks that you can repeat over and over again.How to Plan your book Launch - Using Kindle Promotions (free).Get a Fast Start by making a blueprint to write &amp; market eBooks without wasting time.\n\nDon’t ask customers to “Like Me”, ask them to “Buy Now” SELL WITHOUT SOCIAL MEDIANo Advanced Computer skills or Marketing Experience Required.See how the pro&#039;s use real-time search to find topics that sell really well.Start today to build Extra Income Streams from eBooks by writing nonfiction.\n\nLearn to “Go To School” by researching existing best-sellers on Kindle; save time by focusing on what works.\n\nSpecial sections of this book show you all about:Learn to use Kindle Promotions to get top #rankings in categoriesPower Up Sales by Power Packing your &quot;Look Inside&quot;Use our system to get legitimateReviews that are customer magnets.How Use Your Your Sales Reports to fine-tune your listing for maximum sales.\n\nLearn the business of writing short, nonfiction eBooks on specialized topics that are already selling eBooks. Stop trying to guess what works and learn to research how a topic is selling before you write the book. The key to building a steady income stream from book sales - is to find what works, then just repeat it - over and over for higher royalties. Tips on writing great books and building your own business selling ebooks. Let&#039;s get started, now!", "Kindle Cash Publishing Marketing Selling Nonfiction", "Kindle Cash Publishing Marketing Selling Nonfiction - Kindle edition by Don A. Singletary. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Kindle Cash Publishing Marketing Selling Nonfiction.", "future", "closed", "open", "", "kindle-cash-publishing-marketing-selling-nonfiction", "", "", "2014-02-04 16:53:19", "2014-02-04 16:53:19", "", "0", "http://blogsforsales.com/ebooks/kindle-cash-publishing-marketing-selling-nonfiction/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2014-02-05 16:45:56", "2014-02-05 16:45:56", "How To Sell More Kindle Ebooks In 7 Days\n\n I Believe Kindle Publishing Should Be Fun, Profitable And Very, Very Easy\n<!--more-->\n If you want your book to become a Kindle best seller I can show you how! Learn how to:\n\n Increase Your Book&#039;s Amazon And Google Search Traffic By 423% In 30 Minutes\n\n If you&#039;re a self-published author without a large platform or following, you will never be able to promote more than the published authors with huge marketing budgets. But you can outrank them on Amazon search every time! Why? Because 99% of Kindle authors don&#039;t know how to increase their search engine rankings in Amazon and Google. But I do - and I&#039;m going to show you how in this book (it won&#039;t cost you a dime to implement these strategies).\n\n Most authors (even the ones with publishers and big marketing budgets) have no idea how to do keyword research, tag their book, add the right search keywords when they publish their book or insert keywords in their book description without it sounding like it was written by a robot.\n\n For New Authors: Step-By-Step Instructions With Picture Tutorials\n\n If you&#039;re a first-time Kindle publisher or technologically challenged then this book is for you! I even had my Grandma Ann Knowles follow the instructions step by step and she gave it a big thumbs up for easy to use instructions. The playing field has been leveled with ebook publishing - and if my Grandma can do it I guarantee you can too!\n\n For Existing Authors: How To Sell More Books In 5 Days Than You Did Last Month\n\n I&#039;m going to share with you my KDP Select Free Promotion Marketing Formula for getting tens of thousands of readers to download your book in just 5 days. All you have to do is read the Marketing Formula instructions and follow them (it takes about 3 hours of work to get thousands of new readers).\n\n How To Sell On Kindle Using Your Book Description\n\n If you think your book is going to sell itself think again! If you&#039;re a fiction author or novelist, you have to show your readers the story and engage them in it or they won&#039;t buy a book from an unknown author. And if you&#039;re a non-fiction author, you have to tell potential readers how your book is going to help them solve their problem fast or they&#039;ll click away without buying. I&#039;m going to show you the Show And Tell system for selling more books on Kindle by giving you readers what they want and overcoming objections in your book description!\n\n Kindle marketing isn&#039;t about having a big marketing budget or publisher behind you - but you still need exposure and a great offer. This book will help you with get more exposure with Amazon search and other great marketing tips.\n\n You also have to make buying your book an irresistible offer so that when browsers get done reading your book description they say, &quot;I have to buy this book!&quot; You can&#039;t do that without a strategic plan and a well-written book description.\n\n Bonus! Video interviews with best-selling Kindle authors as they share their coveted book marketing strategies.\n\n About The Author\n\n My poetry was first published at age 16 in Teen Ink magazine and I started writing books at age 19 but had no idea how to get my message out to anyone other than my friends and family. Finally, I discovered Amazon&#039;s Kindle Publishing platform and published my first book on Kindle on February 10, 2012.\n\n Since then, I&#039;ve sold tens of thousands of ebooks on Kindle and now earn a full-time income as a part-time Kindle author. I&#039;ve since helped hundreds of self-published authors like myself sell more books on Kindle. If I can do it you can too!\n\n Learn how to sell more books on Amazon today. Scroll up and grab your copy today.", "The Kindle Publishing Bible: How To Sell More Kindle Ebooks on Amazon (The Kindle Bible)", "The Kindle Publishing Bible: How To Sell More Kindle Ebooks on Amazon (The Kindle Bible) [Tom Corson-Knowles] on . *FREE* shipping on qualifying offers. <b><font align=center>How To Sell More Kindle Ebooks In 7 Days</font></b> <b><font align=center>I Believe Kindle Publishing Should Be Fun", "future", "closed", "open", "", "the-kindle-publishing-bible-how-to-sell-more-kindle-ebooks-on-amazon-the-kindle-bible", "", "", "2014-02-05 16:45:56", "2014-02-05 16:45:56", "", "0", "http://blogsforsales.com/ebooks/the-kindle-publishing-bible-how-to-sell-more-kindle-ebooks-on-amazon-the-kindle-bible/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("47", "1", "2014-02-07 12:48:30", "2014-02-07 12:48:30", "Is it really possible to make a living as a self-published or small press author? Best-selling author, Karen Baney understands how hard it is to sell eBooks. Her success didn’t come overnight, but instead it came through persistence and patience. She applied the principles and tips of book marketing success that she now shares with you. “I want to help other authors break out of the grind of dismal book sales. There are so many techniques from the world of business that we, as authors, can apply to our writing business.” –Karen Baney This book is designed for the busy writer: concise and information packed. Well-organized, it is broken down into 10 key areas of eBook marketing. Each key contains: • Success Tips – brief impactful statements that drive home important points • Do’s and don’ts for marketing and building your brand as an author • Concise lists summarizing each key • Marketing Minute—an opportunity to evaluate your own progress and apply what you just learned to your marketing plan. What makes Karen Baney a creditable authority? In addition to 20 years in business, she holds a Masters of Business Administration from Arizona State University. In her second year as a published author she achieved over 200,000 eBook downloads. Whether you’re a new or veteran author, 10 Keys to eBook Marketing Success can help you learn how to sell books online and improve your marketing plan.", "10 Keys to Ebook Marketing Success", "", "future", "closed", "open", "", "10-keys-to-ebook-marketing-success", "", "", "2014-02-07 12:48:30", "2014-02-07 12:48:30", "", "0", "http://blogsforsales.com/ebooks/10-keys-to-ebook-marketing-success/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2014-02-07 15:58:48", "2014-02-07 15:58:48", "25% off FOR A LIMITED TIME! Normally $3.99.\n\nDo you want to quit your day job and follow your dream as a published writer?\n<!--more-->\nA comprehensive, hyperbole-free introduction to publishing your work on Amazon&#039;s KDP\n\n*Now with bonus addendum &quot;The Power of Free on Amazon Kindle&quot;*\n\nThe rise of self-publishing on has recently allowed writers around the world to realize their dream of publishing their books in the world&#039;s largest book stores.\n\nThe facts speak for themselves - write and publish a book today and it can earn you the passive income you need to get writing on the next book...and the next one after that.\n\nGlen Chapman (author of &quot;The Power of Free on Amazon Kindle&quot;) outlines everything you need to know to publish and market your book, with a particular focus on Amazon, by far the biggest eBook store in the world. This is the guide he wishes he had read when he was starting out!\n\nIncluding -\n\n- Getting Started\n\n- Formatting Your Book\n\n- Creating Effective Book Covers that Sell\n\n- Publishing Your First Book through KDP\n\n- The importance of getting those first few sales to increase visibility\n\n- Coming Up With the Perfect Title and Synopsis\n\n- Pricing Strategy\n\n- KDP Select ”&quot; Do You Go Exclusive or Play the Field?\n\n- Should You Read Reviews of Your Books?\n\n- The Value of Promoting Outside of Amazon\n\n- Should You Take Advantage of KDP Select Free Days?\n\n- Death &amp; Taxes\n\n- Amazon Alternatives\n\n- The Importance of Genuine Reviews\n\n- Paid Promotion ”&quot; Is it worth it?\n\n- The Importance of Blogs\n\n- Social Marketing\n\n- Perma-Free\n\n- Kindle Countdown Deals\n\n- Those Pesky Refunds\n\n- Fiction v Non-Fiction\n\n- Print on Demand\n\n- The Amazon algorithms\n\n- Links &amp; Resources\n\nThere are some fabulous publishing guides out there (such as Write.Publish.Repeat), but there are also a lot of hyped up books that overstate your chances of becoming a best-seller and sound like they are selling you an Ab-Roller or a ShamWow. Unless lightning just happens to strike in the right place, the only thing that will get you a best-seller is a lot of writing and a lot of clever promotion. It&#039;s a slow grind that is only for those passionate about writing. If you are looking for a source of income to replace your blog advertising or other get rich quick scheme, this is not the guide for you. If you can think of nothing better than using your words to weave magic for the widest possible audience (and get paid for it to boot!), this guide may just be up your alley.\n\n˃˃˃ Now is the time to establish a presence on Amazon - it&#039;s easier than you think to get started. If you have a novel ready to go, you could literally &#039;go live&#039; on Amazon within 24 hours from now! But that&#039;s just when the hard work begins...\n\nGrab a copy today to get your copy for 25% off!", "The Newbie\'s Guide to Publishing on Amazon - A comprehensive guide to getting started in self-publishing", "", "future", "closed", "open", "", "the-newbies-guide-to-publishing-on-amazon-a-comprehensive-guide-to-getting-started-in-self-publishing", "", "", "2014-02-07 15:58:48", "2014-02-07 15:58:48", "", "0", "http://blogsforsales.com/ebooks/the-newbies-guide-to-publishing-on-amazon-a-comprehensive-guide-to-getting-started-in-self-publishing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2014-02-09 11:03:53", "2014-02-09 11:03:53", "Outlines the methods the top 5% of successful self-published authors utilize to produce their eBooks in a professional, cost-effective manner.\nShows what happened after Amazon changed the rules and what you need to do right now to adjust your strategy.\nHow to adopt the philosophy that will allow promotional opportunities to come to you.\nIn February 2012 Martin Crosbie&#039;s self-published eBook &quot;My Temporary Life&quot; hit Amazon&#039;s top ten overall bestseller list. The next month Amazon posted a press release revealing that Crosbie had made $46,000 in one month, with one book. Prior to this, his novel was rejected one hundred and thirty times by traditional publishers and agents. In the months that followed, &quot;My Temporary Life&quot; and its sequel have been consistent sellers, often sitting atop Amazon&#039;s rankings. Crosbie&#039;s story has been mentioned in Publisher&#039;s Weekly, Forbes online, and other media outlets around the world. In fact, Amazon referred to him as one of their 2012 success stories in their year-end press release. &quot;How I Sold 30,000 eBooks on Amazon&#039;s Kindle-An Easy-To-Follow Self-Publishing Guidebook&quot; tells the story of how he became a full-time writer, detailing the specific steps he took to find and connect with his readers. Plus, it describes how he adjusted his strategy when Amazon changed their systems.", "How I Sold 30,000 eBooks on Amazon\'s Kindle: An Easy-To-Follow Self-Publishing Guidebook", "How I Sold 30, 000 eBooks on Amazon\'s Kindle: An Easy-To-Follow Self-Publishing Guidebook [Martin Crosbie] on . *FREE* shipping on qualifying offers. <span> <span><strong>Outlines </strong>the methods the top 5% of successful self-published authors utilize to produce their eBooks in a professional", "future", "closed", "open", "", "how-i-sold-30000-ebooks-on-amazons-kindle-an-easy-to-follow-self-publishing-guidebook", "", "", "2014-02-09 11:03:53", "2014-02-09 11:03:53", "", "0", "http://blogsforsales.com/ebooks/how-i-sold-30000-ebooks-on-amazons-kindle-an-easy-to-follow-self-publishing-guidebook/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("50", "1", "2014-02-09 16:52:01", "2014-02-09 16:52:01", "So you&#039;ve published your book but it is not selling? The publishing world is highly competitive, and the advent of ebooks has changed the landscape further in 2010. How you do make your book stand out? This book contains practical ideas that you should pursue to start generating sales.", "My Book Isn\'t Selling! The Chargan Book of Marketing Ideas", "My Book Isn\'t Selling! The Chargan Book of Marketing Ideas - Kindle edition by Philip Ragan. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading My Book Isn\'t Selling! The Chargan Book of Marketing Ideas.", "future", "closed", "open", "", "my-book-isnt-selling-the-chargan-book-of-marketing-ideas", "", "", "2014-02-09 16:52:01", "2014-02-09 16:52:01", "", "0", "http://blogsforsales.com/ebooks/my-book-isnt-selling-the-chargan-book-of-marketing-ideas/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("51", "1", "2014-02-10 10:18:46", "2014-02-10 10:18:46", "Use the power of KDP Select free promotion to get more visibility and more paid sales!\n\nIn this brand new guide, Glen Chapman outlines not only the strategies and techniques for sending your book to the top of the Amazon Free Charts, but also gives you the marketing theory behind your potential strategy.\n<!--more-->\nThere are more than enough guides out there on Amazon and on the various blogs telling you where to promote your free book. Chapman&#039;s approach is slightly different -\n- Where to concentrate your efforts and valuable time, in keeping with Pareto&#039;s law of 80/20. Chapman details the best sites to focus on in terms of &#039;bang for your buck&#039; (or, more accurately &#039;bang for your time&#039;) when you are executing your &#039;free&#039; strategy on KDP Select.\n\n- Why &#039;free&#039; is just another marketing tool\n\n- Why, despite the advent of free books, there will always be the majority of consumers who are prepared to pay for useful information or high-quality entertainment\n\nMany bemoan the advent of KDP select and the &#039;free promotion&#039; in general, however you can&#039;t argue with results. Nascent self-publishers have almost all had the same experience when launching themselves on the Amazon platform - successfully launch your book with a cleverly executed free period on KDP select and you will go on to move significantly higher numbers of books in the period following. Not only will that particular title go on to rank higher and sell more units, any other books by the same author will get the &#039;halo effect&#039; and see a greater number of sales.\n\nScroll up and grab a copy today.", "The Power of Free on Amazon Kindle", "The Power of Free on Amazon Kindle - Kindle edition by Glen Chapman. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading The Power of Free on Amazon Kindle.", "future", "closed", "open", "", "the-power-of-free-on-amazon-kindle", "", "", "2014-02-10 10:18:46", "2014-02-10 10:18:46", "", "0", "http://blogsforsales.com/ebooks/the-power-of-free-on-amazon-kindle/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("52", "1", "2014-02-12 12:05:42", "2014-02-12 12:05:42", "A Step By Step Guide To Making Your Own eBook and Print Book Covers Without Big Expense.\n\nWould you like to create your own eBook and print book covers without having to hire a graphic designer? But you are\n<!--more-->\nhesitant because you think you need buy and learn expensive software and the result will look &quot;home made&quot;?\n\nWouldn&#039;t it be cool to make your own professional looking eBook and print book covers using software you already have and know how to\n\nuse?\n\nThis is definitely within your reach. Making your own book covers is a lot of fun and it is not as hard or complicated or expensive\n\nas you think.\n\nThe fact is, common software you may already have provides a great tool for making excellent book covers. MS PowerPoint is the\n\nperfect tools for producing superior book covers as it is geared towards graphical presentations and has the utilities needed to\n\nmerge colors, textures, fonts and images together in visually pleasing presentations which can be suitably formatted as book covers.\n\nThis book will provide you with:\n\n• How to use software you are already familiar with to produce top notch book covers which compete with the best.\n• Technical instructions for setting up and formatting both eBook and Print Book covers to meet publishing requirements.\n• Creative design guidelines for producing eye catching book covers in eBook and Print Book sizes.\n• Examples of real books on sale now created using this method.\n• Valuable tool to allow you to maintain control over your book cover designs and keep your costs down.\n\nMaking your own book covers is also a lot of fun!!\n\nYou can do this too - even if you&#039;ve never done it before.\n\nGive it a try - you will be very glad you did!!", "How To Make Your Own Book Covers and Save $1,000\'s !!!", "", "future", "closed", "open", "", "how-to-make-your-own-book-covers-and-save-1000s", "", "", "2014-02-12 12:05:42", "2014-02-12 12:05:42", "", "0", "http://blogsforsales.com/ebooks/how-to-make-your-own-book-covers-and-save-1000s/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("53", "1", "2014-02-13 17:10:36", "2014-02-13 17:10:36", "Do You Want to Sky Rocket Your EBook Sales?\nAmazon&#039;s KDP Select offers publishers a unique opportunity to become a best selling author. In this book you will discover how to use KDP Select to your advantage to enjoy as many sales as possible.\n\n&quot;EBook Publishing: 101+ EBook Marketing Tips With Promotion Spreadsheets!&quot; includes over 101+ marketing tips to kick your promo into high gear PLUS a step by step KDP Select promotion plan with Quick and Easy Spreadsheets!\n<!--more-->\nThis is the exact plan I use to get thousands of downloads on my KDP Select days. Using all free, quality methods, one of my books alone enjoyed over 22,000 downloads (which resulted in hundreds of sales) in just 2 days with KDP Select!\n\nIn the marketing tips section you will discover:\nIncrease your productivity - (how long should you work for, how you can burn calories and get fit while writing your book...+more!)Plan ahead to save time and effort - (easy tip for picking pen names, mind mapping tools...+ more!)Work smarter not harder - (quick character generator, how customer reviews on competitors books can help you write yours...+ more!)Create good book descriptions - (a call to action can increase sales, attention grabbing headlines pique interest...+ more!)Handy Tools for eBooks - (check your rankings all in one place, count up your Kindle book sales in an instant...+ more!)Top Ten Writer Resources - (get inspired with classic free literature, need grammar or style help - find it here...+ more!)And so much more! Over 101+ marketing tips to help kick your promotion into high gear!\nIn addition the book includes my SECRET SAUCE!\nThe book includes a step by step KDP Select promotion activity plan with the Quick and Easy Downloadable Spreadsheets! These spreadsheets will totally organize you, giving you maximum mileage for your efforts!\n\nYou will LOVE how easy it is to open up your spreadsheets and follow the activities to promote your KDP Select days. KDP Select Promo days have never been easier and more effective!\n\nWant to increase your downloads and sales?\n\nGrab your copy of &quot;EBook Publishing: 101+ EBook Marketing Tips With Promotion Spreadsheets!&quot; today!", "EBook Publishing: 101+ EBook Marketing Tips With Promotion Spreadsheets! (Kindle Publishing)", "", "future", "closed", "open", "", "ebook-publishing-101-ebook-marketing-tips-with-promotion-spreadsheets-kindle-publishing", "", "", "2014-02-13 17:10:36", "2014-02-13 17:10:36", "", "0", "http://blogsforsales.com/ebooks/ebook-publishing-101-ebook-marketing-tips-with-promotion-spreadsheets-kindle-publishing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("54", "1", "2014-02-14 12:43:55", "2014-02-14 12:43:55", "Ebook Millionaire is a complete step by step guide to building a massive revenue stream through selling your books online-either via your own blog or via Amazon Kindle and other e-readers.\n\n Many books on Kindle never sell more than one or two copies- not because they are not well written but because they are not well marketed. This book will teach authors the almost guaranteed method of success in self publishing starting from before the book is written: Market research- to guarantee you have a pool of hungry buyers desperate for your book-before you have even written a word!\n<!--more-->\n It also teaches you both external and internal marketing. Many authors are good writers but are not very good at marketing. Internal marketing is optimising the Kindle platform to get more sales, more reviews, get your books listed high on the sales rankings and being seen by more people.\n\n External marketing will explain in an easy to follow format how to blog, how to use Twitter, the importance of Facebook and the value of traditional marketing systems.\n\n E-book Millionaire is not another &quot;get rich quick&quot; guide. This book follows the exact system used by the author to create a regular five figure monthly income from these same methods. The steps are simple but the information world changes all the time and the simple things often get overlooked.\n\n If these are not done properly your book will be lost amongst the thousands vying for the browsers attention.\n\n This book will help you immensely if you are looking to publish your first book, if you already have published a book but it is not selling yet or if you are looking to create a serious self publishing empire with multiple titles in multiple genres.\n\n If you are serious about online book sales and have not read this book, you are simply losing money!", "EBook Millionaire: Your Complete Guide to Making Money Selling EBooks-FAST!", "", "future", "closed", "open", "", "ebook-millionaire-your-complete-guide-to-making-money-selling-ebooks-fast", "", "", "2014-02-14 12:43:55", "2014-02-14 12:43:55", "", "0", "http://blogsforsales.com/ebooks/ebook-millionaire-your-complete-guide-to-making-money-selling-ebooks-fast/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("55", "1", "2014-02-14 16:48:01", "2014-02-14 16:48:01", "Is it really possible to make a living as a self-published or small press author?\nBest-selling author, Karen Baney understands how hard it is to sell eBooks. Her success didn’t come overnight, but instead it came through persistence and patience. She applied the principles and tips of book marketing success that she now shares with you.\n\n“I want to help other authors break out of the grind of dismal book sales. There are so many techniques from the world of business that we, as authors, can apply to our writing business.” –Karen Baney\n<!--more-->\nThis book is designed for the busy writer: concise and information packed. Well-organized, it is broken down into 10 key areas of eBook marketing. Each key contains:\nSuccess Tips – brief impactful statements that drive home important points\nDo’s and don’ts for marketing and building your brand as an author\nConcise lists summarizing each key\nMarketing Minute—an opportunity to evaluate your own progress and apply what you just learned to your marketing plan.\n\nWhat makes Karen Baney a creditable authority? In addition to 20 years in business, she holds a Masters of Business Administration from Arizona State University. In her second year as a published author she achieved over 200,000 eBook downloads.\n\nWhether you’re a new or veteran author, 10 Keys to eBook Marketing Success can help you learn how to sell books online and improve your marketing plan.", "10 Keys to Ebook Marketing Success", "10 Keys to Ebook Marketing Success - Kindle edition by Karen Baney. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading 10 Keys to Ebook Marketing Success.", "future", "closed", "open", "", "10-keys-to-ebook-marketing-success-2", "", "", "2014-02-14 16:48:01", "2014-02-14 16:48:01", "", "0", "http://blogsforsales.com/ebooks/10-keys-to-ebook-marketing-success-2/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("56", "1", "2014-02-15 13:07:38", "2014-02-15 13:07:38", "The Essential Author Success Guide says it all in the title—it is an essential tool for every author&#039;s success not only as a writer but as a marketer.\n\nThe book contains the following categories:\n<!--more-->\n• Self-publishing vs. Traditional Publishing: It compares and contrasts the two and clearly defnes the pros and cons for emerging writers.\n\n• The Five Steps of Self-Publishing: It provides five practical steps that are easily applicable, while offering helpful suggestions on who to partner with.\n\n• How to Market Your Book: It gives helpful advice on how to catch the attention of readers and buyers.\n\n• Kindle Direct Publishing: It answers writer&#039;s questions on how to publish books directly through kindle and how to successfully do it.\n\n• Social Media Marketing: It explores the benefts of social media such as facebook, twitter, and youtube, and investigates ways writers can use these media to their full advantage.\n\n•Boost Your Book Sales with a Virtual Book Tour: It demystifes a Book Blog Tour and shows exactly how writers can use this to enhance their book sales.\n\n• Community Marketing: It draws writers&#039; attention to more traditional forms of marketing such as fundraising and public speaking.\n\n• How to Get Book Reviews: It emphasizes how critical good book reviews are to the success of each book, and offers suggestions on how to gain such positive reviews.\n\n• Free Marketing Strategies: It presents even more insightful ideas on how and where to market self-published books.\n\n• Total Marketing Plan: It enables writers to combine good writing with an excellent marketing plan to ensure the success of their books.\n\n&quot;Self-publishing has never been more easy or possible, and yet talented, enthusiastic writers are often at a loss at how to market their work. The Essential Author Success Guide is a compact, information-rich book designed to empower writers&#039; success.&quot;", "How To Self-Publish and Really Make Money Selling Your Book on Amazon with Kindle eBook Marketing Tactics, Facebook, Twitter, and Blog Marketing Techniques: The Essential Author Success Guide", "", "future", "closed", "open", "", "how-to-self-publish-and-really-make-money-selling-your-book-on-amazon-with-kindle-ebook-marketing-tactics-facebook-twitter-and-blog-marketing-techniques-the-essential-author-success-guide", "", "", "2014-02-15 13:07:38", "2014-02-15 13:07:38", "", "0", "http://blogsforsales.com/ebooks/how-to-self-publish-and-really-make-money-selling-your-book-on-amazon-with-kindle-ebook-marketing-tactics-facebook-twitter-and-blog-marketing-techniques-the-essential-author-success-guide/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("57", "1", "2014-02-16 11:38:14", "2014-02-16 11:38:14", "Having A Hard Time Selling E-Books on Amazon?\nPublished your book on Kindle but no one&#039;s buying? No reviews and languishing at the bottom of Amazon&#039;s search results? Don&#039;t know how to promote your e-book to the masses, or don&#039;t even know where to begin? Kindle Marketing Made Easy can help!\n\nBrought to you by the author of the Amazon Kindle Bestseller, 500 Social Media Marketing Tips, Kindle Marketing Made Easy is your essential Kindle publishing guide, teaching you how to get your fiction or non-fiction e-book ranking higher in Amazon search, encourage rave reviews, promote your work like a pro, and ultimately sell more Kindle e-Books on Amazon!\n<!--more-->\nHere&#039;s Just A Little of What You Will Discover:\n\nHow to craft a killer book title and description that will get your book FOUND on Amazon.How to design a professional book cover that will POP from the screen in search results.A FREE Kindle e-book template to create a professional cover in minutes!How to use free promos to improve your book&#039;s ranking, get reviews, and encourage sales.E-book pricing strategy to earn you the maximum amount of profit possible.How to promote your e-book online and in the real world in mere minutes a week.The two-word strategy that will increase your book sales - guaranteed!A template to have your book formatted and ready to publish on Kindle in minutes!... And lots more!\nThe Facts About Kindle eBook Sales - A.K.A Why Your E-Book Isn&#039;t Selling\nAuthors who received help with story editing, formatting, copy editing and proofreading make 13% more money than the average self-publisher.A professional cover design can boost earnings by a further 34%.10% of all self-publishers - the ones with a great e-book marketing strategy - make 75% of ALL the money, and 50% of self-published e-books make less than $500 a year. Which group would you rather be in?\n\nMake Positive Changes In Minutes!\nKindle Marketing Made Easy features essential advice that will immediately benefit your Kindle marketing plan, and help you build on it in just minutes per day. Don&#039;t miss out! Buy your copy and start the journey to increased book sales today!\n\nP.S. No Kindle? No worries! Buy Kindle Marketing Made Easy to enjoy on Kindle for PC, iPhone, and Android devices too!", "Kindle Marketing Made Easy: How to Promote Like A Pro, Get Rave Reviews, Sell More E-Books on Amazon, and Make Money With Kindle", "", "future", "closed", "open", "", "kindle-marketing-made-easy-how-to-promote-like-a-pro-get-rave-reviews-sell-more-e-books-on-amazon-and-make-money-with-kindle", "", "", "2014-02-16 11:38:14", "2014-02-16 11:38:14", "", "0", "http://blogsforsales.com/ebooks/kindle-marketing-made-easy-how-to-promote-like-a-pro-get-rave-reviews-sell-more-e-books-on-amazon-and-make-money-with-kindle/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("58", "1", "2014-02-16 15:00:22", "2014-02-16 15:00:22", "The Fine Print of Self-Publishing, now in its fifth edition, has been lauded by industry professionals as the go-to book for authors considering self-publishing. The Fine Print has helped thousands of authors understand self-publishing companies&#039; services, contract terms, printing markups, and royalty calculations. This latest edition includes new chapters on e-book publishing and book marketing, as well as updated head-to-head comparisons of major self-publishing service providers, including free book-publishing companies to consider and self-publishing companies to avoid.", "The Fine Print of Self-Publishing, Fifth Edition: A Primer on Contracts, Printing Costs, Royalties, Distribution, E-Books, and Marketing", "The Fine Print of Self-Publishing, Fifth Edition: A Primer on Contracts, Printing Costs, Royalties, Distribution, E-Books, and Marketing [Mark Levine] on . *FREE* shipping on qualifying offers. The Fine Print of Self-Publishing, </i> now in its fifth edition, has been lauded by industry professionals as the go-to book for authors considering self-publishing. The Fine Print</i> has helped thousands of authors understand self-publishing companies\' services", "future", "closed", "open", "", "the-fine-print-of-self-publishing-fifth-edition-a-primer-on-contracts-printing-costs-royalties-distribution-e-books-and-marketing", "", "", "2014-02-16 15:00:22", "2014-02-16 15:00:22", "", "0", "http://blogsforsales.com/ebooks/the-fine-print-of-self-publishing-fifth-edition-a-primer-on-contracts-printing-costs-royalties-distribution-e-books-and-marketing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("59", "1", "2014-02-18 11:34:03", "2014-02-18 11:34:03", "Sol Adoni is a pioneer of the eBook Industry. He has published hundreds of eBooks and has millions of eBooks downloaded over almost 20 years of eBook Publishing.\n\nSol Adoni the honorary chairman of Adoni Publishing explains how to properly format an eBook today and how to promote it.\n<!--more-->\nA short read filled with essential information by an expert in the emerging industry of eBook Publishing", "eBook Publishing - eBook Promotion by Sol Adoni Chairman of Adoni Publishing", "", "future", "closed", "open", "", "ebook-publishing-ebook-promotion-by-sol-adoni-chairman-of-adoni-publishing", "", "", "2014-02-18 11:34:03", "2014-02-18 11:34:03", "", "0", "http://blogsforsales.com/ebooks/ebook-publishing-ebook-promotion-by-sol-adoni-chairman-of-adoni-publishing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2014-02-19 10:54:10", "2014-02-19 10:54:10", "From the author of several Top 100 Kindle eBooks (in their darkly comedic and satirical genres) comes this humorous, yet highly informative booklet which explores the darker side of self-publishing - revealing the many follies and pitfalls; the endless swindles and bamboozles which lurk in the shadowy, slimeball encrusted corners...\n\nIt is tailor-made for anyone fitting the following descriptions:\n<!--more-->\n-Beginning authors trying to get a foot in the door (building your platform)\n\n-Writers who have been bilked out of hundreds of dollars (perhaps more!) on faulty marketing or advertising scams\n\n-Anyone interested in taking the self-publishing or self-marketing route\n\n-Those who wish to understand the common run of the mill schemes which endlessly plague the rapidly expanding marketplace\n\n-People wise enough to realize a little knowledge goes a long way\n\nThis is not a book which states &quot;Follow my ten simple steps and you too can become a best-selling author!&quot;\n\nI am not here to make idle promises, tug at your heart-strings, or pander to your desires - no, no, far from it in fact. For I too grew tired of the deceitful programs, the misleading systems, the fake and fruitless guides that are all too prevalent in this booming industry. I do not whisper sweet nothings in your ear or guarantee success if you purchase my products...I am here to expose the widespread time sinks many, if not all, beginning writers fall victim to. Spare yourself the frustration of countless failed attempts, only to end up clutching handfuls of hair which you have unknowingly ripped from your own head! And that, fair reader, is a hard look to pull off.\n\nWith this book, I hope you will utilize the age old maxim of &quot;Learn from the mistakes of others - you don&#039;t have time to make them all on your own.&quot;\n\nNow come with me and let us take a look inside this depraved activity we call promotion...", "Self-Publishing: Scams, Lies, and BULLSH*T - How NOT to Promote and Market Your Ebook", "Self-Publishing: Scams, Lies, and BULLSH*T - How NOT to Promote and Market Your Ebook - Kindle edition by S.R. Tooms, Lady Spud. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Self-Publishing: Scams, Lies, and BULLSH*T - How NOT to Promote and Market Your Ebook.", "future", "closed", "open", "", "self-publishing-scams-lies-and-bullsht-how-not-to-promote-and-market-your-ebook", "", "", "2014-02-19 10:54:10", "2014-02-19 10:54:10", "", "0", "http://blogsforsales.com/ebooks/self-publishing-scams-lies-and-bullsht-how-not-to-promote-and-market-your-ebook/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("61", "1", "2014-02-20 12:01:26", "2014-02-20 12:01:26", "Have you published an eBook but having trouble getting sales? Wondering how to harness the power of the Internet to promote your novel, short story, or non-fiction title to millions of potential customers? This book can help!\n\n500 Ways to Promote Your eBook Online provides hundreds of simply-written expert tips, sharing secrets about how to build your readership via social media spaces, attract and engage with customers, optimize your book&#039;s cover and blurb, and sell more copies!\n<!--more-->\nYour readers are out there, go and get them with 500 Ways to Promote Your eBook Online.", "500 Ways to Promote Your eBook Online: Internet eBook Marketing Tips to Sales Success for Kindle, Kobo, and More!", "500 Ways to Promote Your eBook Online: Internet eBook Marketing Tips to Sales Success for Kindle, Kobo, and More! - Kindle edition by Andrew Macarthy. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading 500 Ways to Promote Your eBook Online: Internet eBook Marketing Tips to Sales Success for Kindle, Kobo, and More!.", "future", "closed", "open", "", "500-ways-to-promote-your-ebook-online-internet-ebook-marketing-tips-to-sales-success-for-kindle-kobo-and-more", "", "", "2014-02-20 12:01:26", "2014-02-20 12:01:26", "", "0", "http://blogsforsales.com/ebooks/500-ways-to-promote-your-ebook-online-internet-ebook-marketing-tips-to-sales-success-for-kindle-kobo-and-more/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2014-02-20 15:16:49", "2014-02-20 15:16:49", "If you&#039;re an Ebook Author who wants to know the secrets of Ebook Marketing, Ebook Writing, and ebook publishing, then you&#039;re about to discover how to get your own profitable, money-making ebook right now!\n\n&quot;How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask &quot; - gives you the answers to 20 important questions and challenges every Ebook Author faces, including:\nHow do I hire someone to write my ebook for me? (and get GREAT content),,,Can you still make money with ebooks in today&#039;s market? (is it too crowded?)...What are the best ebook topics that will sell? (and which ones suck?)...How do I get my ebook published? (do I need a publisher?)...Can I publish my fiction story or a novel as an ebook and actually sell it?What software do I need to write and publish my ebook? (tip: you probably already have it on your computer!)How do you write a &quot;how to&quot; ebook? (so people LOVE it and want to buy more?)What is a good subject to write an Ebook on that people would be willing to pay for? (so you can cash-in with Kindle!)...... and MUCH more!\n<!--more-->\nSo, if you&#039;re serious about wanting your own profitable, money-making ebook and you want to know how to write and publish ebooks, then you need to grab a copy of &quot;How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask &quot; right now, because Ebook Marketing Expert, Jim Edwards, will reveal to you how every Ebook Author, regardless of experience level, can succeed - Today!", "How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask", "How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask - Kindle edition by Jim Edwards. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading How To Write and Publish Ebooks: The Top 20 Questions Every Ebook Author Needs To Ask.", "future", "closed", "open", "", "how-to-write-and-publish-ebooks-the-top-20-questions-every-ebook-author-needs-to-ask", "", "", "2014-02-20 15:16:49", "2014-02-20 15:16:49", "", "0", "http://blogsforsales.com/ebooks/how-to-write-and-publish-ebooks-the-top-20-questions-every-ebook-author-needs-to-ask/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("63", "1", "2014-02-24 13:48:06", "2014-02-24 13:48:06", "Sell a lot more Kindle ebooks using methods proven to give the best results.\nIf you&#039;re selling ebooks on Amazon, you&#039;re about to find out the very best ways of how to promote your book, and actually selling ebooks on Amazon, The author has found these, more than anything else, to deliver the best results.\n\nPLEASE NOTE: This is for non-fiction Kindle ebooks, not fiction.\n<!--more-->\nI have learned all these methods and strategies through trial and error. I know what works and what doesn&#039;t. These are all the methods I&#039;ve used to sell a lot of Kindle ebooks on Amazon.\n\nIn this book, I explain step-by-step what I do so you can get similar results. I make sure you fully understand by using explanations, examples, and pictures. I tell you everything I know that works best. If it&#039;s not in this book, chances are I&#039;ve found it not to give decent results.\n\nYou&#039;ll learn...\nWhat you must have first to get the very best results\nThis step is simple, but important. If you try to succeed without this, your results will be poor. It&#039;s not difficult.\n\nBe found\nThe best ways of getting the most people to see your book. (It&#039;s not having a website or blog. It&#039;s all on Amazon.)\n\nThe secret to using the best keywords\nThis is how to know what the best keywords are and where to place them for the best results.\n\nI&#039;ll teach you a little trick to make your book appear higher in search results.\n\nHow to select the best category for the most sales\nIf you pick the wrong category, it&#039;ll either be too competitive and result in low sales, or not be competitive enough and give you little or no results.\n\nI&#039;ll show you how to use, what I call, the category climbing method. It&#039;s the best way of building up sales.\n\nMake your sales high by using the book promotion duo\nThese are the only two Kindle ebook marketing strategies I use. That&#039;s because they work better than many other methods I&#039;ve learned. These two book promotion methods work together far more powerfully than on their own. Together, you&#039;ll find they deliver excellent results.\n\nHow to sell ebooks on Amazon the best way\nEasily create book titles that practically sell ebooks on their own\nYou&#039;ll discover the thing that makes all non-fiction Kindle ebooks sell the most. You&#039;ll be able to turn this knowledge to good use by using the powerful feature/benefit formula.\n\nTo help you, I&#039;ll also show you a good little method for creating book titles.\n\nSell more books by writing book descriptions that get the sale\nThis is how to sell books using a description writing method that works. I give you the template that I&#039;ve found works the best.\n\nYou&#039;ll also find out about the list that you can use over and over again.\n\nIncrease your sales by making sure of two important things\nHaving these two, really do make a difference to Kindle ebook sales results.\n\nThe checklist\nAt the end of the book, I lay it all out for you in an easy to follow step-by-step checklist.\n\nYou can either continue to sell your Kindle ebooks using the methods you are using now, or you can start using what works and delivers the best sales results.", "The Kindle Book Sales Formula: How to sell books on amazon the right way - The methods proven to work best (How to Write a Book and Sell It Series)", "", "future", "closed", "open", "", "the-kindle-book-sales-formula-how-to-sell-books-on-amazon-the-right-way-the-methods-proven-to-work-best-how-to-write-a-book-and-sell-it-series", "", "", "2014-02-24 13:48:06", "2014-02-24 13:48:06", "", "0", "http://blogsforsales.com/ebooks/the-kindle-book-sales-formula-how-to-sell-books-on-amazon-the-right-way-the-methods-proven-to-work-best-how-to-write-a-book-and-sell-it-series/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2014-02-25 11:41:04", "2014-02-25 11:41:04", "&quot;How to Self-Publish Your eBook&quot; is everything you need to know from start to finishing about publishing on all the main platforms. So you have written your book and you are excited about getting it out there and selling, but now what? Basically you have two choices: 1. You can spend months trying to learn everything there is to learn about publishing your own eBook or 2. You can read &quot;How to Self-Publish Your eBook from Start to Finish&quot; by James Calthorpe and turbo charge your sales from day 1 James who is also the author of eBook Millionaire (a bestselling book on how to market your eBook) takes you through everything you need to know from start to finish on self-publishing your eBook. This book focuses on eBooks and so if you are interested in publishing your book the traditional way then this book is not for you! This book is for you however if: You want to shortcut the whole publishing process You want to maximise your sales from day 1 You want to save a lot of time, frustration and money You want to know the truth about which companies are best to work with and which platforms work for you What you spend your time on and what tasks actually make you money A personal note from the author: &quot;I wrote this book because it took me so long to find all the pitfalls of self-publishing which cost me a lot of time and money. Finding out what I should be doing to get it right was painful. I wish I had this book when I started publishing my books as I would have made very different decisions and a lot more sales and I would have saved myself months&quot;. James takes you through all the platforms and how to get the best out of them as well as the various tips, hints and techniques you can use to hit your publishing goals quickly. You will learn everything you need to know to prepare your book, who to work with and where the real money is in self-publishing. You will learn: How to load your book quickly and efficiently onto all the main retail outlets How to set your price effectively Which web sites to go to in order to get the best and most up to date information Which companies to use and when to use them based on your goals and YOUR outcomes How to set up your book so you get the most sales you can as soon as you can You can get more book sales! Just apply what you learn here and you will be set up for success.", "How to Self-Publish Your eBook From Start to Finish: Everything You Need to Know to Get to The Top", "How to Self-Publish Your eBook From Start to Finish: Everything You Need to Know to Get to The Top [James Calthorpe] on . *FREE* shipping on qualifying offers. How to Self-Publish Your eBook is everything you need to know from start to finishing about publishing on all the main platforms. So you have written your book and you are excited about getting it out there and selling", "future", "closed", "open", "", "how-to-self-publish-your-ebook-from-start-to-finish-everything-you-need-to-know-to-get-to-the-top", "", "", "2014-02-25 11:41:04", "2014-02-25 11:41:04", "", "0", "http://blogsforsales.com/ebooks/how-to-self-publish-your-ebook-from-start-to-finish-everything-you-need-to-know-to-get-to-the-top/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2014-02-26 14:59:29", "2014-02-26 14:59:29", "After You have created your eBook you will need to Find your Audience and Market your eBook or Digital Product effectively. This title is aimed specifically at eBooks and other Digital Products that are delivered as downloads on the Internet. Because of this Download Delivery there are several Special and Specific Marketing Techniques You Need to Know to Sell Successfully. It is not enough to create your eBook and put it up onto the usual places, Amazon Kindle, Barnes &amp; Noble Nook, and others. Even with great a Great Title and Content and with announcements to your Social Networks you still may not be reaching your full Potential Market. You need to Increase your Exposure and fill in the gaps with Marketing. Plus to be really Successful you will want to automate as much of the process as possible so that you can spend your time creating new eBooks and other products instead of maintaining your marketing. As you follow along, you learn by doing, mastering the programs at your own pace. You are provided with a dynamic educational tool - an information rich resource you can refer to again and again. Sections include: • About eBook Marketing• The Importance of Titles • Determining Your Market • Manufacturing • Using Kunaki • Your Sales Web Site • Your email Auto-responder • Article Writing • Your eBook Blog • Driving Traffic to Sales Page • Forums, Social Media • More Traffic Ideas •", "Marketing eBooks Tutorial Training Course on 1 DVD, 11 Hours in 129 Video Lessons, Computer Software Video Tutorials", "", "future", "closed", "open", "", "marketing-ebooks-tutorial-training-course-on-1-dvd-11-hours-in-129-video-lessons-computer-software-video-tutorials", "", "", "2014-02-26 14:59:29", "2014-02-26 14:59:29", "", "0", "http://blogsforsales.com/ebooks/marketing-ebooks-tutorial-training-course-on-1-dvd-11-hours-in-129-video-lessons-computer-software-video-tutorials/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2014-02-27 12:00:55", "2014-02-27 12:00:55", "So you wrote an eBook and it&#039;s not selling well.\n\nThat&#039;s why you need to read this book, How to Book of eBook Promotion. Written by one of the founders of the eBook Industry, Sol Adoni, who has been creating and selling eBooks through a massive network of websites dedicated to promoting and selling eBooks for almost 20 years..\n<!--more-->\nSol Adoni explains the various techniques a self-published author or small Publishng Company can use to PROMOTE EBOOKS and compete with the big companies.\n\nSol Adoni explains the almost twenty year history of eBooks and chronicles how he used search engines, social media, print, radio and videos to promote and sell eBooks.\n\nIf you have written an eBook and want to self publish it and promote it, this is a MUST READ. It also has vital information to help smaller publishers compete in today&#039;s world of social media, kindles, nooks and google.\n\nA short read packed by vital knowledge by a founder of the digital revolution of eBooks.\n\nLook for Sol Adoni&#039;s other eBooks on eBook Publishng and Marketing on Amazon.", "How to Book of eBook Promotion", "How to Book of eBook Promotion - Kindle edition by Sol Adoni. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading How to Book of eBook Promotion.", "future", "closed", "open", "", "how-to-book-of-ebook-promotion", "", "", "2014-02-27 12:00:55", "2014-02-27 12:00:55", "", "0", "http://blogsforsales.com/ebooks/how-to-book-of-ebook-promotion/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2014-02-27 15:17:16", "2014-02-27 15:17:16", "A Marketing guide ebook that offers a thorough overview of all key facets of the Marketing process. Offers helpful insights to all types of businesses, including small businesses, online operators and marketing professionals.\n\nLearn how market research, solution development, promotion, customer service and relationship management all intertwine in your effort to build and maintain a loyal customer base.", "Marketing as a Business System: A Guide to a Thorough, Integrated Marketing Function for Your Business", "", "future", "closed", "open", "", "marketing-as-a-business-system-a-guide-to-a-thorough-integrated-marketing-function-for-your-business", "", "", "2014-02-27 15:17:16", "2014-02-27 15:17:16", "", "0", "http://blogsforsales.com/ebooks/marketing-as-a-business-system-a-guide-to-a-thorough-integrated-marketing-function-for-your-business/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2014-02-28 12:19:34", "2014-02-28 12:19:34", "If you want to publish your eBook on all the eBook stores (Amazon.com&#039;s Kindle, BarnesandNoble.com&#039;s Nook, Apple&#039;s iBookstore, and more), then get &quot;How to Make Money with Ebooks&quot; now.\n\nHere&#039;s What You Get Inside &quot;How To Make Money With Ebooks&quot;:Discover how to find the right topic that can help sell your eBook.Uncover how to find the BEST title so your eBook can stand out in the marketplace.Find out how to create great content whether you write it yourself or hire someone else to do it for you.How to sell your eBook on ALL the major eBook platforms such as Amazon.com&#039;s Kindle Store, BarnesandNoble.com&#039;s Nook Store, Apple&#039;s iBookstore, Google Play Store, and much more.How to market your eBook the right way without spending a lot of money.Gain greater reach, impact, and profits by learning how to scale up your business by creating more eBooks the right way.Discover how to outsource your work so majority of the work (if not all) can be done by others.What&#039;s Unique About This Book?\n<!--more-->\nDiscover how to sell your eBook on ALL the major eBook platforms (Kindle, Nook, iBookstore, Google Play Store, etc) instead of just one eBook platform.Learn how to publish your eBook from an eBook publisher and author&#039;s point of view since the author has both experiences.Get the exact blueprint that has allowed the author BJ Min to launch 2 publishing companies to produce over 250+ eBooks in fiction &amp; non-fiction genres.Get a complete step-by-step formula to succeed in the eBook business.Access to step-by-step image tutorials to guide you to get real life results.Excellent resource for aspiring authors, authors because this book helps anyone publish their first eBook on all the major platforms.Comprehensive resource for eBook publishers because this is also a great guideline to start a publishing company.Fantastic resource for internet marketers and business owners because the eBook platforms are a great way to generate leads for your business.Gain instant credibility and expertise as an authority in your niche by becoming an author of an eBook/book in your field.\n\nBonus Chapter:\n\nYou also get a BONUS chapterHow to Sell a Physical Book on Amazon.com&#039;s Bookstore!You will discover how to turn your eBook into a PHYSICAL BOOK and sell it on Amazon.com&#039;s BOOKS section.After checking out the bonus chapter, now you can become an author of a real book and an eBook! About author:\n\nAbout the Author:\n\nBJ Min is the publisher of two eBook publishing companies that has published 250+ eBooks in fiction and non-fiction categories on Amazon.com&#039;s Kindle, BarnesandNoble.com&#039;s Nook, Apple&#039;s iBookstore, and more.\n\nIf you want to make and sell your eBook on all the eBook stores (Amazon.com&#039;s Kindle, BarnesandNoble.com&#039;s Nook, Apple&#039;s iBookstore, and more), then get &quot;How to Make Money with Ebooks&quot; now!", "How To Make Money With Ebooks - Your Step-By-Step Guide To Create and Sell Your Ebook on Kindle, Nook, and iBookstore", "How To Make Money With Ebooks - Your Step-By-Step Guide To Create and Sell Your Ebook on Kindle, Nook, and iBookstore [BJ Min] on . *FREE* shipping on qualifying offers. <b>If you want to publish your eBook on all the eBook stores (\'s Kindle, BarnesandNoble.com\'s Nook", "future", "closed", "open", "", "how-to-make-money-with-ebooks-your-step-by-step-guide-to-create-and-sell-your-ebook-on-kindle-nook-and-ibookstore", "", "", "2014-02-28 12:19:34", "2014-02-28 12:19:34", "", "0", "http://blogsforsales.com/ebooks/how-to-make-money-with-ebooks-your-step-by-step-guide-to-create-and-sell-your-ebook-on-kindle-nook-and-ibookstore/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2014-02-28 16:32:21", "2014-02-28 16:32:21", "Publish, market, and sell your own e-book.\nAlthough creating an e-book seems fairly straightforward, it is not. You need to select and create a variety of formats that will be read on a variety of e-reader devices--and market and sell your book in a variety of ways.\n\nBefore you take the plunge, get this practical guide. With clear instruction and sensible advice, it will help you navigate the often confusing, time-consuming, and costly world of self-publishing an e-book. The book gives you solid marketing tips for selling your e-book, including using blogging and social media and how to build an online platform. It also discusses key technologies you&#039;ll encounter, including Smashwords, iBooks Author, Amazon, Microsoft Word, Open Office, Calibre, WordPress, E-junkie, and others.\nHelps readers navigate the confusing, time-consuming, and often costly world of self-publishing an e-book Provides both technical how-tos as well solid marketing advice on how to sell your e-book using Facebook, Twitter, Goodreads, and other social media sites Covers essential technologies, such as Smashwords, iBooks Author, Amazon, Microsoft Word, Open Office, Calibre, WordPress, and E-junkie Explores e-book devices, including Kindle, Kobo, Sony Reader, Nook, iPad, and other tablets Delves into the nitty-gritty of e-book formats Before you self-publish your e-book, start first with Publishing eBooks For Dummies.", "Publishing E-Books For Dummies", "Publishing E-Books For Dummies [Ali Luke] on . *FREE* shipping on qualifying offers. Publish, market, and sell your own e-book. Although creating an e-book seems fairly straightforward, it is not. You need to select and create a variety of formats that will be read on a variety of e-reader devices--and market and sell your book in a variety of ways.  Before you take the plunge", "future", "closed", "open", "", "publishing-e-books-for-dummies", "", "", "2014-02-28 16:32:21", "2014-02-28 16:32:21", "", "0", "http://blogsforsales.com/ebooks/publishing-e-books-for-dummies/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2014-03-01 14:11:16", "2014-03-01 14:11:16", "Ready to go to work with a smile on your face? Interested in helping kids while earning $100 an hour? In this kindle Ebook you learn:\n\n*How to get started on this fun career that helps kids (and you!) become healthier through hooping, even if you have no experience.\n<!--more-->\n*Marketing secrets to book yourself solid\n\n*How to create a lesson plan, where to teach &amp; more\n\nBonus: Purchase this Ebook for your chance to win a Kindle! The author is giving one lucky ready a kindle after 500 copies are sold.", "Hooping with Kids", "Hooping with Kids - Kindle edition by Sarah Maccarelli Jordan, Ashutosh Khandha. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Hooping with Kids.", "future", "closed", "open", "", "hooping-with-kids", "", "", "2014-03-01 14:11:16", "2014-03-01 14:11:16", "", "0", "http://blogsforsales.com/ebooks/hooping-with-kids/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("71", "1", "2014-03-02 10:33:10", "2014-03-02 10:33:10", "Directory of over 50 web sites where you can submit your free ebook promotions to in order to maximize your exposure and downloads.", "Kindle Ebook Marketing Directory", "Kindle Ebook Marketing Directory - Kindle edition by James Thomson. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Kindle Ebook Marketing Directory.", "future", "closed", "open", "", "kindle-ebook-marketing-directory", "", "", "2014-03-02 10:33:10", "2014-03-02 10:33:10", "", "0", "http://blogsforsales.com/ebooks/kindle-ebook-marketing-directory/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2014-03-03 12:39:05", "2014-03-03 12:39:05", "Everybody seems to be writing ebooks these days and so many authors seem to be making a bit of a hash of it. The typesetting and layout could spoil it. The cover may make it a non-seller and the additional marketing that goes into many books these days is nearly non-existent. Here is the answer to the new authors prayers. A &#039;one step at a time&#039; guide to creating an ebook that you will be pleased and proud to call your own and that readers will want to buy. How to make the changes your ebook manuscript might need to change it to the print version - Go ahead and do it, increase your potential market. Marketing ideas that will help you to shift even more units. All the information you need and provided to you by someone who&#039;s been there and done it and still doing it.", "Writing And Marketing Books And Ebooks - One Step At A Time: An easy guide to writing and marketing your written creations", "", "future", "closed", "open", "", "writing-and-marketing-books-and-ebooks-one-step-at-a-time-an-easy-guide-to-writing-and-marketing-your-written-creations", "", "", "2014-03-03 12:39:05", "2014-03-03 12:39:05", "", "0", "http://blogsforsales.com/ebooks/writing-and-marketing-books-and-ebooks-one-step-at-a-time-an-easy-guide-to-writing-and-marketing-your-written-creations/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2014-03-03 16:49:44", "2014-03-03 16:49:44", "This eBook on how to write and publish en eBook will help you get your first eBook listed for sale starting with the Kindle Store, Lulu, and Barnes and Noble.\n\nBut it&#039;s more than just that. I take you through the basics: writing tips, finding niches that you can sell your eBook in using simple and free tools, and more.\n<!--more-->\nThis is not for the advanced eBook writer or publisher, although I am certain there might be a few nuggets for them as well.\n\nIt&#039;s for the person just starting out in the eBook writing and marketing journey.\n\nI&#039;ve taken great pains to be sure that everything is simple to understand and implement and I am certain you&#039;ll enjoy the eBook and the journey...\n\nTable of Contents:\n\nWhy publish your eBooks online? 4\nReason #1: We live in a modern world 4\nReason #2: The market for eBooks has exploded 5\nReason #3: There’s money to be made 5\n\nDoes eBook Design Matter? 7\n\nWhat Makes A Quality eBook! 7\n\nYour Best Solutions 8\n\nHow do you write an eBook that sells? 12\n\n#1 The Basic Layouts of your eBook: The Cover 13\n#2 The Basic Layouts of your eBook: Table of Contents 18\n#3 The Basic Layouts of your eBook: Copyright &amp; Disclaimer 19\n#4 The Basic Layouts of your eBook: Formatting 20\n#5 The Basic Layouts of your eBook: Bonuses &amp; about the Author 24\nMajor Principle #1: Write with result-oriented focus 26\nMajor Principle #2: Write with plain simple language 29\nMajor Principle #3: Write with a lot of spacing 30\n\nWhat you should do right now! 34\nStep 1: Research niches 34\nStep 2: Start writing using basic layout and principles 35\nStep 3: Publish using the step-by-step guides 37\n\nHow do you publish your eBook? 38\nStep-by-Step: How to publish on Kindle Store 38\nStep-by-Step: How to publish on Lulu.com 50\nStep-by-Step: How to publish on BN.com 63", "eBook Publishing Guide: How To Write an eBook & Publish It Online In Less Than 7 days!", "", "future", "closed", "open", "", "ebook-publishing-guide-how-to-write-an-ebook-publish-it-online-in-less-than-7-days", "", "", "2014-03-03 16:49:44", "2014-03-03 16:49:44", "", "0", "http://blogsforsales.com/ebooks/ebook-publishing-guide-how-to-write-an-ebook-publish-it-online-in-less-than-7-days/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2014-03-04 13:06:09", "2014-03-04 13:06:09", "All I know about e-Book marketing, is a short book, because I, by no means, claim to know all there is to know about e-book marketing, nor am I even an expert. What I am is experienced in what not to do, enough that I have somehow stumbled on to a few things that actually work and I want to pass that on to other authors. I hope this book will give you at least a few nuggets of helpful of information.", "All I Know About e-Book Marketing", "All I Know About e-Book Marketing - Kindle edition by Laina Turner. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading All I Know About e-Book Marketing.", "future", "closed", "open", "", "all-i-know-about-e-book-marketing", "", "", "2014-03-04 13:06:09", "2014-03-04 13:06:09", "", "0", "http://blogsforsales.com/ebooks/all-i-know-about-e-book-marketing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2014-03-05 16:37:49", "2014-03-05 16:37:49", "Want to Sell More Nonfiction Kindle Books?\nWhat&#039;s the secret to success with Amazon&#039;s Kindle publishing? It all starts with having a &quot;system&quot; for selling more books. As you probably know, it&#039;s getting harder and harder to compete in the Kindle marketplace. That&#039;s why you need a proven plan for increasing your daily sales volume.\n\nIn &quot;61 Ways to Sell More Nonfiction Kindle Books&quot; you&#039;ll learn what Steve Scott does to average 100+ sales EVERY day. (Proof Inside!)\n<!--more-->\nTake Your Nonfiction Kindle Business to the NEXT Level...\nKindle publishing seems like an easy process. You write a book, publish it and then watch the money pour into your bank account. Unfortunately the reality is far from this dream.\n\nThere&#039;s a simple truth about Kindle publishing – It&#039;s not a &#039;get rich quick&#039; strategy. Sure, you can complete a book in a few days, but it&#039;s not easy to get people to actually buy it.\n\nThe people who succeed on Amazon understand the balance between quality content and great marketing. Moreover, they know how to build an audience of long-term customers who buy every new offer.\n\nThe good news is it&#039;s not hard to improve your Kindle success. Amazon has built an amazing platform that&#039;s designed to help you sell more books. Understand how it works and you&#039;ll produce one best-seller after the other.\n\nDISCOVER:: 61 Strategies for Selling More Books\n&quot;61 Ways to Sell More Nonfiction Kindle Books&quot; details a variety of techniques that will increase your daily sales volume.\n\nInside this guide you&#039;ll discover:\n10 Pillars of a Rock-Solid Kindle Business (Strategies #1 to #10)\n4 Rules of Internal Book Marketing (Strategies #11 to #14)\nMaximize Your Amazon Book Listing (Strategies #15 to #21)\nUsing the Author Page to Sell More Books (Strategies #22 to #27)\nIncrease Book Sales with Free KDP Select Promotions (Strategies #28 to #32)\nHow Pricing Affects Your Total Books Sales (Strategies #33 to #37)\nHow to Build a Loyal Audience with an Author Platform (Strategies #38 to #41)\nWhy an Email List is the Ultimate Author Platform (Strategies #42 to #46)\nAdvanced Book Sales Techniques (Strategies #47 to #52)\nFollow &quot;White-Hat&quot; Kindle Practices (Strategies #53 to #58)\nThe Mindset of a Best-Selling Kindle Author (Strategies #59 to #61)\nYou can get more book sales! Just apply a few of these techniques and you&#039;ll get more customers, downloads and reviews.\n\nWould You Like To Know More?\nDownload now and take your Kindle business to the next level.\n\nScroll to the top of the page and select the buy button.", "61 Ways to Sell More Nonfiction Kindle Books", "", "future", "closed", "open", "", "61-ways-to-sell-more-nonfiction-kindle-books", "", "", "2014-03-05 16:37:49", "2014-03-05 16:37:49", "", "0", "http://blogsforsales.com/ebooks/61-ways-to-sell-more-nonfiction-kindle-books/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2014-03-06 10:52:56", "2014-03-06 10:52:56", "How To Sell More Books On Amazon In Just 8 Days\n\nI Believe Every Author Can Become A Book Marketing Ninja With This System\n<!--more-->\nYou could be just 8 days away from record book sales. Learn how to:\n\nAttract Thousands of Readers With These Free Marketing Strategies\nWhether you&#039;re a brand new author or have been selling books by the thousands, you&#039;ve never seen these book marketing strategies anywhere else.\n\nUse Secret Amazon Analytics Technology To Increase Sales by 73%\nI stumbled upon this simple trick that allows you to track ALL of your traffic to your Amazon book page. Using this technique, I&#039;ve been able to test every marketing strategy I could get my hands on to help sell more books. Learn the one simple change that increased my conversions by 73% in a week.\n\nLearn The Ninja System For KDP Select Marketing Success\nUsing my list of 43 free marketing resources, my friend launched a simple fitness book... and just in 8 days 14,428 people downloaded the book for free and he made over 400 sales. Not only that, but his book became the #1 Weight Loss book in the Paid Kindle Store and #320 overall in the Kindle Store with over 200 sales a day at $4.99!\n\nDominate Your Niche or Genre By Bundling\nIf you&#039;re a serial author then you&#039;ve probably already written several books and have hundreds of more ideas in your head. Learn the proven system for bundling your books to provide readers easier access to your work and grow your book sales exponentially with very little extra work. This is the secret strategy that every multiple New York Times bestselling author uses!\n\nHow To Market A Book Like A Professional\nThe problem is most authors don&#039;t know how to market their books properly. They either don&#039;t do any marketing or spend all their time, money and energy on marketing strategies that don&#039;t even more! Ninjas understand that writing a bestselling book is more about selling than it is about writing! Writing is the prerequisite for success - but marketing is what makes books sell.\n\nHow To Get Your New Books Featured As An Amazon Hot New Release\nLearn the system for getting Amazon to promote your new books for you! Only three books make it into the Hot New Release section for each category - and Amazon promotes them heavily. Find out what it takes to get there and you can dramatically improve your new book launches and sales.\n\nHow To Use Amazon Listmania To Skyrocket Your Sales\nLearn how to use a simple Listmania list to sell more books on Amazon fast. No more expensive book marketing strategies or ads are needed!\n\nAbout The Author\n\nTom Corson-Knowles is the bestselling author of The Kindle Publishing Bible and The Kindle Formatting Bible, among others. Tom is an avid entrepreneur and loves helping other authors succeed by marketing effectively directly to readers instead of hoping, wishing and praying for more sales.\n\nLearn how to sell more books on Amazon today. Scroll up and grab your copy today.", "Ninja Book Marketing Strategies: How To Sell More Books In 8 Days Using 8 Ninja Marketing Tactics", "Ninja Book Marketing Strategies: How To Sell More Books In 8 Days Using 8 Ninja Marketing Tactics - Kindle edition by Tom Corson-Knowles. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Ninja Book Marketing Strategies: How To Sell More Books In 8 Days Using 8 Ninja Marketing Tactics.", "future", "closed", "open", "", "ninja-book-marketing-strategies-how-to-sell-more-books-in-8-days-using-8-ninja-marketing-tactics", "", "", "2014-03-06 10:52:56", "2014-03-06 10:52:56", "", "0", "http://blogsforsales.com/ebooks/ninja-book-marketing-strategies-how-to-sell-more-books-in-8-days-using-8-ninja-marketing-tactics/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2014-03-09 12:49:27", "2014-03-09 12:49:27", "Have you ever wanted to write and publish a digital book? Here&#039;s a basic pocket handbook to writing and marketing an eBook that doesn&#039;t take a Ph.D to understand. It&#039;s in simple, easy to understand English. It&#039;s not true that everything that has been said has already been written. Since that unfortunate axiom came into use, the whole universe has changed. Technology has changed, ideas have changed, and the mindsets of entire nations have changed. The fact is that this is the perfect time to write an eBook. What the publishing industry needs are people who can tap into the world as it is today – innovative thinkers who can make the leap into the new millennium and figure out how to solve old problems in a new way. Within the contents of this Pocket Guide is everything your really need to know if you&#039;ve ever want to create a Digital Book, presently known as an eBook: * Why Write an eBook? * How to Write an eBook * Overcoming Writer’s Block * Choosing an eBook Compiler * Rating eBook Compilers * Steps to Publishing Success * How to Price Your eBook * Bonus: eBooks are Promotional Powerhouses", "A Pocket Guide To Writing an eBook & eBook Marketing", "A Pocket Guide To Writing an eBook & eBook Marketing [MR Robert K. Teske Jr.] on . *FREE* shipping on qualifying offers. Have you ever wanted to write and publish a digital book? Here\'s a basic pocket handbook to writing and marketing an eBook that doesn\'t take a Ph.D to understand. It\'s in simple", "future", "closed", "open", "", "a-pocket-guide-to-writing-an-ebook-ebook-marketing", "", "", "2014-03-09 12:49:27", "2014-03-09 12:49:27", "", "0", "http://blogsforsales.com/ebooks/a-pocket-guide-to-writing-an-ebook-ebook-marketing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2014-03-10 12:36:38", "2014-03-10 12:36:38", "Ebook Millionaire is a complete step by step guide to building a massive revenue stream through selling your books online-either via your own blog or via Amazon Kindle and other e-readers.\n eBook Millionaire is the accompanying book to &quot;How to Self-Publish Your eBook From Start to Finish; Everything You Need to Know to Get to The Top&quot; which covers how to best set your book up on all the main sites.\n Many books on Kindle never sell more than one or two copies- not because they are not well written but because they are not well marketed. This book will teach authors the almost guaranteed method of success in self-publishing starting from before the book is written: Market research- to guarantee you have a pool of hungry buyers desperate for your book-before you have even written a word!\nIt also teaches you both external and internal marketing. Many authors are good writers but are not very good at marketing. Internal marketing is optimising the Kindle platform to get more sales, more reviews, get your books listed high on the sales rankings and being seen by more people.\nExternal marketing will explain in an easy to follow format how to blog, how to use Twitter, the importance of Facebook and the value of traditional marketing systems.\n E-book Millionaire is not another &quot;get rich quick&quot; guide. This book follows the exact system used by the author to create a regular five figure monthly income from these same methods. The steps are simple but the information world changes all the time and the simple things often get overlooked.\n If these are not done properly your book will be lost amongst the thousands vying for the browsers attention.\nThis book will help you immensely if you are looking to publish your first book, if you already have published a book but it is not selling yet or if you are looking to create a serious self-publishing empire with multiple titles in multiple genres.\n If you are serious about online book sales and have not read this book, you are simply losing money!\n So go back up to the top and click &quot;buy&quot;! so you can sell more books!", "EBook Millionaire: Your Complete Guide to Making Money Selling EBooks-FAST!", "EBook Millionaire: Your Complete Guide to Making Money Selling EBooks-FAST! - Kindle edition by James Calthorpe. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading EBook Millionaire: Your Complete Guide to Making Money Selling EBooks-FAST!.", "future", "closed", "open", "", "ebook-millionaire-your-complete-guide-to-making-money-selling-ebooks-fast-2", "", "", "2014-03-10 12:36:38", "2014-03-10 12:36:38", "", "0", "http://blogsforsales.com/ebooks/ebook-millionaire-your-complete-guide-to-making-money-selling-ebooks-fast-2/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("79", "1", "2014-03-10 15:22:53", "2014-03-10 15:22:53", "Whether you are a CEO, who&#039;s written a book to position yourself as a thought leader in your field, or a soccer mom, who wants to write the great American novel, Get Your Book Published! gives you vital keys to publish and market like an expert.\nThis book will help you:\nUnderstand the different types of publishing options availablePlot the development of your book from editing to cover designNavigate the terms of a publishing contractUnderstand the role of the literary agentAvoid land mines that derail and defeat so many authorsDecide how best to tailor and format your message (mobile apps, eBooks, on-line courses, blog articles) Learn the sales channels where your book can best be soldBuild a foundation for marketing that will get you noticed\n If you want to publish properly and profitably, this is the book to read!", "Get Your Book Published!: From Contracts to Covers, Editing to eBooks, Marketing and Sales, What Every Writer and Author Should Know", "Get Your Book Published!: From Contracts to Covers, Editing to eBooks, Marketing and Sales, What Every Writer and Author Should Know [David Welday III] on . *FREE* shipping on qualifying offers. Whether you are a CEO, who\'s written a book to position yourself as a thought leader in your field, or a soccer mom", "future", "closed", "open", "", "get-your-book-published-from-contracts-to-covers-editing-to-ebooks-marketing-and-sales-what-every-writer-and-author-should-know", "", "", "2014-03-10 15:22:53", "2014-03-10 15:22:53", "", "0", "http://blogsforsales.com/ebooks/get-your-book-published-from-contracts-to-covers-editing-to-ebooks-marketing-and-sales-what-every-writer-and-author-should-know/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2014-03-11 12:39:24", "2014-03-11 12:39:24", "The biggest challenge for Kindle eBook Writer is not the writer books but to reach to the audience and marketing of his/her book. Author can use Amazon KDP Select Program to offer his/her book for free as a Promotional Activity. One can offer free for 5 days in every 90 days. More downloads readers’ do, more exposure your book and you will get. Here I present lot of sources to jumpstart your Kindle Book Marketing and get lot and lot of exposure.", "153+ free online places to promote your kindle book when it\'s free. Exact Links - Time Saver - Big Exposure (Kindle Book Marketing Series)", "", "future", "closed", "open", "", "153-free-online-places-to-promote-your-kindle-book-when-its-free-exact-links-time-saver-big-exposure-kindle-book-marketing-series", "", "", "2014-03-11 12:39:24", "2014-03-11 12:39:24", "", "0", "http://blogsforsales.com/ebooks/153-free-online-places-to-promote-your-kindle-book-when-its-free-exact-links-time-saver-big-exposure-kindle-book-marketing-series/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("81", "1", "2014-03-11 15:01:54", "2014-03-11 15:01:54", "Bible of eBook Promotion.\n\nWritten by one of the founders of the eBook Industry, Sol Adoni, who has been creating and selling eBooks through a massive network of websites dedicated to promoting and selling eBooks.\n<!--more-->\nSol Adoni explains the various techniques an self-published author or small Publishng Company can use to PROMOTE EBOOKS with the big companies.\n\nSol Adoni explains the almost twenty year history of eBooks and chronicles how he used search engines, social media, print, radio and videos to promote and sell eBooks.\n\nIf you have written an eBook and want to self publish it, this is a MUST READ. It also has vital information to help smaller publishers compete in today&#039;s world of social media, kindles, nooks and google.\n\nA short read packed by vital knowledge by a founder of the digital revolution.\n\nLook for Sol Adoni&#039;s other eBooks on eBook Publishng and Marketing on Amazon.", "Bible Of eBook Promotion", "Bible Of eBook Promotion - Kindle edition by Sol Adoni. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Bible Of eBook Promotion.", "future", "closed", "open", "", "bible-of-ebook-promotion", "", "", "2014-03-11 15:01:54", "2014-03-11 15:01:54", "", "0", "http://blogsforsales.com/ebooks/bible-of-ebook-promotion/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2014-03-13 16:31:04", "2014-03-13 16:31:04", "Questa Guida gratuita vuole aiutare autori ed editori a promuovere e vendere i propri ebook su Smashwords ma anche su tutti gli altri negozi virtuali. La Guida, partendo da come Smashwords aiuta gli autori a promuovere l&#039;ebook, dà 30 utilissimi suggerimenti per costruire autonomamente e gratuitamente un ottimo ebook marketing. Perciò è utile a tutti gli autori e non solo a quelli che pubblicano su Smashwords.\n\nTraduzione italiana a cura di Giuseppe Meligrana\n<!--more-->\nPER INIZIARE\n\nIntroduzione. Informazioni sulla Guida all’ebook Marketing Smashwords\nDue parole su Smashwords\nImpostazione delle aspettative\nCome Smashwords aiuta autori ed editori a commercializzare i loro ebook\nAdottare una mentalità marketing attiva\nIl marketing deve iniziare subito. Create il vostro social network\nI link aiutano i lettori a scoprire i vostri ebook\nL’importanza dell’aiuto reciproco tra autori\n\n30 suggerimenti per un marketing gratuito\nSuggerimento 1: Aggiornare la firma e-mail\nSuggerimento 2: Postare la notizia sul vostro sito o blog\nSuggerimento 3: Contattare i vostri amici, familiari, collaboratori, soci e fan\nSuggerimento 4: Mettere un avviso sui vostri social network\nSuggerimento 5: Aggiornare le firme nei forum\nSuggerimento 6: Raccogliere lettori con Twitter\nSuggerimento 7: Pubblicare più di un ebook su Smashwords per creare un effetto moltiplicatore\nSuggerimento 8: Pubblicizzare gli altri ebook in ogni ebook che pubblicate\nSuggerimento 9: Facilitare i lettori a connettersi con voi\nSuggerimento 10: Pubblicare un comunicato stampa e diffonderlo ovunque\nSuggerimento 11: Aiutare i giornalisti on-line\nSuggerimento 12. Incoraggiare i vostri fan ad acquistare e recensire il vostro ebook\nSuggerimento 13. Scrivere recensioni per altri ebook su Smashwords\nSuggerimento 14: Partecipare ai forum online\nSuggerimento 15: Sperimentare i buoni sconto\nSuggerimento 16: Scrivere un blog\nSuggerimento 17: Scrivere nelle colonne degli ospiti dei blog\nSuggerimento 18: Invitare altri autori a postare sul vostro blog\nSuggerimento 19: Fare interviste ad altri autori sul vostro blog\nSuggerimento 20: Partecipare alle conversazioni sui blog\nSuggerimento 21: Organizzare un blog tour\nSuggerimento 22: Usare Google Alert per scoprire dove le conversazioni hanno luogo\nSuggerimento 23: Usare i video YouTube per conquistare i lettori\nSuggerimento 24: Stampare biglietti da visita\nSuggerimento 25: Incoraggiare i fan a fare marketing per i vostri ebook\nSuggerimento 26: Creare una Guida per il lettore alla fine del vostro ebook\nSuggerimento 27: Inserire interi capitoli di altri vostri ebook alla fine di ogni ebook\nSuggerimento 28: Fare uno scambio di titoli o di capitoli con un altro autore alla fine di ogni ebook\nSuggerimento 29: Invitare altri autori ad unirsi a voi in Smashwords\nSuggerimento 30: Promuovere il vostro ebook sui siti o nei luoghi reali di maggiore “interesse ebook”\n\nAppendice\nLe otto cose che dovete fare con un ebook\nLe sette cose che non dovete fare con un ebook\n\nL’autore\nBiografia\nAltre opere di Mark Coker pubblicate in Smashwords\nCollegarsi con Mark Coker\nCollegarsi con i colleghi autori Smashwords", "Guida all\'Ebook Marketing Smashwords (Smashwords Guides) (Italian Edition)", "", "future", "closed", "open", "", "guida-allebook-marketing-smashwords-smashwords-guides-italian-edition", "", "", "2014-03-13 16:31:04", "2014-03-13 16:31:04", "", "0", "http://blogsforsales.com/ebooks/guida-allebook-marketing-smashwords-smashwords-guides-italian-edition/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2014-03-14 12:41:11", "2014-03-14 12:41:11", "The first job of an author is, of course, to write great books, but these days, their second job is to market them.\n\nMarketing isn&#039;t a skill that most authors have naturally, and there is little formal training. But when your book hits the shelves, and the sales don&#039;t start rolling in, there&#039;s only two things an author can do. Keep writing more books and ... Get to grips with marketing.\n<!--more-->\nThis book is for authors who want to sell more books, but it&#039;s also for those writers who want to think more like an entrepreneur. It&#039;s for traditionally published authors who want to take control of their future, and for self-published authors who want to jump-start a career.\n\n**\n&quot;Joanna Penn&#039;s How to Market a Book is the most up to date, personable guide to modern book marketing I know. Packed with tips from the charming and well-informed Penn, it&#039;s an essential guide for indie authors who want to keep up with the ever-shifting world of book marketing.&quot;\n\nJoel Friedlander, TheBookDesigner.com, A Self-Publisher&#039;s Companion\n\n** \nThere are some short-term tactics for those who want to kick up immediate sales, but the focus of the book is more about instilling values and marketing principles that will help your long-term career as a writer.\n\nIt&#039;s also about going beyond just the book, because the methods in this guide can take you from being an author into professional speaking, making money from other products and creating opportunities that you can&#039;t even imagine yet.\n\nThere are no rules in this game, but learning this kind of authentic marketing has certainly changed my life, so read on and I&#039;ll share everything I know with you.\n\nHow To Market A Book covers an extensive range of marketing principles, strategies and tactics:\n\nPart 1: Marketing Principles - including myths, how to balance your time, co-opetition and generosity Part 2: Prerequisites for Success - including an understanding of yourself and your target market, professional editing and cover design, your book page on the retailer websites, pricing and the use of freePart 3: No Platform Needed - Short-term Marketing - including how to get book reviews, paid advertising, using traditional media and tips for TV, radio and press releases Part 4: The Author Platform - Long-term Marketing - including the reasons why a platform is a good thing, author branding, your author website, list-building and email marketing, content marketing and blogging, audio and podcasting, video and book trailers, social networking, professional speaking, and becoming an author-entrepreneur. Part 5: Launching Your Book - including how launching has changed, soft launch, launch spikes, post launch and relaunches as well as lessons learned from some major book launches.Plus/ tips for when you get overwhelmed and plenty more links to further resources.\n\n**\n\n&quot;Right now, self-publishing is a wide open opportunity for writers. But it&#039;s a confusing and increasingly competitive field. Joanna Penn is one of the guides I rely on to help me navigate the maze, make better marketing decisions, and sell more books. If you read this book, she&#039;ll do the same for you.&quot;\n\nMark McGuinness, Coach and author of Resilience: Facing Down Rejection and Criticism on the Road to Success\n\n**\nClick to sample or buy the book now.", "How To Market A Book", "How To Market A Book - Kindle edition by Joanna Penn. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading How To Market A Book.", "future", "closed", "open", "", "how-to-market-a-book", "", "", "2014-03-14 12:41:11", "2014-03-14 12:41:11", "", "0", "http://blogsforsales.com/ebooks/how-to-market-a-book/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2014-03-15 12:28:04", "2014-03-15 12:28:04", "Many endeavor to market their eBooks in many different ways. However, it&#039;s evident that most persons tend to follow the crowd in marketing. They do what others are doing to market their books. Research shows that a particular marketing tunnel can become crowded, and thus become weak as to deliver the same returns on investment as it used to over time.\n\nThere is the need to discover and learn a new marketing channel to reach your target audience - if you&#039;re to experience great returns on your investment of having self-published a book. In this marketing report, you will become aware of a new link, an untapped vast marketing channel that would give your product massive great returns. Therefore, this report will guide you on how to implement &#039;out of the box&#039; marketing strategy for your book and thus earn much good returns.", "How To Market Your eBook - A Marketing Project Report 2013", "How To Market Your eBook - A Marketing Project Report 2013 - Kindle edition by Richard Hopkins. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading How To Market Your eBook - A Marketing Project Report 2013.", "future", "closed", "open", "", "how-to-market-your-ebook-a-marketing-project-report-2013", "", "", "2014-03-15 12:28:04", "2014-03-15 12:28:04", "", "0", "http://blogsforsales.com/ebooks/how-to-market-your-ebook-a-marketing-project-report-2013/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2014-03-15 15:17:19", "2014-03-15 15:17:19", "Increase your e-book sales with better social media marketing. This easy-to-read, and short guide will walk you through the basics of how to use social media to reach your target audience without preaching to the choir. Includes Facebook, LinkedIn, Twitter, Google Plus, Blogging, and more!", "Increase e-Book Sales with Social Media Marketing", "Increase e-Book Sales with Social Media Marketing - Kindle edition by Erin McBride. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Increase e-Book Sales with Social Media Marketing.", "future", "closed", "open", "", "increase-e-book-sales-with-social-media-marketing", "", "", "2014-03-15 15:17:19", "2014-03-15 15:17:19", "", "0", "http://blogsforsales.com/ebooks/increase-e-book-sales-with-social-media-marketing/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2014-03-16 12:31:16", "2014-03-16 12:31:16", "This guide defines a marketing process that you can use to put structure around your daily, monthly and annual marketing and sales activities.\n\nThe process covers more than just traditional marketing and ties together all go-to-market business activities: strategic planning, financial planning and measurement, creative development, marketing execution and sales, and customer retention.", "The Strategic Marketing Process - How to Structure Your Marketing Activities to Achieve Better Results", "", "future", "closed", "open", "", "the-strategic-marketing-process-how-to-structure-your-marketing-activities-to-achieve-better-results", "", "", "2014-03-16 12:31:16", "2014-03-16 12:31:16", "", "0", "http://blogsforsales.com/ebooks/the-strategic-marketing-process-how-to-structure-your-marketing-activities-to-achieve-better-results/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("87", "1", "2014-03-16 15:30:52", "2014-03-16 15:30:52", "Are you the author of a nonfiction or self-help book?\n\nWhat would you say if I told you this one simple trick in writing your book description could easily help you sell an extra hundred books each and every month?\n<!--more-->\nThe thing to remember when you write a nonfiction book description is - It’s all about the customer. If you can show the customer you can help them get what they want, you will have them eating out of your hands.\n\nThere are a lot of Kindle advice books out there. All of them are trying to tell you how to write a book the fastest, that you need to search Google keywords for the latest hottest topics, and that you need to spend hours every day implementing a social media campaign to help people find your book.\n\nWhat would you say if I told you that was all a bunch of Bullshit?\n\nI sold over 150 copies of my first book in three weeks without resorting to a single one of those tactics.\n\nThe fact is - Amazon does over 90 percent of the work for you in marketing your book. Before you go off site to sell books, you need to optimize all of Amazon&#039;s marketing tools.\n\nHere are just a few of the topics this book is going to cover.\n\n1) Creating covers that demand attention\n2) How to write a title that will reach out and slap you customer in the face\n3) How to write a book description that will make them want to buy your book - NOW!\n4) Why you need a compelling &quot;Meet the Author&quot; page, and how you can use it to position yourself as an expert in your subject matter\n5) How to add tags to your book\n6) Why you need customer reviews, and how you can get more of them\n7) All you need to know about KDP Select\n8) Pricing strategies to sell more books\n\nIf you are the author of a non-fiction how to or advice book, this guide will help you sell more books.\n\nAbout the Author\nNick Vulich is the author of eight Kindle books including Freaking Idiots Guide to Selling on eBay, How anyone can make $100 or more everyday selling on eBay. Nick has worked in e-commerce for over thirteen years, selling both on eBay and Amazon. He also edits several successful blogs including Digital History Project and Retro Iowa.\n\nHis latest book Freaking Idiots Guide to Making Money with Fiverr, How people are making $1000 a month providing simple services is now available on Kindle.", "Freaking Idiots Guide to Writing a Kindle Bestseller: Tips & Tricks to Make your Book A Bestseller in Its Category (Freaking Idiots Guides)", "Freaking Idiots Guide to Writing a Kindle Bestseller: Tips & Tricks to Make your Book A Bestseller in Its Category (Freaking Idiots Guides) [Nick Vulich] on . *FREE* shipping on qualifying offers. <b>Are you the author of a nonfiction or self-help book?</b> What would you say if I told you this one simple trick in writing your book description could easily help you sell an extra hundred books each and every month? The thing to remember when you write a nonfiction book description is -<b> It’s all about the customer</b>. If you can show the customer you can help them get what they want", "future", "closed", "open", "", "freaking-idiots-guide-to-writing-a-kindle-bestseller-tips-tricks-to-make-your-book-a-bestseller-in-its-category-freaking-idiots-guides", "", "", "2014-03-16 15:30:52", "2014-03-16 15:30:52", "", "0", "http://blogsforsales.com/ebooks/freaking-idiots-guide-to-writing-a-kindle-bestseller-tips-tricks-to-make-your-book-a-bestseller-in-its-category-freaking-idiots-guides/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2014-03-18 11:42:26", "2014-03-18 11:42:26", "&quot;Your book is better than all of the other &quot;how to&quot; kindle guidebooks put together! I own at least 50 and yours is FAR superior to ALL of the others.&quot; - Author Gary Yantis\n\nWant Your Kindle Book To Be A #1 Bestseller?\nYou&#039;re about to discover the secrets I used to go from struggling self published author to outranking the biggest publishers, hitting #1 best seller status in one of the most competitive categories, and doing it all without a big budget, fan base or spending hours on promotions.\n<!--more-->\nResults like this shouldn&#039;t be possible for someone self publishing. But they are when you use the step-by-step blueprint revealed in this book.\n\nDon&#039;t waste another second of your time or hard earned dollar marketing your book until you know:\n\n• How bestselling authors guarantee they&#039;ll make a lot of sales before they write a single word. Almost all &quot;average&quot; authors skip this step and are doomed from the start!\n\n• How to see what books people crave so you deliver a red-hot book people will beg you to buy!\n\n• How to position yourself in a niche so you’re seen as hands-down the *best* choice among the competition!\n\n• How to utilize simple psychological tactics in your description that practically FORCE people to buy your book!\n\n• How to get your books in front of thousands and thousands of fans on a shoestring budget. Note: This trick helped shoot my book up to #1 bestseller in under a week!\n\n• How to use a 5 second “trick” to sell more books and increase your royalties by up to 500%!\n\n• How to double, triple, or even quadruple your income from every single book you sell!\n\n• And much more!\n\nIf you wish you could call yourself a bestselling author...\n\nIf you wish you never had to waste another second or dollar on ineffective marketing techniques...\n\nIf you wish you knew the strategies you can use to literally outsell the biggest names in ALL of book publishing...\n\nThen Kindle Bestseller Secrets is the book you&#039;ve wished for. Click buy today!\n\nAbout The Author:\n\nI&#039;ve earned over $5,383 in royalties in 11 days from a single kindle book, taught over 1,300 students from all over the world how to market their kindle books, and regularly network with many of the world&#039;s top kindle authors.\n\nWhen you buy Kindle Bestseller Secrets, you&#039;re not only getting my insights, but the distilled wisdom from numerous bestselling kindle authors all revealed in one book. I created this book to be the &quot;go-to&quot; guide on kindle self publishing and marketing. It is the book I wish I had when I first got into publishing, and now I&#039;m giving back to fellow authors by offering my best insights in one easy to read guide.", "Kindle Bestseller Secrets: 10 Tricks Bestselling Non-Fiction Authors Use To Dominate Kindle", "Kindle Bestseller Secrets: 10 Tricks Bestselling Non-Fiction Authors Use To Dominate Kindle - Kindle edition by Derek Doepker. Download it once and read it on your Kindle device, PC, phones or tablets. Use features like bookmarks, note taking and highlighting while reading Kindle Bestseller Secrets: 10 Tricks Bestselling Non-Fiction Authors Use To Dominate Kindle.", "future", "closed", "open", "", "kindle-bestseller-secrets-10-tricks-bestselling-non-fiction-authors-use-to-dominate-kindle", "", "", "2014-03-18 11:42:26", "2014-03-18 11:42:26", "", "0", "http://blogsforsales.com/ebooks/kindle-bestseller-secrets-10-tricks-bestselling-non-fiction-authors-use-to-dominate-kindle/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("89", "1", "2014-03-19 14:41:20", "2014-03-19 14:41:20", "You’ve written an eBook. Now what? Mike McCann shares award-winning steps and techniques for marketing eBooks into a full time income in &quot;How to Market Your EBooks.&quot;\n\n“Mike has more than 300 hyperlinked resources an eBook author can immediately use. ”\nMark Winters\nAustin, TX\n<!--more-->\n“I can be busy eight hours+/day from the ideas Mike includes in this eBook…”\nCarol Jenkins\nRichmond, VA\n\n“Mike has many techniques on marketing an eBook in one place. More than I’ve seen.”\nJason Williard\nTacoma, WA\n\n&quot;How to Market Your EBooks&quot; guides eBook (and print) authors through creating a marketing plan and strategy for the digital world while developing a full-time comfortable income.\n\nIn &quot;How to Market Your EBooks,&quot; learn how to reach out and “connect” with readers by:\n• developing a professional website and blog\n• implementing an effective publicity plan\n• having effective guest appearances on radio and TV\n• creating and populating a YouTube channel for promoting your eBook\n• effectively and creatively using social networking channels and,\n• participating in blog tours and book video trailers without traveling.\n\n&quot;How to Market Your EBooks&quot; also reveals little known techniques on how to use “sales nodes” and “price pulsing” to increase eBook sales.\n\nReaders of &quot;How to Market Your EBooks&quot; are invited to join the monthly eBook marketing updates (details on last page of book). If you want to sell eBooks with the opportunity to create a full-time income, then &quot;How to Market Your EBooks&quot; is for you!", "How to Market Your EBooks, Over 300 Resources to Help Authors Sell EBooks", "", "future", "closed", "open", "", "how-to-market-your-ebooks-over-300-resources-to-help-authors-sell-ebooks", "", "", "2014-03-19 14:41:20", "2014-03-19 14:41:20", "", "0", "http://blogsforsales.com/ebooks/how-to-market-your-ebooks-over-300-resources-to-help-authors-sell-ebooks/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("90", "1", "2014-03-20 11:22:23", "2014-03-20 11:22:23", "The first job of an author is, of course, to write great books, but these days, their second job is to market them.\nMarketing isn&#039;t a skill that most authors have naturally, and there is little formal training. But when your book hits the shelves, and the sales don&#039;t start rolling in, there&#039;s only two things an author can do. Keep writing more books and ... Get to grips with marketing.\n\nThis book is for authors who want to sell more books, but it&#039;s also for those writers who want to think more like an entrepreneur.\nIt&#039;s for traditionally published authors who want to take control of their future, and for self-published authors who want to jump-start a career.\n<!--more-->\nThere are some short-term tactics for those who want to kick up immediate sales, but the focus of the book is more about instilling values and marketing principles that will help your long-term career as a writer.\n\nIt&#039;s also about going beyond just the book, because the methods in this guide can take you from being an author into professional speaking, making money from other products and creating opportunities that you can&#039;t even imagine yet.\n\nThere are no rules in this game, but learning this kind of authentic marketing has certainly changed my life, so read on and I&#039;ll share everything I know with you.\n\nHow To Market A Book covers an extensive range of marketing principles, strategies and tactics:\n\n* Part 1: Marketing Principles - including myths, how to balance your time, co-opetition and generosity\n* Part 2: Prerequisites for Success - including an understanding of yourself and your target market, professional editing and cover design, your book page on the retailer websites, pricing and the use of free\n* Part 3: No Platform Needed - Short-term Marketing - including how to get book reviews, paid advertising, using traditional media and tips for TV, radio and press releases\n* Part 4: The Author Platform - Long-term Marketing - including the reasons why a platform is a good thing, author branding, your author website, list-building and email marketing, content marketing and blogging, audio and podcasting, video and book trailers, social networking, professional speaking, and becoming an author-entrepreneur.\nPart 5: Launching Your Book - including how launching has changed, soft launch, launch spikes, post launch and relaunches as well as lessons learned from some major book launches. Plus/ tips for when you get overwhelmed and plenty more links to further resources.", "How To Market A Book", "How To Market A Book [Joanna Penn] on . *FREE* shipping on qualifying offers. <b> The first job of an author is, of course, to write great books, but these days, their second job is to market them. </b> Marketing isn\'t a skill that most authors have naturally", "future", "closed", "open", "", "how-to-market-a-book-2", "", "", "2014-03-20 11:22:23", "2014-03-20 11:22:23", "", "0", "http://blogsforsales.com/ebooks/how-to-market-a-book-2/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("91", "1", "2014-01-31 19:27:39", "2014-01-31 19:27:39", " ", "", "", "publish", "closed", "open", "", "91", "", "", "2014-01-31 19:27:39", "2014-01-31 19:27:39", "", "0", "http://blogsforsales.com/ebooks/?p=91", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("92", "1", "2014-01-31 19:30:17", "2014-01-31 19:30:17", "A few simple tricks to help you leap over the competition - Ebook publishing tips and tricks.", "Ebook Marketing", "", "inherit", "closed", "open", "", "41-revision-v1", "", "", "2014-01-31 19:30:17", "2014-01-31 19:30:17", "", "41", "http://blogsforsales.com/ebooks/41-revision-v1/", "0", "revision", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "76", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "91", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "111", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "128", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "129", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "130", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "131", "0");
INSERT INTO `wp_term_relationships` VALUES("36", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("40", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("41", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("42", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("44", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("45", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("45", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("45", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("45", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("45", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("45", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("47", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("48", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "28", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "30", "0");
INSERT INTO `wp_term_relationships` VALUES("51", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("51", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("51", "31", "0");
INSERT INTO `wp_term_relationships` VALUES("51", "32", "0");
INSERT INTO `wp_term_relationships` VALUES("51", "33", "0");
INSERT INTO `wp_term_relationships` VALUES("52", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("53", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("54", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "34", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("56", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("57", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "40", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "42", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "43", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "44", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "45", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "47", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "48", "0");
INSERT INTO `wp_term_relationships` VALUES("59", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "49", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "50", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "51", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "52", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "53", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "54", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "55", "0");
INSERT INTO `wp_term_relationships` VALUES("61", "56", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "57", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "58", "0");
INSERT INTO `wp_term_relationships` VALUES("63", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "59", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "60", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "61", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "62", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "63", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "64", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "65", "0");
INSERT INTO `wp_term_relationships` VALUES("65", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "66", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "67", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "68", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "69", "0");
INSERT INTO `wp_term_relationships` VALUES("67", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "70", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "71", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "72", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "73", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "74", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "75", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "76", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "58", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "64", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "77", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "78", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "79", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "80", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "81", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "82", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "83", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "84", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "85", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "87", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "88", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "89", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "90", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "91", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "92", "0");
INSERT INTO `wp_term_relationships` VALUES("71", "93", "0");
INSERT INTO `wp_term_relationships` VALUES("72", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("73", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "94", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "95", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "96", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "97", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "98", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "99", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "58", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "81", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "83", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "84", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "100", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "101", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "102", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "59", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "99", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "103", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "61", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "62", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "63", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "104", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "105", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "106", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "107", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "108", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "109", "0");
INSERT INTO `wp_term_relationships` VALUES("79", "110", "0");
INSERT INTO `wp_term_relationships` VALUES("80", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "58", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "66", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "68", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "111", "0");
INSERT INTO `wp_term_relationships` VALUES("82", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "112", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "113", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "114", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "115", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "116", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "117", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "118", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "119", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "120", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "121", "0");
INSERT INTO `wp_term_relationships` VALUES("86", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "122", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "123", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "124", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "125", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "99", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "126", "0");
INSERT INTO `wp_term_relationships` VALUES("89", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "112", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "113", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "127", "0");
INSERT INTO `wp_term_relationships` VALUES("91", "2", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "nav_menu", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("10", "10", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("11", "11", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("12", "12", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("13", "13", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("14", "14", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("15", "15", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("16", "16", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("17", "17", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("18", "18", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("19", "19", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("20", "20", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("21", "21", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("22", "22", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("23", "23", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("24", "24", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("25", "25", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("26", "26", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("27", "27", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("28", "28", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("29", "29", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("30", "30", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("31", "31", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("32", "32", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("33", "33", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("34", "34", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("35", "35", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("36", "36", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("37", "37", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("38", "38", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("39", "39", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("40", "40", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("41", "41", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("42", "42", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("43", "43", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("44", "44", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("45", "45", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("46", "46", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("47", "47", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("48", "48", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("49", "49", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("50", "50", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("51", "51", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("52", "52", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("53", "53", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("54", "54", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("55", "55", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("56", "56", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("57", "57", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("58", "58", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("59", "59", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("60", "60", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("61", "61", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("62", "62", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("63", "63", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("64", "64", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("65", "65", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("66", "66", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("67", "67", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("68", "68", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("69", "69", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("70", "70", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("71", "71", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("72", "72", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("73", "73", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("74", "74", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("75", "75", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("76", "76", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("77", "77", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("78", "78", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("79", "79", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("80", "80", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("81", "81", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("82", "82", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("83", "83", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("84", "84", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("85", "85", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("86", "86", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("87", "87", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("88", "88", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("89", "89", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("90", "90", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("91", "91", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("92", "92", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("93", "93", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("94", "94", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("95", "95", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("96", "96", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("97", "97", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("98", "98", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("99", "99", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("100", "100", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("101", "101", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("102", "102", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("103", "103", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("104", "104", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("105", "105", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("106", "106", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("107", "107", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("108", "108", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("109", "109", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("110", "110", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("111", "111", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("112", "112", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("113", "113", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("114", "114", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("115", "115", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("116", "116", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("117", "117", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("118", "118", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("119", "119", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("120", "120", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("121", "121", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("122", "122", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("123", "123", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("124", "124", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("125", "125", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("126", "126", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("127", "127", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("128", "128", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("129", "129", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("130", "130", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("131", "131", "post_tag", "", "0", "1");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Making Money With Ebooks", "making-money-with-ebooks", "0");
INSERT INTO `wp_terms` VALUES("2", "Menu 1", "menu-1", "0");
INSERT INTO `wp_terms` VALUES("3", "Writing Your Ebook", "writing-your-ebook", "0");
INSERT INTO `wp_terms` VALUES("4", "All About Ebooks", "all-about-ebooks", "0");
INSERT INTO `wp_terms` VALUES("5", "Products", "products", "0");
INSERT INTO `wp_terms` VALUES("6", "ebook", "ebook", "0");
INSERT INTO `wp_terms` VALUES("7", "Mark Coker", "mark-coker", "0");
INSERT INTO `wp_terms` VALUES("8", "Mark Coker via Smashwords", "mark-coker-via-smashwords", "0");
INSERT INTO `wp_terms` VALUES("9", "BUSINESS &amp; ECONOMICS / Business Writing", "business-economics-business-writing", "0");
INSERT INTO `wp_terms` VALUES("10", "REFERENCE / Writing Skills", "reference-writing-skills", "0");
INSERT INTO `wp_terms` VALUES("11", "Don A. Singletary", "don-a-singletary", "0");
INSERT INTO `wp_terms` VALUES("12", "Sing Systems", "sing-systems", "0");
INSERT INTO `wp_terms` VALUES("13", "EDUCATION / Reference", "education-reference", "0");
INSERT INTO `wp_terms` VALUES("14", "Tom Corson-Knowles", "tom-corson-knowles", "0");
INSERT INTO `wp_terms` VALUES("15", "Authentic Health Coaching", "authentic-health-coaching", "0");
INSERT INTO `wp_terms` VALUES("16", "0988433648", "0988433648", "0");
INSERT INTO `wp_terms` VALUES("17", "Business / Economics / Finance", "business-economics-finance", "0");
INSERT INTO `wp_terms` VALUES("18", "Advertising &amp; Promotion", "advertising-promotion", "0");
INSERT INTO `wp_terms` VALUES("19", "Business &amp; Economics / Advertising &amp; Promotion", "business-economics-advertising-promotion", "0");
INSERT INTO `wp_terms` VALUES("20", "Martin Crosbie", "martin-crosbie", "0");
INSERT INTO `wp_terms` VALUES("21", "How I Sold 30", "how-i-sold-30", "0");
INSERT INTO `wp_terms` VALUES("22", "CreateSpace Independent Publishing Platform", "createspace-independent-publishing-platform", "0");
INSERT INTO `wp_terms` VALUES("23", "1492241504", "1492241504", "0");
INSERT INTO `wp_terms` VALUES("24", "Business/Economics", "businesseconomics", "0");
INSERT INTO `wp_terms` VALUES("25", "Business &amp; Economics", "business-economics", "0");
INSERT INTO `wp_terms` VALUES("26", "E-Commerce - Internet Marketing", "e-commerce-internet-marketing", "0");
INSERT INTO `wp_terms` VALUES("27", "Philip Ragan", "philip-ragan", "0");
INSERT INTO `wp_terms` VALUES("28", "Chargan My Book Publisher", "chargan-my-book-publisher", "0");
INSERT INTO `wp_terms` VALUES("29", "BUSINESS &amp; ECONOMICS / Sales &amp; Selling", "business-economics-sales-selling", "0");
INSERT INTO `wp_terms` VALUES("30", "LITERARY CRITICISM / Books &amp; Reading", "literary-criticism-books-reading", "0");
INSERT INTO `wp_terms` VALUES("31", "Glen Chapman", "glen-chapman", "0");
INSERT INTO `wp_terms` VALUES("32", "The Power of Free on Amazon Kindle", "the-power-of-free-on-amazon-kindle", "0");
INSERT INTO `wp_terms` VALUES("33", "COMPUTERS / Electronic Commerce", "computers-electronic-commerce", "0");
INSERT INTO `wp_terms` VALUES("34", "Karen Baney", "karen-baney", "0");
INSERT INTO `wp_terms` VALUES("35", "10 Keys to Ebook Marketing Success", "10-keys-to-ebook-marketing-success", "0");
INSERT INTO `wp_terms` VALUES("36", "Author Services International", "author-services-international", "0");
INSERT INTO `wp_terms` VALUES("37", "LLC", "llc", "0");
INSERT INTO `wp_terms` VALUES("38", "BUSINESS &amp; ECONOMICS / Marketing / General", "business-economics-marketing-general", "0");
INSERT INTO `wp_terms` VALUES("39", "Mark Levine", "mark-levine", "0");
INSERT INTO `wp_terms` VALUES("40", "The Fine Print of Self-Publishing", "the-fine-print-of-self-publishing", "0");
INSERT INTO `wp_terms` VALUES("41", "Fifth Edition: A Primer on Contracts", "fifth-edition-a-primer-on-contracts", "0");
INSERT INTO `wp_terms` VALUES("42", "Printing Costs", "printing-costs", "0");
INSERT INTO `wp_terms` VALUES("43", "Royalties", "royalties", "0");
INSERT INTO `wp_terms` VALUES("44", "Distribution", "distribution", "0");
INSERT INTO `wp_terms` VALUES("45", "E-Books", "e-books", "0");
INSERT INTO `wp_terms` VALUES("46", "and Marketing", "and-marketing", "0");
INSERT INTO `wp_terms` VALUES("47", "Bascom Hill Publishing Group", "bascom-hill-publishing-group", "0");
INSERT INTO `wp_terms` VALUES("48", "1626525358", "1626525358", "0");
INSERT INTO `wp_terms` VALUES("49", "S.R. Tooms", "s-r-tooms", "0");
INSERT INTO `wp_terms` VALUES("50", "Lady Spud", "lady-spud", "0");
INSERT INTO `wp_terms` VALUES("51", "Self-Publishing: Scams", "self-publishing-scams", "0");
INSERT INTO `wp_terms` VALUES("52", "Lies", "lies", "0");
INSERT INTO `wp_terms` VALUES("53", "HUMOR / Topic / Business &amp; Professional", "humor-topic-business-professional", "0");
INSERT INTO `wp_terms` VALUES("54", "Andrew Macarthy", "andrew-macarthy", "0");
INSERT INTO `wp_terms` VALUES("55", "Kobo", "kobo", "0");
INSERT INTO `wp_terms` VALUES("56", "and More!", "and-more", "0");
INSERT INTO `wp_terms` VALUES("57", "Jim Edwards", "jim-edwards", "0");
INSERT INTO `wp_terms` VALUES("58", "COMPUTERS / Electronic Publishing", "computers-electronic-publishing", "0");
INSERT INTO `wp_terms` VALUES("59", "James Calthorpe", "james-calthorpe", "0");
INSERT INTO `wp_terms` VALUES("60", "1489590498", "1489590498", "0");
INSERT INTO `wp_terms` VALUES("61", "Language", "language", "0");
INSERT INTO `wp_terms` VALUES("62", "Language Arts / Linguistics / Literacy", "language-arts-linguistics-literacy", "0");
INSERT INTO `wp_terms` VALUES("63", "Language Arts &amp; Disciplines", "language-arts-disciplines", "0");
INSERT INTO `wp_terms` VALUES("64", "Language Arts &amp; Disciplines / Publishing", "language-arts-disciplines-publishing", "0");
INSERT INTO `wp_terms` VALUES("65", "Publishing", "publishing", "0");
INSERT INTO `wp_terms` VALUES("66", "Sol Adoni", "sol-adoni", "0");
INSERT INTO `wp_terms` VALUES("67", "How to Book of eBook Promotion", "how-to-book-of-ebook-promotion", "0");
INSERT INTO `wp_terms` VALUES("68", "Adoni Publishing", "adoni-publishing", "0");
INSERT INTO `wp_terms` VALUES("69", "COMPUTERS / Digital Media / General", "computers-digital-media-general", "0");
INSERT INTO `wp_terms` VALUES("70", "BJ Min", "bj-min", "0");
INSERT INTO `wp_terms` VALUES("71", "Nook", "nook", "0");
INSERT INTO `wp_terms` VALUES("72", "and iBookstore", "and-ibookstore", "0");
INSERT INTO `wp_terms` VALUES("73", "Hot Methods", "hot-methods", "0");
INSERT INTO `wp_terms` VALUES("74", "Incorporated", "incorporated", "0");
INSERT INTO `wp_terms` VALUES("75", "0988522810", "0988522810", "0");
INSERT INTO `wp_terms` VALUES("76", "Business Writing", "business-writing", "0");
INSERT INTO `wp_terms` VALUES("77", "Ali Luke", "ali-luke", "0");
INSERT INTO `wp_terms` VALUES("78", "Publishing E-Books For Dummies", "publishing-e-books-for-dummies", "0");
INSERT INTO `wp_terms` VALUES("79", "For Dummies", "for-dummies", "0");
INSERT INTO `wp_terms` VALUES("80", "1118342909", "1118342909", "0");
INSERT INTO `wp_terms` VALUES("81", "Computer Books: General", "computer-books-general", "0");
INSERT INTO `wp_terms` VALUES("82", "Self-publishing", "self-publishing", "0");
INSERT INTO `wp_terms` VALUES("83", "Computers - Desktop Publishing", "computers-desktop-publishing", "0");
INSERT INTO `wp_terms` VALUES("84", "Computers", "computers", "0");
INSERT INTO `wp_terms` VALUES("85", "Sarah Maccarelli Jordan", "sarah-maccarelli-jordan", "0");
INSERT INTO `wp_terms` VALUES("86", "Ashutosh Khandha", "ashutosh-khandha", "0");
INSERT INTO `wp_terms` VALUES("87", "Hooping with Kids", "hooping-with-kids", "0");
INSERT INTO `wp_terms` VALUES("88", "EDUCATION / Training &amp; Certification", "education-training-certification", "0");
INSERT INTO `wp_terms` VALUES("89", "HEALTH &amp; FITNESS / Exercise", "health-fitness-exercise", "0");
INSERT INTO `wp_terms` VALUES("90", "James Thomson", "james-thomson", "0");
INSERT INTO `wp_terms` VALUES("91", "Kindle Ebook Marketing Directory", "kindle-ebook-marketing-directory", "0");
INSERT INTO `wp_terms` VALUES("92", "Cabana Books", "cabana-books", "0");
INSERT INTO `wp_terms` VALUES("93", "BUSINESS &amp; ECONOMICS / Entrepreneurship", "business-economics-entrepreneurship", "0");
INSERT INTO `wp_terms` VALUES("94", "Laina Turner", "laina-turner", "0");
INSERT INTO `wp_terms` VALUES("95", "All I Know About e-Book Marketing", "all-i-know-about-e-book-marketing", "0");
INSERT INTO `wp_terms` VALUES("96", "Five Seas Ink", "five-seas-ink", "0");
INSERT INTO `wp_terms` VALUES("97", "Book Marketing Group", "book-marketing-group", "0");
INSERT INTO `wp_terms` VALUES("98", "COMPUTERS / Web / Web Services &amp; APIs", "computers-web-web-services-apis", "0");
INSERT INTO `wp_terms` VALUES("99", "LANGUAGE ARTS &amp; DISCIPLINES / Authorship", "language-arts-disciplines-authorship", "0");
INSERT INTO `wp_terms` VALUES("100", "MR Robert K. Teske Jr.", "mr-robert-k-teske-jr", "0");
INSERT INTO `wp_terms` VALUES("101", "1470080206", "1470080206", "0");
INSERT INTO `wp_terms` VALUES("102", "Electronic Publishing", "electronic-publishing", "0");
INSERT INTO `wp_terms` VALUES("103", "BUSINESS &amp; ECONOMICS / New Business Enterprises", "business-economics-new-business-enterprises", "0");
INSERT INTO `wp_terms` VALUES("104", "David Welday III", "david-welday-iii", "0");
INSERT INTO `wp_terms` VALUES("105", "Get Your Book Published!: From Contracts to Covers", "get-your-book-published-from-contracts-to-covers", "0");
INSERT INTO `wp_terms` VALUES("106", "Editing to eBooks", "editing-to-ebooks", "0");
INSERT INTO `wp_terms` VALUES("107", "Marketing and Sales", "marketing-and-sales", "0");
INSERT INTO `wp_terms` VALUES("108", "What Every Writer and Author Should Know", "what-every-writer-and-author-should-know", "0");
INSERT INTO `wp_terms` VALUES("109", "HigherLife Publishing", "higherlife-publishing", "0");
INSERT INTO `wp_terms` VALUES("110", "1939183006", "1939183006", "0");
INSERT INTO `wp_terms` VALUES("111", "Bible Of eBook Promotion", "bible-of-ebook-promotion", "0");
INSERT INTO `wp_terms` VALUES("112", "Joanna Penn", "joanna-penn", "0");
INSERT INTO `wp_terms` VALUES("113", "How To Market A Book", "how-to-market-a-book", "0");
INSERT INTO `wp_terms` VALUES("114", "BUSINESS &amp; ECONOMICS / Small Business", "business-economics-small-business", "0");
INSERT INTO `wp_terms` VALUES("115", "Richard Hopkins", "richard-hopkins", "0");
INSERT INTO `wp_terms` VALUES("116", "SELF-HELP / General", "self-help-general", "0");
INSERT INTO `wp_terms` VALUES("117", "SELF-HELP / Twelve-Step Programs", "self-help-twelve-step-programs", "0");
INSERT INTO `wp_terms` VALUES("118", "Erin McBride", "erin-mcbride", "0");
INSERT INTO `wp_terms` VALUES("119", "Increase e-Book Sales with Social Media Marketing", "increase-e-book-sales-with-social-media-marketing", "0");
INSERT INTO `wp_terms` VALUES("120", "Baby Duck Books", "baby-duck-books", "0");
INSERT INTO `wp_terms` VALUES("121", "REFERENCE / Personal &amp; Practical Guides", "reference-personal-practical-guides", "0");
INSERT INTO `wp_terms` VALUES("122", "Nick Vulich", "nick-vulich", "0");
INSERT INTO `wp_terms` VALUES("123", "1482651130", "1482651130", "0");
INSERT INTO `wp_terms` VALUES("124", "Reference", "reference", "0");
INSERT INTO `wp_terms` VALUES("125", "Writing Skills", "writing-skills", "0");
INSERT INTO `wp_terms` VALUES("126", "Derek Doepker", "derek-doepker", "0");
INSERT INTO `wp_terms` VALUES("127", "1490590919", "1490590919", "0");
INSERT INTO `wp_terms` VALUES("128", "ebooks", "ebooks", "0");
INSERT INTO `wp_terms` VALUES("129", "creating ebooks", "creating-ebooks", "0");
INSERT INTO `wp_terms` VALUES("130", "writing your first ebook", "writing-your-first-ebook", "0");
INSERT INTO `wp_terms` VALUES("131", "ebook marketing", "ebook-marketing", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("2", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp330_toolbar,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media,wp360_revisions");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "wp_dashboard_quick_press_last_post_id", "25");
INSERT INTO `wp_usermeta` VALUES("15", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("16", "1", "metaboxhidden_nav-menus", "a:3:{i:0;s:8:\"add-post\";i:1;s:13:\"add-ml-slider\";i:2;s:12:\"add-post_tag\";}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "nav_menu_recently_edited", "2");
INSERT INTO `wp_usermeta` VALUES("18", "1", "wp_user-settings", "align=left&imgsize=thumbnail&editor=tinymce&galfile=1&ngg_upload_resize=1&uploader=1&mfold=o&libraryContent=browse&urlbutton=file&hidetb=1&wplink=1");
INSERT INTO `wp_usermeta` VALUES("19", "1", "wp_user-settings-time", "1391191836");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$BcUCLsMAQa8o49OMOB8ywSsb2d1YSB.", "admin", "mail@yourmail.comndremedies.info", "", "2013-12-06 17:13:19", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1;